/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: component.cpp,v 1.4 2003/11/10 07:51:14 monaka Exp $
 */



// $Header: /cvsroot/toppers-utils/if40/cfg/base/component.cpp,v 1.4 2003/11/10 07:51:14 monaka Exp $

#include "component.h"
#include <iostream>
#include <algorithm>
#include <fstream>

using namespace std;

int       Component::barrierFlag = 0;		//ǽХꥢ
Directory Component::persistentContainer;	//³ǡƥ

Component::Component(int order)
{	componentList().insert(pair<int,Component *>(order,this));	}

	//ǥȥ饯
Component::~Component(void)
{
    multimap<int, Component *>::iterator scope;

		//ʤϿꥹȤ鼫ʬ򳰤
	scope = componentList().begin();
	while(scope != componentList().end())
	{
		if(scope->second == this)
		{
	        componentList().erase(scope);
			break;
		}
		++ scope;
	}
}

string & Component::bootBanner(void)
{
	static string s_bootBanner;
	return s_bootBanner;
}

multimap<int,Component *> & Component::componentList(void)
{
	static multimap<int,Component *> s_componentList;
	return s_componentList;
}

list<Component *> & Component::activatedComponentList(void)
{
	static list<Component *> s_activatedComponentList;
	return s_activatedComponentList;
}

	//ư׵ȯ
	//  allow_multiinstance : ʣư뤳ȤĤ
void Component::activateComponent(bool allow_multiinstance)
{
    if(allow_multiinstance || (find(activatedComponentList().begin(),activatedComponentList().end(), this) == activatedComponentList().end()))
        activatedComponentList().push_back(this);  
}

bool Component::findOption(Directory & container, const char * id, const char * longId, std::string * value)
{
	Directory * node = getOption(container, id, longId);
	if(node != 0)
	{
		if(value != 0)
		{
			*value = node->getLastChild()->toString();
		}
		return true;
	}
	return false;
}

	//ꤷץǼΡɤμ
	//  container : ץǼ륳ƥ
	//  id        : ץ̤ID (û: -x)
	//  loongid   : ץ̤ID (Ĺ: --xx)
	//  dirty     : ƥӥåȤΩƤ뤫ɤ
	//      : Ρ (NULL: Ĥʤ)
Directory * Component::getOption(Directory & container, const char * id, const char * longId, bool dirty)
{
    Directory * param;
    Directory * scope;

    param = container.findChild("Parameter");

    if( ((id != 0) && ((scope = param->findChild(id)) != 0)) ||							/* û̾פ */
        ((longId != 0) && ((scope = param->findChild(string("-") + longId)) != 0)) )	/* Ĺ̾פ */
    {
		if(dirty)
			(*scope) = 1;
		return scope;
    }

    return NULL;
}

	//ѥ᡼뤫ɤγǧ򤷤Ĥġ
	//֥ѥ᡼ǧѤߡפΥå
bool Component::checkOption(Directory & container, const char * id, const char * longId)
{
	bool        result = false;
    Directory * param;
    Directory * scope;

    param = container.findChild("Parameter");

	if((scope = param->findChild(id)) != NULL)
		(*scope) = 1, result = true;

	if((scope = param->findChild(longId)) != NULL)
		(*scope) = 1, result = true;

	return result;
}

	//2ĤΥץܤΥޡ
Directory * Component::mergeOption(Directory & container, const char * to, const char * from)
{
	Directory * src;
	Directory * dest;
	Directory * node;

	src  = container.findChild("Parameter",to,NULL);
	dest = container.findChild(string("Parameter/") + from);

	if(dest == 0)
		return src;

	if(src == 0)
		src = container.openChild("Parameter",to,NULL);

	node = dest->getFirstChild();
	while(node != 0)
	{
		src->addChild(new Directory(node->toString()));
		node = node->getNext();
	}

	dest->erase();

	return src;
}

	//ץܤɲ
static void addOptionItem(Directory * parameter, const string & key, const string & item)
{
    Directory * node;

    node = parameter->findChild(key);

    if(item.empty())
    {
		/* Ȥ̵ץʣꤹΤϵʤ */
		if(node != 0)
			throw Exception("The option [%s] should not be specified twice or more times.","ץ[%s]¿ŻѤϤǤޤ").format(key.c_str());

		parameter->addChild(key, new Directory());
    }else
    {
        if(node != 0)
        {
				//Ʊץʣѥ᡼ꤵƤ
            node->addChild(item.empty() ? new Directory("") : new Directory(item));
            *node = item;
        }else
            parameter->addChild(key, new Directory(item))->addChild("000", new Directory(item));
    }
}

	//ץ
void Component::parseOption(int argc, char ** argv, Directory & container, const char * default_option)
{
    multimap<int, Component *>::iterator scope;
    Directory * parameter;
	string work;
	string prevparam;
	string::size_type i,j;
 
	if(default_option != 0)
	{
		work.assign(default_option);
		work += string(" ");
	}

		//㳰
	scope = componentList().begin();

    try{
        parameter = container.addChild("Parameter");

			/* ¹Էξ */
		(*parameter)["#exec"] = *argv;
		work.assign(*argv);
		i = work.find_last_of("/\\");
		if(i != string::npos)
		{
			work.erase(i+1);
			if(!work.empty())
				(*parameter)["#execdir"] = work;
		}

			/* ѥ᡼ꥹ */
		for(i=1;*(argv+i)!=0;i++)
		{
			work += *(argv+i);
			work += ' ';
		}
		(*parameter)["#cmdline"] = work.substr(0,work.size()-1);

		
		
            //ѥ᡼ѡ
		prevparam = DEFAULT_PARAMETER;
	    while(*(++argv) != 0)
	    {
		    work.assign(*argv);
		    if(work[0] == '-')
		    {
			    i = work.find_first_of('=');
			    j = work.find_first_not_of('-');
			    if(i == j || j == string::npos)
                    throw Exception(Exception::FATAL,"Wrong option [%s]","ʥץ [%s]").format(work.c_str());

			    if(i != string::npos)
				{
					prevparam = DEFAULT_PARAMETER;
                    addOptionItem(parameter, work.substr(1, i-1), work.substr(i+1));
				}
			    else
				{
					prevparam = work.substr(1);
                    addOptionItem(parameter, prevparam, string(""));
				}
		    }else
                addOptionItem(parameter, prevparam, work);
	    }

			/* ץ̵ǥإɽ */
		if(argc == 1)
			parameter->addChild("h");

        {       //Хʥץ

				//ǥХå
			if(findOption(container, "debug","debug"))
			{
				cerr << "\n[debug-info] : Parameter\n";
				container.findChild("Parameter")->drawTree(&cerr);
                container.addChild("Debug");
				DebugMessage::setStream(&cerr);
				DebugMessage::setVerbose(true);
			}

				//Ϥϥ顼å˱ƶΤǰֺǽ˽
            if(findOption(container,"lj","japanese"))
                Message::selectCodepage(0x441);

            if(findOption(container,"le","english"))
                Message::selectCodepage(0);

            if(findOption(container,"v","verbose"))
                VerboseMessage::setVerbose(true);

			if(!findOption(container, "nl","nologo") && VerboseMessage::getVerbose())
				cerr << bootBanner() << '\n';

            if(findOption(container,"h","help"))
                cerr << '\n' << Message(
					"Global option\n"
					"  -lj, --japanese         : Use Japanese as display language\n"
					"  -le, --english          : Use English as display language(default)\n"
					"  -v, --verbose           : Display verbose messages\n"
					"  -nl, --nologo           : Do not display the boot banner\n"
					"  -ext, --extension       : Enable extensions\n"
					"  -no-ext, --no-extension : Restrict use of extensions (Override -ext)\n"
					"  -is, --initialsettings = [filename]\n"
					"                          : Load the initial settings form the file specified\n"
					"  -nis, --no-initialsettings\n"
					"                          : Never load and store the initial seetings\n\n",
                    "ΤΥץ\n"
					"  -lj, --japanese         : ܸɽޤ\n"
					"  -le, --english          : Ѹɽޤ\n"
                    "  -v,  --verbose          : вʤɤɽޤ\n"
					"  -nl, --nologo           : ưΥХʡɽޤ\n"
					"  -ext, --extension       : ĥǽͭˤޤ\n"
					"  -no-ext, --no-extension : ĥǽ̵ˤޤ\n"
					"  -is, --initialsettings  : Ѥޤ [ե̾ǽ]\n");

			if(!findOption(container,"is","initialsettings"))
				loadPersistentContainer(container);

			if(findOption(container,"ext","extension"))
				enable(EXTENSION);

			if(findOption(container,"no-ext","no-extension"))
				disable(EXTENSION);

				/* ¾Хʥץ */
			checkOption(container,"D","dump");
			checkOption(container,"Dx","dump-xml");
        }

			/* ³Ūͤꤹ (Hidden option) */
		Directory * node;
		if( (node = getOption(container,"set","settings"))->getFirstChild() != NULL)
		{
			node = node->getFirstChild();
			while(node != NULL)
			{
				work = node->toString();
				node = node->getNext();

				setPersistentString(work, node->toString());
				node = node->getNext();
			}
		}else
		{
				//ݡͥȤˤѥ᡼
			scope = componentList().begin();
			while(scope != componentList().end())
			{
				DebugMessage("Component [%s] parseOption starts\n","ݡͥȵư [%s] - parseOption\n").format(typeid(*scope->second).name());
				scope->second->parseOption(container);
				DebugMessage("Component [%s] parseOption end\n","ݡͥȽλ [%s] - parseOption\n").format(typeid(*scope->second).name());

				++ scope;
			}
		}

			/* ٤ƤΥץ󤬤Ƚ줿ɤå */
		{
			work.erase();
			parameter = parameter->getFirstChild();
			while(parameter != NULL)
			{
				if(*parameter == Directory::UNKNOWN)
					work += string(", -") + parameter->getKey();
				parameter = parameter->getNext();
			}

				/* Ƥʤץ󤬤 */
			if(!work.empty())
			{
					/* ƬˤĤƤ", "ơ顼ɽ */
				work = work.substr(2);
				throw Exception("Unknown option [%s] specified","ʤäѥ᡼ [%s]").format(work.c_str());
			}
		}
    }
    catch(Exception & e)
    {
			//onFatalExitƽФоݤȤʤ륳ݡͥȤΤߤĤƺ
		componentList().erase(scope,componentList().end());
        throw Exception(Exception::FATAL, "%s\nFatal error occured during command line parsing.","%s\nޥɥ饤󥪥ץβ̿Ūʥ顼Ĥޤ").format((const char *)e);
    }

		/* ˽λȤα³ƥʥåץǡȽ */
	if(findOption(container, "is", "initialsettings") && !findOption(container,"np","no-persistents"))
		storePersistentContainer(container);
}

	//ǥХåѥƥʥץ롼
void Component::dumpContainerSnapshot(Directory & container, bool forcedly)
{
	string dump;

	if(forcedly || findOption(container, "D", "dump", &dump) || findOption(container,"debug","debug"))
	{
		if(dump.empty())
			dump.assign("container.txt");

		fstream f(dump.c_str(), ios::out);
		if(f.is_open())
		{
			f << "Last configuration was finished successfully\n\n";
			container.drawTree(&f);
			f.close();
		}
	}

	if(forcedly || findOption(container, "Dx", "dump-xml", &dump) || findOption(container,"debug","debug"))
	{
		if(dump.empty())
			dump.assign("container.xml");

		fstream f("container.xml",ios::out);
		if(f.is_open())
		{
			container.drawTree_byXML(&f);
			f.close();
		}
	}
}

	//ư׵᤬ФƤ륳ݡͥȤεư
void Component::executeComponents(Directory & container)
{
    Component * cmp;

    while(!activatedComponentList().empty())
    {
        cmp = *activatedComponentList().begin();
        activatedComponentList().pop_front();
        try{
			DebugMessage("Component [%s] body starts\n","ݡͥȵư [%s] - body\n").format(typeid(*cmp).name());
            cmp->body(container);
			DebugMessage("Component [%s] body finished\n","ݡͥȽλ [%s] - body\n").format(typeid(*cmp).name());
        }
		catch(Exception & e)
        {
			dumpContainerSnapshot(container);

            if(e.isFatal())
                throw e;
            cerr << e << Message("(continue...)\n","(³Ԥޤ...)\n");
        }
    }

	dumpContainerSnapshot(container);
}

	//㳰ȯ
void Component::fire_onFatalExit(Directory & container)
{
	multimap<int, Component *>::iterator scope;

	dumpContainerSnapshot(container);

	scope = componentList().begin();
    while(scope != componentList().end())
    {
        try{
			DebugMessage("Component [%s] onFatalExit starts\n","ݡͥȵư [%s] - onFatalExit\n").format(typeid(*scope->second).name());
            scope->second->onFatalExit(container);
			DebugMessage("Component [%s] onFatalExit finished\n","ݡͥȽλ [%s] - onFatalExit\n").format(typeid(*scope->second).name());
        }
		catch(Exception & e)
        {
			cerr << Message("[Internal error] : A function derived from Component::onFatalExit reports occurence of exception\n","[顼] : ݡͥȤonFatalExit᥽åɤ㳰򵯤ޤ\n");
            cerr << "  " << e << Message("(continue...)\n","(³Ԥޤ...)\n");
        }
		++ scope;
    }

		/* ˽λʤäȤα³ƥʥåץǡȽ */
	if(!findOption(container,"nis","no-initialsettings"))
		storePersistentContainer(container);
}

void Component::loadPersistentContainer(Directory & container)
{
	fstream file;
	string  filename;

	findOption(container,"is","initialsettings",&filename);
	if(filename.empty())
		filename.assign(FILENAME_PERSISTENTCONTAINER);

	file.open(filename.c_str(),ios::in|ios::binary);
	if(!file.is_open())
	{
		file.clear();

			/*  or ꤵ줿꤫鳫ʤä顢exeƱǻ */
		filename = container["/Parameter/#execdir"].toString() + filename;
		file.open(filename.c_str(),ios::in|ios::binary);
	}

	if(file.is_open())
		persistentContainer.Load(&file);
	
	persistentContainer["#filename"] = filename;

	DebugMessage("Load the persistent variables from \"%s\"\n","³ѿ \"%s\" ɤ߽Фޤ\n").format(filename.c_str());
}

void Component::storePersistentContainer(Directory & container)
{
	fstream file;
	string  filename;

	filename = persistentContainer["#filename"].toString(FILENAME_PERSISTENTCONTAINER);

	if(!filename.empty())
	{
		file.open(filename.c_str(),ios::out|ios::binary);
		if(!file.is_open())
		{
			file.clear();

				/*  or ꤵ줿꤫鳫ʤä顢exeƱǻ */
			filename = container["/Parameter/#execdir"].toString() + filename;
			file.open(filename.c_str(),ios::out|ios::binary);
			if(!file.is_open())
				throw Exception("Failed to open the initial settings file \"%s\".","ե[%s]¸Ǥޤ").format(filename.c_str());
		}
		
		DebugMessage("Store the persistent variables from \"%s\"\n","³ѿ \"%s\" ؽ񤭽Фޤ\n").format(filename.c_str());

		persistentContainer.Store(&file);
		file.close();
	}

		/* ǥХåѥ׽ */
	if(findOption(container,"D","dump"))
	{
		fstream txt;
		
		filename.erase(filename.find_last_of('.'));
		filename += ".txt";
		txt.open(filename.c_str(),ios::out);
		
		persistentContainer.drawTree(&txt);

		txt.close();
	}

		/* ǥХåѥ׽ (XML) */
	if(findOption(container,"Dx","dump-xml"))
	{
		fstream xml;
		
		filename.erase(filename.find_last_of('.'));
		filename += ".xml";
		xml.open(filename.c_str(),ios::out);
		
		if(xml.is_open())
			persistentContainer.drawTree_byXML(&xml);
		xml.close();
	}
}

