/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: except.cpp,v 1.4 2003/11/10 07:51:14 monaka Exp $
 */



// $Header: /cvsroot/toppers-utils/if40/cfg/base/except.cpp,v 1.4 2003/11/10 07:51:14 monaka Exp $

#include "except.h"
#undef Throw

using namespace std;

unsigned long Message::current_codepage_index = 0;

unsigned long Message::codepage[NUM_SUPPORTLANGUAGE] =
{
	0x0000, /* Neutral language ( = English ) */
	0x0441  /* Japanese */
};

Message::Message(const char * msg, ...)
{
	va_list vl;
	va_start(vl, msg);
    initMessage(vl, msg);
}

void Message::initMessage(va_list vl, const char * msg)
{
    int count = current_codepage_index;

    while(count-- > 0)
        msg = va_arg(vl, const char *);

    message = msg;
}

Message::Message(Message & src)
{	message = src.message;	}


bool Message::selectCodepage(unsigned long cp)
{
	unsigned long i;

	for(i=0;i<NUM_SUPPORTLANGUAGE;i++)
		if(cp == codepage[i])
		{
			current_codepage_index = i;
			return true;
		}

	return false;
}
/*
Message & format(Message & str, ...)
{
	va_list vl;
	char buffer[1024];

	va_start(vl, str);
	vsprintf(buffer, (const char *)str, vl);

    str.message.assign(buffer);

	return str;
}
*/

ostream & operator << (ostream & out, const Message & msg)
{
    out << (const char *)msg;
    return out;
}

//------

Exception::Exception(int initcode, const char * first, ...) : code(initcode)
{
    va_list vl;

    if(first != 0)
    {
        va_start(vl, first);
        initMessage(vl, first);
    }else
        message = "Unknown Exception";
}

Exception::Exception(const char * first, ...) : code(FATAL)
{
    va_list vl;

    va_start(vl, first);
    initMessage(vl, first);
}

Exception::Exception(const Exception & exc)
{
    code = exc.code;
    message = exc.message;
}

Exception::Exception(const Exception * exc)
{
    code = exc->code;
    message = exc->message;
}

Exception::~Exception(void)
{
}

bool Exception::isFatal(void) const
{   return code < 0;    }


Exception::operator int (void) const
{   return code;    }

//------

bool VerboseMessage::verboseControl = false;
std::ostream * VerboseMessage::outputStream = 0;

VerboseMessage::VerboseMessage(const char * msg, ...)
{
	va_list vl;
	va_start(vl, msg);
    initMessage(vl, msg);
}

VerboseMessage::~VerboseMessage(void)
{
    if(verboseControl && (outputStream != 0))
        *outputStream << message;
}

//------

bool DebugMessage::verboseControl = false;
std::ostream * DebugMessage::outputStream = 0;

DebugMessage::DebugMessage(const char * msg, ...)
{
	va_list vl;
	va_start(vl, msg);
    initMessage(vl, msg);
}

DebugMessage::~DebugMessage(void)
{
    if(verboseControl && (outputStream != 0))
        *outputStream << message;
}
