/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: except.h,v 1.5 2003/11/10 07:51:14 monaka Exp $
 */



// $Header: /cvsroot/toppers-utils/if40/cfg/base/except.h,v 1.5 2003/11/10 07:51:14 monaka Exp $

#ifndef __EXCEPT
#define __EXCEPT

#ifdef _MSC_VER
	#pragma warning(disable:4786)
#endif

#include <string>
#include <cstdarg>
#include <cstdio>

#include <iostream>
#include <list>

#include "garbage.h"

#define NUM_SUPPORTLANGUAGE 2
#define MESSAGE_BUFFERSIZE  4096

/*
 * 顼ʤɤˤåϡƤӽФޤǤݤȤ̤äƤΤǡ
 * Ǥ¤ñ褦ˤƤΤǥСإåɤƤޤäƤ⡢
 * ɤۥȤưΤ̵롥
 */

/*
 * Message : ʣåݻ뤿δܥ饹
 */

class Message
{
private:
	static unsigned long current_codepage_index;
	static unsigned long codepage[NUM_SUPPORTLANGUAGE];

protected:
	std::string message;

    Message(void) {};
    void initMessage(va_list, const char * = 0);

public:
	Message(const char *, ...);
	Message(Message &);
	virtual ~Message(void) {};

	operator const char * (void) const;
	operator const std::string & (void) const;

	static bool selectCodepage(unsigned long = 0x0000);

    template<class T>
    inline Message & format(const T first, ...)
    {
        va_list vl;
        char buffer[MESSAGE_BUFFERSIZE];

        va_start(vl, first);
        vl = (va_list)((char *)vl - sizeof(first));
        vsprintf(buffer, message.c_str(), vl);
        message.assign(buffer);

        return *this;
    }

    friend Message & format(Message &, ...);
    friend std::ostream & operator << (std::ostream &, const Message &);
};

inline Message::operator const char *(void) const
{	return message.c_str();	}

inline Message::operator const std::string & (void) const
{	return message;	}


//------

/*
 * VerboseMessage : 椬ĤƤ̥å
 */

class VerboseMessage : public Message
{
private:
    static std::ostream * outputStream;
    static bool verboseControl;

public:
    VerboseMessage(const char *, ...);
    virtual ~VerboseMessage(void);

    static inline void setStream(std::ostream * out)
    {   outputStream = out; };

    static inline void setVerbose(bool mode)
    {   verboseControl = mode;  };


	static inline bool getVerbose(void)
	{	return verboseControl && (outputStream != 0);	}
    
	template<class T>
    static inline void print(T msg)
    {
        if(getVerbose())
            (*outputStream) << msg;
    };
 
    template<class T>
    inline VerboseMessage & format(const T first, ...)
    {
        va_list vl;
        char buffer[MESSAGE_BUFFERSIZE];

        va_start(vl, first);
        vl = (va_list)((char *)vl - sizeof(first));
        vsprintf(buffer, message.c_str(), vl);
        message.assign(buffer);

        return *this;
    };
};

//------

/*
 * DebugMessage : 椬ĤƤ̥å (ǥХå)
 *		(ۤȤɤinlineʤΤVerboseMessageƱѤ)
 */

class DebugMessage : public Message
{
private:
    static std::ostream * outputStream;
    static bool verboseControl;

public:
    DebugMessage(const char *, ...);
    virtual ~DebugMessage(void);

    static inline void setStream(std::ostream * out)
    {   outputStream = out; };

    static inline void setVerbose(bool mode)
    {   verboseControl = mode;  };


	static inline bool getVerbose(void)
	{	return verboseControl && (outputStream != 0);	}
    
	template<class T>
    static inline void print(T msg)
    {
        if(getDebug())
            (*outputStream) << msg;
    };
 
    template<class T>
    inline DebugMessage & format(const T first, ...)
    {
        va_list vl;
        char buffer[MESSAGE_BUFFERSIZE];

        va_start(vl, first);
        vl = (va_list)((char *)vl - sizeof(first));
        vsprintf(buffer, message.c_str(), vl);
        message.assign(buffer);

        return *this;
    };
};

//------

/*
 * Exception : ̿ŪʻݤФå
 */
#define throwable throw Exception

class Exception : public Message
{
protected:
	static Exception   lastException;

    int  code;

    explicit Exception(const Exception *);
public:
    enum 
    {
        FATAL = 0x80000000 
    };

    Exception(int, const char * = 0, ...);
    Exception(const char *, ...);
    Exception(const Exception &);
	virtual ~Exception(void);

    bool isFatal(void) const;
    operator int (void) const;

    template<class T>
    inline Exception & format(const T first, ...)
    {
        va_list vl;
        char buffer[MESSAGE_BUFFERSIZE];

        va_start(vl, first);
        vl = (va_list)((char *)vl - sizeof(first));
        vsprintf(buffer, message.c_str(), vl);
        message.assign(buffer);

        return *this;
    }
};

#endif

