/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2002 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: fc_binutils.cpp,v 1.4 2003/11/10 07:51:14 monaka Exp $
 */

#include "defs.h"

#include "filecontainer.h"
#include "except.h"
#include "component.h"

#include "if40_defs.h"

#include <stdlib.h>
#include <string.h>

#include <cassert>
#include <fstream>
#include <sstream>
#include <string>
#include <map>

#define SIZE_STRINGBUFFER	1024
#define SIZE_LOADPAGE		65536		//2٤ɬ

#define HOST_ENDIAN	LITTLE		//ۥȤȥ륨ǥ
//#define HOST_ENDIAN	BIG			//ۥȤӥåǥ


using namespace std;


/*
 *  binutilsȤäե륳ƥʥ饹
 */
class filecontainer_binutils : public filecontainer, public Component
{
protected:
	enum tagEndian { UNKNOWN, LITTLE, BIG } endian;		//åȥǥ
	map<string, unsigned long> symbol_table;			//ѥϥåɤ
	map<unsigned long, char *> contents;				//ǡƥ
	string symbol_prefix;								//ܥץե

	void         check_defaultendian(void);
	void         check_defaultprefix(void);

	unsigned int load_symbols_withGnuNM(const char * module);
	void         obtain_contents(const char * module);

    virtual void parseOption(Directory &);    

public:
	filecontainer_binutils(void);
	~filecontainer_binutils(void);

	virtual bool attach_module(const char *);
	virtual bool change_endian(void * target, unsigned int size);
	virtual bool load_contents(void * dest, unsigned long address, unsigned int size);
	virtual unsigned long get_symbol_address(const char *);
	virtual const char * get_architecture(void);

} Instance_of_filecontainer_binutils;

filecontainer_binutils::filecontainer_binutils(void)
{
	instance = this;
	endian = HOST_ENDIAN;	//ۥȤΥǥ˹碌
}

filecontainer_binutils::~filecontainer_binutils(void)
{
	map<unsigned long, char *>::iterator scope;

		//ǡХåեκ
	scope = contents.begin();
	while(scope != contents.end())
	{
		delete [] scope->second;
		scope->second = NULL;

		++ scope;
	}

	contents.clear();
}

void filecontainer_binutils::parseOption(Directory & parameter)
{
	string loadmodule;
	string work;

		/* إɽ */
	if(findOption(parameter,"h","help"))
	{
		cout << endl << Message(
			"File container (binutils) - option\n"
			"  -mb : Take the target byte order for big endian\n"
			"  -ml : Take the target byte order for little endian\n"
			"ե졼å - ץ\n"
			"  -mb : åȤ ӥåǥǤ\n"
			"  -ml : åȤ ȥ륨ǥǤ\n");
		return;
	}

		/* ǥեȤǥӥåǥ (ǼưФǾ񤭤) */
	if(findOption(parameter,"mb","mb"))
	{
			/* ӥå/ȥƱϥ顼 */
		if(findOption(parameter,"ml","ml"))
			throw Exception("The two conflict options appeared - \"mb\" and \"ml\"","2Ĥȿ륪ץ󤬻ꤵƤޤ - \"mb\"  \"ml\"");
		endian = BIG;
	}

		/* ǥեȤǥȥ륨ǥ (ǼưФǾ񤭤) */
	if(findOption(parameter,"ml","ml"))
		endian = LITTLE;
}

	/* ե򳫤ƥȥեǤ뤳Ȥǧ */
static bool attach_textfile(fstream & file, const char * filename)
{
	streamsize	i;
	streamsize	itemcount;
	char		buffer[SIZE_STRINGBUFFER];

	if(file.is_open())
		file.close();

		//ץ
	file.open(filename,ios::in);
	if(!file.is_open())
		throw Exception("File not found \"%s\"","ե(%s)ޤ").format(filename);

		/* ǽ128ʸФơХʥ̵ɤǧ */

	file.read(buffer, 128);
	itemcount = file.gcount();
	if(itemcount == 0)
		throw Exception("File \"%s\" has no stream.","ե(%s)ˤȤޤ").format(filename);

	for(i=0;i<itemcount;i++)
		if(!isprint(buffer[i]) && !isspace(buffer[i]))
		{
			file.close();
			return false;	//ХʥΤޤʤä
		}

	file.seekg(0, ios::beg);
	return true;
}


/*
 *  load_symbols_withGnuNM : GNU NMȤäƥܥɤ߽Ф
 */

unsigned int filecontainer_binutils::load_symbols_withGnuNM(const char * filename)
{
	int           itemcount;
	unsigned long address;
	char *        pos;
	char *        epos;
	fstream       content;
	char          buffer[SIZE_STRINGBUFFER];

	if(!attach_textfile(content, filename))
	{
			/* ХʥäȤˤnmư */
		FILE * pipe;
		string cmdline;
		string symfile;

			/* ץ൯ư : objcopy -F srec ե̾ ƥݥե̾ */
		strcpy(buffer, "cfgXXXXXX");
		mktemp(buffer);
		symfile.assign(buffer);
		
		cmdline = string(CMD_SYMBOLLISTER) + " " + filename + " > " + symfile;
		pipe   = popen(cmdline.c_str(), "r");
		if(pipe == NULL)
			throw Exception("Error on External program execution \"%s\"","ץ൯ư˼ - \"%s\"").format(cmdline.c_str());
		pclose(pipe);

			/* ƥݥǤ̤򥹥ȥ꡼˼ */

		if(!attach_textfile(content, symfile.c_str()))
			throw Exception("Internal error : nm did not create the destination srec file \"%s\"","顼 : nmե\"%s\"ϤƤޤ").format(symfile.c_str());

		remove(symfile.c_str());		//UNIXǤϳޤ޺ϤäƤ⤤ (ƥкȤǤϾʤ餷)
	}

	itemcount = symbol_table.size();
	VerboseMessage("Symbol loading [NM] \"%s\"\n","ܥ [NM] \"%s\"\n").format(filename);

		/* ܥμ */
	content.seekg(0,ios::beg);
	while(!content.eof())
	{
		content.getline(buffer,SIZE_STRINGBUFFER);
		if(buffer[0] == '\0')
			break;

			/* ʸܤڡ -> ̤ܥ */
		if(buffer[0] != ' ')
		{
				/* ɥ쥹Υѡ (16ʿ) */
			pos = ::strtok(buffer," \n\t\r");
			address = ::strtoul(pos, &epos, 16);

				/* ܥ°Υѡ () */
			pos = ::strtok(NULL, " \n\t\r");

				/* ܥ̾Υѡ */
			pos = ::strtok(NULL, " \n\t\r");
			if(*pos != '*')
				symbol_table.insert(pair<string, unsigned long>(string(pos), address));
		}
	}

	return symbol_table.size() - itemcount;
}

	/* ݥ󥿰ư,Ĥ16ʸ->Ѵ */
static unsigned int hextodec(char * & target, unsigned int digit)
{
	unsigned int result;

	result = 0;
	while(digit-- > 0)
	{
		result <<= 4;
		if((*target >= '0') && (*target <= '9'))
			result |= *target - '0';
		else
			if((*target >= 'A') && (*target <= 'F'))
				result |= *target - 'A' + 10;
			else
				if((*target >= 'a') && (*target <= 'f'))
					result |= *target - 'a' + 10;
				else
					break;
		++ target;
	}

	return result;
}

	/* ȥS쥳ɤβ */
void filecontainer_binutils::obtain_contents(const char * filename)
{
	int      itemcount;
	fstream  content;
	char     buffer[SIZE_STRINGBUFFER];

		/* ʤμ߽ */

	if(!attach_textfile(content, filename))
	{
			/* Хʥʤobjcopyư */
		FILE * pipe;
		string cmdline;
		string srecfile;

			/* ץ൯ư : objcopy -F srec ե̾ ƥݥե̾ */
		strcpy(buffer, "cfgXXXXXX");
		mktemp(buffer);
		srecfile.assign(buffer);

		cmdline = string(CMD_OBJCOPY) + " -F srec " + filename + " " + srecfile;
		pipe   = popen(cmdline.c_str(), "r");
		if(pipe == NULL)
			throw Exception("Error on External program execution \"%s\"","ץ൯ư˼ - \"%s\"").format(cmdline.c_str());
		pclose(pipe);

			/* ƥݥǤ̤򥹥ȥ꡼˼ */

		if(!attach_textfile(content, srecfile.c_str()))
			throw Exception("Internal error : objcopy did not create the destination srec file \"%s\"","顼 : objcopyե\"%s\"ϤƤޤ").format(srecfile.c_str());

		remove(srecfile.c_str());		//UNIXǤϳޤ޺ϤäƤ⤤ (ƥǤϾʤ餷)
	}


	itemcount = symbol_table.size();
	VerboseMessage("Section data loading - \"%s\"\n","ǡμ - \"%s\"\n").format(filename);

		/* ȥS쥳ɥեμ */
	unsigned int	address;
	map<unsigned long, char *>::iterator storage;

	content.seekg(0,ios::beg);
	storage = contents.end();
	address = 0;

	while(!content.eof())
	{
		char *			scope;
		char *			tail;
		unsigned int	baseaddress;

		content.getline(buffer,SIZE_STRINGBUFFER);

		scope = buffer;
		if(*scope == '\0')
			break;

		/*
			The general format of an S-record follows: 
			+-------------------//------------------//-----------------------+
			| type | count | address  |            data           | checksum |
			+-------------------//------------------//-----------------------+
		*/

		if(*scope != 'S')
			throw Exception("Internal error : Syntax error on parsing Motolora S File","顼 : ȥS쥳ɲϻ顼");

		scope = buffer + 2;
		tail  = &buffer[4] + hextodec(scope, 2)*2 - 2;	//åʬ˰ư

		switch(buffer[1])
		{
		case '1':
			address = hextodec(scope, 4);
			break;
		case '2':
			address = hextodec(scope, 6);
			break;
		case '3':
			address = hextodec(scope, 8);
			break;

		case '5':
			break;

			/* 嵭ʳΥפϥǡեɤʤ */
		default:
			continue;
		}

			/* 1ХȤĥХåե˼Ǥ */
		baseaddress = 0;
		while(scope < tail)
		{
				/* ХåեΥڡ/ */
			if(storage == contents.end() || (address & ~(SIZE_LOADPAGE-1)) != 0)
			{
				baseaddress += address & ~(SIZE_LOADPAGE-1);
				storage = contents.find(baseaddress);
				if(storage == contents.end())
					storage = contents.insert(pair<unsigned long, char *>(baseaddress, new char[SIZE_LOADPAGE])).first;
				address &= SIZE_LOADPAGE - 1;
			}

			*(storage->second + address) = hextodec(scope, 2);
			++ address;
		}

		address = baseaddress + address;	//S5
	}
}

	/* ؿץեμư */
void filecontainer_binutils::check_defaultprefix(void)
{
	static const char * candidate_list [] = { "_", NULL };		//ץեθ
	static const char target_symbol[] = "_kernel_tmax_tskid";	//ɬ¸ߤCѿ

	map<string, unsigned long>::iterator scope;

	string symbol;
	const char ** candidate;

	symbol.assign(target_symbol);

		/* ޤϥץեʤĩ */
	scope = symbol_table.find(symbol);
	if(scope == symbol_table.end())
	{
			/* ץեƬ­ƺĩ */
		candidate = candidate_list;
		while(*candidate != NULL)
		{
			symbol = string(*candidate) + target_symbol;
			scope = symbol_table.find(symbol);
			if(scope != symbol_table.end())
			{
				symbol_prefix.assign(*candidate);
				break;
			}

			++ candidate;
		}

			/* ɤˤҤäʤ */
		if(*candidate == NULL)
			throw Exception("Specified symbol table does not contain JSP symbols (Make sure the file is suitable).","ꤵ줿եJSPɬܥܥޤǤʤᡢ³ԤǤޤ");
	}

	if(!symbol_prefix.empty())
		VerboseMessage("  Checker takes [%s] as the default symbol prefix\n","  ܥץե : [%s]\n").format(symbol_prefix.c_str());
}

	/* ǥμư */
void filecontainer_binutils::check_defaultendian(void)
{
	unsigned int tsknum;

		/* οޤˤ礭(4096ʾ)ä顢ǥϵդȽ */
	this->load_variable(&tsknum, sizeof(int), "_kernel_tmax_tskid");
	if(tsknum > 0x000fffff)
	{
			//ȿž
		endian = endian == LITTLE ? BIG : LITTLE;
	}
}

/*
 *  attach_module : оݥ⥸塼򥢥å
 */
bool filecontainer_binutils::attach_module(const char * filename)
{
	string work;
	string::size_type pos;

	work.assign(filename);

	pos = work.find_first_of(',');
	if(pos != string::npos)
	{
			//ǽι: ܥե̾
		work.erase(pos);
		load_symbols_withGnuNM(work.c_str());

		work.assign(filename).erase(0,pos+1);
		obtain_contents(work.c_str());
	}else
	{
		load_symbols_withGnuNM(filename);		//nmư
		obtain_contents(work.c_str());			//objcopyư
	}

		//ưн
	check_defaultprefix();
	check_defaultendian();

	return true;
}

bool filecontainer_binutils::change_endian(void * target, unsigned int size)
{
	assert(target != NULL);
	assert(size != 0);

		//ۥȤȥåȤΥǥ󤬰ʤѴʤƤ⤤
	if(endian == HOST_ENDIAN)
		return true;

	/*
	 *  ᥤ롼 : bswapʤǡľ˽
	 */
	char * top, * tail;

	top  = (char *)target;
	tail = (char *)target+size -1;

	while(top < tail)
	{
		*top ^= *tail, *tail ^= *top, *top ^= *tail;
		++ top;
		-- tail;
	}

	return true;
}


bool filecontainer_binutils::load_contents(void * dest, unsigned long address, unsigned int size)
{
	map<unsigned long, char *>::iterator scope;
	char * buffer;

	assert(dest != NULL);

		/* Хåեڡ */
	scope = contents.find(address & ~(SIZE_LOADPAGE-1));
	if(scope == contents.end())
		throw Exception("Internel error: Memory read with unmapped address","顼; ޥåפƤʤɥ쥹Ȥäƥ꡼ɤԤޤ");

		/* Ƥʣ */
	buffer = scope->second + (address & (SIZE_LOADPAGE-1));
	memcpy(dest, buffer, size);

	return true;
}


/*
 * get_symbol_address : ܥ̾饢ɥ쥹ͤ
 */
unsigned long filecontainer_binutils::get_symbol_address(const char * symbol)
{
	map<string, unsigned long>::iterator scope;
	string symbol_name;

		//ܥ̾ ("_"Ȥν)
	symbol_name = symbol_prefix + symbol;

	scope = symbol_table.find(symbol_name);
	if(scope == symbol_table.end())
		return 0;

	return (*scope).second;
}

/*
 * get_architecture : ƥ̾μ
 */
const char * filecontainer_binutils::get_architecture(void)
{
		//Ȥꤢå̾äƥƥ̾ˤƤ
		// #ɤХʡˤȤäƤʤ ΤȤ

	if(endian == LITTLE)
		return "Little endian target (with GNU/Binutils)";
	else
		return "Big endian target (with GNU/Binutils)";
}
