/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2002 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: fc_windows.cpp,v 1.4 2003/11/10 07:51:14 monaka Exp $
 */


#include "filecontainer.h"

#include "except.h"

#include <windows.h>
#include <imagehlp.h>

#include <string>

using namespace std;

class filecontainer_windows : public filecontainer
{
protected:
	HANDLE process;
	LOADED_IMAGE image;
	DWORD base;

public:
	filecontainer_windows(void);
	~filecontainer_windows(void);

	virtual bool attach_module(const char *);
	virtual bool change_endian(void * target, unsigned int size);
	virtual bool load_contents(void * dest, unsigned long address, unsigned int size);
	virtual unsigned long get_symbol_address(const char *);
	virtual const char * get_architecture(void) { return "Windows"; };

} Instance_of_filecontainer_windows;

filecontainer_windows::filecontainer_windows(void)
{
	process = 0;
	base = 0;
	instance = this;
}

filecontainer_windows::~filecontainer_windows(void)
{}


bool filecontainer_windows::attach_module(const char * filename)
{
	process = ::GetCurrentProcess();
	if(::SymInitialize( process , NULL, FALSE) == FALSE)
		Exception("Internal Error : ImageHelper API initialization failure","顼 : ˼Ԥޤ (ImageHlp)");
	
	base = ::SymLoadModule(process, NULL, const_cast<char *>(filename), NULL, 0, 0);
	
	image.SizeOfImage = sizeof(LOADED_IMAGE);
	if(::MapAndLoad(const_cast<char *>(filename), NULL, &image, FALSE, TRUE) == FALSE)
		Exception("Internel error : Module loading failure [%s]","顼:⥸塼ɤ߹ߤ˼Ԥޤ [%s]").format(filename);
	return true;
}

bool filecontainer_windows::change_endian(void * target, unsigned int size)
{
		//WindowsͥƥƱΤѴʤפʤ
	return true;
}


bool filecontainer_windows::load_contents(void * dest, unsigned long address, unsigned int size)
{
	PIMAGE_SECTION_HEADER header;
	unsigned int i;

	address -= base;
	for(i=0;i<image.NumberOfSections;i++)
	{
		header = image.Sections+i;
		if(address >= header->VirtualAddress && address < header->VirtualAddress + header->SizeOfRawData)
		{
			address -= header->VirtualAddress - header->PointerToRawData;
			::CopyMemory(dest,image.MappedAddress + address,size);

			return true;
		}
	}

	Exception("Internel error: Memory read with unmapped address","顼; ޥåפƤʤɥ쥹Ȥäƥ꡼ɤԤޤ");

	return false;
}

unsigned long filecontainer_windows::get_symbol_address(const char * symbol)
{
	IMAGEHLP_SYMBOL sym;
	char buffer[256];

	if(process == NULL || base == 0)
		Exception("Not initialized","Ƥޤ");

	sym.SizeOfStruct = sizeof(sym);
	sym.MaxNameLength = 0;

	if(::SymGetSymFromName(process, const_cast<char *>(symbol), &sym) == FALSE)
	{
		sprintf(buffer,"_%s",symbol);
		if(::SymGetSymFromName(process, const_cast<char *>(buffer), &sym) == FALSE)
			return 0;
	}

	return sym.Address;
}
