/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: filecontainer.h,v 1.4 2003/11/10 07:51:14 monaka Exp $
 */



#ifndef __FILECONTAINER_H
#define __FILECONTAINER_H

#ifdef _MSC_VER
#pragma warning(disable:4786)
#endif

#include <map>
#include <string>

struct variable_information
{
	union {
		unsigned long address;
		long value;
	};
	unsigned int  size;
};

class filecontainer
{
protected:
	struct tagStructureInformation
	{
		unsigned int size;
		unsigned int offset;
	};

	static filecontainer * instance;

	std::map<std::string, std::string> objectname;
	std::map<std::string, struct tagStructureInformation> structure_information;

public:

	filecontainer(void) { instance = 0; };
	virtual ~filecontainer(void) {};

	static filecontainer * get_instance(void) { return instance; };

	virtual bool attach_module(const char *) =0;
	virtual bool change_endian(void * target, unsigned int size) =0;
	virtual bool load_contents(void * dest, unsigned long address, unsigned int size) =0;
	virtual unsigned long get_symbol_address(const char *) =0;
	virtual const char * get_architecture(void) =0;

	bool attach_infofile(const char *);
	bool load_variable(void * dest, unsigned int size, const char * name);
	bool load_variable(void * dest, unsigned int size, unsigned long address, const char * name);
	struct variable_information get_variable_information(const char *,unsigned long = 0);
	std::string get_objectname(int id, const char * type = "_GLOBAL");
};

#endif
