/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: mpstrstream.cpp,v 1.4 2003/11/10 07:51:14 monaka Exp $
 */


// $Header: /cvsroot/toppers-utils/if40/cfg/base/mpstrstream.cpp,v 1.4 2003/11/10 07:51:14 monaka Exp $

#ifdef _MSC_VER
	#pragma warning(push)
	#pragma warning(disable:4786)
	#pragma warning(disable:4290)
#endif

#include "mpstrstream.h"
#include <stdarg.h>

using namespace std;

typedef std::list<struct mpstrstream::tagStreamPartInfo *> List;

list<struct mpstrstream::tagStreamPartInfo *>::iterator mpstrstream::findpart(const char * partname) const
{
	List::const_iterator scope;

	scope = container.begin();
	while(scope != container.end())
	{
		if((*scope)->name.compare(partname) == 0)
			break;
		++ scope;
	}
	return *reinterpret_cast<List::iterator *>(&scope);
}

mpstrstream::~mpstrstream(void)
{
	if(fileoutput && !filename.empty())
	{
			/* serialize()Ƥ֤ȡ㳰äˡ³ѡȤ˴Ԥʤ */
		fstream file(filename.c_str(), ios::out);

		if(file.is_open())
		{
			serialize(file);
			file.close();
		}
	}

	while(!container.empty())
	{
		delete *(container.begin());
		container.pop_front();
	}
}

stringstream & mpstrstream::moveto(const char * partname) throw(Exception)
{
	List::iterator scope;

	scope = container.begin();
	while(scope != container.end())
	{
		if((*scope)->name.compare(partname) == 0)
		{
			current = scope;
			return (*current)->stream;
		}
		++ scope;
	}

	throw Exception("mpstrstream : There is no part named [%s].","mpstrstream : [%s]ʤѡ̾¸ߤʤ").format(partname);
	return (*current)->stream;	//Never reachable
}

stringstream & mpstrstream::moveto(unsigned int pos)
{
	List::iterator scope;

	scope = container.begin();
	while(pos -- > 0)
		++ scope;

	current = scope;
	return (*current)->stream;
}

stringstream & mpstrstream::moveto(enum tagPosition pos)
{
	switch(pos)
	{
	case BEGIN:
		current = container.begin();
		break;
	case END:
		current = container.end();
		break;
	}
	return (*current)->stream;
}

stringstream & mpstrstream::createpart(const char * partname, const char * second, ... )
{
	struct tagStreamPartInfo * info;
	va_list vl;

	va_start(vl, second);
	vl = (char *)vl - sizeof(const char *);

	while(partname != 0)
	{
		info = new struct tagStreamPartInfo;
		info->name.assign(partname);
		info->flags = DEFAULT;
		container.insert(current, info);

		partname = va_arg(vl, const char *);
	}

	return (*current)->stream;
}

stringstream & mpstrstream::insertpart(const char * partname, const char * successor) throw(Exception)
{
	struct tagStreamPartInfo * info;
	List::iterator scope;

	scope = container.end();
	if(successor != 0)
		if((scope = findpart(successor)) == container.end())
			throw Exception("Stream does not have the part (%s).","ȥ꡼϶(%s)ޤ").format(successor);

	info = new struct tagStreamPartInfo;
	info->name.assign(partname);
	info->flags = DEFAULT;
	current = container.insert(scope, info);
	
	return (*current)->stream;
}

void mpstrstream::erasepart(const char * partname)
{
	List::iterator scope;

	if((scope = findpart(partname)) == container.end())
		return;

	if(scope == container.begin())
		current = ++ container.begin();
	else
	{
		current = scope;
		-- current;
	}

	delete (*scope);
	container.erase(scope);
}

void mpstrstream::movepart(const char * partname, const char * successor) throw(Exception)
{
	List::iterator src;
	List::iterator dest;

	if((src = findpart(partname)) == container.end())
		throw Exception("Stream dones not have the part (%s).","ȥ꡼϶(%s)ޤ").format(partname);
	if(successor != 0)
	{
		if((dest = findpart(successor)) == container.end())
			throw Exception("Stream dones not have the part (%s).","ȥ꡼϶(%s)ޤ").format(successor);
	}else
		dest = container.end();

	current = container.insert(dest, (*src));
	container.erase(src);
}

void mpstrstream::serialize(void) throw(Exception)
{
	fstream file(filename.c_str(), ios::out);

	if(!file.is_open())
		throw Exception("File creation failure of %s","ե(%s)ޤ").format(filename.c_str());

	serialize(file);

	file.close();
}

ostream & mpstrstream::serialize(ostream & out)
{
	string buffer;
	List::iterator scope;

	scope = container.begin();
	while(scope != container.end())
	{
		if(((*scope)->flags & NO_SERIALIZE) == 0)
		{
			buffer = (*scope)->stream.str();
			out.write(buffer.c_str(), buffer.size());
		}
		++ scope;
	}

	return out;
}

int mpstrstream::setf(int flag)
{
	int old_flag;
	if(current == container.end())
		return -1;

	old_flag = (*current)->flags;
	(*current)->flags = flag;

	return old_flag;
}

