/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: parser.cpp,v 1.4 2003/11/10 07:51:14 monaka Exp $
 */



// $Header: /cvsroot/toppers-utils/if40/cfg/base/parser.cpp,v 1.4 2003/11/10 07:51:14 monaka Exp $

#include "defs.h"
#include "parser.h"
#include <sstream>

using namespace std;

/*
 *  Ƭˤʸ
 */
Token & Token::trim(void)
{
	string::iterator scope;

		/*  */
	scope = begin();
	while(*scope == ' ' || *scope == '\t' || *scope == '\r' || *scope == '\n')
		++ scope;
	erase(begin(), scope);

	if(!empty())
	{
			/*  */
		scope = end();
		do {
			-- scope;
		} while(*scope == ' ' || *scope == '\t' || *scope == '\r' || *scope == '\n');
		++ scope;
		erase(scope, end());
	}
	return *this;
}


 /*
  *  ʸƥŸ (֥륯Ȥμ + ץ󥹤Ÿ)
  */
Token & Token::chopLiteral(void)
{
    if(type != STRINGLITERAL)
        return *this;

    string::iterator scope;

        //顼Τ˲򤹤
    string src(*this);
    string work;

    if(src[0] != '"' || src[src.length()-1] != '"')
        return *this;

    src = src.substr(1, src.length()-2);

    scope = src.begin();
    while(scope != src.end())
    {
        if(*scope == '\\')
        {
                //ƥ\ǽ뤳ȤϤʤΤǥåʤ
            ++ scope;
            switch(*scope)
            {
            case '"':   work += '"';   break;
            case 't':   work += '\t';  break;
            case 'r':   work += '\r';  break;
            case 'n':   work += '\n';  break;
            case 'b':   work += '\b';  break;
            case '\\':   work += '\\';  break;
            default:
                throw Exception("Illegal escape sequence [\\%c]","ץ[\\%c]Ǥ").format(*scope);
            }
        }else
            work += *scope;

        ++ scope;
    }

    type = STRING;
    assign(work);
    value = this->length();

    return *this;
}

	/* ڤʸ (ʸǰ̣ʸ) */
const char * Parser::Punctuator =
	",;(){}";

	/* 黻 (üʸʤʸ) */
const char * Parser::Operator =
	"+-*/&|%^~!?[]=:.#";

Token Parser::lastErrorToken;


 /*
  *  ȥ꡼फʸڤФ
  */
inline int Parser::getChar(void)
{
    int work = current->stream->get();

		/* ֹν */
    if(work == '\n')
        current->line ++;
	
		/* ȥ꡼Τν */
	if(PutBackCount == 0)
	{
		if(LogBuffer != 0 && isenabled(LOGGING))
			*LogBuffer += static_cast<char>(work);
	}else
		PutBackCount --;	//Ǥɤ߹Ǥ

    return work;
}

 /*
  *  Фʸ򥹥ȥ꡼֤
  */
inline void Parser::putBack(int ch)
{
		/* ֹΤν */
    if(ch == '\n')
        current->line --;

		/* ȥ꡼Τν */
	PutBackCount ++;

    current->stream->putback(ch);
}

 /*
  *  Parser饹Υǥȥ饯
  */
Parser::~Parser(void)
{
	list<tagFile *>::iterator scope;

		/* ǸޤǥѡƤʤʤ顢ȤꤢåƤ */
	if(current != 0)
		fileStack.push_front(current);

		/* å˴ */
	scope = fileStack.begin();
	while(scope != fileStack.end())
	{
		if((*scope)->stream != 0 && (*scope)->stream != &cin)
			delete (*scope)->stream;		//ȥ꡼˴
		delete (*scope);					//¤ΤΥǡΰ˴

		++ scope;
	}

		/* ǰΤ */
	fileStack.clear();
	TokenStack.clear();
}


 /*
  *  ̻ҤڽФ (̻ = [a-zA-Z_][0-9a-zA-Z_]*)
  */
bool Parser::getIdentifier(Token & token,int ch)
{
	token.value = 0;

	do {
		token.value ++;
		token += static_cast<char>(ch);
        ch = getChar();
	} while( (ch >='a' && ch <= 'z') || (ch >='A' && ch <= 'Z') || (ch == '_') || (ch >= '0' && ch <= '9') );

	if(ch != -1)
		putBack(static_cast<char>(ch));

	token.type = Token::IDENTIFIER;
	return true;
}


 /*
  *  ǥ쥯ƥ֤ڽФȽ
  */
bool Parser::parseDirectives(Token & token, int ch, bool allow_space)
{
	Token directive;
	map<string, ParseUnit *>::iterator scope;

		//ɤФ
	do {
		token += static_cast<char>(ch);
		ch = getChar();
	} while(ch == ' ' || ch == '\t');
	
	if(ch >= '0' && ch <= '9')
	{
			//GNU-cpp lineǥ쥯ƥ к
		directive.assign("line");
		this->putBack(ch);
	}else
	{
			//ǥ쥯ƥ֤ɤ߽Ф
		putBack(ch);
		getToken(directive);
		token += directive;
	}

		//lineǥ쥯ƥ֤β
	if(directive.compare("line") == 0)
	{
		Token token;

		getToken(token, Token::INTEGER);
		setCurrentLine(token.value -1);

		getToken(token, Token::STRINGLITERAL);
		token.chopLiteral();
		setStreamIdentifier(token);

		return true;
	}

		//pragmaǥ쥯ƥ֤β
	if(directive.compare("pragma") == 0)	
	{
		getToken(directive);
		token += " ";
		token += directive;

		if((scope = Directive::container().find(directive)) != Directive::container().end())
		{
			(*scope).second->body(directive, *Container, *this, string(""));

				//;ʬʥȡɤФ
			if(!TokenStack.empty())
			{
				do {
					token = TokenStack.front();
					TokenStack.pop_front();
				} while(!TokenStack.empty() && !allow_space && token.type == Token::SPACE);

				return true;
			}
		}
	}

		//includeǥ쥯ƥ֤β
	if(directive.compare("include") == 0)
	{
		cerr << getStreamLocation() << Message(": Configurator found 'include' directive\nKernel configuration file must be preprocessed.\n",": #includeǥ쥯ƥ֤ȯޤ\n ͥ빽եCץץå̲ᤵɬפޤ\n");
		throw Exception("Illegal kernel configuration file","ʥͥ빽ե");
	}

	putBack(directive);
	return false;
}


 /*
  *  ʸڽФ
  *    ڡ,    #ǻϤޤäƲԤޤ    CΥȥ֥å
  *    2ϢΥå(//)Ԥޤ
  *    4ĤȤ߹碌
  */
bool Parser::getWhitespace(Token & token, int ch, bool allow_space)
{
	int prev;

	token.type = Token::SPACE;
	switch(ch)
	{
	case '/':
		ch = getChar();

		switch(ch)
		{
			/* ȥ֥å */
		case '*':
			token += "/*";
			prev = '\x0';
			while( ((ch = getChar()) != '/') || (prev!='*'))
			{
				token += static_cast<char>(ch);
				prev = ch;
			}
			token += static_cast<char>(ch);
			break;

			/* ֥륹å */
		case '/':
			token += '/';
			do {
				token += static_cast<char>(ch);
			} while( (ch = getChar()) != '\n' );
			break;

			/* '/'ǻϤޤäǤ */
		default:
			putBack(ch);
			return getOperator(token, '/');;
		}
		break;

		/* # ǻϤޤ */
	case '#':
			/* ǥ쥯ƥ̵֤ or ʥǥ쥯ƥ֤Τʤ */
		if(! (isenabled(DIRECTIVE) && parseDirectives(token, ch, allow_space)) )
		{
				//ԤޤɤФ
			TokenStack.clear();
			do {
				token += static_cast<char>(ch);
				ch = getChar();
			} while(ch != '\n');
			putBack(ch);
		}
		break;

		/* ¯˸ʸ */
	case ' ':
	case '\t':
	case '\n':
	case '\r':
		do {
			token += static_cast<char>(ch);
			ch = getChar();
		} while((ch == ' ') || (ch == '\n') || (ch == '\r') || (ch == '\t'));
		putBack(static_cast<char>(ch));
		break;
	}
	return true;
}


 /*
  *  ͤڽФ (8/10/16, /)
  *   2ʤɾäΤǤޤ
  */
bool Parser::getInteger(Token & token, int ch)
{
	bool minus = false; 

	if(ch == '-')
	{
		minus = true;
		ch = getChar();
		if(ch < '0' || ch >'9')
		{
			putBack(static_cast<char>(ch));
			return false;
		}
		token += "-";
	}

	token.type = Token::INTEGER;
	token.value = 0;


	if(ch == '0')
	{
		token += static_cast<char>(ch);
		ch = getChar();
		if(ch == 'x' || ch == 'X')
		{
			token += static_cast<char>(ch);
			ch = getChar();
			while((ch >= '0' && ch <= '9') || (ch >= 'a' && ch <= 'f') || (ch >= 'A' && ch <= 'F'))
			{
				token += static_cast<char>(ch);
				if((ch -= '0') >= 10)
				{
					ch = ch + '0' - 'A' + 10;
					if(ch >= 16)
						ch = ch - ('a' - 'A');
				}
				token.value = token.value * 16 + ch;
				ch = getChar();
			}
		}else
		{
			while(ch >= '0' && ch <= '7')
			{
				token += static_cast<char>(ch);
				token.value = token.value * 8 + ch - '0';
				ch = getChar();
			}
		}
	}else
	{
		do {
			token += static_cast<char>(ch);
			token.value = token.value * 10 + ch - '0';
			ch = getChar();
		} while(ch >= '0' && ch <= '9');
	}

	if(minus)
		token.value = - token.value;

	if(ch != -1)
		putBack(static_cast<char>(ch));

	return true;
}


 /*
  *  ڥ졼(üʸȹ礻ʤȡ)ڽФ
  */
bool Parser::getOperator(Token & token, int ch)
{
	const char * work;

		/* chڥ졼ʸǤ뤫ɤΤ */
	for(work = Operator;*work != '\x0' && *work != ch;work++);
	if(*work == '\x0')
		return false;

		/* ³ʸ⥪ڥ졼ʸǤ뤫ɤΤ */
	do {
		token += static_cast<char>(ch);
		ch = getChar();
		for(work = Operator;*work != '\x0' && *work != ch;work++);
	} while(*work != '\x0');

	putBack(ch);
	token.type = Token::OPERATOR;
	return true;
}


 /*
  *  ʸƥ (֥륯Ȥǳ줿ʸ)
  *    󥰥륯Ȥ褦ˤ
  */
bool Parser::getStringLiteral(Token & token, int delimitor)
{
	int ch;
	int prev;
	int position;
	int prev_line;

	prev_line = current->line;
	position  = current->stream->tellg();

	ch = delimitor;

	token.value = 1;
	token.type = Token::STRINGLITERAL;
    token.assign("");
    token += static_cast<char>(ch);

    while(!current->stream->bad() && !current->stream->eof())
    {
    	prev = ch;
	    ch = getChar();
        token += static_cast<char>(ch);
        token.value ++;

        if(ch == delimitor && prev != '\\')
            return true;
    }

		//äĤƺƥץ󤷤ơƥ볫Ϥ " μ˰ư
	
	current->line = prev_line;
	current->stream->seekg(position);
	current->stream->clear();

    throw Exception("Unterminated string literal appeared.","ĤƤʤʸƥ򸡽Фޤ");
    return false;
}


 /*
  *  ȡڽФ
  */
enum Token::tagTokenType Parser::getToken(Token & token, bool allow_space)
{
	int ch;
	const char * work;

	do {
		token.erase();
		token.type = Token::ERROR;
		token.value = 0;

			//ȡ󥹥åڤФ
		if(!TokenStack.empty())
		{
			do {
				token = TokenStack.front();
				TokenStack.pop_front();
			} while(!TokenStack.empty() && !allow_space && token.type == Token::SPACE);

			if(!allow_space && token.type != Token::SPACE)
				return token.type;
		}

			//ȥ꡼फڤФ
		if(current == NULL || current->stream == NULL || current->stream->bad())
		{
			token.assign("<End of stream>");
			return (token.type = Token::EOS);
		}

			//ȤΥȥ꡼बˤʤä
		if(current->stream->eof())
		{
				//ե륹å鼡Υȥ꡼
			if(!fileStack.empty())
			{
				if(current->stream != &cin)
					delete current->stream;
				delete current;
				
				current = *fileStack.begin();
				fileStack.pop_front();
			}else
			{
				token.assign("<End of stream>");
				return (token.type = Token::EOS);
			}
		}

		ch = getChar();

			//First(whitespaces) is [ \n\t\r/#]
		if( (ch == ' ') || (ch == '\t') || (ch == '\n') || (ch == '\r') || (ch == '/') || (isHeadofLine && ch == '#'))
		{
			if(ch == '\n')
				isHeadofLine = true;

			if(getWhitespace(token, ch, allow_space))
				if((token == Token::SPACE && allow_space) || !(token == Token::SPACE || token == Token::ERROR))
					return token.type;

			continue;
		}else
			break;
	}while(true);

    isHeadofLine = false;

    token.line = current->line;

		//First(identifier) is [a-zA-Z_]
	if(	(ch >='a' && ch <= 'z') || (ch >='A' && ch <= 'Z') || (ch == '_') )
		if(getIdentifier(token, ch))
			return Token::IDENTIFIER;

		//First(integer) is [\-0-9]
	if( (ch >='0' && ch <='9') || (ch == '-') )
		if(getInteger(token,ch))
			return Token::INTEGER;

		//First(string) is ["']
	if( ch == '"' || ch == '\'')
		if(getStringLiteral(token,ch))
			return Token::STRINGLITERAL;

		//Operator
	if(getOperator(token,ch))
		return Token::OPERATOR;

		//Punctuator
	work = Punctuator;
	while(*work != '\x0')
		if( *(work++) == ch )
		{
			token += static_cast<char>(ch);
			return (token.type = Token::PUNCTUATOR);
		}

	token += static_cast<char>(ch);
	token.type = Token::UNKNOWN;
	return Token::UNKNOWN;
}


 /*
  *  ȡ ȥ꡼४ڥ졼 (˥ƥŪ)
  */
ostream & operator << (ostream & out, Token & src)
{
	switch(src.type)
	{
	case Token::IDENTIFIER:
		out << "<IDENTIFIER:["; break;
	case Token::INTEGER:
		out << "<INTEGER:["; break;
	case Token::STRINGLITERAL:
		out << "<STRINGLITERAL:["; break;
	case Token::STRING:
		out << "<STRING:["; break;
	case Token::OPERATOR:
		out << "<OPERATOR:["; break;
	case Token::PUNCTUATOR:
		out << "<PUNCTUATOR:["; break;
	case Token::RESERVEDWORD:
		out << "<RESERVEDWORD:["; break;
	case Token::SPECIAL:
		out << "<SPECIAL:["; break;
	case Token::SPACE:
		out << "<SPACE:["; break;
	case Token::UNKNOWN:
		out << "<UNKNOWN>"; return out;
	case Token::ERROR:
		out << "<ERROR>"; return out;
	default:
		out << "<???:[";
	}

	return out << static_cast<string &>(src) << "]("<<src.value<<")>";
}


 /*
  *  ͽڽФ(Ȥǧ)
  */
void Parser::getToken(const char * term, const char * second, ...)
{
    Token token;
	va_list vl;

    if(term == NULL)
        throw Exception("Internal: GetToken received an empty string as reserved word.","顼: GetToken˶ʸϤޤ");

	va_start(vl, second);
	vl = (char *)vl - sizeof(const char *);

	do {
		getToken(token, false);
		if(token.compare(term) != 0)
		{
			lastErrorToken = token;
			throw Exception("Token [%s] should be replaced by [%s]","[%s][%s]Ǥ٤Ǥ").format(token.c_str(),term);
		}
		term = va_arg(vl, const char *);
	}while(term != 0);
}

string Parser::getStreamLocation(void)
{
	list<tagFile *>::iterator scope;

	string location;
	char buffer[16];

	if(current == 0)
		return string("");

	::sprintf(buffer, ":%d", current->line);
	location += current->identifier;
	location += buffer;

	if(!fileStack.empty())
	{
		location += " (included at ";

		scope = fileStack.begin();
		while(scope != fileStack.end())
		{
			::sprintf(buffer, ":%d, ", (*scope)->line);
			location += (*scope)->identifier;
			location += buffer;

			++ scope;

		}

		location.erase(location.size()-2);
		location += ")";
	}

	return location;
}

void Parser::pushStream(const std::string & filename, std::string strid)
{
	fstream * fin;

	if(current != 0)
		fileStack.push_front(current);
		
	fin = new fstream(filename.c_str(),ios::in);

	if(fin->is_open())
	{
		if(strid.size() == 0)
			strid = filename;

		current = new tagFile;
		current->stream     = fin;
		current->identifier = strid;
		current->line       = 1;
	}else
	{		
		throw Exception("File operatation failure : [%s]","ե˼Ԥޤ [%s]").format(filename.c_str());
		delete fin;
	}
}

void Parser::pushStdStream(std::string strid)
{
	stringstream * work = new stringstream;
	char buffer[1024];
	int  count;

		//ɸϤξ򤹤٤Ƽ (顼нѤ seekg/tellg Ȥ)
	do {
		cin.read(buffer, 1024);
		count = cin.gcount();
		work->write(buffer, count);
	} while(count != 0);

	if(current != 0)
		fileStack.push_front(current);

	current = new tagFile;
	current->stream     = work;
	current->identifier = strid;
	current->line       = 1;
}

string * Parser::setLogBuffer(string * buffer)
{
	string * old = LogBuffer;
	LogBuffer = buffer;
	PutBackCount = 0;
	return old;
}

streampos Parser::getLogBufferPos(int offset)
{
	streampos pos;
	
	pos = 0;
	if(LogBuffer != 0)
		pos = LogBuffer->size();
	pos += offset - PutBackCount;
	return pos;
}

void Parser::doPreProcess(const char * cmd)
{
	string         tempfilename;
	char           buffer[1024];
	int            count;
	fstream        tempfile;
	string         work;
	stringstream * stream;

	if(current == NULL || current->stream == NULL)
		throw Exception("No stream specified for processing","оݤȤʤ륹ȥ꡼बꤵƤޤ");


		/* Υȥ꡼Ƥ򤹤٤ƥƥݥ˽񤭽Ф */

	strcpy(buffer,"cfgXXXXXX");
	mktemp(buffer);

	tempfilename.assign(buffer);
	tempfile.open(tempfilename.c_str(),ios::out);

	if(!tempfile.is_open())
		throw Exception("Failed to open a temporary file","ƥݥեκ˼Ԥޤ");

	do {
		current->stream->read(buffer, 1024);
		count = current->stream->gcount();
		tempfile.write(buffer, count);
	} while(count != 0);
	tempfile.close();


		/* ȥ꡼ູؤ */

	preprocessname = tempfilename;
	originalname   = current->identifier;

	if(current->stream != &cin)
		delete current->stream;
	stream = new stringstream;
	current->stream = stream;


		/* ץץåεư & Ϥμ */

	work  = string(cmd) + " " + tempfilename;
	VerboseMessage(" Start the external preprocessor [%s]\n"," ץưޤ [%s]\n").format(work.c_str());

	FILE * pipe = popen(work.c_str(),"r");
	while(feof(pipe) == 0)
		stream->put((char)fgetc(pipe));

	pclose(pipe);
	remove(tempfilename.c_str());
	isHeadofLine = true;
}



ParseUnit::ParseUnit(void * _container, const char * name)
{
	map<string, ParseUnit *> * container;
    string work(name);
	string apiname;
	string::size_type i,j;

	i = 0;
	container = reinterpret_cast<map<string, ParseUnit *> *>(_container);
	
	do {
		j = work.find_first_of(',', i);
		apiname = work.substr(i, j-i);

		if(container->find(apiname) != container->end())
	        throw Exception("Multiple registration of [%s]\n","[%s]ʣϿ褦ȤƤޤ").format(apiname.c_str());
	    (*container)[apiname] = this;
		i = j + 1;
	}while(j != string::npos);
}

void ParseUnit::printList(void * _container)
{
    int i;
	map<string, ParseUnit *> * container;
    map<string, ParseUnit *>::iterator scope;

	container = reinterpret_cast<map<string, ParseUnit *> *>(_container);
    if(container->empty())
    {
        cerr << "  " << Message("None of element registed\n", "ϿƤǤϤޤ\n");
        return;
    }

    i = 0;
    scope = container->begin();
    while(scope != container->end())
    {
        cerr << '[' << (*scope).first << "] ";

        if(i++ >= 6)
        {
            i = 0;
            cerr << '\n';
        }

        ++ scope;
    }

    if(i != 0)
        cerr << '\n';
}

Token & ParseUnit::parseParameter(Parser & p)
{
	static Token result;
	Token token;
	int nest = 0;

	result.type = Token::ERROR;
	result.value = 0;
	result.assign("");

	do
	{
		p.getToken(token);
		if(token == Token::PUNCTUATOR)
		{
			if(token.compare("(") == 0)
				nest ++;
			else if(token.compare(")") == 0)
				nest --;
			else if(nest == 0)
				break;
			if(nest < 0)
				throw Exception("')' appeared before '('.","бʤĤ̤ޤ");
		}

		if(result == Token::ERROR)
			result = token;
		else
		{
			result.type = Token::STRING;
			result += ' ';
			result += token;
		}

	}while(true);

	p.putBack(token);
	result.trim();
	return result;
}

int ParseUnit::parseParameters(Parser & p, Directory * container, int min, int max)
{
	Token work;
	int count = 0;

	if(max == 0)
		max = min;

	do
	{
		Token & token = parseParameter(p);
		if(token.type == Token::ERROR)
			break;

		if(token == Token::INTEGER)
			container->addChild(new Directory(token.value));
		else
			container->addChild(new Directory((string &)token));

		count ++;
		p.getToken(work);
	}while(work.compare(",")==0 && count < max);

	if(count < min)
		throw Exception("Too few parameters [%d/%d]","ѥ᡼οʤޤ [%d/%d]").format(count, min);

	p.putBack(work);
	return count;
}

int ParseUnit::parseParameters(Parser & p, Directory * container, const char * paramlist)
{
	Token work;
	int count;
	string list;
	string key;
	string::size_type head,tail;

	list.assign(paramlist);

	count = 0;
	head = 0;
	tail = list.find_first_of(',');
	key = list.substr(head,tail-head);

	do
	{
		if(head == string::npos)
			Exception("Too many parameters","ѥ᡼ο¿ޤ");

		Token & token = parseParameter(p);
		if(token.type == Token::ERROR)
			break;

		if(token == Token::INTEGER)
			container->addChild(key,new Directory(token.value));
		else
			container->addChild(key,new Directory((string &)token));

		if(tail != string::npos)
		{
			head = tail + 1;
			tail = list.find_first_of(',',head);
			key = list.substr(head,tail != string::npos ? tail-head : string::npos);
			count ++;
			p.getToken(work);
		}else
			break;
	}while(work.compare(",")==0);

	if(tail != string::npos)
		throw Exception("Too few parameters","ѥ᡼οʤޤ");

	return count;
}

//------

Directory * StaticAPI::last = NULL;

map<std::string, class ParseUnit *> & StaticAPI::container(void)
{
	static map<std::string, class ParseUnit *> _container;
	return _container;
}

Directory * StaticAPI::allocate(Directory & container, const Token & token, const char * id, bool regist)
{
	static unsigned int assignment_count = 0;
	Directory * node;

	if(!(token == Token::IDENTIFIER || token == Token::INTEGER))
		throw Exception("Given token(%s) is not suitable for an object identifier.","֥Ȥμ̾ȤѤǤʤ(%s)ꤵޤ").format(token.c_str());

	if(regist && (token == Token::INTEGER && token.value <= 0))
		throw Exception("Cannot assign an ID number less or equal to 0.","0ʲIDֹꤹ뤳ȤϤǤޤ");


	node = container.findChild(id);
	if(node != 0)
	{
		Directory::iterator scope;

		scope = node->begin();
		while(scope != node->end())
		{
			if((*scope).first.compare(token) == 0)
				throw Exception("Identifier %s is already used.","̾%sϤǤѤƤޤ").format(token.c_str());
			++ scope;
		}
	}else
		node = container.addChild(id);

	node = node->addChild(token);
	(*node)["#order"] = assignment_count++;

	if(token == Token::IDENTIFIER)
	{
		if(regist)
		{
			Directory * scope = container.openChild("/","identifier",token.c_str(),NULL);
			if(*scope == Directory::INTEGER)
				*node = scope->toInteger();
		}
	}else
		*node = token.value;

	last = node;
	return node;
}

//------

map<std::string, class ParseUnit *> & Directive::container(void)
{
	static map<std::string, class ParseUnit *> _container;
	return _container;
}

//------

ParserComponent::ParserComponent(void) : Component(PARSER)
{}

ParserComponent::~ParserComponent(void)
{}

void ParserComponent::parseOption(Directory & container)
{
    if(findOption(container, "h", "help"))
    {
        cerr << Message(
            "Static API parser\n"
            "  -s, --source=filename     : Specify the source file\n"
			"  -idir ,--ignore-directive : Ignore directives\n"
            "  -iapi ,--ignore-api       : Ignore unknown static api\n"
			"  -t, --through             : Get unprocessed APIs through\n"
            "  --print-api               : Show registered static api list\n", 
            "ŪAPIѡ\n"
            "  -s, --source=ե̾   : ϥե̾ꤷޤ\n"
			"  -idir ,--ignore-directive : ǥ쥯ƥ֤βϤԤޤ\n"
            "  -iapi, --ignore-api       : ϿƤʤAPI̵뤷ޤ\n"
			"  -t, --through             : ʤäAPI̲ᤵޤ\n"
            "  --print-api               : ϿƤAPIΰɽޤ\n");
        return;
    }

    if(findOption(container, 0, "print-api"))
    {
		cerr << Message("List of Registerd Static API\n","ŪAPI \n");
        StaticAPI::printList();
        return;
    }

	checkOption(container, "idir", "ignore-directive");
	checkOption(container, "iapi", "ignore-api");
	checkOption(container, "t", "through");

	checkOption(container, "s", "source");

	if(mergeOption(container, "s", DEFAULT_PARAMETER) != 0 || mergeOption(container, "s", "-source") != 0)
		activateComponent();
}

bool ParserComponent::parseStaticAPI(Parser & p, Directory & container, Token token, const string domain)
{
	bool isParseErrorOccured;
    map<string, ParseUnit *>::iterator api;
	Directory * node;

    if(token.type != Token::IDENTIFIER)
        return false;

	isParseErrorOccured = false;
	StaticAPI::clearLastObject();
	node = container[PARSERESULT].addChild();

	try {
		node->addChild("api",new Directory(token));
		node->addChild("begin",new Directory((long)p.getLogBufferPos(-(int)token.size()-1)));
		if(!domain.empty())
			node->addChild("domain", new Directory(domain));

		api = StaticAPI::container().find(token);
	    if(api == StaticAPI::container().end())
	    {
	        if(ignoreUnknownAPI)
	        {
				cerr << Message("%s: Unknown static api %s was ignored. (skipped)\n","%s: ϿAPI %s ̵뤵ޤ\n").format(p.getStreamLocation().c_str(),token.c_str());
	            do {
	                p.getToken(token);
	            }while(token.compare(";") != 0);
				node->addChild("end",new Directory((long)p.getLogBufferPos()));
				(*node) = (long)0;
	            return true;
	        }
	        throw Exception("Static API [%s] is not registered in the configurator", "ŪAPI[%s]̤ϿǤ").format(token.c_str());
		}

		DebugMessage("  StaticAPI [%s]\n","  ŪAPI  [%s]\n").format((*api).first.c_str());

	    p.getToken("(");

		(*api).second->body(token, container, p, domain);

	    p.getToken(")");
	    p.getToken(";");

		node->addChild("end",new Directory((long)p.getLogBufferPos()));
		(*node) = (long)1;
	}
	catch(Exception & e)
	{
		int offset;
		string work;
		work = p.getStreamLocation() + (const char *)Message(":[Error] ",":[顼] ") + (const string &)e;
		isParseErrorOccured = true;

		dumpContainerSnapshot(container);
		StaticAPI::dropLastObject();
		failCount ++;

		offset = 0;
		token = p.getLastErrorToken();
		while (token != Token::ERROR && token != Token::EOS)
		{
			if( token == ";" )
				break;

				//ɤ߽ФȡŪAPIƱ̾ʤ äȥߥ˺
		    api = StaticAPI::container().find(token);
			if(api != StaticAPI::container().end())
			{
				cerr << Message("<The following error must be occured by lack of ';' at the end of previous line>\n","<Υ顼ľԤ';'˺ˤǽ⤤Ǥ>\n");
				offset = -(int)token.size();
				p.putBack(token);
				break;
			}

			p.getToken(token);
        }

		node->addChild("end",new Directory((long)p.getLogBufferPos(offset)));
		(*node) = (long)0;

		cerr << work << '\n';

		throw Exception("Fatal error on Static API parsing","ŪAPIιʸϤ˼Ԥޤ");
	}

    return true;
}

/*
 *  ǤʤäAPIɸϤǤФ
 */
void ParserComponent::throughConfigurationFile(string & log, Directory & container)
{
	Directory *        node;
	string::size_type  pos;
	string::size_type  begin;
	string::size_type  end;

	pos = 0;
	end = 0;

	node = container[PARSERESULT].getFirstChild();
	while(node != NULL)
	{
		begin = static_cast<string::size_type>((*node)["begin"].toInteger());
		end   = static_cast<string::size_type>((*node)["end"].toInteger());

		if(pos < begin)
			cout << log.substr(pos, begin - pos);

		if(node->toInteger() == 0)
		{
			cout << log.substr(begin, end - begin);
		}else
		{
			for(pos = begin; pos < end; ++pos)
				if( log.at(pos) == '\n' )
					cout << '\n';
		}
		node = node->getNext();
	}

	if(end < log.size())
		cout << log.substr(end);

	throw Exception("","");
}


void ParserComponent::body(Directory & container)
{
    Token token;
    Parser p(container);
    Directory * scope;
	string logbuffer;

	failCount = 0;
	
		//idirץν
	if(findOption(container, "idir","ignore-directive"))
		p.disable(Parser::DIRECTIVE);

	ignoreUnknownAPI = findOption(container, "iapi", "ignore-api");

	if(findOption(container,"t","through"))
	{
		p.setLogBuffer(&logbuffer);
		ignoreUnknownAPI = true;
	}

		//ϥ
	scope = getOption(container, "s");
    if(scope->size() == 0)
    {
        scope = 0;
        p.pushStdStream(Message("Standard Input","ɸ"));
        VerboseMessage("Starting parse with standard input\n","ɸϤλϤ򳫻Ϥޤ\n");
    }else
		scope = scope->getFirstChild();

    try{
        do {
            if(scope != 0)
            {
                VerboseMessage("Starting parse with file[%s]\n","ե[%s]λϤ򳫻Ϥޤ\n").format((const char *)*scope);
				p.pushStream(*scope);
            }

			this->parse(p, container);

			if(p.getToken(token) != Token::EOS)
                throw Exception("Buffer has remaining tokens, parsing is not yet finished", "ѡǤޤ");

			if(failCount != 0)
				throw Exception("Total %d failures found in this configuration.","%dĤξ㳲ޤ").format(failCount);

            VerboseMessage("Parse finished\n","Ϥ˽λޤ\n");

        } while(scope != 0 && (scope = scope->getNext()) != 0);

		if(findOption(container,"t","through"))
			throughConfigurationFile(logbuffer,container);

		container[PARSERESULT].erase();
    }
    catch(Exception & e)
    {
		string work;

		work = p.getStreamLocation() + (const char *)Message(":[Error] ",":[顼] ") + (const string &)e;
		throw Exception(work.c_str(),work.c_str());
    }
}

