/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: singleton.cpp,v 1.3 2003/11/10 07:51:14 monaka Exp $
 */
// $Header: /cvsroot/toppers-utils/if40/cfg/base/singleton.cpp,v 1.3 2003/11/10 07:51:14 monaka Exp $

#include "base/singleton.h"
//#include "base/testsuite.h"

using namespace std;

	//ƤΥ󥰥ȥ󥤥󥹥󥹤ǤƤ뤫ɤ
bool SingletonBase::is_valid = true;

    //atexit¹Ԥɤ
bool SingletonBase::initialize = false;

    //ǥȥ饯
struct SingletonBase::chain * SingletonBase::top  = 0;
struct SingletonBase::chain * SingletonBase::tail = 0;


    //ϿƤ륷󥰥ȥ
void SingletonBase::final_release(void) throw()
{
    while(top != 0) {
        struct chain * node = top;
        top = node->next;

        (*node->destructor)();

        delete node;
    }
    tail = 0;
}

    //ǥȥ饯ɲ
bool SingletonBase::addDestructor(void (* destructor)(void)) throw()
{
    bool result = false;
    chain * node = new(nothrow) chain;
    if(node != 0) {

        node->next       = 0;
        node->destructor = destructor;
        
        if(tail == 0)
            top = tail = node;
        else
            tail->next = node;

        result = true;

        if(!initialize) {
            atexit(final_release);
            initialize = true;
        }
    }
    else {
            //ǥȥ饯˼
        (*destructor)();
        is_valid = false;
    }
    return result;
}


