/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: singleton.h,v 1.3 2003/11/10 07:51:14 monaka Exp $
 */
// $Header: /cvsroot/toppers-utils/if40/cfg/base/singleton.h,v 1.3 2003/11/10 07:51:14 monaka Exp $

#ifndef SINGLETON_H
#define SINGLETON_H

#ifdef _MSC_VER
#  pragma warning(disable:4290)	//C++ 㳰λ̵뤵ޤؿ __declspec(nothrow) ǤʤȤΤɽޤ
#  pragma warning(disable:4291) //ɤ㳰򥹥ȡ'new' 黻ҤѤƤȥޤ (кѤ)
#endif

//#include "base/testsuite.h"

#include <new>
#include <stdexcept>

/*
 *  󥰥ȥѥ 
 */
class SingletonBase {
public:
    struct chain {
        struct chain * next;
        void (*destructor)(void);
    };

		//󥰥ȥǥ󥹥󥹤Ȥ򼨤Υ饹
		//    Υ饹Singleton餷βǤʤΤǡ
		//    ۤΥ饹餳ˤĥ󥹥ȥ饯Ѥ뤳ȤϤǤʤ
	class SingletonConstructionLocker
	{
	friend class SingletonBase;
	protected:
		SingletonConstructionLocker() {}
	};

private:
    static bool   initialize;
    static bool   is_valid;
    static struct chain * top;
    static struct chain * tail;

        //ϿƤ륷󥰥ȥ
    static void final_release(void) throw();

protected:
        //ǥȥ饯ɲ
    static bool addDestructor(void (* destructor)(void)) throw();

		//SingletonConstructionLockerեȥ
	inline static SingletonConstructionLocker getLocker(void)
	{	return SingletonConstructionLocker();   }

public:
    inline static bool isValid(void) throw()
    {   return is_valid;   }

    //TESTSUITE_PROTOTYPE(main);
};


template<class T>
class Singleton : SingletonBase
{
protected:
    Singleton(void);
    ~Singleton(void);

    static T * instance;

    static void destructor(void) throw()
    {
        if(instance != 0) {
            delete instance;
            instance = 0;
        }
    }

    static T * createInstance(std::nothrow_t) throw()
    {
        T * instance = 0;
        try {
            instance = new(nothrow) T(getLocker());

            if(instance != 0) {
                if(!addDestructor(destructor))
                    throw false;    //catch¹Ԥ
            }
        }
        catch(...) {
            if(instance != 0) {
                try { delete instance; } catch(...) {}
                instance = 0;
            }
        }
        return instance;
    }

    static T * createInstance(void) throw(std::bad_alloc)
    {
        instance = createInstance(nothrow);
        if(instance == 0)
            throw std::bad_alloc();
        return instance;
    }

public:
    inline static T * getInstance(void) throw(std::bad_alloc)
    {
        if(instance == 0)
            instance = createInstance();
        return instance;
    }

    inline static T * getInstance(std::nothrow_t) throw()
    {
        if(instance == 0)
            instance = createInstance(nothrow);
        return instance;
    }
};

template<class T> T *          Singleton<T>::instance        = 0;

#define SINGLETON_CONSTRUCTOR(x)  explicit x(const SingletonBase::SingletonConstructionLocker &)
#define SINGLETON_CONSTRUCTOR_(x) explicit x(const SingletonBase::SingletonConstructionLocker & _singleton)

#define SINGLETON_WRAPPER(derived, base) class derived : public base { SINGLETON_CONSTRUCTOR_(derived) throw() : base(_singleton) {} };

#endif /* SINGLETON_H */

