/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: if40_parser.cpp,v 1.9 2003/11/19 07:00:37 monaka Exp $
 */

// $Header: /cvsroot/toppers-utils/if40/cfg/if40/if40_parser.cpp,v 1.9 2003/11/19 07:00:37 monaka Exp $

#include <stdarg.h>

#include "if40_defs.h"
#include "parser.h"
#include "mpstrstream.h"
#include <set>
#include <map>

using namespace std;

class CoreParser : public ParserComponent
{
protected:
	int assignID(Directory & container, const char * category);
    virtual void parseOption(Directory &);  
public:
	CoreParser(void);
	virtual bool parse(Parser & p, Directory & container);
} instance_of_Parser;

CoreParser::CoreParser(void)
{
	bootBanner().assign("=== TOPPERS/JSP Kernel Configurator ver.9.2 (for JSP rel 1.3 (pl=1)) ===");
}


void CoreParser::parseOption(Directory & container)
{
	ParserComponent::parseOption(container);

	if(findOption(container,"h","help"))
	{
        cerr << Message(
			"  -obj, --dump-object=filename : Dump the object tree into the file specified\n"
            "  -ao, --assign-order=order : Specify the order of automatic ID assignment\n"
			"    You can use three terms below as ordering rule.\n"
            "     alphabetic (in alphabetic order)\n"
			"     fcfs       (in arrival order [as default])\n"
			"     reverse    (reverse the order)\n"
            "  -1.3  : Generates kernel_cfg.c for TOPPERS/JSP rel 1.3\n",
			"  -obj, --dump-object=ե̾ : ꤷե˥֥ȾϤޤ\n"
            "  -ao, --assign-order= : ưIDγꤷޤ\n"
			"    ϼ3Ĥȹ礻ǻꤷޤ.\n"
            "     alphabetic (ABC), fcfs ( [ǥե]), reverse (ս)\n"
            "  -1.3  : TOPPERS/JSP rel 1.3 ѤΥե졼եޤ\n");
        return;
	}

	checkOption(container,"cpu","cpu");
	checkOption(container,"system","system");
	checkOption(container,"1.3","1.3");
}


static long getIDSize(Directory & container, const char * name)
{
	Directory * node = container[DYNAMICID].findChild(name,NULL);
	Directory * dynamic = node->getFirstChild();

	long idsize = dynamic->toInteger(0);
	return idsize;
}


static int displayDynamicID(Directory & container)
{
	Directory * node;
	Directory * category;
	Directory * scope;

	node = container.findChild(DYNAMICID,NULL);
	if(node == 0 || node->size() == 0)
		return 0;

	VerboseMessage("Dynamic ID list\n","ưŪIDɽ\n");

	category = node->getFirstChild();
	while(category != 0)
	{
		scope = category->getFirstChild();
		VerboseMessage::print(category->format("$@: "));
		VerboseMessage::print(scope->format("$@\n"));

		category = category->getNext();
	}

	return node->size();
}

static int displayHandler(Directory & container, const char * category, const char * format)
{
	Directory * node;
	Directory * scope;

	node = container.findChild(OBJECTTREE,category,NULL);
	if(node == 0 || node->size() == 0)
		return 0;

	VerboseMessage("Handler assignment list [%s]\n","ϥɥɽ [%s]\n").format(category);

	scope = node->getFirstChild();
	while(scope != 0)
	{
		VerboseMessage::print(scope->format(format));
		scope = scope->getNext();
	}

	return node->size();
}

int CoreParser::assignID(Directory & container, const char * category)
{
	Directory * node;
	Directory * scope;
	Directory * work;
	set<int> idpool;
	map<int, Directory *> sorter;
	map<int, Directory *>::iterator p_sorter;
	enum tagAssignmentOrder { UNKNOWN, ALPHABETIC, FCFS, REVERSE=0x80, REVERSE_ALPHABETIC, REVERSE_FCFS } order;
	int i;

		//ѥ᡼
	i = FCFS;
	node = getOption(container,"ao","assign-order");
	if(node != 0)
	{
		scope = node->getFirstChild();
		while(scope != 0)
		{
			string param = scope->toString();
			if(param.compare("alphabetic") == 0 || param.compare("ALPHABETIC") == 0)
				i = (i & 0xf0) | ALPHABETIC;
			else if(param.compare("fcfs") == 0 || param.compare("FCFS") == 0)
				i = (i & 0xf0) | FCFS;
			else if(param.compare("reverse") == 0 || param.compare("REVERSE") == 0)
				i |= REVERSE;

			scope = scope->getNext();
		}
	}
	order = static_cast<enum tagAssignmentOrder>(i);

		//
	node = container.findChild(OBJECTTREE,category,NULL);
	if(node == 0)
		return 0;

	for(i=1;i< (signed int) node->size() + 32; i++)
		idpool.insert(i);

		//սηȡѤIDκ
	i = 0;
	scope = node->getFirstChild();
	while(scope != 0)
	{
		if( *scope == Directory::INTEGER )
			idpool.erase(*scope);
		else
		{
				//ʣ̾Τ¸ߥå
			work = container.openChild("/","identifier",scope->getKey().c_str(),NULL);
			if( *work == Directory::INTEGER)
			{
				VerboseMessage("Assigning the same ID (%d) since the name (%s[%s]) is duplicated\n","IDֹ(%d)ۼƱ̾Υ֥(%s[%s])˳Ƥޤ\n").format(work->toInteger(),scope->getKey().c_str(),category);
				idpool.erase(*scope = work->toInteger());
			} else
			{
					//ˡ˽äƳɲ
				switch(order)
				{
				case ALPHABETIC:
					sorter[i++] = scope;
					break;
				case REVERSE_ALPHABETIC:
					sorter[i--] = scope;
					break;
				case FCFS:
				default:
					sorter[scope->openChild("#order")->toInteger()] = scope;
					break;
				case REVERSE_FCFS:
					sorter[-scope->openChild("#order")->toInteger()] = scope;
					break;
				}
			}
		}
		scope = scope->getNext();
	}

		//ID
	p_sorter = sorter.begin();
	while(p_sorter != sorter.end())
	{
		scope = (*p_sorter).second;
		if( !(*scope == Directory::INTEGER) )
		{
			i = *(idpool.begin());
			idpool.erase(idpool.begin());

			work = container.openChild("/","identifier",scope->getKey().c_str(),NULL);
			*work = i;
			*scope = i;
		}
		++ p_sorter;
	}

		//ɽ
	if(node->size() != 0 && VerboseMessage::getVerbose())
	{
		VerboseMessage("Object ID assignment list [%s]\n","֥IDɽ [%s]\n").format(category);

		sorter.clear();
		scope = node->getFirstChild();
		while(scope != 0)
		{
			sorter[scope->toInteger()] = scope;
			scope = scope->getNext();
		}

		p_sorter = sorter.begin();
		while(p_sorter != sorter.end())
		{
			VerboseMessage("  %3d : %s\n","  %3d : %s\n").format((*p_sorter).first, (*p_sorter).second->getKey().c_str());
			++ p_sorter;
		}
	}

	return node->size();
}

bool CoreParser::parse(Parser & p, Directory & container)
{
	Token token;
	bool isParseErrorOccured;
	multimap<int, const char *> sorter;
	multimap<int, const char *>::iterator scope;

	try{
		isParseErrorOccured = false;
		do {
			p.getToken(token);
			if(token == Token::IDENTIFIER)
			{
					/* 顼Ƥ³Τǡ
						ȤФƤƤɤɤ³ */
				try 
				{	this->parseStaticAPI(p, container, token);	}
				catch(...)
				{	isParseErrorOccured = true;					}

			}
		}while(token != Token::EOS);

		p.setLogBuffer(NULL);

		if(isParseErrorOccured)
			throw Exception(Exception::FATAL,"The configuration process was aborted due to occurence of parse error","ʸϤ˼ԤǤޤ");

		if(container[OBJECTTREE "/" TASK].size() == 0)
			throw Exception("Kernel requires one or more task objects.","֥Ȥޤ");

		sorter.insert(pair<int, const char *>(container[OBJECTTREE "/" TASK].size(), TASK));
		sorter.insert(pair<int, const char *>(container[OBJECTTREE "/" SEMAPHORE].size(), SEMAPHORE));
		sorter.insert(pair<int, const char *>(container[OBJECTTREE "/" EVENTFLAG].size(), EVENTFLAG));
		sorter.insert(pair<int, const char *>(container[OBJECTTREE "/" DATAQUEUE].size(), DATAQUEUE));
		sorter.insert(pair<int, const char *>(container[OBJECTTREE "/" MAILBOX].size(), MAILBOX));
		sorter.insert(pair<int, const char *>(container[OBJECTTREE "/" FIXEDSIZEMEMORYPOOL].size(), FIXEDSIZEMEMORYPOOL));
		sorter.insert(pair<int, const char *>(container[OBJECTTREE "/" CYCLICHANDLER].size(), CYCLICHANDLER));

		sorter.insert(pair<int, const char *>(container[OBJECTTREE "/" VARSIZEMEMORYPOOL].size(), VARSIZEMEMORYPOOL));
		sorter.insert(pair<int, const char *>(container[OBJECTTREE "/" MESSAGEBUFFER].size(), MESSAGEBUFFER));
		sorter.insert(pair<int, const char *>(container[OBJECTTREE "/" MUTEX].size(), MUTEX));
		sorter.insert(pair<int, const char *>(container[OBJECTTREE "/" RENDEZVOUSPORT].size(), RENDEZVOUSPORT));

		sorter.insert(pair<int, const char *>(container[OBJECTTREE "/" INTERRUPTSERVICE].size(), INTERRUPTSERVICE));

		scope = sorter.begin();
		while(scope != sorter.end())
		{
			if( (*scope).first != 0 )
				assignID(container, (*scope).second);
			++ scope;
		}


		displayHandler(container, EXSERVICECALL, "  $@ : $(svcrtn)\n");
		displayHandler(container, INTERRUPTHANDLER, "  $@ : $(inthdr)\n");
		displayHandler(container, EXCEPTIONHANDLER, "  $@ : $(exchdr)\n");
		displayHandler(container, INITIALIZER, "  $@ : $(inirtn)($(exinf))\n");
		displayHandler(container, FINALIZER, "  $@ : $(finrtn)($(exinf))\n");

		displayDynamicID(container);

		return true;
	}
	catch(Exception & e)
	{		throw e;		}
}

/* ======================================================================== */

DECLARE_DIRECTIVE(assigner,"assign_id")
{
	Token name;
	Token value;

	p.getToken(name, Token::IDENTIFIER);
	p.getToken(value, Token::INTEGER);

	if(value.value <= 0)
		throw Exception("Cannot assign an ID number less or equal to 0.","0ʲIDֹꤹ뤳ȤϤǤޤ");

	*container.openChild("/","identifier",name.c_str(),NULL) = value.value;
}

DECLARE_DIRECTIVE(parameter,"parameter")
{
	Token token;
	string key;
	string::size_type i,j;

	do {
		p.getToken(token);
		if(!(token == Token::STRINGLITERAL))
			throw Exception("parameter pragma requires additional parameter put in '\"...\"'","parameterץ饰ޤˤ\"...\"ǳ줿ɲåѥ᡼ɬפǤ");

		token.chopLiteral();

		if(token[0] == '-')
		{
			i = token.find_first_of('=');
			j = token.find_first_not_of('-');
			if(i == j || j == string::npos)
                throw Exception(Exception::FATAL,"Wrong option [%s]","ʥץ [%s]").format(token.c_str());

			if(i != string::npos)
			{
				key = DEFAULT_PARAMETER;
				*container.openChild(string("/Parameter/") + token.substr(1, i-1)) = token.substr(i+1);
			}
			else
			{
				key = token.substr(1);
				*container.openChild(string("/Parameter/") + key) = string("");
			}
		}else
			*container.openChild(string("/Parameter/") + key) = token;

		p.getToken(token);
	} while(token.compare(",") == 0);

	p.putBack(token);
}


/* ======================================================================== */
class ConfigurationFileGenerator : public Component
{
protected:
	bool libstyle_include;
	bool restrict_zero;
	bool def_prototype;

	enum tagDefinition { HEADER=1, TNUM=2, BUFFER=4, DEFINITION=8, CONTROLBLOCK=16, SHORT_ID=32, TNUMNO=64, INIT=128, PROTOTYPE=256, INITLIST=512 };
  void createObjectDefinition(mpstrstream *, Directory &, long, int, ...);
  void ConfigurationFileGenerator::createReservedID(mpstrstream * out, Directory & container, const char* sym);

	virtual void parseOption(Directory &);
	virtual void body(Directory &);
	virtual void onFatalExit(Directory &);

public:
	ConfigurationFileGenerator(void) : Component(CODEGENERATOR) {};
} instance_of_Configurator;

void ConfigurationFileGenerator::parseOption(Directory & parameter)
{
	string work;
	mpstrstream * stream;

	if(findOption(parameter,"h","help"))
	{
        cerr << endl << Message(
			"Kernel configuration file generator\n"
            "  -id, --kernel_id=filename  : Specify the name of ID assignment file\n"
            "  -cfg,--kernel_cfg=filename : Specify the name of kernel configuration file\n"
			"  -il, --include-libstyle    : Use #include <...> style for kernel headers\n"
			"  -oproto, --output-prototype: Output task prototype definitions in kernel_cfg\n"
			"  -z, --nonzero              : Do not output ZERO macro and related definitions\n",
			"ͥ빽ե\n"
            "  -id, --kernel_id=ե̾  : IDե̾ꤷޤ\n"
            "  -cfg,--kernel_cfg=ե̾ : ͥ빽ե̾ꤷޤ\n"
			"  -il, --include-libstyle      : ͥΥإåե<...>ηǽϤޤ\n"
			"  -oproto, --output-prototype  : Τʤɤkernel_cfg.cޤ\n"
			"  -z, --nonzero                : ZEROޥλѤ¤ޤ\n");
        return;
	}

		/*
		 *  ͥ륳ե졼̤Υե (kernel_cfg.c) ν
		 */
	if(!findOption(parameter,"cfg","kernel_cfg",&work))
		work.assign("kernel_cfg.c");

	stream = new mpstrstream(work);
	stream->createpart("header","include",TASK,SEMAPHORE,EVENTFLAG,DATAQUEUE,MAILBOX,FIXEDSIZEMEMORYPOOL,CYCLICHANDLER,INTERRUPTHANDLER,EXCEPTIONHANDLER,KERNELBUFFER,INITIALIZER,TERMINATOR,OBJECT_INITIALIZER,VARSIZEMEMORYPOOL,ALARMHANDLER,OVERRUNHANDLER,ATTACHED_ISR,INTERRUPTSERVICE,MESSAGEBUFFER,MUTEX,RENDEZVOUSPORT,EXSERVICECALL,"others",NULL);
	parameter[KERNEL_CFG] = stream;


		/*
		 *  IDշ̤Υե (kernel_id.h) ν
		 */
	if(!findOption(parameter,"id","kernel_id",&work))
		work.assign("kernel_id.h");

	stream = new mpstrstream(work);
	stream->createpart("header","body","footer",NULL);
	(*stream)["header"] << "#ifndef __KERNEL_ID_H\n#define __KERNEL_ID_H\n\n";
	(*stream)["footer"] << "\n#endif /* __KERNEL_ID_H */\n";
	parameter[KERNEL_ID] = stream;

		/* ¾ץ */
	restrict_zero = findOption(parameter,"z","zero");
	def_prototype = findOption(parameter,"oproto","output-prototype");
	libstyle_include = findOption(parameter,"il","include-libstyle");
	
	checkOption(parameter,"mcfg","minimize-cfg");
	checkOption(parameter,"ZERO","ZERO");
	checkOption(parameter,"obj", "dump-object");

	activateComponent();
}

void ConfigurationFileGenerator::onFatalExit(Directory & container)
{
	mpstrstream * stream;

		//㳰ǰ۾ｪλ顢եʤ
	stream = reinterpret_cast<mpstrstream *>(container[KERNEL_CFG].toPointer());
	if(stream != NULL)
		stream->disableFileoutput();

	stream = reinterpret_cast<mpstrstream *>(container[KERNEL_ID].toPointer());
	if(stream != NULL)
		stream->disableFileoutput();
}

void ConfigurationFileGenerator::createObjectDefinition(mpstrstream * out, Directory & container, long idsize, int flag, ...)
{
	Directory * scope;
	const char * buffer;
	string work;

	map<int, Directory *> sorter;
	map<int, Directory *>::iterator psorter;

	va_list vl;
	int i;

	Directory & id = container[string(PREFIX "/") + container.getKey().c_str()];

	if(container.size() == 0 && findOption(container,"mcfg","minimize-cfg"))
	{
		Component::barrier(Component::EXTENSION,Message("Use of the extended option --minimize-cfg. Please use -ext option together.","--minimizeץϳĥǽǤѤˤ--extꤷƤ"));
		return;
	}
	va_start(vl, flag);


		//ɬפʾκ
	work = string(va_arg(vl, const char *));
	id["id"]  = work;
	for(i=0; i<(signed)work.size(); i++)
		work[i] = work[i] - 'a' + 'A';
	id["ID"]  = work;

	if((flag & SHORT_ID) != 0)
	{
		work = string(va_arg(vl, const char *));
		id["sid"]  = work;
		for(i=0; i<(signed)work.size(); i++)
			work[i] = work[i] - 'a' + 'A';
		id["SID"]  = work;
	}else
	{
		id["sid"] = id["id"].toString();
		id["SID"] = id["ID"].toString();
	}

	if(!findOption(container, "1.3", "1.3"))
		id["symbolprefix"] = "_kernel_";

	work = container.getKey();
	id["name"] = work;
	out->moveto(work);

		//֥Ƚؿɲ
	if((flag & INIT) != 0 && container.size() != 0)
		container["/" OBJECT_INITIALIZER].addChild(new Directory(work));

	(*out) << "\n\t/* " << Message("Object initializer [%s]","֥Ƚ֥å [%s]").format(work.c_str()) << " */\n\n";

	if((flag & TNUM) != 0)
	{
		idsize += container.size();
		(*out) << id.format("#define TNUM_$(ID)ID ");
		(*out) << idsize << "\n\n";
		(*out) << id.format("const ID $(symbolprefix,)tmax_$(id)id = (TMIN_$(ID)ID + TNUM_$(ID)ID - 1);\n\n");
	}

	if((flag & TNUMNO) != 0)
	{
		(*out) << id.format("#define TNUM_$(ID)NO ") << container.size() << "\n\n";
		(*out) << id.format("const UINT $(symbolprefix,)tnum_$(id)no = TNUM_$(ID)NO;\n\n");
	}

		/* ID˥ (λϢ֤ꤷƤϤʤΤǡåϤʤ) */
	if((flag & (BUFFER|DEFINITION)) != 0)
	{
		i = 0;
		scope = container.getFirstChild();
		while(scope != 0)
		{
			sorter[scope->toInteger(i++)] = scope;
			scope = scope->getNext();
		}
	}

		//ץȥν
	if((flag & PROTOTYPE) != 0)
	{
		buffer = va_arg(vl, const char *);

		if(def_prototype)
		{
			set<string> func;
			set<string>::iterator pfunc;

			scope = container.getFirstChild();
			while(scope != NULL)
			{
				if ((*psorter).second->findChild("_reserved") == 0)
				{
					func.insert(scope->format(buffer));
				}
				scope = scope->getNext();
			}

			pfunc = func.begin();
			while(pfunc != func.end())
			{
				(*out) << (*pfunc) << endl;
				++ pfunc;
			}
		}
	}

		//Хåեκ
	if((flag & BUFFER) != 0 && container.size() != 0)
	{
		buffer = va_arg(vl, const char *);
		psorter = sorter.begin();
		while(psorter != sorter.end())
		{
			if ((*psorter).second->findChild("_reserved") == 0)
			{
				(*out) << (*psorter).second->format(buffer) << '\n';
			}
			++ psorter;
		}
		(*out) << '\n';
	}

		//֥å(xINIB)/֥å(xINIA)ν
	if((flag & DEFINITION) != 0)
	{
		buffer = va_arg(vl, const char *);
		if ( (flag & TNUM) != 0)
		{
			int reserved = 0;
			psorter = sorter.begin();
			while(psorter != sorter.end())
			{
				if ((*psorter).second->findChild("_reserved") != 0)
				{
					++reserved;
				}
				++ psorter;
			}
			(*out) << id.format("#define TNUM_$(SID)INIA (") << (container.size() - reserved) << ")\n";
			(*out) << id.format("const UINT $(symbolprefix,)tnum_$(sid)inia = TNUM_$(SID)INIA;\n");
		}
		if(container.size() != 0)
		{
			if ( (flag & TNUMNO) != 0)
			{
				(*out) << id.format("const $(SID)INIB") << id.format(" $(symbolprefix,)$(sid)inib") << id.format("_table[TNUM_$(ID)NO] = {\n");
			} else 
			{
				(*out) << id.format("const $(SID)INIA") << id.format(" $(symbolprefix,)$(sid)inia") << id.format("_table[TNUM_$(SID)INIA] = {\n");
			}
			psorter = sorter.begin();
			bool first = true;
			while(psorter != sorter.end())
			{
			  if ((*psorter).second->findChild("_reserved") == 0)
			    {
			      if (!first)
				{
				  (*out) << ",\n";
				}
			      first = false;
			      (*out) << "\t{" << (*psorter).second->format(buffer) << '}';
			    }
			  ++ psorter;
			}
			(*out) << "};\n\n";
		}else
			if( !restrict_zero ) 
			{
			  if ( (flag & TNUMNO) != 0)
			    (*out) << id.format("__ZERO(const $(SID)INIB,$(symbolprefix,)$(sid)inib_table);\n");
			  else
			    (*out) << id.format("__ZERO(const $(SID)INIA,$(symbolprefix,)$(sid)inia_table);\n");
			}
	}

	if((flag & INITLIST) != 0)
	{
		Directory * node;

			/* IDֹ򥽡 */
		sorter.clear();
		node = container.getFirstChild();
		while(node != NULL)
		{
			sorter.insert(pair<int,Directory*>(node->findChild("#order")->toInteger(), node));
			node = node->getNext();
		}

		*out << id.format("const ID $(symbolprefix,)$(sid)order_table[TNUM_$(SID)INIA] = {");
		psorter = sorter.begin();
		while(psorter != sorter.end())
		{
			if ((*psorter).second->findChild("_reserved") == 0)
			{
				if(psorter != sorter.begin())
					*out << ',';
				*out << psorter->second->toInteger();
			}
			++ psorter;
		}
		*out << "};\n\n";
	}

		//֥å(xCB)ν
	if((flag & CONTROLBLOCK) != 0)
	{
		if(container.size() != 0)
		  {
		    (*out) << id.format("$(SID)CB $(symbolprefix,)$(sid)cb_table[TNUM_$(ID)");
		    if ( (flag & TNUMNO) != 0)
		      (*out) << "NO";
		    else
		      (*out) << "ID";
		    (*out) << "];\n";

		    if ( (flag & TNUM) != 0)
		      (*out) << id.format("$(SID)INIB $(symbolprefix,)$(sid)inib_table[TNUM_$(ID)ID];\n");
		    (*out) << "\n";
		  }		    
		else
			if( !restrict_zero )
			  {
				(*out) << id.format("__ZERO($(SID)CB, $(symbolprefix,)$(sid)cb_table);\n");
				if ( (flag & TNUM) != 0)
				  (*out) << id.format("__ZERO($(SID)INIB, $(symbolprefix,)$(sid)inib_table);\n");
				(*out) << "\n";
			  }
	}
}

void ConfigurationFileGenerator::createReservedID(mpstrstream * out, Directory & container, const char* sym)
{
  Directory & id = container[string(PREFIX "/") + container.getKey().c_str()];

  unsigned int size = container.size();
  (*out) << id.format("#define TNUM_$(ID)_RID (") << size << ")\n";
  (*out) << id.format("const UINT $(symbolprefix,)tnum_$(sid)rid = TNUM_$(ID)_RID;\n");

  if (size != 0)
    {
      Directory * scope;

      (*out) << id.format("const ID $(symbolprefix,)$(sid)rid_table[TNUM_$(ID)_RID] = {");

      scope = container.getFirstChild();
      while(true)
	{
	  (*out) << scope->format(" $@");
	  scope = scope->getNext();
	  if (scope == 0)
	    {
	      break;
	    }
	  else 
	    {
	      (*out) << ", ";
	    }
	}
      (*out) << "};\n\n";
    }
  else
    {
      if( !restrict_zero )
	{
	  (*out) << id.format("__ZERO(const ID, $(symbolprefix,)$(sid)rid_table);\n\n");
	}

    }
}

void ConfigurationFileGenerator::body(Directory & container)
{
	Directory cont;
	Directory * scope;
	mpstrstream * out;
	string work;
	int idsize;

		/* kernel_id.hν */
	out = reinterpret_cast<mpstrstream *>(container(KERNEL_ID)->toPointer());
	out->moveto("body");
	scope = container("/identifier")->getFirstChild();
	while(scope != 0)
	{
		(*out) << "#define " << scope->getKey() << " " << scope->toInteger() << endl;
		scope = scope->getNext();
	}

		/* kernel_cfg.cν */
	out = reinterpret_cast<mpstrstream *>(container(KERNEL_CFG)->toPointer());
	out->moveto("header");
	(*out) << "/* Configured by [" << container["/Parameter/#cmdline"].toString() << "] */\n\n";

	(*out) <<	"#include \"kernel_cfg.h\"\n"
				"#include \"kernel_id.h\"\n"
				"\n";

	if(findOption(container,"1.3","1.3"))
		(*out) <<	"#if TKERNEL_PRVER >= 0x1011\n";

	(*out) <<	"#define CFG_INTHDR_ENTRY(inthdr) INTHDR_ENTRY(inthdr)\n"
				"#define CFG_EXCHDR_ENTRY(exchdr) EXCHDR_ENTRY(exchdr)\n"
				"#define CFG_INT_ENTRY(inthdr) INT_ENTRY(inthdr)\n"
				"#define CFG_EXC_ENTRY(exchdr) EXC_ENTRY(exchdr)\n";

	if(findOption(container,"1.3","1.3"))
		(*out) <<	"#else\n"
					"  #define CFG_INTHDR_ENTRY(inthdr) INTHDR_ENTRY(ENTRY(inthdr), inthdr)\n"
					"  #define CFG_EXCHDR_ENTRY(exchdr) EXCHDR_ENTRY(ENTRY(exchdr), exchdr)\n"
					"  #define CFG_INT_ENTRY(inthdr) ENTRY(inthdr)\n"
					"  #define CFG_EXC_ENTRY(exchdr) ENTRY(exchdr)\n"
					"#endif\n";

	(*out) << "\n";

	if( !restrict_zero )
	{
		if(!findOption(container, "ZERO","ZERO",&work))
			work.assign("x y[0]");
		(*out) << "#ifdef _MSC_VER\n  #define __ZERO(x,y) _declspec(naked) void y(void){}\n#else\n  #define __ZERO(x,y) " << work << "\n#endif\n\n";
	}

		/* INCLUDE */
	out->moveto(INCLUDEFILE);
	scope = container(OBJECTTREE "/" INCLUDEFILE)->getFirstChild();
	(*out) << "\t/* " << Message("User specified include files","桼Υ󥯥롼ɥե") << "*/\n";
	while(scope != 0)
	{
		(*out) << "#include " << scope->toString() << endl;
		scope = scope->getNext();
	}
	(*out) << '\n';

		/* TASK */
	cont = container[OBJECTTREE "/" TASK];
	idsize = getIDSize(container, TASK);
	createObjectDefinition(out, cont, idsize, HEADER|TNUM|SHORT_ID|BUFFER|DEFINITION|CONTROLBLOCK|INIT|PROTOTYPE|INITLIST,"tsk", "t", "void $(task)(VP_INT exinf);", "static VP __stack_$@[TCOUNT_VP($(stksz))];","$@, {$(tskatr), (VP_INT)($(exinf)), (FP)($(task)), INT_PRIORITY($(itskpri)), TROUND_VP($(stksz)), __stack_$@, $(texatr), (FP)($(texrtn))}");

	cont = container[RESERVEDID "/" TASK];
	createReservedID(out, cont, "t");

		/* SEMAPHORE */
	cont = container[OBJECTTREE "/" SEMAPHORE];
	idsize = getIDSize(container, SEMAPHORE);
	createObjectDefinition(out, cont, idsize, HEADER|TNUM|DEFINITION|CONTROLBLOCK|INIT,"sem", "$@, {$(sematr), $(isemcnt), $(maxsem)}");

	cont = container[RESERVEDID "/" SEMAPHORE];
	createReservedID(out, cont, "sem");

		/* EVENTFLAG */
	cont = container[OBJECTTREE "/" EVENTFLAG];
	idsize = getIDSize(container, EVENTFLAG);
	createObjectDefinition(out, cont, idsize, HEADER|TNUM|DEFINITION|CONTROLBLOCK|INIT,"flg", "$@, {$(flgatr), $(iflgptn)}");

	cont = container[RESERVEDID "/" EVENTFLAG];
	createReservedID(out, cont, "flg");

		/* DATAQUEUE */
	cont = container[OBJECTTREE "/" DATAQUEUE];
	idsize = getIDSize(container, DATAQUEUE);
	createObjectDefinition(out, cont, idsize, HEADER|TNUM|BUFFER|DEFINITION|CONTROLBLOCK|INIT,"dtq", "#if ($(dtqcnt)) > 0\n  static VP_INT __dataqueue_$@[$(dtqcnt)];\n#else\n  #define __dataqueue_$@ NULL\n#endif","$@, {$(dtqatr), $(dtqcnt), __dataqueue_$@}");

	cont = container[RESERVEDID "/" DATAQUEUE];
	createReservedID(out, cont, "dtq");

		/* MAILBOX */
	cont = container[OBJECTTREE "/" MAILBOX];
	idsize = getIDSize(container, MAILBOX);
	createObjectDefinition(out, cont, idsize, HEADER|TNUM|DEFINITION|CONTROLBLOCK|INIT,"mbx","$@, {$(mbxatr), $(maxmpri)}");

	cont = container[RESERVEDID "/" MAILBOX];
	createReservedID(out, cont, "mbx");

		/* FIXEDSIZEMEMORYPOOL */
	cont = container[OBJECTTREE "/" FIXEDSIZEMEMORYPOOL];
	idsize = getIDSize(container, FIXEDSIZEMEMORYPOOL);
	createObjectDefinition(out, cont, idsize, HEADER|TNUM|BUFFER|DEFINITION|CONTROLBLOCK|INIT,"mpf","static VP __fixedsize_memorypool_$@[TCOUNT_VP($(blksz)) * (($(blkcnt)))];","$@, {$(mpfatr), TROUND_VP($(blksz)), __fixedsize_memorypool_$@, (VP)((VB *)__fixedsize_memorypool_$@ + sizeof(__fixedsize_memorypool_$@))}");

	cont = container[RESERVEDID "/" FIXEDSIZEMEMORYPOOL];
	createReservedID(out, cont, "mpf");

		/* CYCLICHANDLER */
	cont = container[OBJECTTREE "/" CYCLICHANDLER];
	idsize = getIDSize(container, CYCLICHANDLER);
	createObjectDefinition(out, cont, idsize, HEADER|TNUM|DEFINITION|CONTROLBLOCK|INIT|PROTOTYPE,"cyc","void $(cychdr)(VP_INT exinf);","$@, {$(cycatr),(VP_INT)($(exinf)),(FP)($(cychdr)),$(cyctim),$(cycphs)}");

	cont = container[RESERVEDID "/" CYCLICHANDLER];
	createReservedID(out, cont, "cyc");

		/* INTERRUPTHANDLER */
	cont = container[OBJECTTREE "/" INTERRUPTHANDLER];
	idsize = getIDSize(container, INTERRUPTHANDLER);
	createObjectDefinition(out, cont, idsize, HEADER|BUFFER|TNUMNO|DEFINITION|INIT|PROTOTYPE,"inh","void $(inthdr)(void);","CFG_INTHDR_ENTRY($(inthdr));","$@,$(inhatr),(FP)CFG_INT_ENTRY($(inthdr))");

		/* EXCEPTIONHANDLER */
	cont = container[OBJECTTREE "/" EXCEPTIONHANDLER];
	idsize = getIDSize(container, EXCEPTIONHANDLER);
	createObjectDefinition(out, cont, idsize, HEADER|BUFFER|TNUMNO|DEFINITION|INIT|PROTOTYPE,"exc","void $(exchdr)(void);","CFG_EXCHDR_ENTRY($(exchdr));","$@,$(excatr),(FP)CFG_EXC_ENTRY($(exchdr))");


		/* VARSIZEMEMORYPOOL */
	cont = container[OBJECTTREE "/" VARSIZEMEMORYPOOL];
	idsize = getIDSize(container, VARSIZEMEMORYPOOL);
	createObjectDefinition(out, cont, idsize, HEADER|TNUM|BUFFER|DEFINITION|CONTROLBLOCK|INIT,"mpl","static VP __varsize_memorypool_$@[TCOUNT_VP($(mplsz))];","$@, {$(mplatr), TROUND_VP($(mplsz)), __varsize_memorypool_$@}");

	cont = container[RESERVEDID "/" VARSIZEMEMORYPOOL];
	createReservedID(out, cont, "mpl");

		/* ALARMHANDLER */
	cont = container[OBJECTTREE "/" ALARMHANDLER];
	idsize = getIDSize(container, ALARMHANDLER);
	createObjectDefinition(out, cont, idsize, HEADER|TNUM|DEFINITION|CONTROLBLOCK|INIT|PROTOTYPE,"alm","void $(almhdr)(VP_INT exinf);","$@, {$(almatr),(VP_INT)($(exinf)),(FP)($(almhdr))}");

	cont = container[RESERVEDID "/" ALARMHANDLER];
	createReservedID(out, cont, "alm");

		/* OVERRUNHANDLER */
	cont = container[OBJECTTREE "/" OVERRUNHANDLER];
	idsize = getIDSize(container, OVERRUNHANDLER);
	createObjectDefinition(out, cont, idsize, HEADER|TNUMNO|BUFFER|DEFINITION|INIT,"ovr","void $(ovrhdr)(ID tskid, VP_INT exinf);", "$(ovratr),(FP)($(ovrhdr))");

		/* INTERRUPTSERVICE */
	cont = container[OBJECTTREE "/" INTERRUPTSERVICE];
	idsize = getIDSize(container, INTERRUPTSERVICE);
	createObjectDefinition(out, cont, idsize, HEADER|TNUM|DEFINITION|CONTROLBLOCK|INIT,"isr", "");

	cont = container[RESERVEDID "/" INTERRUPTSERVICE];
	createReservedID(out, cont, "isr");

		/* MESSAGEBUFFER */
	cont = container[OBJECTTREE "/" MESSAGEBUFFER];
	idsize = getIDSize(container, MESSAGEBUFFER);
	createObjectDefinition(out, cont, idsize, HEADER|TNUM|BUFFER|DEFINITION|CONTROLBLOCK|INIT,"mbf","static VP __message_buffer_$@[TCOUNT_VP($(mbfsz))];","$@, {$(mbfatr), $(maxmsz), TROUND_VP($(mbfsz)), __message_buffer_$@}");

	cont = container[RESERVEDID "/" MESSAGEBUFFER];
	createReservedID(out, cont, "mbf");

		/* MUTEX */
	cont = container[OBJECTTREE "/" MUTEX];
	idsize = getIDSize(container, MUTEX);
	createObjectDefinition(out, cont, idsize, HEADER|TNUM|BUFFER|DEFINITION|CONTROLBLOCK|INIT,"mtx","/*mutex$@*/","$@, {$(mtxatr), $(ceilpri)}");

	cont = container[RESERVEDID "/" MUTEX];
	createReservedID(out, cont, "mtx");

		/* RENDEZVOUSPORT */
	cont = container[OBJECTTREE "/" RENDEZVOUSPORT];
	idsize = getIDSize(container, RENDEZVOUSPORT);
	createObjectDefinition(out, cont, idsize, HEADER|TNUM|BUFFER|DEFINITION|CONTROLBLOCK|INIT,"por","/*port$@*/", "$@, {$(poratr),$(maxcmsz),$(maxrmsz)}");

	cont = container[RESERVEDID "/" RENDEZVOUSPORT];
	createReservedID(out, cont, "por");

		/* EXSERVICECALL */
	cont = container[OBJECTTREE "/" EXSERVICECALL];
	idsize = getIDSize(container, EXSERVICECALL);
	createObjectDefinition(out, cont, idsize, HEADER|BUFFER|TNUMNO|DEFINITION|CONTROLBLOCK|INIT|PROTOTYPE,"svc","/*svc$@*/", "ER_UINT $(svcrtn)();", "$@,$(svcatr),(FP)$(svcrtn)");

	cont = container[RESERVEDID "/" EXSERVICECALL];
	createReservedID(out, cont, "svc");

	if(!findOption(container, "1.3", "1.3"))
		work.assign("_kernel_");
	else
		work.empty();


		/* ֥Ƚ롼 */
	out->moveto(OBJECT_INITIALIZER);
	(*out) << "\t/* " << Message("Object initialization routine","֥Ƚ롼") << " */\n\n";
	(*out) << "void\n" << work << "object_initialize(void)\n{\n"
	  "\t_kernel_bufmgr_initialize();\n";
	scope = container["/" OBJECT_INITIALIZER].getFirstChild();
	while(scope != 0)
	{
		(*out) << '\t' << work << scope->toString() << "_initialize();\n";
		scope = scope->getNext();
	}
	(*out) << "}\n\n";


	out->moveto(KERNELBUFFER);
	(*out) << "\t/* " << Message("Kernel buffer","ͥХåե") << " */\n\n";
	(*out) << "#define TSIZE_KERNEL_BUFFER ";
	scope = container[SYSTEM "/" KERNELBUFFER].getFirstChild();
	if (scope == 0) {
		(*out) << "(256)\n";
	} else 	{
		(*out) << scope->format("($@)\n");
	}
	(*out) << "VP __kernel_bufmgr_buffer[TSIZE_KERNEL_BUFFER];\n";
	(*out) << "const SIZE __kernel_bufmgr_buffer_size = TSIZE_KERNEL_BUFFER;\n";

		/* ϥɥ */
	out->moveto(INITIALIZER);
	(*out) << "\t/* " << Message("Initialization handler","ϥɥ鵯ư롼") << " */\n\n";
	(*out) << "void\n" << work << "call_inirtn(void)\n{\n";
	scope = container[OBJECTTREE "/" INITIALIZER].getFirstChild();
	while(scope != 0)
	{
		(*out) << scope->format("\t$(inirtn)( (VP_INT)($(exinf)) );\n");
		scope = scope->getNext();
	}
	(*out) << "}\n\n";

		/* ϥɥ */
	out->moveto(TERMINATOR);
	(*out) << "\t/* " << Message("Termination handler","ϥɥ鵯ư롼") << " */\n\n";
	(*out) << "void\n" << work << "call_terrtn(void)\n{\n";
	scope = container[OBJECTTREE "/" TERMINATOR].getFirstChild();
	while(scope != 0)
	{
		(*out) << scope->format("\t$(terrtn)( (VP_INT)($(exinf)) );\n");
		scope = scope->getNext();
	}
	(*out) << "}\n\n";

		/* ߥӥ롼(Ū) */
	out->moveto(ATTACHED_ISR);
	(*out) << "\t/* " << Message("Attached interrupt service routine","ߥӥ롼(Ū)") << " */\n\n";
	(*out) << "const ISRINIB _kernel_attached_isr_table[] = {\n";
	scope = container[OBJECTTREE "/" ATTACHED_ISR].getFirstChild();
	while(scope != 0)
	{
		(*out) << scope->format("\t{ $(isratr), (VP_INT)($(exinf)), $(intno), (FP)($(isr))},\n");
		scope = scope->getNext();
	}
	(*out) << "};\n\n";

	out->moveto("others");
	(*out) << "TMEVTN	" << work << "tmevt_heap[TNUM_TSKID + TNUM_CYCID];\n\n";

	container["/object_initializer"].erase();


	string filename;
	if(findOption(container,"obj","dump-object",&filename))
	{
		if(filename.empty())
			filename.assign("kernel_obj.dat");

		fstream f(filename.c_str(),ios::out|ios::binary);
		if(f.is_open())
		{
			container[OBJECTTREE].Store(&f);
			f.close();
		}else
			throw Exception(" Failed to open the file %s for storing object definitions"," ֥ȾǼ뤿Υե(%s)ޤ").format(filename.c_str());
	}
}


/* ======================================================================== */
