/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: st16c2550.h,v 1.3 2003/11/10 07:51:19 monaka Exp $
 */

/*
 *   ST16C2550  ʰSIOɥ饤
 */
#ifndef _ST16C2550_H_
#define _ST16C2550_H_

#ifndef _MACRO_ONLY
#include <itron.h>
#include <sil.h>
#endif /* _MACRO_ONLY */

#include "sys_config.h"




#ifndef _MACRO_ONLY

/*
 *  ꥢI/OݡȽ֥å
 */
typedef struct sio_port_initialization_block {
    UW reg_base;    /* 쥸Υ١ɥ쥹 */
    UB lcr_val;     /* ⡼ɥ쥸   */
    UB dlm_val;     /* ܡ졼Ⱦ̤   */
    UB dll_val;     /* ܡ졼Ȳ̤   */
    UW pinter_val;  /* ߵĥӥå   */    
} SIOPINIB;

/*
 *  ꥢI/Oݡȴ֥å
 */
typedef struct sio_port_control_block {
    const SIOPINIB  *siopinib; /* ꥢI/OݡȽ֥å */
    VP_INT          exinf;     /* ĥ */
    BOOL    openflag;          /* ץѤߥե饰 */
    BOOL    sendflag;          /* ߥ֥͡ե饰 */
    BOOL    getready;          /* ʸ */
    BOOL    putready;          /* ʸǤ */
}SIOPCB;

/*
 *  Хå롼μֹ
 */
#define SIO_ERDY_SND    1u      /* ǽХå */
#define SIO_ERDY_RCV    2u      /* ΥХå */


/*
 * ͥ뵯ưѤν(sys_putcѤ뤿)
 */
extern void st16c2550_init(void);

/*
 *  ꥢI/OݡȤؤΥݡ󥰤Ǥν
 */
extern void st16c2550_pol_putc(char c, ID siopid);


/*
 *  SIOɥ饤Фν롼
 */
extern void st16c2550_initialize(void);


/*
 *  ץ󤷤ƤݡȤ뤫
 */
extern BOOL st16c2550_openflag(void);


/*
 *  ꥢI/OݡȤΥץ
 */
extern SIOPCB   *st16c2550_opn_por(ID siopid, VP_INT exinf);


/*
 *  ꥢI/OݡȤΥ
 */
extern void st16c2550_cls_por(SIOPCB *siopcb);


/*
 *  ꥢI/OݡȤؤʸ
 */
extern BOOL st16c2550_snd_chr(SIOPCB *siopcb, char c);


/*
 *  ꥢI/OݡȤʸ
 */
extern INT  st16c2550_rcv_chr(SIOPCB *siopcb);


/*
 *  ꥢI/OݡȤΥХåε
 */
extern void st16c2550_ena_cbr(SIOPCB *siopcb, UINT cbrtn);


/*
 *  ꥢI/OݡȤΥХåζػ
 */
extern void st16c2550_dis_cbr(SIOPCB *siopcb, UINT cbrtn);


/*
 *  SIOγߥӥ롼
 */
extern void st16c2550_isr(void);


/*
 *  ꥢI/OݡȤǽХå
 */
extern void st16c2550_ierdy_snd(VP_INT exinf);


/*
 *  ꥢI/OݡȤμΥХå
 */
extern void st16c2550_ierdy_rcv(VP_INT exinf);


#endif /* _MACRO_ONLY */


#endif /* _FDC37C935A_H_ */
