#include <t_services.h>

ID tskid, semid, flgid, dtqid, mbxid, mtxid, mbfid, porid, mpfid, mplid, isrid, cycid, almid;
ID *p_tskid;
PRI tskpri, *p_tskpri;
FN fncd;
TMO tmout;
RELTIM	dlytim, almtim;
OVRTIM	ovrtim;
SYSTIM	p_systim[1];
T_MSG	pk_msg[1], *ppk_msg[1];
VP_INT	stacd, data, p_data[1], arg1, arg2, arg3, arg4, arg5, p_excinf;
VP	msg[100], blk, p_blk[1];
TEXPTN	rasptn;
FLGPTN	setptn, clrptn, waiptn, p_flgptn[1];
RDVPTN	calptn, acpptn;
RDVNO	rdvno, p_rdvno[1];
EXCNO	excno;
MODE	wfmode;
UINT	msgsz, cmsgsz, rmsgsz, blksz;
INHNO	inhno;
INTNO	intno;
IPM		ipm, p_ipm[1];

#define	PACKET(UC, lc)	\
	T_C##UC	pk_c##lc[1];	\
	T_R##UC	pk_r##lc[1];

PACKET(TSK, tsk)
PACKET(SEM, sem)
PACKET(FLG, flg)
PACKET(DTQ, dtq)
PACKET(MBX, mbx)
PACKET(MTX, mtx)
PACKET(MBF, mbf)
PACKET(POR, por)
PACKET(MPF, mpf)
PACKET(MPL, mpl)
PACKET(ISR, isr)
PACKET(CYC, cyc)
PACKET(ALM, alm)

T_DTEX	pk_dtex[1];
T_DOVR	pk_dovr[1];
T_DINH	pk_dinh[1];
T_DEXC	pk_dexc[1];
T_DSVC	pk_dsvc[1];

T_RTST	pk_rtst[1];
T_RTEX	pk_rtex[1];
T_RRDV	pk_rrdv[1];
T_ROVR	pk_rovr[1];
T_RSYS	pk_rsys[1];
T_RVER	pk_rver[1];
T_RCFG	pk_rcfg[1];

void test()
{
	ER		ercd;
	UINT	size;

	ercd = ERCD(-5, -10);
	ercd = MERCD(ercd);
	ercd = SERCD(ercd);

	size = TROUND_VP(5);
	size = TCOUNT_VP(5);

	cre_tsk(tskid, pk_ctsk);
	acre_tsk(pk_ctsk);
	del_tsk(tskid);
	act_tsk(tskid);
	iact_tsk(tskid);
	can_act(tskid);
	sta_tsk(tskid, stacd);
	ext_tsk();
	exd_tsk();
	ter_tsk(tskid);
	chg_pri(tskid, tskpri);
	get_pri(tskid, p_tskpri);
	ref_tsk(tskid, pk_rtsk);
	ref_tst(tskid, pk_rtst);
	slp_tsk();
	tslp_tsk(tmout);
	wup_tsk(tskid);
	iwup_tsk(tskid);
	can_wup(tskid);
	rel_wai(tskid);
	irel_wai(tskid);
	sus_tsk(tskid);
	rsm_tsk(tskid);
	frsm_tsk(tskid);
	dly_tsk(dlytim);
	def_tex(tskid, pk_dtex);
	ras_tex(tskid, rasptn);
	iras_tex(tskid, rasptn);
	dis_tex();
	ena_tex();
	sns_tex();
	ref_tex(tskid, pk_rtex);
	cre_sem(semid, pk_csem);
	acre_sem(pk_csem);
	del_sem(semid);
	sig_sem(semid);
	isig_sem(semid);
	wai_sem(semid);
	pol_sem(semid);
	twai_sem(semid, tmout);
	ref_sem(semid, pk_rsem);
	cre_flg(flgid, pk_cflg);
	acre_flg(pk_cflg);
	del_flg(flgid);
	set_flg(flgid, setptn);
	iset_flg(flgid, setptn);
	clr_flg(flgid, clrptn);
	wai_flg(flgid, waiptn,
			wfmode, p_flgptn);
	pol_flg(flgid, waiptn,
			wfmode, p_flgptn);
	twai_flg(flgid, waiptn,
			wfmode, p_flgptn, tmout);
	ref_flg(flgid, pk_rflg);
	cre_dtq(dtqid, pk_cdtq);
	acre_dtq(pk_cdtq);
	del_dtq(dtqid);
	snd_dtq(dtqid, data);
	psnd_dtq(dtqid, data);
	ipsnd_dtq(dtqid, data);
	tsnd_dtq(dtqid, data, tmout);
	fsnd_dtq(dtqid, data);
	ifsnd_dtq(dtqid, data);
	rcv_dtq(dtqid, p_data);
	prcv_dtq(dtqid, p_data);
	trcv_dtq(dtqid, p_data, tmout);
	ref_dtq(dtqid, pk_rdtq);
	cre_mbx(flgid, pk_cmbx);
	acre_mbx(pk_cmbx);
	del_mbx(flgid);
	snd_mbx(mbxid, pk_msg);
	rcv_mbx(mbxid, ppk_msg);
	prcv_mbx(mbxid, ppk_msg);
	trcv_mbx(mbxid, ppk_msg, tmout);
	ref_mbx(mbxid, pk_rmbx);
	cre_mtx(mtxid, pk_cmtx);
	acre_mtx(pk_cmtx);
	del_mtx(mtxid);
	loc_mtx(mtxid);
	ploc_mtx(mtxid);
	tloc_mtx(mtxid, tmout);
	unl_mtx(mtxid);
	ref_mtx(mtxid, pk_rmtx);
	cre_mbf(mbfid, pk_cmbf);
	acre_mbf(pk_cmbf);
	del_mbf(mbfid);
	snd_mbf(mbfid, msg, msgsz);
	psnd_mbf(mbfid, msg, msgsz);
	tsnd_mbf(mbfid, msg, msgsz, tmout);
	rcv_mbf(mbfid, msg);
	prcv_mbf(mbfid, msg);
	trcv_mbf(mbfid, msg, tmout);
	ref_mbf(mbfid, pk_rmbf);
	cre_por(porid, pk_cpor);
	acre_por(pk_cpor);
	del_por(porid);
	cal_por(porid, calptn, msg, cmsgsz);
	tcal_por(porid, calptn, msg, cmsgsz, tmout);
	acp_por(porid, acpptn, p_rdvno, msg);
	pacp_por(porid, acpptn, p_rdvno, msg);
	tacp_por(porid, acpptn, p_rdvno, msg, tmout);
	fwd_por(porid, acpptn, rdvno, msg, cmsgsz);
	rpl_rdv(rdvno, msg, rmsgsz);
	ref_por(porid, pk_rpor);
	ref_rdv(rdvno, pk_rrdv);
	cre_mpf(mpfid, pk_cmpf);
	acre_mpf(pk_cmpf);
	del_mpf(mpfid);
	get_mpf(mpfid, p_blk);
	pget_mpf(mpfid, p_blk);
	tget_mpf(mpfid, p_blk, tmout);
	rel_mpf(mpfid, blk);
	ref_mpf(mpfid, pk_rmpf);
	cre_mpl(mplid, pk_cmpl);
	acre_mpl(pk_cmpl);
	del_mpl(mplid);
	get_mpl(mplid, blksz, p_blk);
	pget_mpl(mplid, blksz, p_blk);
	tget_mpl(mplid, blksz, p_blk, tmout);
	rel_mpl(mplid, blk);
	ref_mpl(mplid, pk_rmpl);
	set_tim(p_systim);
	get_tim(p_systim);
	isig_tim();
	cre_cyc(cycid, pk_ccyc);
	acre_cyc(pk_ccyc);
	cre_cyc(cycid, pk_ccyc);
	del_cyc(cycid);
	sta_cyc(cycid);
	stp_cyc(cycid);
	ref_cyc(cycid, pk_rcyc);
	cre_alm(almid, pk_calm);
	acre_alm(pk_calm);
	del_alm(almid);
	sta_alm(almid, almtim);
	stp_alm(almid);
	ref_alm(almid, pk_ralm);
	def_ovr(pk_dovr);
	sta_ovr(tskid, ovrtim);
	stp_ovr(tskid);
	ref_ovr(tskid, pk_rovr);
	rot_rdq(tskpri);
	irot_rdq(tskpri);
	get_tid(p_tskid);
	iget_tid(p_tskid);
	loc_cpu();
	iloc_cpu();
	unl_cpu();
	iunl_cpu();
	dis_dsp();
	ena_dsp();
	sns_ctx();
	sns_loc();
	sns_dsp();
	sns_dpn();
	vsns_ini();
	ref_sys(pk_rsys);
	def_inh(inhno, pk_dinh);
	cre_isr(isrid, pk_cisr);
	acre_isr(pk_cisr);
	del_isr(isrid);
	ref_isr(isrid, pk_risr);
	dis_int(intno);
	ena_int(intno);
	chg_ipm(ipm);
	get_ipm(p_ipm);
	def_svc(fncd, pk_dsvc);
	cal_svc(fncd, arg1, arg2, arg3, arg4, arg5);
	def_exc(excno, pk_dexc);
	ref_cfg(pk_rcfg);
	ref_ver(pk_rver);
	vxsns_ctx(p_excinf);
	vxsns_loc(p_excinf);
	vxsns_dsp(p_excinf);
	vxsns_dpn(p_excinf);
	vxsns_tex(p_excinf);
}

