/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id:$
 */
#include <t_services.h>
#include <cstdlib>
#include <new>
#include "kernel_id.h"
#include "diag_new.h"

volatile bool result = false;

void sub_task(VP_INT exinf)
{
	int* p[1000];
 	syslog(LOG_NOTICE, "sub_task");
	for (;;)
	{
  	for (int i = 0; i < 1000; i++)
		{
  		p[i] = new int(i);
			assert(*p[i] == i);
		}
  	for (int i = 0; i < 1000; i++)
		{
		  delete p[i];
			p[i] = 0;
		}
		result = true;
 	}
}

/*
 *  ᥤ󥿥
 */
void main_task(VP_INT exinf)
{
	vmsk_log(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_EMERG));

	serial_ctl_por(TASK_PORTID, (IOCTL_CRLF | IOCTL_FCSND | IOCTL_FCRCV));

  act_tsk(SUB_TASK);

	for (int i = 0; i < 1000; i++)
	{
		dly_tsk(0);
		int* p = new int(i);
		assert(*p == i);
		delete p;
	}

  try
  {
  	int* p = new int[0x10000000];
  	delete[] p;
  	result = false;
  }
  catch (std::bad_alloc&)
  {
  }

	if (result)
   	syslog(LOG_NOTICE, "test succeeded");
  else
  	syslog(LOG_NOTICE, "test failed");

	std::exit(0);
}

