/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id:$
 */

/* 
 *  C++ǽɾץ
 */

#include <t_services.h>
#include <cstdlib>
#include "kernel_id.h"
#include "diag_performance.h"

#ifndef	SINGLE

extern "C" void _toppers_cxxrt_reset_specific(void) throw();

#else

void _toppers_cxxrt_reset_specific() {}

void *_sbrk_r(struct _reent *_ptr, ptrdiff_t _nbytes)
{
  extern char end;
  static char *_heap_ptr = &end;
  static char *_heap_end = (char*)~0L;
  char *_base;

  if (!_kernel_iniflg)
  {
    volatile char _auto;
    if (&_auto < _heap_end)
      _heap_end = (char*)&_auto;
  }

  if (_heap_ptr + _nbytes + 32 > _heap_end)
  {
    _ptr->_errno = errno = ENOMEM;
    return (void*)-1;
  }

  _base = _heap_ptr;
  _heap_ptr += _nbytes;
  return _base;
}

int main()
{
	return 0;
}

#endif

int a;

struct foo
{
	void* p_;
	foo(void* p) : p_(p) {}
};

struct hoge
{
	void *p_;
	~hoge() throw();
};

hoge::~hoge() throw()
{
	p_ = 0;
}

void test_new_delete(int n)
{				//  break
	char *p[1000];
	for (int i = 0; i < n; i++)
	{
		p[i] = new char[i];
	}
	for (int i = 0; i < n; i++)
	{
		delete[] p[i];
	}
	a = 0;		//  break
}

void test_throw()
{
	hoge x, y, z;
	throw foo(0);
}

void test_exception(int n)
{				//  break
	for (int i = 0; i < n; i++)
	{
		try
		{
			test_throw();
		}
		catch (...)
		{
		}
	}
}				//  break

void test()
{
	test_new_delete(1);
	test_new_delete(100);
	test_new_delete(1000);

	test_exception(1);
	test_exception(100);
	test_exception(1000);

}

void inirtn(VP_INT)
{
	test();
}

/*
 *  ᥤ󥿥
 */
void main_task(VP_INT exinf)
{
	_toppers_cxxrt_reset_specific();
	test();
	std::exit(0);
}
