/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: diag_flg.c,v 1.1 2003/11/20 06:19:04 monaka Exp $
 */

#include <t_services.h>
#include "kernel_id.h"
#include "diag_flg.h"

/*
 *
 */
void flg_task(VP_INT exinf)
{
	ER ercd;
	ID flgid;
	FLGPTN flgptn;

	flgid = (ID)exinf;

	ercd = wai_flg(flgid, 0x0101, TWF_ANDW, &flgptn);
	if (ercd != E_OK) {
		syslog(LOG_EMERG, "Something wrong in wai_flg. (%d).", ercd);
		goto error;
	}
	dly_tsk(0);
	wup_tsk(MAIN_TASK);

 error:
	ext_tsk();
}

BOOL
test_flg1()
{
	ER ercd;
	T_RFLG rflg;

	ercd = ref_flg(FLG1, &rflg);
	if (ercd != E_OK || rflg.wtskid != TSK_NONE) {
		syslog(LOG_EMERG, "Wrong wtskid in ref_flg.");
		return FALSE;
	}
	if (rflg.flgptn != 0xc0c0) {
		syslog(LOG_EMERG, "Wrong flgptn in ref_flg. (A %x)", rflg.flgptn);
		return FALSE;
	}

	ercd = set_flg(FLG1, 0x0101);
	if (ercd != E_OK) {
		syslog(LOG_EMERG, "Something wrong in set_flg. (%d)", ercd);
		return FALSE;
	}
	ercd = ref_flg(FLG1, &rflg);
	if (ercd != E_OK || rflg.flgptn != 0xc1c1) {
		syslog(LOG_EMERG, "Wrong flgptn in ref_flg. (B %x)", rflg.flgptn);
		return FALSE;
	}

	ercd = clr_flg(FLG1, 0x0101);
	if (ercd != E_OK) {
		syslog(LOG_EMERG, "Something wrong in clr_flg. (%d)", ercd);
		return FALSE;
	}
	ercd = ref_flg(FLG1, &rflg);
	if (ercd != E_OK || rflg.flgptn != 0x0101) {
		syslog(LOG_EMERG, "Wrong flgptn in ref_flg. (C %x)", rflg.flgptn);
		return FALSE;
	}

	return TRUE;
}

BOOL
test_flg2()
{
	T_CFLG cflg;
	BOOL stat;
	ER ercd;

	cflg.flgatr = TA_HLNG;
	cflg.iflgptn = 0xc0c0;

	ercd = cre_flg(RESERVED_FLGID, &cflg);
	if (ercd != E_OK) {
		syslog(LOG_EMERG, "Something wrong in cre_flg. (%d)", ercd);
		return FALSE;
	}

	act_tsk(FLG_TASK);
	dly_tsk(0);

	ercd = set_flg(RESERVED_FLGID, 0x0101);

	slp_tsk();

	return TRUE;
}

BOOL
test_flg3()
{
	T_CFLG cflg;
	T_RFLG rflg;
	BOOL stat;
	ER ercd;
	ER_ID flgid;

	cflg.flgatr = TA_HLNG;
	cflg.iflgptn = 1234;

	flgid = acre_flg(&cflg);
	if (flgid < E_OK) {
		syslog(LOG_EMERG, "Something wrong in acre_flg. (%d)", ercd);
		return FALSE;
	}

	ercd = del_flg(flgid);
	if (ercd != E_OK) {
		syslog(LOG_EMERG, "Something wrong in del_flg. (%d)", ercd);
		return FALSE;
	}

	return TRUE;
}

/*
 *  ᥤ󥿥
 */
void main_task(VP_INT exinf)
{
	BOOL stat;

	vmsk_log(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_INFO));

	stat = test_flg1();
	if (stat) {
		syslog(LOG_INFO, "test_flg1 succeeded.");
	} else {
		syslog(LOG_EMERG, "test_flg1 failed.");
		goto error;
	}

	stat = test_flg2();
	if (stat) {
		syslog(LOG_INFO, "test_flg2 succeeded.");
	} else {
		syslog(LOG_EMERG, "test_flg2 failed.");
		goto error;
	}

	stat = test_flg3();
	if (stat) {
		syslog(LOG_INFO, "test_flg3 succeeded.");
	} else {
		syslog(LOG_EMERG, "test_flg3 failed.");
		goto error;
	}

	syslog(LOG_NOTICE, "All tests passed.");
 error:
	kernel_exit();
}
