/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: diag_kmem.c,v 1.1 2003/11/20 06:19:04 monaka Exp $
 */

#include <t_services.h>
#include "kernel_id.h"
#include "diag_kmem.h"
#include "kernel/bufmgr.h"

VP buffer[5000];

BOOL test_kmem(KMEMB *kmemb)
{
	BOOL stat;
	VB *buf[10];
	INT i;
	INT j;
	INT h;

	for (i = 0; i < 10; i++) {
	  buf[i] = NULL;
	}

	for (h = 0; h < 10; h++) {
		for(i = 0; i < 3; i++) {
			stat = kmem_allocate(kmemb, 1600, (VP)&buf[i]);
			if (!stat) {
				syslog(LOG_EMERG, "Can't allocate (%d,%d)", h, i);
				return FALSE;
			}
		}
		stat = kmem_allocate(kmemb, 500, (VP)&buf[9]);
		if (stat) {
			syslog(LOG_EMERG, "Something wrong. (%d)", h);
			return FALSE;
		}

		for(i = 0; i < 3; i++) {
			stat = kmem_release(kmemb, buf[i]);
			if (!stat) {
				syslog(LOG_EMERG, "Can't release (%d,%d)", h, i);
				return FALSE;
			}
		}
	}
	return TRUE;
}

BOOL test_kmem2(KMEMB *kmemb)
{
	BOOL stat;
	VB *buf[10];
	INT i;
	INT j;
	INT h;

		for(i = 0; i < 9; i++) {
			stat = kmem_allocate(kmemb, 500, (VP)&buf[i]);
			if (!stat) {
				syslog(LOG_EMERG, "Can't allocate");
				return FALSE;
			}
			for(j = 0; j < 500; j++) {
				buf[i][j] = j & 0xff;
			}
		}
		stat = kmem_allocate(kmemb, 500, (VP)buf[9]);
		if (stat) {
			syslog(LOG_EMERG, "Something wrong in kmem_allocate.");
			return FALSE;
		}

		for(i = 0; i < 9; i++) {
			stat = kmem_release(kmemb, buf[i]);
			if (!stat) {
				syslog(LOG_EMERG, "Can't release");
				return FALSE;
			}
		}
		stat = kmem_release(kmemb, 0);
		if (stat) {
			syslog(LOG_EMERG, "Something wrong in kmem_release.");
			return FALSE;
		}

	return TRUE;
}

BOOL test_bufmgr()
{
	BOOL stat;
	VB *buf[10];
	INT i;
	INT j;
	INT h;

	for(i = 0; i < 9; i++) {
		bufmgr_allocate(&stat, 500, (VP)&buf[i]);
		if (!stat) {
			syslog(LOG_EMERG, "Can't allocate buffer (%d)", i);
			return FALSE;
		}
		for(j = 0; j < 500; j++) {
			buf[i][j] = j & 0xff;
		}
	}
	bufmgr_allocate(&stat, 500, (VP)&buf[9]);
	if (stat) {
		syslog(LOG_EMERG, "Something wrong in kmem_allocate.");
		return FALSE;
	}

	for(i = 0; i < 9; i++) {
		stat = _kernel_bufmgr_release(buf[i]);
		if (!stat) {
			syslog(LOG_EMERG, "Can't release");
			return FALSE;
		}
	}
	stat = _kernel_bufmgr_release(0);
	if (stat) {
		syslog(LOG_EMERG, "Something wrong in kmem_release. (NULL)");
		return FALSE;
	}
	stat = _kernel_bufmgr_release((VP)1);
	if (!stat) {
		syslog(LOG_EMERG, "Something wrong in kmem_release. ((VP)1)");
		return FALSE;
	}

	return TRUE;
}

BOOL test_mpf1()
{
	INT i;
	ER ercd;
	VP vp[4];
	vp[3] = NULL;

	for (i = 0; i < 3; i++) {
		ercd = get_mpf(MPF1, &vp[i]);
		if (ercd != E_OK) {
			syslog(LOG_EMERG, "get_mpf failed.(A)");
			return FALSE;
		}
	}
	ercd = pget_mpf(MPF1, &vp[4]);
	if (ercd == E_OK) {
		syslog(LOG_EMERG, "get_mpf failed.(B)");
		return FALSE;
	}

	for(i = 0; i < 3; i++) {
		ercd = rel_mpf(MPF1, vp[i]);
		if (ercd != E_OK) {
			syslog(LOG_EMERG, "rel_mpf failed.");
			return FALSE;
		}
	}
	ercd = rel_mpf(MPF1, vp[4]);
	if (ercd == E_OK) {
		syslog(LOG_EMERG, "rel_mpf failed.(B)");
		return FALSE;
	}

	ercd = del_mpf(MPF1);
	if (ercd != E_OK) {
		syslog(LOG_EMERG, "something wrong in del_mpf.");
	}

	return TRUE;
}

BOOL test_mpf2()
{
	INT i;
	ER ercd;
	VP vp[4];
	vp[3] = NULL;

	T_CMPF cmpf;
	cmpf.mpfatr = TA_HLNG;
	cmpf.mpf = NULL;
	cmpf.blksz = 300;
	cmpf.blkcnt = 3;

	ercd = acre_mpf(&cmpf);
	if (ercd <= 0) {
		syslog(LOG_EMERG, "acre_mpf failed. %d", ercd);
		return FALSE;
	}

	ercd = del_mpf(ercd);
	if (ercd != E_OK) {
		syslog(LOG_EMERG, "del_mpf failed. %d", ercd);
	}

	ercd = cre_mpf(RESERVED_MPF, &cmpf);
	if (ercd != E_OK) {
		syslog(LOG_EMERG, "cre_mpf failed.");
		return FALSE;
	}

	for (i = 0; i < 3; i++) {
		ercd = get_mpf(RESERVED_MPF, &vp[i]);
		if (ercd != E_OK) {
			syslog(LOG_EMERG, "get_mpf failed.(A)");
			return FALSE;
		}
	}

	ercd = pget_mpf(RESERVED_MPF, &vp[4]);
	if (ercd == E_OK) {
		syslog(LOG_EMERG, "get_mpf failed.(B) %d", i);
		return FALSE;
	}

	for(i = 0; i < 3; i++) {
		ercd = rel_mpf(RESERVED_MPF, vp[i]);
		if (ercd != E_OK) {
			syslog(LOG_EMERG, "rel_mpf failed. (%d,%x)", i, vp[i]);
			return FALSE;
		}
	}
	ercd = rel_mpf(RESERVED_MPF, vp[4]);
	if (ercd == E_OK) {
		syslog(LOG_EMERG, "rel_mpf failed.(B)");
		return FALSE;
	}

	ercd = del_mpf(RESERVED_MPF);
	if (ercd != E_OK) {
		syslog(LOG_EMERG, "del_mpf failed.", ercd);
	}

	ercd = del_mpf(RESERVED_MPF);
	if (ercd != E_OBJ) {
		syslog(LOG_EMERG, "something wrong in del_mpf. %d", ercd);
	}

	return TRUE;
}

BOOL test_mpl1()
{
	INT i;
	ER ercd;
	VP vp[5];
	T_RMPL t_rmpl;

	vp[3] = NULL;
	
	for (i = 0; i < 3; i++) {
		ercd = get_mpl(MPL1, 900, &vp[i]);
		if (ercd != E_OK) {
			syslog(LOG_EMERG, "get_mpl failed.(A)");
			return FALSE;
		}
	}
	ercd = pget_mpl(MPL1, 900, &vp[4]);
	if (ercd == E_OK) {
		syslog(LOG_EMERG, "get_mpl failed.(B)");
		return FALSE;
	}

	for(i = 0; i < 3; i++) {
		ercd = rel_mpl(MPL1, vp[i]);
		if (ercd != E_OK) {
			syslog(LOG_EMERG, "rel_mpl failed.");
			return FALSE;
		}
	}
	ercd = rel_mpl(MPL1, vp[4]);
	if (ercd == E_OK) {
		syslog(LOG_EMERG, "rel_mpl failed.(B)");
		return FALSE;
	}

	ercd = ref_mpl(MPL1, &t_rmpl);

	ercd = del_mpl(MPL1);
	if (ercd != E_OK) {
		syslog(LOG_EMERG, "something wrong in del_mpl.");
	}

	return TRUE;
}

BOOL test_mpl2()
{
	INT i;
	ER ercd;
	VP vp[4];
	vp[3] = NULL;

	T_CMPL cmpl;
	cmpl.mplatr = TA_HLNG;
	cmpl.mpl = NULL;
	cmpl.mplsz = 1000;

	ercd = cre_mpl(RESERVED_MPL, &cmpl);
	if (ercd != E_OK) {
		syslog(LOG_EMERG, "cre_mpl failed.");
		return FALSE;
	}

	for (i = 0; i < 3; i++) {
		ercd = get_mpl(RESERVED_MPL, 300, &vp[i]);
		if (ercd != E_OK) {
			syslog(LOG_EMERG, "get_mpl failed.(A)");
			return FALSE;
		}
	}

	ercd = pget_mpl(RESERVED_MPL, 300, &vp[4]);
	if (ercd == E_OK) {
		syslog(LOG_EMERG, "get_mpl failed.(B) %d", i);
		return FALSE;
	}

	for(i = 0; i < 3; i++) {
		ercd = rel_mpl(RESERVED_MPL, vp[i]);
		if (ercd != E_OK) {
			syslog(LOG_EMERG, "rel_mpl failed. (%d,%x)", i, vp[i]);
			return FALSE;
		}
	}
	ercd = rel_mpl(RESERVED_MPL, vp[4]);
	if (ercd == E_OK) {
		syslog(LOG_EMERG, "rel_mpl failed.(B)");
		return FALSE;
	}

	ercd = del_mpl(RESERVED_MPL);
	if (ercd != E_OK) {
		syslog(LOG_EMERG, "del_mpl failed.", ercd);
	}

	ercd = del_mpl(RESERVED_MPL);
	if (ercd != E_OBJ) {
		syslog(LOG_EMERG, "something wrong in del_mpl. %d", ercd);
	}

	return TRUE;
}

/*
 *  ᥤ󥿥
 */
void main_task(VP_INT exinf)
{
	KMEMB *kmemb;

	vmsk_log(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_INFO));

	kmem_setup(buffer, 5000, &kmemb);

	syslog(LOG_NOTICE, "test_kmem.");
	if (!test_kmem(kmemb)) {
		syslog(LOG_EMERG, "test_kmem failed.");
	} else {
		syslog(LOG_NOTICE, "test_kmem passed.");
	}

	syslog(LOG_NOTICE, "test_kmem2.");
	if (!test_kmem2(kmemb)) {
		syslog(LOG_EMERG, "test_kmem2 failed.");
	} else {
		syslog(LOG_NOTICE, "test_kmem2 passed.");
	}

	syslog(LOG_NOTICE, "test_bufmgr.");
	if (!test_bufmgr()) {
		syslog(LOG_EMERG, "test_bufmgr failed.");
	} else {
		syslog(LOG_NOTICE, "test_bufmgr passed.");
	}

	syslog(LOG_NOTICE, "test_mpf1.");
	if (!test_mpf1()) {
		syslog(LOG_EMERG, "test_mpf1 failed.");
	} else {
		syslog(LOG_NOTICE, "test_mpf1 passed.");
	}

	syslog(LOG_NOTICE, "test_mpf2.");
	if (!test_mpf2()) {
		syslog(LOG_EMERG, "test_mpf2 failed.");
	} else {
		syslog(LOG_NOTICE, "test_mpf2 passed.");
	}

	syslog(LOG_NOTICE, "test_mpl1.");
	if (!test_mpl1()) {
		syslog(LOG_EMERG, "test_mpl1 failed.");
	} else {
		syslog(LOG_NOTICE, "test_mpl1 passed.");
	}

	syslog(LOG_NOTICE, "test_mpl2.");
	if (!test_mpl2()) {
		syslog(LOG_EMERG, "test_mpl2 failed.");
	} else {
		syslog(LOG_NOTICE, "test_mpl2 passed.");
	}


	syslog(LOG_NOTICE, "All tests passed.");

	kernel_exit();
}
