/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: diag_mbf.c,v 1.1 2003/11/20 06:19:04 monaka Exp $
 */

#include <t_services.h>
#include "kernel_id.h"
#include "diag_mbf.h"

void
sync_task(VP_INT exinf)
{
	VB buf[10];
	ER_UINT buflen;
	ER ercd;

	buflen = rcv_mbf(MBF1, buf);
	if (buflen < 0) {
		syslog(LOG_EMERG, "Something wrong in rcv_mbf - sync_task. (%d)", buflen);
	}

	ercd = snd_mbf(MBF1, buf, buflen);
	if (ercd != E_OK) {
		syslog(LOG_EMERG, "Something wrong in snd_mbf - sync_task. (%d)", ercd);
	}

	buf[0] = 'A';
	ercd = snd_mbf(MBF1, buf, buflen);
	if (ercd != E_OK) {
		syslog(LOG_EMERG, "Something wrong in snd_mbf - sync_task. (%d)", ercd);
	}

	ext_tsk();
}

void
sync_task2(VP_INT exinf)
{
	VB buf[10];
	ER_UINT buflen;
	ER ercd;
	ID mbfid;

	mbfid = (ID)exinf;

	while (1) {
		buflen = rcv_mbf(mbfid, buf);
		if (buflen < 0) {
			if (buflen == E_DLT) {
				syslog(LOG_INFO, "E_DLT in rcv_mbf - It might be legal but you should check it.");
			} if (buflen == E_NOEXS) {
				syslog(LOG_INFO, "E_NOEXS in rcv_mbf - It might be legal but you should check it.");
			} else {
				syslog(LOG_EMERG, "Something wrong in rcv_mbf - sync_task2. (%d)", buflen);
			}
			break;
		}

		ercd = snd_mbf(mbfid, buf, buflen);
		if (ercd != E_OK) {
			syslog(LOG_EMERG, "Something wrong in snd_mbf - sync_task2. (%d)", ercd);
			break;
		}
	}

	ext_tsk();
}

void
async_task(VP_INT exinf) {
	ER ercd;
	VB buf[10];
	UINT i;

	for (i = 0; i < 34; i++) {
		ercd = rcv_mbf(ASYNC_MBF, buf);
		if (ercd != 10) {
			syslog(LOG_EMERG, "Something wrong in rcv_mbf - async_task. (%d)", ercd);
		}
	}
	wup_tsk(MAIN_TASK);

	ext_tsk();
}

BOOL
test_mbf6()
{
	UINT i;
	ER ercd;
	VB buf[10];

	for(i = 0; i < 34; i++) {
		ercd = snd_mbf(ASYNC_MBF, buf, 10);
		if (ercd != E_OK) {
			syslog(LOG_EMERG, "Something wrong in snd_mbf - test_mbf6. (%d)", ercd);
			return FALSE;
		}
	}

	ercd = tslp_tsk(1000);
	if (ercd != E_OK) {
		syslog(LOG_EMERG, "Something wrong in snd_mbf - test_mbf6. (%d)", ercd);
		return FALSE;
	}

	return TRUE;
}
	
BOOL
test_mbf1()
{
	VB buf[11] = "abcdefghij";
	int i;
	ER ercd;

	ercd = snd_mbf(MBF1, buf, 10);
	if (ercd != E_OK) {
		syslog(LOG_EMERG, "Something wrong in snd_mbf - test_mbf1. (%d)", ercd);
		return FALSE;
	}
	for (i = 0; i < 10; i++) buf[i] = 'a';

	ercd = rcv_mbf(MBF1, buf);
	if (ercd != 10) {
		syslog(LOG_EMERG, "Something wrong in rcv_mbf - test_mbf1. (%d)", ercd);
		return FALSE;
	}

	ercd = rcv_mbf(MBF1, buf);
	if (ercd != 10 || buf[0] != 'A') {
		syslog(LOG_EMERG, "Something wrong in rcv_mbf - test_mbf1. (%d)", ercd);
		return FALSE;
	}

	return TRUE;
}


BOOL
test_mbf2(ID mbfid)
{
	VB sbuf[11] = "abcdefghi";
	VB rbuf[10];
	int i;
	int j;
	ER ercd;

	for (i = 0; i < 30; i++) {
		ercd = snd_mbf(mbfid, sbuf, sizeof(sbuf) - 1);
		if (ercd != E_OK) {
			syslog(LOG_EMERG, "Something wrong in snd_mbf - test_mbf2. (%d)", ercd);
			return FALSE;
		}

		ercd = rcv_mbf(mbfid, rbuf);
		if (ercd != sizeof(rbuf)) {
			syslog(LOG_EMERG, "Something wrong in rcv_mbf - test_mbf2. (%d)", ercd);
			return FALSE;
		}
		for(j = 0; j < 10; j++) {
			if (sbuf[j] != rbuf[j]) {
				syslog(LOG_EMERG, "Something wrong in test_mbf2. (%d)", ercd);
			}
		}
	}

	return TRUE;
}


BOOL
test_mbf3()
{
	T_CMBF cmbf;
	VB mbf[20];
	ER ercd;
	BOOL stat;

	cmbf.mbfatr = TA_HLNG;
	cmbf.maxmsz = 10;
	cmbf.mbfsz = 5;
	cmbf.mbf = mbf;

	ercd = cre_mbf(RESERVED_MBFID, &cmbf);
	if (ercd != E_OK) {
		syslog(LOG_EMERG, "Error in cre_mbf (%d)", ercd);
		return FALSE;
	}

	syslog(LOG_INFO, "Entering test_mbf2...");
	stat = test_mbf2(RESERVED_MBFID);
	if (stat) {
		syslog(LOG_INFO, "Exit test_mbf2...succeeded");
	} else {
		syslog(LOG_EMERG, "Exit test_mbf2...failed");
		return FALSE;
	}

	ercd = del_mbf(RESERVED_MBFID);
	if (ercd != E_OK) {
		syslog(LOG_EMERG, "Error in del_mbf (%d)", ercd);
		return FALSE;
	}

	return TRUE;
}

BOOL
test_mbf4()
{
	T_CMBF cmbf;
	ER ercd;
	BOOL stat;
	UINT i;

	cmbf.mbfatr = TA_HLNG;
	cmbf.maxmsz = 10;
	cmbf.mbfsz = 5;
	cmbf.mbf = NULL;

	for (i = 0; i < 50; i++) {
		ercd = cre_mbf(RESERVED_MBFID, &cmbf);
		if (ercd != E_OK) {
			syslog(LOG_EMERG, "Error in cre_mbf (%d)", ercd);
			return FALSE;
		}

		stat = test_mbf2(RESERVED_MBFID);
		if (!stat) {
			syslog(LOG_EMERG, "Exit test_mbf2(RESERVED_MBFID)...failed");
			return FALSE;
		}

		ercd = del_mbf(RESERVED_MBFID);
		if (ercd != E_OK) {
			syslog(LOG_EMERG, "Error in del_mbf (%d)", ercd);
			return FALSE;
		}

	}

	return TRUE;
}

BOOL
test_mbf5()
{
	T_CMBF cmbf;
	VB mbf[20];
	ER ercd;
	ER_ID aid;
	BOOL stat;
	UINT i;

	cmbf.mbfatr = TA_HLNG;
	cmbf.maxmsz = 10;
	cmbf.mbfsz = 20;
	cmbf.mbf = mbf;

	aid = acre_mbf(&cmbf);
	if (aid <= E_OK) {
		syslog(LOG_EMERG, "Error in acre_mbf A (%d)", ercd);
		return FALSE;
	}
	ercd = del_mbf(aid);
	if (aid < E_OK) {
		syslog(LOG_EMERG, "Error in del_mbf A (%d)", ercd);
		return FALSE;
	}

	for (i = 0; i < 300; i++) {
		ercd = acre_mbf(&cmbf);
		if (ercd != aid) {
			syslog(LOG_EMERG, "Error in acre_mbf B (ercd=%d,i=%d)", ercd, i);
			return FALSE;
		}

		ercd = del_mbf(aid);
		if (ercd != E_OK) {
			syslog(LOG_EMERG, "Error in del_mbf B (recd=%d,i=%d)", ercd, i);
			return FALSE;
		}

	}

	return TRUE;
}

/*
 *  ᥤ󥿥
 */
void
main_task(VP_INT exinf)
{
	ER	ercd;
	BOOL	stat;
	vmsk_log(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_INFO));


	act_tsk(SYNC_TASK);
	stat = test_mbf1();
	if (stat) {
		syslog(LOG_NOTICE, "Test mbf1 succeeded.");
	} else {
		syslog(LOG_EMERG, "Test mbf1 failed.");
		goto error;
	}

	act_tsk(SYNC_TASK2);
	stat = test_mbf2(MBF2);
	if (stat) {
		syslog(LOG_NOTICE, "Test mbf2 succeeded.");
	} else {
		syslog(LOG_EMERG, "Test mbf2 failed.");
		goto error;
	}

	act_tsk(SYNC_TASK3);
	stat = test_mbf3();
	if (stat) {
		syslog(LOG_NOTICE, "test_mbf3 succeeded.");
	} else {
		syslog(LOG_EMERG, "test_mbf3 failed.");
		goto error;
	}

#if 0
	stat = test_mbf4();
	if (stat) {
		syslog(LOG_NOTICE, "test_mbf4 succeeded.");
	} else {
		syslog(LOG_EMERG, "test_mbf4 failed.");
		goto error;
	}
#endif

	stat = test_mbf5();
	if (stat) {
		syslog(LOG_NOTICE, "test_mbf5 succeeded.");
	} else {
		syslog(LOG_EMERG, "test_mbf5 failed.");
		goto error;
	}

	act_tsk(ASYNC_TASK);
	stat = test_mbf6();
	if (stat) {
		syslog(LOG_NOTICE, "test_mbf6 succeeded.");
	} else {
		syslog(LOG_EMERG, "test_mbf6 failed.");
		goto error;
	}


	syslog(LOG_NOTICE, "All tests passed.");
 error:
	kernel_exit();
}
