/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: diag_mbx.c,v 1.1 2003/11/20 06:19:04 monaka Exp $
 */

#include <t_services.h>
#include "kernel_id.h"
#include "diag_mbx.h"

/*
 *
 */
void mbx_task(VP_INT exinf)
{
	ER ercd;
	ID mbxid;
	T_MSG *pk_msg;

	mbxid = (ID)exinf;

	ercd = rcv_mbx(mbxid, &pk_msg);
	if (ercd != E_OK) {
		syslog(LOG_EMERG, "Something wrong in wai_mbx. (%d).", ercd);
		goto error;
	}
	dly_tsk(0);
	wup_tsk(MAIN_TASK);

 error:
	ext_tsk();
}

BOOL
test_mbx1()
{
	ER ercd;
	T_RMBX rmbx;
	T_MSG t_msg;

	ercd = ref_mbx(MBX1, &rmbx);
	if (ercd != E_OK || rmbx.wtskid != TSK_NONE) {
		syslog(LOG_EMERG, "Wrong wtskid in ref_mbx.");
		return FALSE;
	}

	act_tsk(MBX_TASK);
	dly_tsk(0);

	ercd = ref_mbx(MBX1, &rmbx);
	if (ercd != E_OK || rmbx.wtskid != MBX_TASK) {
		syslog(LOG_EMERG, "Wrong wtskid in ref_mbx. (NOT MBX_TASK == %d)", rmbx.wtskid);
		return FALSE;
	}

	ercd = snd_mbx(MBX1, &t_msg);
	dly_tsk(0);

	slp_tsk();

	return TRUE;
}

BOOL
test_mbx2()
{
	T_CMBX cmbx;
	T_MSG t_msg;
	BOOL stat;
	ER ercd;

	cmbx.mbxatr = TA_HLNG;
	cmbx.maxmpri = 1;
	cmbx.mprihd = NULL;

	ercd = cre_mbx(RESERVED_MBXID, &cmbx);
	if (ercd != E_OK) {
		syslog(LOG_EMERG, "Something wrong in cre_mbx. (%d)", ercd);
		return FALSE;
	}

	act_tsk(RESERVED_MBX_TASK);
	dly_tsk(0);

	ercd = snd_mbx(RESERVED_MBXID, &t_msg);

	slp_tsk();

	return TRUE;
}

BOOL
test_mbx3()
{
	T_CMBX cmbx;
	BOOL stat;
	ER ercd;
	ER_ID mbxid;

	cmbx.mbxatr = TA_HLNG;
	cmbx.maxmpri = 1;
	cmbx.mprihd = NULL;

	mbxid = acre_mbx(&cmbx);
	if (mbxid < E_OK) {
		syslog(LOG_EMERG, "Something wrong in acre_mbx. (%d)", ercd);
		return FALSE;
	}

	ercd = del_mbx(mbxid);
	if (ercd != E_OK) {
		syslog(LOG_EMERG, "Something wrong in del_mbx. (%d)", ercd);
		return FALSE;
	}

	return TRUE;
}

/*
 *  ᥤ󥿥
 */
void main_task(VP_INT exinf)
{
	BOOL stat;

	vmsk_log(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_INFO));

	stat = test_mbx1();
	if (stat) {
		syslog(LOG_INFO, "test_mbx1 succeeded.");
	} else {
		syslog(LOG_EMERG, "test_mbx1 failed.");
		goto error;
	}

	stat = test_mbx2();
	if (stat) {
		syslog(LOG_INFO, "test_mbx2 succeeded.");
	} else {
		syslog(LOG_EMERG, "test_mbx2 failed.");
		goto error;
	}

	stat = test_mbx3();
	if (stat) {
		syslog(LOG_INFO, "test_mbx3 succeeded.");
	} else {
		syslog(LOG_EMERG, "test_mbx3 failed.");
		goto error;
	}

	syslog(LOG_NOTICE, "All tests passed.");
 error:
	kernel_exit();
}
