/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: diag_multiqueue.c,v 1.1 2003/11/20 06:19:04 monaka Exp $
 */

#include <t_services.h>
#include "kernel_id.h"
#include "diag_mbf.h"
#include "kernel/multiqueue.h"

typedef struct {
	MULTIOBJCB wobjcb;
	QUEUE qb;
	QUEUE qc;
	UINT value;
} MULTIQUEUE;

BOOL test1()
{
	MULTIQUEUE	top_queue;
	MULTIQUEUE	queue2;
	MULTIQUEUE	queue3;
	MULTIQUEUE	queue4;
	MULTIQUEUE	queue5;
	MULTIQUEUE	*ptr;
	UINT i;

	for (i = 0; i < 3; i++) {
		multiqueue_initialize((MULTIOBJCB *)&top_queue, i);
		multiqueue_insert_prev((MULTIOBJCB *)&top_queue, (MULTIOBJCB *)&queue2, i);
		multiqueue_insert_prev((MULTIOBJCB *)&top_queue, (MULTIOBJCB *)&queue3, i);
		multiqueue_insert_prev((MULTIOBJCB *)&top_queue, (MULTIOBJCB *)&queue4, i);
		multiqueue_insert_prev((MULTIOBJCB *)&top_queue, (MULTIOBJCB *)&queue5, i);

		multiqueue_delete((MULTIOBJCB *)&queue4, i);

		ptr = (MULTIQUEUE *)multiqueue_delete_next((MULTIOBJCB *)&top_queue, i);
		if (ptr != &queue2) {
			syslog(LOG_EMERG, "Test1.%d.1 failed.", i);
			return FALSE;
		}
		ptr = (MULTIQUEUE *)multiqueue_delete_next((MULTIOBJCB *)&top_queue, i);
		if (ptr != &queue3) {
			syslog(LOG_EMERG, "Test1.%d.2 failed.", i);
			return FALSE;
		}
		ptr = (MULTIQUEUE *)multiqueue_delete_next((MULTIOBJCB *)&top_queue, i);
		if (ptr != &queue5) {
			syslog(LOG_EMERG, "Test1.%d.3 failed.", i);
			return FALSE;
		}
		if (!multiqueue_empty((MULTIOBJCB *)&top_queue, i)) {
			syslog(LOG_EMERG, "Test1.%d.4 failed.", i);
			return FALSE;
		}
	}

	return TRUE;
}

BOOL test2()
{
	UINT i;
	UINT j;
	UINT k;
	MULTIQUEUE top_queue;
	MULTIQUEUE queue[5];
	MULTIQUEUE *ptr;

	for (i = 0; i < 3; i++) {
		multiqueue_initialize((MULTIOBJCB *)&top_queue, i);
		for(j = 0; j < 5; j++) {
			multiqueue_insert_prev((MULTIOBJCB *)&top_queue, (MULTIOBJCB *)&queue[j], i);
			queue[j].value = j;
		}
		
		ptr = NULL;
		k = 0;
		while((ptr = (MULTIQUEUE *)multiqueue_enumerate((MULTIOBJCB *)&top_queue, (MULTIOBJCB *)ptr, i)) != NULL) {
			if (ptr != &queue[k]) {
				syslog(LOG_EMERG, "Error in test2.%d.1", k + 1);
				return FALSE;
			}
			if (ptr->value != k) {
				syslog(LOG_EMERG, "Error in test2.%d.2", k + 1);
				return FALSE;
			}
			k++;
		}
	}

	return TRUE;
}

/*
 *  ᥤ󥿥
 */
void
main_task(VP_INT exinf)
{
	ER	ercd;
	BOOL	stat;
	
	vmsk_log(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_INFO));

	stat = test1();
	if (!stat) {
		goto error;
	}

	stat = test2();
	if (!stat) {
		goto error;
	}

		
	syslog(LOG_NOTICE, "All tests passed.");
 error:
	kernel_exit();
}
