/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: diag_por.c,v 1.1 2003/11/20 06:19:04 monaka Exp $
 */

#include <t_services.h>
#include "kernel_id.h"
#include "diag_por.h"

void
sync_task(VP_INT exinf)
{
	VB buf[10];
	ER_UINT buflen;
	ER ercd;
	RDVNO	rdvno;

	while (1) {
		buflen = acp_por(POR1, 0x1234, &rdvno, buf);
		if (buflen < 0) {
			syslog(LOG_EMERG, "Something wrong in acp_por - sync_task. (%d)", buflen);
		}

		buf[0] = 'A';
		ercd = rpl_rdv(rdvno, buf, buflen);
		if (ercd != E_OK) {
			syslog(LOG_EMERG, "Something wrong in rpl_rdv - sync_task. (%d)", ercd);
		}
	}

	ext_tsk();
}

void
fwd_task(VP_INT exinf)
{
	VB buf[10];
	ER_UINT buflen;
	ER ercd;
	RDVNO	rdvno;

	while (1) {
		buflen = acp_por(POR2, 0x2345, &rdvno, buf);
		if (buflen < 0) {
			syslog(LOG_EMERG, "Something wrong in acp_por - sync_task. (%d)", buflen);
		}

		buf[0] = 'B';
		ercd = fwd_por(POR1, 0x1234, rdvno, buf, buflen);
		/*		ercd = cal_por(POR1, 0x1234, buf, buflen); */
		if (ercd != E_OK) {
			syslog(LOG_EMERG, "Something wrong in fwd_por - sync_task. (%d)", ercd);
		}
	}

	ext_tsk();
}

BOOL
test_por1()
{
	VB buf[11] = "abcdefghij";
	ER_UINT buflen;
	UINT i;

	for (i = 0; i < 5; i++) {
		buflen = cal_por(POR1, 0x1234, buf, 10);
		if (buflen != 10 || buf[0] != 'A') {
			syslog(LOG_EMERG, "Something wrong in cal_por - test_por1. (%d)", buflen);
			return FALSE;
		}
	}

	return TRUE;
}

BOOL
test_por2()
{
	VB buf[11] = "abcdefghij";
	ER_UINT buflen;
	UINT i;

	buflen = cal_por(POR2, 0x2345, buf, 0);
	if (buflen != 0) {
		syslog(LOG_EMERG, "Something wrong in cal_por - test_por2. (%d != %d)", i,buflen);
		return FALSE;
	}

	for (i = 1; i < 11; i++) {
		buflen = cal_por(POR2, 0x2345, buf, i);
		if (buflen != i || buf[0] != 'A') {
			syslog(LOG_EMERG, "Something wrong in cal_por - test_por2. (%d != %d, %c)", i,buflen, buf[0]);
			return FALSE;
		}
	}

	return TRUE;
}

/*
 *  ᥤ󥿥
 */
void
main_task(VP_INT exinf)
{
	ER	ercd;
	BOOL	stat;
	vmsk_log(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_INFO));


	act_tsk(SYNC_TASK);
	stat = test_por1();
	if (stat) {
		syslog(LOG_NOTICE, "Test por1 succeeded.");
	} else {
		syslog(LOG_EMERG, "Test por1 failed.");
		goto error;
	}

	act_tsk(FWD_TASK);
	stat = test_por2();
	if (stat) {
		syslog(LOG_NOTICE, "Test por2 succeeded.");
	} else {
		syslog(LOG_EMERG, "Test por2 failed.");
		goto error;
	}

	syslog(LOG_NOTICE, "All tests passed.");
 error:
	kernel_exit();
}
