/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: diag_sem.c,v 1.1 2003/11/20 06:19:04 monaka Exp $
 */

#include <t_services.h>
#include "kernel_id.h"
#include "diag_sem.h"

/*
 *
 */
void sem_task(VP_INT exinf)
{
	T_RSEM rsem;
	ER ercd;
	INT i;
	ID semid;

	semid = (ID)exinf;

	for(i = 0; i < 4; i++) {
		ercd = ref_sem(semid, &rsem);
		if (ercd != E_OK || rsem.semcnt != 3 - i) {
			syslog(LOG_EMERG, "Something wrong in ref_sem. (%d).", ercd);
			goto error;
		}

		ercd = wai_sem(semid);
		if (ercd != E_OK) {
			syslog(LOG_EMERG, "Something wrong in wai_sem. (%d).", ercd);
			goto error;
		}
	}

 error:
	ext_tsk();
}


BOOL
test_sem_common1(ID semid, ID wtskid)
{
	T_RSEM rsem;
	ER ercd;
	INT i;

	ercd = ref_sem(semid, &rsem);
	if (rsem.wtskid != wtskid) {
			syslog(LOG_EMERG, "Something wrong in ref_sem. (%d, %d).", rsem.wtskid, ercd);
	}

	for(i = 0; i < 4; i++) {
		ercd = sig_sem(semid);
		if (ercd != E_OK) {
			syslog(LOG_EMERG, "Something wrong in sig_sem. (%d).", ercd);
			return FALSE;
		}
	}

	return TRUE;
}

BOOL
test_sem1()
{
	BOOL stat;

	act_tsk(SEM1_TASK);
	dly_tsk(0);

	stat = test_sem_common1(SEM1, SEM1_TASK);
	return stat;
}

BOOL
test_sem2()
{
	T_CSEM csem;
	BOOL stat;
	ER ercd;

	csem.sematr = TA_HLNG;
	csem.isemcnt = 3;
	csem.maxsem = 3;

	ercd = cre_sem(RESERVED_SEMID, &csem);
	if (ercd != E_OK) {
		syslog(LOG_EMERG, "Something wrong in cre_sem. (%d)", ercd);
		return FALSE;
	}

	act_tsk(SEM_RESERVED_TASK);
	dly_tsk(0);

	stat = test_sem_common1(RESERVED_SEMID, SEM_RESERVED_TASK);
	if (!stat) {
		syslog(LOG_EMERG, "Something wrong in test_sem_common1.");
		return FALSE;
	}
	ercd = del_sem(RESERVED_SEMID);
	if (ercd != E_OK) {
		syslog(LOG_EMERG, "Something wrong in del_sem. (%d)", ercd);
		return FALSE;
	}
	ercd = del_sem(RESERVED_SEMID);
	if (ercd == E_OK) {
		syslog(LOG_EMERG, "Something wrong in del_sem. (%d)", ercd);
		return FALSE;
	}

	return TRUE;
}

BOOL
test_sem3()
{
	T_CSEM csem;
	T_RSEM rsem;
	BOOL stat;
	ER ercd;
	ER_ID semid;
	csem.sematr = TA_HLNG;
	csem.isemcnt = 3;
	csem.maxsem = 3;

	semid = acre_sem(&csem);
	if (semid != 1) {
		syslog(LOG_EMERG, "Something wrong in cre_sem. (%d)", ercd);
		return FALSE;
	}

	ercd = ref_sem(semid, &rsem);
	if (ercd != E_OK || rsem.semcnt != 3) {
		syslog(LOG_EMERG, "Something wrong in ref_sem. (%d).", ercd);
		return FALSE;
	}

	ercd = del_sem(ercd);
	if (ercd != E_OK) {
		syslog(LOG_EMERG, "Something wrong in del_sem. (%d)", ercd);
		return FALSE;
	}

	return TRUE;
}

/*
 *  ᥤ󥿥
 */
void main_task(VP_INT exinf)
{
	BOOL stat;

	vmsk_log(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_INFO));

	stat = test_sem1();
	if (stat) {
		syslog(LOG_INFO, "test_sem1 succeeded.");
	} else {
		syslog(LOG_EMERG, "test_sem1 failed.");
		goto error;
	}

	stat = test_sem2();
	if (stat) {
		syslog(LOG_INFO, "test_sem2 succeeded.");
	} else {
		syslog(LOG_EMERG, "test_sem2 failed.");
		goto error;
	}

	syslog(LOG_NOTICE, "All tests passed.");
 error:
	kernel_exit();
}
