/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: diag_svc.c,v 1.1 2003/11/20 06:19:04 monaka Exp $
 */

#include <t_services.h>
#include "kernel_id.h"
#include "diag_svc.h"

ER_UINT
exsvc1(VP_INT arg1) {
	return 10;
}

ER_UINT
exsvc2(VP_INT arg1) {
	char *s;
	s = (char *)arg1;
	s[4] = 'w';

	return E_OK;
}

void main_task(VP_INT exinf) {
	ER ercd;
	char hello[] = "Hello";
	T_DSVC dsvc;

	vmsk_log(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_INFO));

	ercd = cal_svc(1, "Hello", NULL, NULL, NULL, NULL);
	if (ercd != 10) {
		syslog(LOG_EMERG, "Something wrong in cal_svc or exsvc1.");
	}

	ercd = cal_svc(2, hello, NULL, NULL, NULL, NULL);
	if (ercd != 0 || hello[4] != 'w') {
		syslog(LOG_EMERG, "Something wrong in cal_svc or exsvc2.");
	}

	dsvc.svcatr = TA_HLNG;
	dsvc.svcrtn = exsvc1;
	ercd = def_svc(3, &dsvc);
	if (ercd != 0) {
		syslog(LOG_EMERG, "Something wrong in def_svc (exsvc1).");
	}
	ercd = cal_svc(3, "Hello", NULL, NULL, NULL, NULL);
	if (ercd != 10) {
		syslog(LOG_EMERG, "Something wrong in cal_svc or exsvc1. (%d)", ercd);
	}


	dsvc.svcatr = TA_HLNG;
	dsvc.svcrtn = exsvc2;
	ercd = def_svc(3, &dsvc);
	if (ercd != 0) {
		syslog(LOG_EMERG, "Something wrong in def_svc (exsvc2).");
	}
	ercd = cal_svc(3, hello, NULL, NULL, NULL, NULL);
	if (ercd != 0 || hello[4] != 'w') {
		syslog(LOG_EMERG, "Something wrong in cal_svc or exsvc2 (%d).", ercd);
	}

	dsvc.svcatr = TA_HLNG;
	dsvc.svcrtn = NULL;
	ercd = def_svc(3, &dsvc);
	if (ercd != 0) {
		syslog(LOG_EMERG, "Something wrong in def_svc (NULL).");
	}
	ercd = cal_svc(3, hello, NULL, NULL, NULL, NULL);
	if (ercd != E_RSFN) {
		syslog(LOG_EMERG, "Something wrong in cal_svc (NULL).");
	}

	syslog(LOG_INFO, "All tests passed.");

	kernel_exit();
}
