/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: alarm.c,v 1.20 2003/11/10 13:41:07 monaka Exp $
 */

/*
 *	顼ϥɥ鵡ǽ
 */

#include "jsp_kernel.h"
#include "check.h"
#include "alarm.h"

/*
 *  顼ϥɥIDκ͡kernel_cfg.c
 */
extern const ID	tmax_almid;

/*
 *  顼ϥɥ֥åΥꥢkernel_cfg.c
 */
extern ALMINIB	alminib_table[];

/*
 *  顼ϥɥ֥åϢۥڥοkernel_cfg.c
 */
extern const UINT	tnum_alminia;

/*
 *  顼ϥɥ֥åϢۥڥΥꥢkernel_cfg.c
 */
extern const ALMINIA	alminia_table[];

/*
 *  顼ϥɥͽIDΥꥢkernel_cfg.c
 */
extern const ID		almrid_table[];

/*
 *  顼ϥɥͽIDο (kernel_cfg.c)
 */
extern const UINT	tnum_almrid;

/*
 *  顼ϥɥ֥åΥꥢkernel_cfg.c
 */
extern ALMCB	almcb_table[];

/*
 *  顼ϥɥο
 */
#define TNUM_ALM	((UINT)(tmax_almid - TMIN_ALMID + 1))

/*
 *  顼ϥɥID饢顼ϥɥ֥åФΥޥ
 */
#define INDEX_ALM(almid)	((UINT)((almid) - TMIN_ALMID))
#define get_almcb(almid)	(&(almcb_table[INDEX_ALM(almid)]))

/*
 *  IDưѥե꡼ꥹ
 */
extern QUEUE alm_freelist;

/*
 *  ޤ顼ϥɥη
 */
typedef void	(*ALMHDR)(VP_INT exinf);

/*
 *  顼ϥɥ鵡ǽν
 */
#ifdef __almini

QUEUE alm_freelist;

void
alarm_initialize()
{
	UINT	i;
	ALMCB	*almcb;
	ALMINIB *alminib;
	const ALMINIA *alminia;
	const ID	*almrid;

	/*
	 * ͥ뵯ưξ֤˴ؤ餺ʤФʤΤ
	 * ޤ롣
	 */
	for (almcb = almcb_table, i = 0; i < TNUM_ALM; almcb++, i++) {
		queue_initialize(&(almcb->wait_queue));
	}
	queue_initialize(&alm_freelist);

	/*
	 * alminia ˤäƼΤޤ
	 */
	for (alminia = alminia_table, i = 0; i < tnum_alminia; alminia++, i++) {
		alminib = &alminib_table[alminia->almid - TMIN_ALMID];
		*alminib = alminia->alminib;
		almcb = &almcb_table[alminia->almid - TMIN_ALMID];
		almcb->alminib = alminib;
		almcb->exist = KOBJ_EXIST;
		almcb->reserved = TRUE;
		/* TODO:  */
	}

	/*
	 *  ͽID
	 */
	for (almrid = almrid_table, i = 0; i < tnum_almrid; almrid++, i++) {
		almcb[*almrid - TMIN_ALMID].reserved = TRUE;
	}

	/*
	 * alminia ˤäƼʤΤ
	 */
	for (almcb = almcb_table, i = 0; i < TNUM_ALM; almcb++, i++) {
		if (almcb->alminib == NULL) {
			almcb->exist = KOBJ_NOEXS;
			almcb->alminib = &alminib_table[i];

			if (!CHECK_OBJECT_RESERVED(almcb)) {
				queue_insert_prev(&alm_freelist, (QUEUE*)almcb);
			}
		}
	}
}

#endif /* __almini */

/*
 *  顼ϥɥ鵯ưΤΥ।٥ȥ֥åϿ
 */
#ifdef __almenq

#if 0
void
tmevtb_enqueue_alm(ALMCB *almcb, EVTTIM evttim)
{
  /* TODO: */
     /*
	tmevtb_enqueue_evttim(&(almcb->tmevtb), evttim,
				(CBACK) call_almhdr, (VP) almcb);
	almcb->evttim = evttim;
  */
}
#endif

#endif /* __almenq */

/*
 *  顼ϥɥ
 */
#ifdef __cre_alm

SYSCALL ER
cre_alm(ID almid, const T_CALM * pk_calm)
{
	ALMCB	*almcb;
	ALMINIB *alminib;
	ER	ercd;
    
	LOG_CRE_ALM_ENTER(almid);
	CHECK_TSKCTX_UNL();

	CHECK_ALMID(almid);
	almcb = get_almcb(almid);
	CHECK_OBJECT_CREATABLE(almcb);
	UPDATE_OBJECT_FREELIST(almcb);

	/*
	 * Ԥ
	 * wait_queue ϡ alarm_initialize()ǽ뤷
	 * del_almλˤݽ롣äơǤϽɬפʤ
	 */
	alminib = almcb->alminib;
	alminib->almatr = pk_calm->almatr;
	/* TODO: alminibν */

	/* TODO: almcbν */


	/*
	 *  ǽ¾Υӥ뤫Ѳǽˤʤ롣
	 */
	almcb->exist = KOBJ_EXIST;

	ercd = E_OK;

    exit:
	LOG_CRE_ALM_LEAVE(ercd);
	return(ercd);
}

#endif /* __cre_alm */

/*
 *  顼ϥɥ(IDֹ漫ưդ)
 */
#ifdef __acre_alm

SYSCALL ER_ID
acre_alm(const T_CALM *pk_calm)
{
	ALMCB	*almcb;
	ALMINIB *alminib;
	ER_ID	ercd;
    
	LOG_ACRE_ALM_ENTER();
	CHECK_TSKCTX_UNL();

	t_lock_cpu();
	almcb = (ALMCB *)t_get_free_id((QUEUE *)&alm_freelist);
	if (almcb == NULL) {
		ercd = E_NOID;
		t_unlock_cpu();
		goto exit;
	}
	almcb->exist = KOBJ_INIT;
	t_unlock_cpu();

	/*
	 * Ԥ
	 */
	queue_initialize(&(almcb->wait_queue));
	alminib = almcb->alminib;
	alminib->almatr = pk_calm->almatr;
	/* TODO: alminibν */

	/* TODO: almcbν */

	ercd = ALMID(almcb);

	/*
	 *  ǽ¾Υӥ뤫Ѳǽˤʤ롣
	 */
	almcb->exist = KOBJ_EXIST;

    exit:
	LOG_ACRE_ALM_LEAVE(ercd);
	return(ercd);
}

#endif /* __acre_alm */

/*
 *  顼ϥɥκ
 */
#ifdef __del_alm
SYSCALL ER
del_alm(ID almid)
{
	ALMCB	*almcb;
	ER	ercd;
    
	LOG_DEL_ALM_ENTER(almid);
	CHECK_TSKCTX_UNL();

	CHECK_ALMID(almid);
	almcb = get_almcb(almid);

	CHECK_OBJECT_DELETABLE(almcb);

	/*
	 * 顼ϥɥ餬ưƤ顢ߤ롣
	 */
	if (almcb->almsta) {
		almcb->almsta = FALSE;
		t_lock_cpu();
		tmevtb_dequeue(&(almcb->tmevtb));
		t_unlock_cpu();
	}

	if (!CHECK_OBJECT_RESERVED(almcb)) {
	  /*
	   * ͽIDǤʤХե꡼ꥹȤ롣
	   */
		t_lock_cpu();
		queue_insert_prev(&alm_freelist, (QUEUE *)almcb);
		t_unlock_cpu();
	}

	/* acre_/cre_ǤΥǽ */
	almcb->exist = KOBJ_NOEXS;

	ercd = E_OK;

    exit:
	LOG_DEL_ALM_LEAVE(ercd);
	return(ercd);
}

#endif /* __del_alm */

/*
 *  顼ϥɥư
 */
#ifdef __sta_alm

SYSCALL ER
sta_alm(ID almid, RELTIM almtim)
{
	ALMCB	*almcb;
	ER	ercd;

	LOG_STA_ALM_ENTER(almid);
	CHECK_TSKCTX_UNL();

	CHECK_ALMID(almid);
	almcb = get_almcb(almid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(almcb);
	ercd = E_NOSPT;
	t_unlock_cpu();
    exit:
	LOG_STA_ALM_LEAVE(ercd);
	return(ercd);
}

#endif /* __sta_alm */

/*
 *  顼ϥɥư
 */
#ifdef __stp_alm

SYSCALL ER
stp_alm(ID almid)
{
	ALMCB	*almcb;
	ER	ercd;

	LOG_STP_ALM_ENTER(almid);
	CHECK_TSKCTX_UNL();

	CHECK_ALMID(almid);
	almcb = get_almcb(almid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(almcb);

	ercd = E_NOSPT;

	t_unlock_cpu();
     exit:
	LOG_STP_ALM_LEAVE(ercd);
	return(ercd);
}

#endif /* __stp_alm */

/*
 *  顼ϥɥξֻ
 */
#ifdef __ref_alm
SYSCALL ER
ref_alm(ID almid, T_RALM *pk_ralm)
{
	ALMCB	*almcb;
	ER	ercd;
    
	LOG_REF_ALM_ENTER(almid);
	CHECK_TSKCTX_UNL();

	CHECK_ALMID(almid);
	almcb = get_almcb(almid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(almcb);

	if (almcb->almsta) {
		pk_ralm->almstat = TALM_STA;
	} else {
		pk_ralm->almstat = TALM_STP;
	}
	/* TODO: pk_ralm->lefttim; */

	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_REF_ALM_LEAVE(ercd);
	return(ercd);
}

#endif /* __ref_alm */

