/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: check.h,v 1.11 2003/11/20 18:00:31 monaka Exp $
 */

/*
 *	顼åѥޥ
 */

#ifndef _CHECK_H_
#define _CHECK_H_

/*
 *  ͥ٤ϰϤȽ
 */
#define VALID_TPRI(tpri) \
	(TMIN_TPRI <= (tpri) && (tpri) <= TMAX_TPRI)

/*
 *  ͥ٤ΥåE_PAR
 */
#define CHECK_TPRI(tpri) {					\
	if (!VALID_TPRI(tpri)) {				\
		ercd = E_PAR;					\
		goto exit;					\
	}							\
}

#define CHECK_TPRI_INI(tpri) {					\
	if (!(VALID_TPRI(tpri) || (tpri) == TPRI_INI)) {	\
		ercd = E_PAR;					\
		goto exit;					\
	}							\
}

#define CHECK_TPRI_SELF(tpri) {					\
	if (!(VALID_TPRI(tpri) || (tpri) == TPRI_SELF)) {	\
		ercd = E_PAR;					\
		goto exit;					\
	}							\
}

/*
 *  ॢȻͤΥåE_PAR
 */
#define CHECK_TMOUT(tmout) {					\
	if (!(TMO_FEVR <= (tmout))) {				\
		ercd = E_PAR;					\
		goto exit;					\
	}							\
}

/*
 *  ¾Υѥ᡼顼ΥåE_PAR
 */
#define CHECK_PAR(exp) {					\
	if (!(exp)) {						\
		ercd = E_PAR;					\
		goto exit;					\
	}							\
}

/*
 *  ¾Υѥ᡼顼ΥåE_PAR
 */
#define CHECK_PAR(exp) {					\
	if (!(exp)) {						\
		ercd = E_PAR;					\
		goto exit;					\
	}							\
}

/*
 *  ե꡼ꥹȤ˳ƲǽID뤫ɤΥå
 *  ǽʥȥ֥åե꡼ꥹȤ̵СNULL֤
 *  ͤNULLΤȤӥ E_NOID ȴ뤳ȤԤ롣
 *  CPUΥåϹԤʤΤǡӥǤǹԤȡ
 */
#define t_get_free_id(list) \
	(queue_empty((list)) ?					\
	 NULL : queue_delete_next((list)))			\

/*
 *  ֥IDϰϤȽ
 */
#define VALID_TSKID(tskid) \
	(TMIN_TSKID <= (tskid) && (tskid) <= tmax_tskid)

#define VALID_SEMID(semid) \
	(TMIN_SEMID <= (semid) && (semid) <= tmax_semid)

#define VALID_FLGID(flgid) \
	(TMIN_FLGID <= (flgid) && (flgid) <= tmax_flgid)

#define VALID_DTQID(dtqid) \
	(TMIN_DTQID <= (dtqid) && (dtqid) <= tmax_dtqid)

#define VALID_MBXID(mbxid) \
	(TMIN_MBXID <= (mbxid) && (mbxid) <= tmax_mbxid)

#define VALID_MPFID(mpfid) \
	(TMIN_MPFID <= (mpfid) && (mpfid) <= tmax_mpfid)

#define VALID_MPLID(mplid) \
	(TMIN_MPLID <= (mplid) && (mplid) <= tmax_mplid)

#define VALID_MTXID(mtxid) \
	(TMIN_MTXID <= (mtxid) && (mtxid) <= tmax_mtxid)

#define VALID_MBFID(mbfid) \
	(TMIN_MBFID <= (mbfid) && (mbfid) <= tmax_mbfid)

#define VALID_PORID(porid) \
	(TMIN_PORID <= (porid) && (porid) <= tmax_porid)

#define VALID_CYCID(cycid) \
	(TMIN_CYCID <= (cycid) && (cycid) <= tmax_cycid)

#define VALID_ALMID(almid) \
	(TMIN_ALMID <= (almid) && (almid) <= tmax_almid)

#define VALID_ISRID(almid) \
	(TMIN_ISRID <= (isrid) && (isrid) <= tmax_isrid)

/*
 *  ֥IDΥåE_ID
 */
#define CHECK_TSKID(tskid) {					\
	if (!VALID_TSKID(tskid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_TSKID_SELF(tskid) {				\
	if (!(VALID_TSKID(tskid) || (tskid) == TSK_SELF)) {	\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_SEMID(semid) {					\
	if (!VALID_SEMID(semid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_FLGID(flgid) {					\
	if (!VALID_FLGID(flgid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_DTQID(dtqid) {					\
	if (!VALID_DTQID(dtqid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_MBXID(mbxid) {					\
	if (!VALID_MBXID(mbxid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_MPFID(mpfid) {					\
	if (!VALID_MPFID(mpfid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_MPLID(mplid) {					\
	if (!VALID_MPLID(mplid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_MTXID(mtxid) {					\
	if (!VALID_MTXID(mtxid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_MBFID(mbfid) {					\
	if (!VALID_MBFID(mbfid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_PORID(porid) {					\
	if (!VALID_PORID(porid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_CYCID(cycid) {					\
	if (!VALID_CYCID(cycid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_ALMID(almid) {					\
	if (!VALID_ALMID(almid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

#define CHECK_ISRID(isrid) {					\
	if (!VALID_ISRID(isrid)) {				\
		ercd = E_ID;					\
		goto exit;					\
	}							\
}

/*
 *  ƽФƥȤΥåE_CTX
 */
#define CHECK_TSKCTX() {					\
	if (sense_context()) {					\
		ercd = E_CTX;					\
		goto exit;					\
	}							\
}

#define CHECK_INTCTX() {					\
	if (!sense_context()) {					\
		ercd = E_CTX;					\
		goto exit;					\
	}							\
}

/*
 *  ƽФƥȤCPUå֤ΥåE_CTX
 */
#define CHECK_TSKCTX_UNL() {					\
	if (sense_context() || t_sense_lock()) {		\
		ercd = E_CTX;					\
		goto exit;					\
	}							\
}

#define CHECK_INTCTX_UNL() {					\
	if (!sense_context() || i_sense_lock()) {		\
		ercd = E_CTX;					\
		goto exit;					\
	}							\
}

/*
 *  ǥѥåα֤ǤʤΥåE_CTX
 */
#define CHECK_DISPATCH() {					\
	if (sense_context() || t_sense_lock() || !(enadsp)) {	\
		ercd = E_CTX;					\
		goto exit;					\
	}							\
}

/*
 *  ¾Υƥȥ顼ΥåE_CTX
 */
#define CHECK_CTX(exp) {					\
	if (!(exp)) {						\
		ercd = E_CTX;					\
		goto exit;					\
	}							\
}

/*
 *  ꤷƤʤΥåE_ILUSE
 */
#define CHECK_NONSELF(tcb) {					\
	if ((tcb) == runtsk) {					\
		ercd = E_ILUSE;					\
		goto exit;					\
	}							\
}

/*
 *  ¾ѥ顼ΥåE_ILUSE
 */
#define CHECK_ILUSE(exp) {					\
	if (!(exp)) {						\
		ercd = E_ILUSE;					\
		goto exit;					\
	}							\
}


/*
 *  cre_ϤѤ롣
 *  ¸ߤ/IDФƤE_OBJ֤¸ߤʤ
 *  ֥Ȥ¸߾֤˰ܹԤ롣
 */
#define CHECK_OBJECT_CREATABLE(exp) {				\
	t_lock_cpu();						\
	if ((exp)->exist != KOBJ_NOEXS) {			\
		t_unlock_cpu();					\
		ercd = E_OBJ;					\
		goto exit;					\
	}							\
	(exp)->exist = KOBJ_INIT;				\
	t_unlock_cpu();						\
}
#define CHECK_TASK_CREATABLE(exp) {				\
	t_lock_cpu();						\
	if ((exp)->exist != KOBJ_NOEXS) {			\
		t_unlock_cpu();					\
		ercd = E_OBJ;					\
		goto exit;					\
	}							\
	(exp)->exist = KOBJ_INIT;				\
	t_unlock_cpu();						\
}

/*
 *  del_ϤѤ롣
 *  ¸ߤʤIDФƤE_OBJ֤¸ߤ
 *  ֥Ȥ¸߾֤˰ܹԤ롣
 */
#define CHECK_OBJECT_DELETABLE(exp) {				\
	t_lock_cpu();						\
	if ((exp)->exist != KOBJ_EXIST) {			\
		t_unlock_cpu();					\
		ercd = E_OBJ;					\
		goto exit;					\
	}							\
	(exp)->exist = KOBJ_INIT;				\
	t_unlock_cpu();						\
}
#define CHECK_TASK_DELETABLE(exp) {				\
	t_lock_cpu();						\
	if ((exp)->exist != KOBJ_EXIST) {			\
		t_unlock_cpu();					\
		ercd = E_OBJ;					\
		goto exit;					\
	}							\
	(exp)->exist = KOBJ_INIT;			\
	t_unlock_cpu();						\
}

#define T_CHECK_OBJECT_EXIST(exp) {				\
	if ((exp)->exist != KOBJ_EXIST) {			\
		t_unlock_cpu();					\
		ercd = E_NOEXS;					\
		goto exit;					\
	}							\
}
#define I_CHECK_OBJECT_EXIST(exp) {				\
	if ((exp)->exist != KOBJ_EXIST) {			\
		i_unlock_cpu();					\
		ercd = E_NOEXS;					\
		goto exit;					\
	}							\
}
#define T_CHECK_TASK_EXIST(exp) {					\
	if ((exp)->exist != KOBJ_EXIST) {		\
		t_unlock_cpu();					\
		ercd = E_NOEXS;					\
		goto exit;					\
	}							\
}
#define I_CHECK_TASK_EXIST(exp) {					\
	if ((exp)->exist != KOBJ_EXIST) {		\
		i_unlock_cpu();					\
		ercd = E_NOEXS;					\
		goto exit;					\
	}							\
}

#define CHECK_OBJECT_RESERVED(exp) ((exp)->reserved)
#define CHECK_TASK_RESERVED(exp) ((exp)->reserved)

/*
 * ȥ֥åե꡼ꥹˤ硢ե꡼ꥹȤ
 * ʤacre_þ
 */
#define UPDATE_OBJECT_FREELIST(exp) {				\
	if (!(CHECK_OBJECT_RESERVED(exp))) {			\
		queue_delete((QUEUE*)(exp));			\
	}							\
 }

#define UPDATE_TASK_FREELIST(exp) {				\
	if (!(CHECK_TASK_RESERVED(exp))) {			\
		queue_delete((QUEUE*)(exp));			\
	}							\
 }

#endif /* _CHECK_H_ */
