/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: cyclic.c,v 1.21 2003/11/10 13:41:07 monaka Exp $
 */

/*
 *	ϥɥ鵡ǽ
 */

#include "jsp_kernel.h"
#include "check.h"
#include "cyclic.h"

/*
 *  ϥɥIDκ͡kernel_cfg.c
 */
extern const ID	tmax_cycid;

/*
 *  ϥɥ֥åΥꥢkernel_cfg.c
 */
extern CYCINIB	cycinib_table[];

/*
 *  ϥɥ֥åϢۥڥοkernel_cfg.c
 */
extern const UINT	tnum_cycinia;

/*
 *  ϥɥ֥åϢۥڥΥꥢkernel_cfg.c
 */
extern const CYCINIA	cycinia_table[];

/*
 *  ϥɥͽIDΥꥢkernel_cfg.c
 */
extern const ID		cycrid_table[];

/*
 *  ϥɥͽIDο (kernel_cfg.c)
 */
extern const UINT	tnum_cycrid;

/*
 *  ϥɥ֥åΥꥢkernel_cfg.c
 */
extern CYCCB	cyccb_table[];

/*
 *  ϥɥο
 */
#define TNUM_CYC	((UINT)(tmax_cycid - TMIN_CYCID + 1))

/*
 *  ϥɥIDϥɥ֥åФΥޥ
 */
#define INDEX_CYC(cycid)	((UINT)((cycid) - TMIN_CYCID))
#define get_cyccb(cycid)	(&(cyccb_table[INDEX_CYC(cycid)]))

/*
 *  IDưѥե꡼ꥹ
 */
extern QUEUE cyc_freelist;

/*
 *  ޤϥɥη
 */
typedef void	(*CYCHDR)(VP_INT exinf);

/*
 *  ϥɥ鵡ǽν
 */
#ifdef __cycini

QUEUE cyc_freelist;

void
cyclic_initialize()
{
	UINT	i;
	CYCCB	*cyccb;
	CYCINIB *cycinib;
	const CYCINIA *cycinia;
	const ID	*cycrid;

	/*
	 * ͥ뵯ưξ֤˴ؤ餺ʤФʤΤ
	 * ޤ롣
	 */
	for (cyccb = cyccb_table, i = 0; i < TNUM_CYC; cyccb++, i++) {
		queue_initialize(&(cyccb->free_queue));
	}
	queue_initialize(&cyc_freelist);

	/*
	 * cycinia ˤäƼΤޤ
	 */
	for (cycinia = cycinia_table, i = 0; i < tnum_cycinia; cycinia++, i++) {
		cycinib = &cycinib_table[cycinia->cycid - TMIN_CYCID];
		*cycinib = cycinia->cycinib;
		cyccb = &cyccb_table[cycinia->cycid - TMIN_CYCID];
		cyccb->cycinib = cycinib;
		cyccb->exist = KOBJ_EXIST;
		cyccb->reserved = TRUE;

		if ((cyccb->cycinib->cycatr & TA_STA) != 0) {
			cyccb->cycsta = TRUE;
			tmevtb_enqueue_cyc(cyccb, cyccb->cycinib->cycphs);
		}
		else {
			cyccb->cycsta = FALSE;
		}
	}

	/*
	 *  ͽID
	 */
	for (cycrid = cycrid_table, i = 0; i < tnum_cycrid; cycrid++, i++) {
		cyccb[*cycrid - TMIN_CYCID].reserved = TRUE;
	}

	/*
	 * cycinia ˤäƼʤΤ
	 */
	for (cyccb = cyccb_table, i = 0; i < TNUM_CYC; cyccb++, i++) {
		if (cyccb->cycinib == NULL) {
			cyccb->exist = KOBJ_NOEXS;
			cyccb->cycinib = &cycinib_table[i];

			if (!CHECK_OBJECT_RESERVED(cyccb)) {
				queue_insert_prev(&cyc_freelist, (QUEUE*)cyccb);
			}
		}
	}
}

#endif /* __cycini */

/*
 *  ϥɥ鵯ưΤΥ।٥ȥ֥åϿ
 */
#ifdef __cycenq

void
tmevtb_enqueue_cyc(CYCCB *cyccb, EVTTIM evttim)
{
	tmevtb_enqueue_evttim(&(cyccb->tmevtb), evttim,
				(CBACK) call_cychdr, (VP) cyccb);
	cyccb->evttim = evttim;
}

#endif /* __cycenq */

/*
 *  ϥɥ
 */
#ifdef __cre_cyc

SYSCALL ER
cre_cyc(ID cycid, const T_CCYC * pk_ccyc)
{
	CYCCB	*cyccb;
	CYCINIB *cycinib;
	ER	ercd;
    
	LOG_CRE_CYC_ENTER(cycid);
	CHECK_TSKCTX_UNL();

	CHECK_CYCID(cycid);
	cyccb = get_cyccb(cycid);
	CHECK_OBJECT_CREATABLE(cyccb);
	UPDATE_OBJECT_FREELIST(cyccb);

	/*
	 * Ԥ
	 * wait_queue ϡ cyclic_initialize()ǽ뤷
	 * del_cycλˤݽ롣äơǤϽɬפʤ
	 */
	cycinib = cyccb->cycinib;
	cycinib->cycatr = pk_ccyc->cycatr;
	/* TODO: cycinibν */

	/* TODO: cyccbν */

	ercd = E_OK;

	/*
	 *  ǽ¾Υӥ뤫Ѳǽˤʤ롣
	 */
	cyccb->exist = KOBJ_EXIST;

    exit:
	LOG_CRE_CYC_LEAVE(ercd);
	return(ercd);
}

#endif /* __cre_cyc */

/*
 *  ϥɥ(IDֹ漫ưդ)
 */
#ifdef __acre_cyc

SYSCALL ER_ID
acre_cyc(const T_CCYC *pk_ccyc)
{
	CYCCB	*cyccb;
	CYCINIB *cycinib;
	ER_ID	ercd;
    
	LOG_ACRE_CYC_ENTER();
	CHECK_TSKCTX_UNL();

	t_lock_cpu();
	cyccb = (CYCCB *)t_get_free_id((QUEUE *)&cyc_freelist);
	if (cyccb == NULL) {
		ercd = E_NOID;
		t_unlock_cpu();
		goto exit;
	}
	cyccb->exist = KOBJ_INIT;
	t_unlock_cpu();

	/*
	 * Ԥ
	 */
	queue_initialize(&(cyccb->free_queue));
	cycinib = cyccb->cycinib;
	cycinib->cycatr = pk_ccyc->cycatr;
	/* TODO: cycinib */

	/* TODO: cyccb */

	ercd = CYCID(cyccb);

	/*
	 *  ǽ¾Υӥ뤫Ѳǽˤʤ롣
	 */
	cyccb->exist = KOBJ_EXIST;

    exit:
	LOG_ACRE_CYC_LEAVE(ercd);
	return(ercd);
}

#endif /* __acre_cyc */

/*
 *  ϥɥκ
 */
#ifdef __del_cyc
SYSCALL ER
del_cyc(ID cycid)
{
	CYCCB	*cyccb;
	ER	ercd;
    
	LOG_DEL_CYC_ENTER(cycid);
	CHECK_TSKCTX_UNL();

	CHECK_CYCID(cycid);
	cyccb = get_cyccb(cycid);

	CHECK_OBJECT_DELETABLE(cyccb);

	/*
	 *ϥɥ餬ưƤ顢ߤ롣
	 * ֥٥ȥ塼äƤǸΥϥɥ
	 * Τ褦¨ǻߤɤΤɤϡ
	 * ͽ񤫤ɤʤΤ褦ʼˤʤ
	 * Ѥ絬ϤˤʤΤǡ¸򤹤뤳Ȥˤ롣
	 */
	if (cyccb->cycsta) {
		cyccb->cycsta = FALSE;
		t_lock_cpu();
		tmevtb_dequeue(&(cyccb->tmevtb));
		t_unlock_cpu();
	}

	if (!CHECK_OBJECT_RESERVED(cyccb)) {
	  /*
	   * ͽIDǤʤХե꡼ꥹȤ롣
	   */
		t_lock_cpu();
		queue_insert_prev(&cyc_freelist, (QUEUE *)cyccb);
		t_unlock_cpu();
	}

	/* acre_/cre_ǤΥǽ */
	cyccb->exist = KOBJ_NOEXS;

	ercd = E_OK;

    exit:
	LOG_DEL_CYC_LEAVE(ercd);
	return(ercd);
}

#endif /* __del_cyc */

/*
 *  ϥɥư
 */
#ifdef __sta_cyc

SYSCALL ER
sta_cyc(ID cycid)
{
	CYCCB	*cyccb;
	ER	ercd;

	LOG_STA_CYC_ENTER(cycid);
	CHECK_TSKCTX_UNL();

	CHECK_CYCID(cycid);
	cyccb = get_cyccb(cycid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(cyccb);
	
	if (cyccb->cycsta) {
		tmevtb_dequeue(&(cyccb->tmevtb));
	}
	else {
		cyccb->cycsta = TRUE;
	}
	tmevtb_enqueue_cyc(cyccb, base_time + cyccb->cycinib->cyctim);
	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_STA_CYC_LEAVE(ercd);
	return(ercd);
}

#endif /* __sta_cyc */

/*
 *  ϥɥư
 */
#ifdef __stp_cyc

SYSCALL ER
stp_cyc(ID cycid)
{
	CYCCB	*cyccb;
	ER	ercd;

	LOG_STP_CYC_ENTER(cycid);
	CHECK_TSKCTX_UNL();

	CHECK_CYCID(cycid);
	cyccb = get_cyccb(cycid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(cyccb);

	if (cyccb->cycsta) {
		cyccb->cycsta = FALSE;
		tmevtb_dequeue(&(cyccb->tmevtb));
	}
	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_STP_CYC_LEAVE(ercd);
	return(ercd);
}

#endif /* __stp_cyc */

/*
 *  ϥɥξֻ
 */
#ifdef __ref_cyc

SYSCALL ER
ref_cyc(ID cycid, T_RCYC *pk_rcyc)
{
	CYCCB	*cyccb;
	ER	ercd;

	LOG_STP_CYC_ENTER(cycid);
	CHECK_TSKCTX_UNL();

	CHECK_CYCID(cycid);
	cyccb = get_cyccb(cycid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(cyccb);

	if (cyccb->cycsta) {
		pk_rcyc->cycstat = TCYC_STA;
	} else {
		pk_rcyc->cycstat = TCYC_STP;
	}

	/* TODO: pk_rcyc->lefttim */

	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_STP_CYC_LEAVE(ercd);
	return(ercd);
}

#endif /* __ref_cyc */

/*
 *  ϥɥ鵯ư롼
 */
#ifdef __cyccal

void
call_cychdr(CYCCB *cyccb)
{
	/*
	 *  εưΤΥ।٥ȥ֥åϿ롥
	 *
	 *  ƱƥåǼϥɥٵư٤ˤϡ
	 *  δؿ isig_tim äˡ٤δؿƤФ
	 *  Ȥˤʤ롥
	 */
	tmevtb_enqueue_cyc(cyccb, cyccb->evttim + cyccb->cycinib->cyctim);

	/*
	 *  ϥɥCPUå֤ǸƤӽФ
	 */
	i_unlock_cpu();
	LOG_CYC_ENTER(cyccb);
	((CYCHDR)(*cyccb->cycinib->cychdr))(cyccb->cycinib->exinf);
	LOG_CYC_LEAVE(cyccb);
	i_lock_cpu();
}

#endif /* __cyccal */
