/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: eventflag.c,v 1.18 2003/11/10 12:09:05 monaka Exp $
 */

/*
 *	٥ȥե饰ǽ
 */

#include "jsp_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "eventflag.h"

/*
 *  ٥ȥե饰IDκ͡kernel_cfg.c
 */
extern const ID	tmax_flgid;

/*
 *  ٥ȥե饰֥åΥꥢkernel_cfg.c
 */
extern FLGINIB	flginib_table[];

/*
 *  ٥ȥե饰֥åϢۥڥοkernel_cfg.c
 */
extern const UINT	tnum_flginia;

/*
 *  ٥ȥե饰֥åϢۥڥΥꥢkernel_cfg.c
 */
extern const FLGINIA	flginia_table[];

/*
 *  ٥ȥե饰ͽIDΥꥢkernel_cfg.c
 */
extern const ID		flgrid_table[];

/*
 *  ٥ȥե饰ͽIDο (kernel_cfg.c)
 */
extern const UINT	tnum_flgrid;

/*
 *  ٥ȥե饰֥åΥꥢkernel_cfg.c
 */
extern FLGCB	flgcb_table[];

/*
 *  ٥ȥե饰ο
 */
#define TNUM_FLG	((UINT)(tmax_flgid - TMIN_FLGID + 1))

/*
 *  ٥ȥե饰ID饤٥ȥե饰֥åФΥޥ
 */
#define INDEX_FLG(flgid)	((UINT)((flgid) - TMIN_FLGID))
#define get_flgcb(flgid)	(&(flgcb_table[INDEX_FLG(flgid)]))

/*
 *  IDưѥե꡼ꥹ
 */
extern QUEUE flg_freelist;

/*
 *  ٥ȥե饰Ԥ֥å
 *
 *  flgptn ϡwaiptn  wfmode Ʊ˻ȤȤϤʤᡤunion 
 *  ȤХ󤹤뤳ȤǽǤ롥
 */
typedef struct eventflag_waiting_information {
	WINFO	winfo;		/* ɸԤ֥å */
	WOBJCB	*wobjcb;	/* Ԥ֥Ȥδ֥å */
	FLGPTN	waiptn;		/* Ԥѥ */
	MODE	wfmode;		/* Ԥ⡼ */
	FLGPTN	flgptn;		/* ԤΥѥ */
} WINFO_FLG;

/*
 *  ٥ȥե饰ǽν
 */
#ifdef __flgini

QUEUE flg_freelist;

void
eventflag_initialize(void)
{
	UINT	i;
	FLGCB	*flgcb;
	FLGINIB *flginib;
	FLGINIA const *flginia;
	ID	const *flgrid;

	/*
	 * ͥ뵯ưξ֤˴ؤ餺ʤФʤΤ
	 * ޤ롣
	 */
	for (flgcb = flgcb_table, i = 0; i < TNUM_FLG; flgcb++, i++) {
		queue_initialize(&(flgcb->wait_queue));
	}
	queue_initialize(&flg_freelist);

	/*
	 * flginia ˤäƼΤޤ
	 */
	for (flginia = flginia_table, i = 0; i < tnum_flginia; flginia++, i++) {
		flginib = &flginib_table[flginia->flgid - TMIN_FLGID];
		*flginib = flginia->flginib;
		flgcb = &flgcb_table[flginia->flgid - TMIN_FLGID];
		flgcb->flginib = flginib;
		flgcb->exist = KOBJ_EXIST;
		flgcb->reserved = TRUE;

		flgcb->flgptn = flginib->iflgptn;
	}

	/*
	 *  ͽID
	 */
	for (flgrid = flgrid_table, i = 0; i < tnum_flgrid; flgrid++, i++) {
		flgcb_table[*flgrid - TMIN_FLGID].reserved = TRUE;
	}

	/*
	 * flginia ˤäƼʤΤ
	 */
	for (flgcb = flgcb_table, i = 0; i < TNUM_FLG; flgcb++, i++) {
		if (flgcb->flginib == NULL) {
			flgcb->exist = KOBJ_NOEXS;
			flgcb->flginib = &flginib_table[i];

			if (!CHECK_OBJECT_RESERVED(flgcb)) {
				queue_insert_prev(&flg_freelist, (QUEUE*)flgcb);
			}
		}
	}
}

#endif /* __flgini */

/*
 *  ٥ȥե饰ԤΥå
 */
#ifdef __flgcnd

BOOL
eventflag_cond(FLGCB *flgcb, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn)
{
	if ((wfmode & TWF_ORW) != 0 ? (flgcb->flgptn & waiptn) != 0
				: (flgcb->flgptn & waiptn) == waiptn) {
		*p_flgptn = flgcb->flgptn;
		if ((flgcb->flginib->flgatr & TA_CLR) != 0) {
			flgcb->flgptn = 0;
		}
		return(TRUE);
	}
	return(FALSE);
}

#endif /* __flgcnd */

/*
 *  ٥ȥե饰
 */
#ifdef __cre_flg

SYSCALL ER
cre_flg(ID flgid, const T_CFLG * pk_cflg)
{
	FLGCB	*flgcb;
	FLGINIB *flginib;
	TCB	*tcb;
	ER	ercd;
    
	LOG_CRE_FLG_ENTER(flgid);
	CHECK_TSKCTX_UNL();

	CHECK_FLGID(flgid);
	flgcb = get_flgcb(flgid);
	CHECK_OBJECT_CREATABLE(flgcb);
	UPDATE_OBJECT_FREELIST(flgcb);

	/*
	 * Ԥ
	 */
	queue_initialize((QUEUE *)flgcb);
	flginib = flgcb->flginib;
	flginib->flgatr = pk_cflg->flgatr;
	flgcb->flgptn = flginib->iflgptn = pk_cflg->iflgptn;

	/*
	 *  ǽ¾Υӥ뤫Ѳǽˤʤ롣
	 */
	flgcb->exist = KOBJ_EXIST;

	ercd = E_OK;

    exit:
	LOG_CRE_FLG_LEAVE(ercd);
	return(ercd);
}

#endif /* __cre_flg */

/*
 *  ٥ȥե饰(IDֹ漫ưդ)
 */
#ifdef __acre_flg

SYSCALL ER_ID
acre_flg(const T_CFLG *pk_cflg)
{
	FLGCB	*flgcb;
	FLGINIB	*flginib;
	TCB	*tcb;
	ER_ID	ercd;
    
	LOG_ACRE_FLG_ENTER();
	CHECK_TSKCTX_UNL();

	t_lock_cpu();
	flgcb = (FLGCB *)t_get_free_id((QUEUE *)&flg_freelist);
	if (flgcb == NULL) {
		ercd = E_NOID;
		t_unlock_cpu();
		goto exit;
	}
	flgcb->exist = KOBJ_INIT;
	t_unlock_cpu();

	/*
	 * Ԥ
	 */
	queue_initialize((QUEUE *)flgcb);
	flginib = flgcb->flginib;
	flginib->flgatr = pk_cflg->flgatr;
	flgcb->flgptn = flginib->iflgptn = pk_cflg->iflgptn;

	ercd = FLGID(flgcb);

	/*
	 *  ǽ¾Υӥ뤫Ѳǽˤʤ롣
	 */
	flgcb->exist = KOBJ_EXIST;

    exit:
	LOG_ACRE_FLG_LEAVE(ercd);
	return(ercd);
}

#endif /* __acre_flg */

/*
 *  ٥ȥե饰κ
 */
#ifdef __del_flg
SYSCALL ER
del_flg(ID flgid)
{
	FLGCB	*flgcb;
	TCB	*tcb;
	ER	ercd;
    
	LOG_DEL_FLG_ENTER(flgid);
	CHECK_TSKCTX_UNL();

	CHECK_FLGID(flgid);
	flgcb = get_flgcb(flgid);

	CHECK_OBJECT_DELETABLE(flgcb);

	/* ԤθդȼԤԤ*/
	while (queue_empty(&(flgcb->wait_queue)) == FALSE) {
		TCB *tcb;
		tcb = (TCB *)queue_delete_next(&(flgcb->wait_queue));
		t_lock_cpu();
		if (wait_deleted(tcb)) {
			dispatch();
		}
		t_unlock_cpu();
	}
	  
	if (!CHECK_OBJECT_RESERVED(flgcb)) {
	  /*
	   * ͽIDǤʤХե꡼ꥹȤ롣
	   */
		t_lock_cpu();
		queue_insert_prev(&flg_freelist, (QUEUE *)flgcb);
		t_unlock_cpu();
	}

	/* acre_/cre_ǤΥǽ */
	flgcb->exist = KOBJ_NOEXS;

	ercd = E_OK;

    exit:
	LOG_DEL_FLG_LEAVE(ercd);
	return(ercd);
}

#endif /* __del_flg */

/*
 *  ٥ȥե饰Υå
 */
#ifdef __set_flg

SYSCALL ER
set_flg(ID flgid, FLGPTN setptn)
{
	FLGCB	*flgcb;
	TCB	*tcb;
	WINFO_FLG *winfo;
	ER	ercd;

	LOG_SET_FLG_ENTER(flgid, setptn);
	CHECK_TSKCTX_UNL();

	CHECK_FLGID(flgid);
	flgcb = get_flgcb(flgid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(flgcb);

	flgcb->flgptn |= setptn;
	if (!(queue_empty(&(flgcb->wait_queue)))) {
		tcb = (TCB *)(flgcb->wait_queue.next);
		winfo = (WINFO_FLG *)(tcb->winfo);
		if (eventflag_cond(flgcb, winfo->waiptn,
					winfo->wfmode, &(winfo->flgptn))) {
			queue_delete(&(tcb->task_queue));
			if (wait_complete(tcb)) {
				dispatch();
			}
		}
	}
	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_SET_FLG_LEAVE(ercd);
	return(ercd);
}

#endif /* __set_flg */

/*
 *  ٥ȥե饰Υåȡ󥿥ƥѡ
 */
#ifdef __iset_flg

SYSCALL ER
iset_flg(ID flgid, FLGPTN setptn)
{
	FLGCB	*flgcb;
	TCB	*tcb;
	WINFO_FLG *winfo;
	ER	ercd;

	LOG_ISET_FLG_ENTER(flgid, setptn);
	CHECK_INTCTX_UNL();

	CHECK_FLGID(flgid);
	flgcb = get_flgcb(flgid);

	i_lock_cpu();
	I_CHECK_OBJECT_EXIST(flgcb);

	flgcb->flgptn |= setptn;
	if (!(queue_empty(&(flgcb->wait_queue)))) {
		tcb = (TCB *)(flgcb->wait_queue.next);
		winfo = (WINFO_FLG *)(tcb->winfo);
		if (eventflag_cond(flgcb, winfo->waiptn,
					winfo->wfmode, &(winfo->flgptn))) {
			queue_delete(&(tcb->task_queue));
			if (wait_complete(tcb)) {
				reqflg = TRUE;
			}
		}
	}
	ercd = E_OK;

	i_unlock_cpu();

    exit:
	LOG_ISET_FLG_LEAVE(ercd);
	return(ercd);
}

#endif /* __iset_flg */

/*
 *  ٥ȥե饰Υꥢ
 */
#ifdef __clr_flg

SYSCALL ER
clr_flg(ID flgid, FLGPTN clrptn)
{
	FLGCB	*flgcb;
	ER	ercd;

	LOG_CLR_FLG_ENTER(flgid, clrptn);
	CHECK_TSKCTX_UNL();

	CHECK_FLGID(flgid);
	flgcb = get_flgcb(flgid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(flgcb);

	flgcb->flgptn &= clrptn; 
	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_CLR_FLG_LEAVE(ercd);
	return(ercd);
}

#endif /* __clr_flg */

/*
 *  ٥ȥե饰Ԥ
 */
#ifdef __wai_flg

SYSCALL ER
wai_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn)
{
	FLGCB	*flgcb;
	WINFO_FLG winfo;
	ER	ercd;

	LOG_WAI_FLG_ENTER(flgid, waiptn, wfmode, p_flgptn);
	CHECK_DISPATCH();
	CHECK_PAR(waiptn != 0);
	CHECK_PAR((wfmode & ~TWF_ORW) == 0);

	CHECK_FLGID(flgid);
	flgcb = get_flgcb(flgid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(flgcb);

	if (!(queue_empty(&(flgcb->wait_queue)))) {
		ercd = E_ILUSE;
	}
	else if (eventflag_cond(flgcb, waiptn, wfmode, p_flgptn)) {
		ercd = E_OK;
	}
	else {
		winfo.waiptn = waiptn;
		winfo.wfmode = wfmode;
		wobj_make_wait((WOBJCB *) flgcb, (WINFO_WOBJ *) &winfo);
		dispatch();
		ercd = winfo.winfo.wercd;
		if (ercd == E_OK) {
			*p_flgptn = winfo.flgptn;
		}
	}

	t_unlock_cpu();

    exit:
	LOG_WAI_FLG_LEAVE(ercd, *p_flgptn);
	return(ercd);
}

#endif /* __wai_flg */

/*
 *  ٥ȥե饰Ԥʥݡ󥰡
 */
#ifdef __pol_flg

SYSCALL ER
pol_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn)
{
	FLGCB	*flgcb;
	ER	ercd;

	LOG_POL_FLG_ENTER(flgid, waiptn, wfmode, p_flgptn);
	CHECK_TSKCTX_UNL();
	CHECK_PAR(waiptn != 0);
	CHECK_PAR((wfmode & ~TWF_ORW) == 0);

	CHECK_FLGID(flgid);
	flgcb = get_flgcb(flgid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(flgcb);

	if (!(queue_empty(&(flgcb->wait_queue)))) {
		ercd = E_ILUSE;
	}
	else if (eventflag_cond(flgcb, waiptn, wfmode, p_flgptn)) {
		ercd = E_OK;
	}
	else {
		ercd = E_TMOUT;
	}

	t_unlock_cpu();

    exit:
	LOG_POL_FLG_LEAVE(ercd, *p_flgptn);
	return(ercd);
}

#endif /* __pol_flg */

/*
 *  ٥ȥե饰ԤʥॢȤ
 */
#ifdef __twai_flg

SYSCALL ER
twai_flg(ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn, TMO tmout)
{
	FLGCB	*flgcb;
	WINFO_FLG winfo;
	TMEVTB	tmevtb;
	ER	ercd;

	LOG_TWAI_FLG_ENTER(flgid, waiptn, wfmode, p_flgptn, tmout);
	CHECK_DISPATCH();
	CHECK_PAR(waiptn != 0);
	CHECK_PAR((wfmode & ~TWF_ORW) == 0);
	CHECK_TMOUT(tmout);

	CHECK_FLGID(flgid);
	flgcb = get_flgcb(flgid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(flgcb);

	if (!(queue_empty(&(flgcb->wait_queue)))) {
		ercd = E_ILUSE;
	}
	else if (eventflag_cond(flgcb, waiptn, wfmode, p_flgptn)) {
		ercd = E_OK;
	}
	else if (tmout == TMO_POL) {
		ercd = E_TMOUT;
	}
	else {
		winfo.waiptn = waiptn;
		winfo.wfmode = wfmode;
		wobj_make_wait_tmout((WOBJCB *) flgcb, (WINFO_WOBJ *) &winfo,
						&tmevtb, tmout);
		dispatch();
		ercd = winfo.winfo.wercd;
		if (ercd == E_OK) {
			*p_flgptn = winfo.flgptn;
		}
	}

	t_unlock_cpu();

    exit:
	LOG_TWAI_FLG_LEAVE(ercd, *p_flgptn);
	return(ercd);
}

#endif /* __twai_flg */

/*
 *  ٥ȥե饰ξֻ
 */
#ifdef __ref_flg
SYSCALL ER
ref_flg(ID flgid, T_RFLG *pk_rflg)
{
	FLGCB	*flgcb;
	ER	ercd;
    
	LOG_REF_FLG_ENTER(flgid);
	CHECK_TSKCTX_UNL();

	CHECK_FLGID(flgid);
	flgcb = get_flgcb(flgid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(flgcb);

	if (!queue_empty(&(flgcb->wait_queue))) {
		TCB	*tcb;
		tcb = (TCB *)queue_peek_next(&(flgcb->wait_queue));
		pk_rflg->wtskid = TSKID(tcb);
	} else {
		pk_rflg->wtskid = TSK_NONE;
	}
	pk_rflg->flgptn = flgcb->flgptn;
	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_REF_FLG_LEAVE(ercd);
	return(ercd);
}

#endif /* __ref_flg */

