/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: interrupt.c,v 1.20 2003/11/20 18:01:00 monaka Exp $
 */

/*
 *	ߴǽ
 */

#include "jsp_kernel.h"
#include "check.h"
#include "interrupt.h"

/*
 *  ߥӥ롼IDκ͡kernel_cfg.c
 */
extern const ID	tmax_isrid;

/*
 *  ߥӥ롼֥åΥꥢkernel_cfg.c
 */
extern ISRINIB	isrinib_table[];

/*
 *  ߥӥ롼֥åϢۥڥοkernel_cfg.c
 */
extern const UINT	tnum_isrinia;

/*
 *  ߥӥ롼֥åϢۥڥΥꥢkernel_cfg.c
 */
extern const ISRINIA	isrinia_table[];

/*
 *  ߥӥ롼ͽIDΥꥢkernel_cfg.c
 */
extern const ID		isrrid_table[];

/*
 *  ߥӥ롼ͽIDο (kernel_cfg.c)
 */
extern const UINT	tnum_isrrid;

/*
 *  ߥӥ롼֥åΥꥢkernel_cfg.c
 */
extern ISRCB	isrcb_table[];

/*
 *  ߥӥ롼ο
 */
#define TNUM_ISR	((UINT)(tmax_isrid - TMIN_ISRID + 1))

/*
 *  ߥӥ롼ID
 *  ߥӥ롼֥åФΥޥ
 */
#define INDEX_ISR(isrid)	((UINT)((isrid) - TMIN_ISRID))
#define get_isrcb(isrid)	(&(isrcb_table[INDEX_ISR(isrid)]))

/*
 *  IDưѥե꡼ꥹ
 */
extern QUEUE isr_freelist;

/*
 *  ߥϥɥֹοkernel_cfg.c
 */
extern const UINT	tnum_inhno;

/*
 *  ߥϥɥ֥åΥꥢkernel_cfg.c
 */
extern const INHINIB	inhinib_table[];

/* 
 *  ߴǽν
 */
#ifdef __inhini

QUEUE isr_freelist;

void
interrupt_initialize()
{
	UINT		i;
	const INHINIB	*inhinib;

	ISRCB		*isrcb;
	ISRINIB		*isrinib;
	const ISRINIA	*isrinia;
	const ID	*isrrid;

#if 0
	/* ߥϥɥ */
	for (inhinib = inhinib_table, i = 0; i < tnum_inhno; inhinib++, i++) {
		if (check_undef_inh((INHNO)isrinib->intno)) {
			define_inh(inhinib->inhno, inhinib->inthdr);
		} else {
			assert("Duplicated inhno.");
		}
	}

	/*
	 *  Ūߥӥ롼ν
	 *  ¾ΥӥȰۤʤꡢATT_cre_,acre_ȤˤʤäƤ뤳Ȥա
	 */
	for (isrinib = attached_isr_table, i = 0; i < TNUM_ATTACHED_ISR; isrinib++, i++) {
		if (check_undef_inh((INHNO)isrinib->intno)) {
			define_inh((INHNO)isrinib->intno, isr_interrupt);
		} else {
			assert("Duplicated intno/inhno.");
		}
	}
#else
	/* ߥϥɥ */
	for (inhinib = inhinib_table, i = 0; i < tnum_inhno; inhinib++, i++) {
		define_inh(inhinib->inhno, inhinib->inthdr);
	}
#endif
	/*
	 * ͥ뵯ưξ֤˴ؤ餺ʤФʤΤ
	 * ޤ롣
	 */
	for (isrcb = isrcb_table, i = 0; i < TNUM_ISR; isrcb++, i++) {
		queue_initialize(&(isrcb->wait_queue));
	}
	queue_initialize(&isr_freelist);

	/*
	 * isrinia ˤäƼΤޤ
	 */
	for (isrinia = isrinia_table, i = 0; i < tnum_isrinia; isrinia++, i++) {
		isrinib = &isrinib_table[isrinia->isrid - TMIN_ISRID];
		*isrinib = isrinia->isrinib;
		isrcb = &isrcb_table[isrinia->isrid - TMIN_ISRID];
		isrcb->isrinib = isrinib;
		isrcb->exist = KOBJ_EXIST;
		isrcb->reserved = TRUE;
	}

	/*
	 *  ͽID
	 */
	for (isrrid = isrrid_table, i = 0; i < tnum_isrrid; isrrid++, i++) {
		isrcb[*isrrid - TMIN_ISRID].reserved = TRUE;
	}

	/*
	 * isrinia ˤäƼʤΤ
	 */
	for (isrcb = isrcb_table, i = 0; i < TNUM_ISR; isrcb++, i++) {
		if (isrcb->isrinib == NULL) {
			isrcb->exist = KOBJ_NOEXS;
			isrcb->isrinib = &isrinib_table[i];

			if (!CHECK_OBJECT_RESERVED(isrcb)) {
				queue_insert_prev(&isr_freelist, (QUEUE*)isrcb);
			}
		}
	}
	
}

#endif /* __inhini */

/*
 *  ߥϥɥ
 */
#ifdef __def_inh

SYSCALL ER
def_inh(INHNO inhno, const T_DINH *pk_dinh)
{
	ER ercd;

	LOG_DEF_INH_ENTER(inhno);

	/*
	 *  ߥӥ롼
	 *  def_inh뤳ȤϤǤʤ
	 */
	if (check_defined_isr((INTNO)inhno)) {
		return E_PAR;
	}

	t_lock_cpu();
	/*
	 *  inhno åϹԤʤ
	 */
	if (pk_dinh == NULL) {
		undef_inh(inhno);
	} else {
		define_inh(inhno, pk_dinh->inthdr);
	}
	ercd = E_OK;

	t_unlock_cpu();
	LOG_DEF_INH_LEAVE(ercd);

	return(ercd);
}

#endif /* __def_inh */

/*
 *  ߥӥ롼
 */
#ifdef __cre_isr

SYSCALL ER
cre_isr(ID isrid, const T_CISR *pk_cisr)
{
	ISRCB	*isrcb;
	ISRINIB *isrinib;
	ER	ercd;
    
	LOG_CRE_ISR_ENTER(isrid);
	CHECK_TSKCTX_UNL();

	/*
	 *  ߥӥ롼Ѱʳγߥϥɥ餬
	 *  Ƥߥ٥˳ߥӥ롼
	 *  Ͽ뤳ȤϤǤʤ
	 */
	if (!check_undefined_inh((INHNO)pk_cisr->intno) &&
	    !check_defined_isr(pk_cisr->intno)) {
		return E_PAR;
	}

	CHECK_ISRID(isrid);
	isrcb = get_isrcb(isrid);
	CHECK_OBJECT_CREATABLE(isrcb);
	UPDATE_OBJECT_FREELIST(isrcb);

	/*
	 * Ԥ
	 * wait_queue ϡ interrupt_initialize()ǽ뤷
	 * del_isrλˤݽ롣äơǤϽɬפʤ
	 */
	isrinib = isrcb->isrinib;
	isrinib->isratr = pk_cisr->isratr;
	isrinib->exinf  = pk_cisr->exinf;
	isrinib->intno  = pk_cisr->intno;
	isrinib->isr	= pk_cisr->isr;

	/* TODO: ʤפϤ*/

	/*
	 *  ǽ¾Υӥ뤫Ѳǽˤʤ롣
	 */
	isrcb->exist = KOBJ_EXIST;

	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_CRE_ISR_LEAVE(ercd);
	return(ercd);
}

#endif /* __cre_isr */

/*
 *  ߥӥ롼IDֹ漫ưդ
 */
#ifdef __acre_isr

SYSCALL ER
acre_isr(const T_CISR *pk_cisr)
{
	ISRCB	*isrcb;
	ISRINIB	*isrinib;
	ER_ID	ercd;
    
	LOG_ACRE_ISR_ENTER();
	CHECK_TSKCTX_UNL();

	/*
	 *  ߥӥ롼Ѱʳγߥϥɥ餬
	 *  Ƥߥ٥˳ߥӥ롼
	 *  Ͽ뤳ȤϤǤʤ
	 */
	if (!check_undefined_inh((INHNO)pk_cisr->intno) &&
	    !check_defined_isr(pk_cisr->intno)) {
		return E_PAR;
	}

	t_lock_cpu();
	isrcb = (ISRCB *)t_get_free_id((QUEUE *)&isr_freelist);
	if (isrcb == NULL) {
		ercd = E_NOID;
		t_unlock_cpu();
		goto exit;
	}
	isrcb->exist = KOBJ_INIT;
	t_unlock_cpu();

	/*
	 * Ԥ
	 */
	queue_initialize(&(isrcb->wait_queue));
	isrinib = isrcb->isrinib;
	isrinib->isratr = pk_cisr->isratr;
	isrinib->exinf  = pk_cisr->exinf;
	isrinib->intno  = pk_cisr->intno;
	isrinib->isr	= pk_cisr->isr;

	ercd = ISRID(isrcb);

	/*
	 *  ǽ¾Υӥ뤫Ѳǽˤʤ롣
	 */
	isrcb->exist = KOBJ_EXIST;

    exit:
	LOG_ACRE_ISR_LEAVE(ercd);
	return(ercd);
}

#endif /* __acre_isr */

/*
 *  ߥӥ롼κ
 */
#ifdef __del_isr

SYSCALL ER
del_isr(ID isrid)
{
	ISRCB	*isrcb;
	ER	ercd;
    
	LOG_DEL_ISR_ENTER(isrid);
	CHECK_TSKCTX_UNL();

	CHECK_ISRID(isrid);
	isrcb = get_isrcb(isrid);

	CHECK_OBJECT_DELETABLE(isrcb);

	/* TODO: դ*/
	  
	if (!CHECK_OBJECT_RESERVED(isrcb)) {
		/*
		 * ͽIDǤʤХե꡼ꥹȤ롣
		 */
		t_lock_cpu();
		queue_insert_prev(&isr_freelist, (QUEUE *)isrcb);
		t_unlock_cpu();
	}

	/* acre_/cre_ǤΥǽ */
	isrcb->exist = KOBJ_NOEXS;

	ercd = E_OK;

    exit:
	LOG_DEL_ISR_LEAVE(ercd);
	return(ercd);
}

#endif /* __del_isr */

/*
 *  TODO:
 */
#ifdef __isrhandler

SYSCALL void
isr_handler(INTNO intno)
{
}

#endif /* __isrhandler */

/*
 *  ߥӥ롼ξֻ
 */
#ifdef __ref_isr

SYSCALL ER
ref_isr(ID isrid, T_RISR *pk_risr)
{
	ISRCB	*isrcb;
	ER	ercd;
    
	LOG_REF_ISR_ENTER(isrid);
	CHECK_TSKCTX_UNL();

	CHECK_ISRID(isrid);
	isrcb = get_isrcb(isrid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(isrcb);

	/*
	 * pk_risrƤϼ
	 * ܥСǤpk_risr϶ʤΤǡ⤹뤳Ȥʤ
	 */
	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_REF_ISR_LEAVE(ercd);
	return(ercd);
}

#endif /* __ref_isr */

/*
 *  ߤζػ
 */
#ifdef __dis_int

SYSCALL ER
dis_int(INTNO intno)
{
	return E_NOSPT;
}

#endif /* __dis_int */

/*
 *  ߤε
 */
#ifdef __ena_int

SYSCALL ER
ena_int(INTNO intno)
{
	return E_NOSPT;
}

#endif /* __ena_int */

