/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2003 by Monami software, Limited Partnership.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: kmem.c,v 1.14 2003/11/20 18:01:51 monaka Exp $
 */

/*
 *  ͥꥢ
 */
#include <limits.h>
#include <stddef.h>
#include "jsp_kernel.h"
#include "kmem.h"

#define alignof(type) offsetof(struct { char a; type b; }, b)

typedef union {
	long l;
#ifdef _int64_
	_int64_ i64;
#endif
#if (__STDC_VERSION__ >= 199901L)
	long long ll;
#endif
	double d;
	long double ld;
} __dummy_for_align;

static const int maxalign = alignof(__dummy_for_align);

/*
 *
 */
#ifdef __kmemsetup

void 
kmem_setup(VP buf, SIZE bufsz, KMEMB **p_kmemb)
{
	KMEMB *top;
	KMEMB *kmemb;

	assert(bufsz > sizeof(KMEMB) * 2);
	assert((UINT)buf % alignof(__dummy_for_align) == 0);

	top = (KMEMB *)buf;
	top->magic = 0;
	top->used = TRUE;
	top->size = 0;
	queue_initialize(&(top->queue));

	kmemb = top + 1;
	kmemb->magic = KMEM_MAGIC;
	kmemb->used = FALSE;
	kmemb->size = bufsz - sizeof(KMEMB);
	queue_insert_prev((QUEUE *)top, (QUEUE *)kmemb);

	*p_kmemb = top;
}

#endif

/*
 *
 */
#ifdef __kmemallocp

BOOL kmem_allocatable(KMEMB *kmemb, UINT size)
{
	KMEMB *ptr;

	/* alignmentȤäƤ */
	size = ((size + sizeof(KMEMB)) + sizeof(__dummy_for_align) - 1) & - sizeof(__dummy_for_align);

	for (ptr = kmemb; ptr != kmemb; ptr = (KMEMB *)(ptr->queue.next)) {
		if (ptr->magic != KMEM_MAGIC) {
			return FALSE;
		}

		if (ptr->used == FALSE && ptr->size >= size) {
			/* Ĥä */
			return TRUE;
		}
	}

	return FALSE;
}

#endif

/*
 *
 */
#ifdef __kmemallocate

BOOL kmem_allocate(KMEMB *kmemb, UINT size, VP *p_blk)
{
	KMEMB *ptr;

	/* alignmentȤäƤ */
	size = ((size + sizeof(KMEMB)) + sizeof(__dummy_for_align) - 1) & - sizeof(__dummy_for_align);

	/* ΰõ */
	for (ptr = (KMEMB *)(kmemb->queue.next); ptr != kmemb; ptr = (KMEMB *)(ptr->queue.next)) {
		if (ptr->magic != KMEM_MAGIC) {
			return FALSE;
		}

		if (ptr->used == FALSE && ptr->size >= size) {
			/* Ĥä */

			if (ptr->size - size > KMEM_DELTA) {
				/* ΰ˽ʬ;͵Τǡʬ䤹롣*/
				KMEMB *s;
				s = (KMEMB *)((UB *)ptr + size);
				s->size = ptr->size - size;
				s->magic = ptr->magic = KMEM_MAGIC;
				s->used = FALSE;

				ptr->size = size;
				ptr->used = TRUE;

				queue_insert_prev((QUEUE *)ptr, (QUEUE *)s);

			} else {
				/* ΰ˽ʬ;͵̵ΤǡƤͭ롣*/
				ptr->used = TRUE;
			}

			/* 桼ĤΤϡإåľ夫顣*/
			*p_blk = (VP)(ptr + 1);
			return TRUE;
		}
	}

	return FALSE;
}

#endif

/*
 *
 */
#ifdef __kmemrelease

BOOL kmem_release(KMEMB *kmemb, VP buf)
{
	KMEMB *hdr;
	KMEMB *check_kmemb;

	hdr = (KMEMB *)buf - 1;

	if (hdr->magic != KMEM_MAGIC) {
		/*
		 * ޥåʥФۤС
		 * ʥɥ쥹Ϥ褿Ȥߤʤ
		 */
		return FALSE;
	}

	hdr->used = FALSE;
	hdr->magic = 0;

	check_kmemb = (KMEMB *)(hdr->queue.next);
	if (check_kmemb->used == FALSE) {
		hdr->size += check_kmemb->size;
		check_kmemb->magic = 0;
		check_kmemb->queue.next->prev = check_kmemb->queue.prev;
		check_kmemb->queue.prev->next = check_kmemb->queue.next;
	}

	/*
	 *  ľΰʤ顢ʻ롣
	 */
	check_kmemb = (KMEMB *)(hdr->queue.prev);
	if (check_kmemb->used == FALSE) {
		check_kmemb->size += hdr->size;
		hdr->magic = 0;
		hdr->queue.next->prev = hdr->queue.prev;
		hdr->queue.prev->next = hdr->queue.next;
	}

	return TRUE;
}

#endif

/*
 *
 */
#ifdef __kmemstat

BOOL
kmem_status(KMEMB *kmemb, SIZE *remain, UINT *maxblk)
{
	KMEMB *hdr;
	KMEMB *blk;
	QUEUE *entry = NULL;
	SIZE maxblksize;

	hdr = (KMEMB *)((B*)kmemb - sizeof(KMEMB));

	if (hdr->magic != KMEM_MAGIC) {
		/*
		 * ޥåʥФۤС
		 * ʥɥ쥹Ϥ褿Ȥߤʤ
		 */
		return FALSE;
	}

	while((entry = queue_enumerate((QUEUE *)hdr, entry)) != NULL) {
		blk = (KMEMB *)entry;

		if (blk->used == FALSE) {
			*remain += blk->size;
			if (maxblksize < blk->size) {
				maxblksize = blk->size;
			}
		}
	}

	/*
	 * ref_mpl λͤ˹碌
	 * ֤˳ǤΥ֥åUINTɽ碌
	 * ͤ礭ˤϡUINTɽ碌ͤġ
	 */
	if (maxblksize >= UINT_MAX) {
		*maxblk = UINT_MAX;
	} else {
		*maxblk = (UINT)maxblksize;
	}
	
	return TRUE;
}
#endif /*__kmemstat*/
