/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: mailbox.c,v 1.26 2003/11/13 03:20:35 monaka Exp $
 */

/*
 *	᡼ܥåǽ
 */

#include "jsp_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "mailbox.h"
#include "bufmgr.h"

/*
 *  ᡼ܥåIDκ͡kernel_cfg.c
 */
extern const ID	tmax_mbxid;

/*
 *  ᡼ܥå֥åΥꥢkernel_cfg.c
 */
extern MBXINIB	mbxinib_table[];

/*
 *  ᡼ܥå֥åϢۥڥοkernel_cfg.c
 */
extern const UINT	tnum_mbxinia;

/*
 *  ᡼ܥå֥åϢۥڥΥꥢkernel_cfg.c
 */
extern const MBXINIA	mbxinia_table[];

/*
 *  ᡼ܥåͽIDΥꥢkernel_cfg.c
 */
extern const ID		mbxrid_table[];

/*
 *  ᡼ܥåͽIDο (kernel_cfg.c)
 */
extern const UINT	tnum_mbxrid;

/*
 *  ᡼ܥå֥åΥꥢkernel_cfg.c
 */
extern MBXCB	mbxcb_table[];

/*
 *  ᡼ܥåο
 */
#define TNUM_MBX	((UINT)(tmax_mbxid - TMIN_MBXID + 1))

/*
 *  ᡼ܥåID᡼ܥå֥åФΥޥ
 */
#define INDEX_MBX(mbxid)	((UINT)((mbxid) - TMIN_MBXID))
#define get_mbxcb(mbxid)	(&(mbxcb_table[INDEX_MBX(mbxid)]))

/*
 *  IDưѥե꡼ꥹ
 */
extern QUEUE mbx_freelist;

/*
 *  ᡼ܥåԤ֥å
 */
typedef struct mailbox_waiting_information {
	WINFO	winfo;		/* ɸԤ֥å */
	WOBJCB	*wobjcb;	/* Ԥ֥Ȥδ֥å */
	T_MSG	*pk_msg;	/* å */
} WINFO_MBX;

/* 
 *  ᡼ܥåǽν
 */
#ifdef __mbxini

QUEUE mbx_freelist;

void
mailbox_initialize()
{
	UINT	i;
	MBXCB	*mbxcb;
	MBXINIB *mbxinib;
	const MBXINIA	*mbxinia;
	const ID	*mbxrid;

	/*
	 * ͥ뵯ưξ֤˴ؤ餺ʤФʤΤ
	 * ޤ롣
	 */
	for (mbxcb = mbxcb_table, i = 0; i < TNUM_MBX; mbxcb++, i++) {
		queue_initialize(&(mbxcb->wait_queue));
	}
	queue_initialize(&mbx_freelist);

	/*
	 * mbxinia ˤäƼΤޤ
	 */
	for (mbxinia = mbxinia_table, i = 0; i < tnum_mbxinia; mbxinia++, i++) {
		mbxinib = &mbxinib_table[mbxinia->mbxid - TMIN_MBXID];
		*mbxinib = mbxinia->mbxinib;
		mbxcb = &mbxcb_table[mbxinia->mbxid - TMIN_MBXID];
		mbxcb->mbxinib = mbxinib;
		mbxcb->exist = KOBJ_EXIST;
		mbxcb->reserved = TRUE;

		/*
		 *  ɸcfgȤäȤmprihdNULLˤʤǽ롣<BTS:21>
		 *  Τ褦cfgǤϸڹܤ롣ɸcfgǤϤΥɤ
		 *  뤳ȤϤʤ
		 */
		if (mbxinib->mprihd == NULL) {
			BOOL stat;
			bufmgr_allocate(&stat, TSZ_MPRIHD(mbxinib->maxmpri), &(mbxinib->mprihd));
			assert(stat);
		}

		mbxcb->head = NULL;
	}

	/*
	 *  ͽID
	 */
	for (mbxrid = mbxrid_table, i = 0; i < tnum_mbxrid; mbxrid++, i++) {
		mbxcb_table[*mbxrid - TMIN_MBXID].reserved = TRUE;
	}

	/*
	 * mbxinia ˤäƼʤΤ
	 */
	for (mbxcb = mbxcb_table, i = 0; i < TNUM_MBX; mbxcb++, i++) {
		if (mbxcb->mbxinib == NULL) {
			mbxcb->exist = KOBJ_NOEXS;
			mbxcb->mbxinib = &mbxinib_table[i];

			if (!CHECK_OBJECT_RESERVED(mbxcb)) {
				queue_insert_prev(&mbx_freelist, (QUEUE*)mbxcb);
			}
		}
	}
}

#endif /* __mbxini */

/*
 *  åͥ٤μФ
 */
#define	MSGPRI(pk_msg)	(((T_MSG_PRI *) pk_msg)->msgpri)

/*
 *  ͥٽå塼ؤ
 */
Inline void
enqueue_msg_pri(T_MSG **p_prevmsg_next, T_MSG *pk_msg)
{
	T_MSG	*pk_nextmsg;

	while ((pk_nextmsg = *p_prevmsg_next) != NULL) {
		if (MSGPRI(pk_nextmsg) > MSGPRI(pk_msg)) {
			break;
		}
		p_prevmsg_next = &(pk_nextmsg->next);
	}
	pk_msg->next = pk_nextmsg;
	*p_prevmsg_next = pk_msg;
}

/*
 *  ᡼ܥå
 */
#ifdef __cre_mbx

SYSCALL ER
cre_mbx(ID mbxid, const T_CMBX * pk_cmbx)
{
	MBXCB	*mbxcb;
	MBXINIB *mbxinib;
	TCB	*tcb;
	ER	ercd;
	VP	mprihd;

	LOG_CRE_MBX_ENTER(mbxid);
	CHECK_TSKCTX_UNL();

	CHECK_MBXID(mbxid);
	mbxcb = get_mbxcb(mbxid);
	CHECK_OBJECT_CREATABLE(mbxcb);
	UPDATE_OBJECT_FREELIST(mbxcb);

	if (pk_cmbx->mprihd == NULL) {
		BOOL stat;
		SIZE mprihdsz;
		mprihdsz = TSZ_MPRIHD(pk_cmbx->maxmpri);
		bufmgr_allocate(&stat, mprihdsz, &mprihd);
		if (stat == FALSE) {
			t_lock_cpu();
			queue_insert_prev((QUEUE *)&mbx_freelist, (QUEUE *)mbxcb);
			mbxcb->exist = KOBJ_NOEXS;
			t_unlock_cpu();

			ercd = E_NOMEM;
			goto exit;
		}
	} else {
		mprihd = pk_cmbx->mprihd;
	}
	
	/*
	 * Ԥ
	 */
	queue_initialize((QUEUE*)mbxcb);
	mbxinib = mbxcb->mbxinib;
	mbxinib->mbxatr = pk_cmbx->mbxatr;
	mbxinib->maxmpri = pk_cmbx->maxmpri;
	mbxinib->mprihd = mprihd;

	mbxcb->head = NULL;

	/*
	 *  ǽ¾Υӥ뤫Ѳǽˤʤ롣
	 */
	mbxcb->exist = KOBJ_EXIST;

	ercd = E_OK;

    exit:
	LOG_CRE_MBX_LEAVE(ercd);
	return(ercd);
}

#endif /* __cre_mbx */

/*
 *  ᡼ܥå(IDֹ漫ưդ)
 */
#ifdef __acre_mbx

SYSCALL ER_ID
acre_mbx(const T_CMBX *pk_cmbx)
{
	MBXCB	*mbxcb;
	TCB	*tcb;
	ER_ID	ercd;
	VP	mprihd;

	LOG_ACRE_MBX_ENTER();
	CHECK_TSKCTX_UNL();

	if (pk_cmbx->mprihd == NULL) {
		BOOL stat;
		SIZE mprihdsz;
		mprihdsz = TSZ_MPRIHD(pk_cmbx->maxmpri);
		bufmgr_allocate(&stat, mprihdsz, &mprihd);
		if (stat == FALSE) {
			ercd = E_NOMEM;
			goto exit;
		}
	} else {
		mprihd = pk_cmbx->mprihd;
	}
	
	t_lock_cpu();
	mbxcb = (MBXCB *)t_get_free_id((QUEUE *)&mbx_freelist);
	if (mbxcb == NULL) {
		ercd = E_NOID;
		t_unlock_cpu();
		goto exit;
	}
	mbxcb->exist = KOBJ_INIT;
	t_unlock_cpu();

	/*
	 * Ԥ
	 */
	queue_initialize((QUEUE*)mbxcb);
	mbxcb->mbxinib->mbxatr = pk_cmbx->mbxatr;
	mbxcb->mbxinib->maxmpri = pk_cmbx->maxmpri;
	mbxcb->head = mprihd;

	ercd = MBXID(mbxcb);

	/*
	 *  ǽ¾Υӥ뤫Ѳǽˤʤ롣
	 */
	mbxcb->exist = KOBJ_EXIST;

    exit:
	if (ercd < E_OK && ercd != E_NOMEM) {
		BOOL stat;
		stat = bufmgr_release(mprihd);
		if (stat == FALSE) {
			ercd = E_SYS;
		}
	}
	LOG_ACRE_MBX_LEAVE(ercd);
	return(ercd);
}

#endif /* __acre_mbx */

/*
 *  ᡼ܥåκ
 */
#ifdef __del_mbx
SYSCALL ER
del_mbx(ID mbxid)
{
	MBXCB	*mbxcb;
	TCB	*tcb;
	ER	ercd;
	BOOL	stat;

	LOG_DEL_MBX_ENTER(mbxid);
	CHECK_TSKCTX_UNL();

	CHECK_MBXID(mbxid);
	mbxcb = get_mbxcb(mbxid);

	CHECK_OBJECT_DELETABLE(mbxcb);

	/* ԤθդȼԤԤ*/
	while (queue_empty(&(mbxcb->wait_queue)) == FALSE) {
		TCB *tcb;
		tcb = (TCB *)queue_delete_next(&(mbxcb->wait_queue));
		t_lock_cpu();
		if (wait_deleted(tcb)) {
			dispatch();
		}
		t_unlock_cpu();
	}

	/*
	 *  ̤ͥΥå塼إåΰХåեޥֵ͡Ѥ롣
	 */
	stat = bufmgr_release(mbxcb->head);
	if (stat) {
		ercd = E_OK;
	} else {
		ercd = E_SYS;
	}

	if (!CHECK_OBJECT_RESERVED(mbxcb)) {
	  /*
	   * ͽIDǤʤХե꡼ꥹȤ롣
	   */
		t_lock_cpu();
		queue_insert_prev(&mbx_freelist, (QUEUE *)mbxcb);
		t_unlock_cpu();
	}

	/* acre_/cre_ǤΥǽ */
	mbxcb->exist = KOBJ_NOEXS;

    exit:
	LOG_DEL_MBX_LEAVE(ercd);
	return(ercd);
}

#endif /* __del_mbx */

/*
 *  ᡼ܥåؤ
 */
#ifdef __snd_mbx

SYSCALL ER
snd_mbx(ID mbxid, T_MSG *pk_msg)
{
	MBXCB	*mbxcb;
	TCB	*tcb;
	ER	ercd;
    
	LOG_SND_MBX_ENTER(mbxid, pk_msg);
	CHECK_TSKCTX_UNL();

	CHECK_MBXID(mbxid);
	mbxcb = get_mbxcb(mbxid);

	CHECK_PAR((mbxcb->mbxinib->mbxatr & TA_MPRI) == 0
		  || (TMIN_MPRI <= MSGPRI(pk_msg)
		      && MSGPRI(pk_msg) <= mbxcb->mbxinib->maxmpri));

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mbxcb);

	if (!(queue_empty(&(mbxcb->wait_queue)))) {
		tcb = (TCB *) queue_delete_next(&(mbxcb->wait_queue));
		((WINFO_MBX *)(tcb->winfo))->pk_msg = pk_msg;
		if (wait_complete(tcb)) {
			dispatch();
		}
		ercd = E_OK;
	}
	else if ((mbxcb->mbxinib->mbxatr & TA_MPRI) != 0) {
		enqueue_msg_pri(&(mbxcb->head), pk_msg);
		ercd = E_OK;
	}
	else {
		pk_msg->next = NULL;
		if (mbxcb->head != NULL) {
			mbxcb->last->next = pk_msg;
		}
		else {
			mbxcb->head = pk_msg;
		}
		mbxcb->last = pk_msg;
		ercd = E_OK;
	}

	t_unlock_cpu();

    exit:
	LOG_SND_MBX_LEAVE(ercd);
	return(ercd);
}

#endif /* __snd_mbx */

/*
 *  ᡼ܥåμ
 */
#ifdef __rcv_mbx

SYSCALL ER
rcv_mbx(ID mbxid, T_MSG **ppk_msg)
{
	MBXCB	*mbxcb;
	WINFO_MBX winfo;
	ER	ercd;
    
	LOG_RCV_MBX_ENTER(mbxid, ppk_msg);
	CHECK_DISPATCH();
    
	CHECK_MBXID(mbxid);
	mbxcb = get_mbxcb(mbxid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mbxcb);

	if (mbxcb->head != NULL) {
		*ppk_msg = mbxcb->head;
		mbxcb->head = (*ppk_msg)->next;
		ercd = E_OK;
	}
	else {
		wobj_make_wait((WOBJCB *) mbxcb, (WINFO_WOBJ *) &winfo);
		dispatch();
		ercd = winfo.winfo.wercd;
		if (ercd == E_OK) {
			*ppk_msg = winfo.pk_msg;
		}
	}

	t_unlock_cpu();

    exit:
	LOG_RCV_MBX_LEAVE(ercd, *ppk_msg);
	return(ercd);
}

#endif /* __rcv_mbx */

/*
 *  ᡼ܥåμʥݡ󥰡
 */
#ifdef __prcv_mbx

SYSCALL ER
prcv_mbx(ID mbxid, T_MSG **ppk_msg)
{
	MBXCB	*mbxcb;
	ER	ercd;
    
	LOG_PRCV_MBX_ENTER(mbxid, ppk_msg);
	CHECK_TSKCTX_UNL();
    
	CHECK_MBXID(mbxid);
	mbxcb = get_mbxcb(mbxid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mbxcb);

	if (mbxcb->head != NULL) {
		*ppk_msg = mbxcb->head;
		mbxcb->head = (*ppk_msg)->next;
		ercd = E_OK;
	}
	else {
		ercd = E_TMOUT;
	}

	t_unlock_cpu();

    exit:
	LOG_PRCV_MBX_LEAVE(ercd, *ppk_msg);
	return(ercd);
}

#endif /* __prcv_mbx */

/*
 *  ᡼ܥåμʥॢȤ
 */
#ifdef __trcv_mbx

SYSCALL ER
trcv_mbx(ID mbxid, T_MSG **ppk_msg, TMO tmout)
{
	MBXCB	*mbxcb;
	WINFO_MBX winfo;
	TMEVTB	tmevtb;
	ER	ercd;
    
	LOG_TRCV_MBX_ENTER(mbxid, ppk_msg, tmout);
	CHECK_DISPATCH();
	CHECK_TMOUT(tmout);
    
	CHECK_MBXID(mbxid);
	mbxcb = get_mbxcb(mbxid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mbxcb);

	if (mbxcb->head != NULL) {
		*ppk_msg = mbxcb->head;
		mbxcb->head = (*ppk_msg)->next;
		ercd = E_OK;
	}
	else if (tmout == TMO_POL) {
		ercd = E_TMOUT;
	}
	else {
		wobj_make_wait_tmout((WOBJCB *) mbxcb, (WINFO_WOBJ *) &winfo,
						&tmevtb, tmout);
		dispatch();
		ercd = winfo.winfo.wercd;
		if (ercd == E_OK) {
			*ppk_msg = winfo.pk_msg;
		}
	}

	t_unlock_cpu();

    exit:
	LOG_TRCV_MBX_LEAVE(ercd, *ppk_msg);
	return(ercd);
}

#endif /* __trcv_mbx */

/*
 *  ᡼ܥåξֻ
 */
#ifdef __ref_mbx
SYSCALL ER
ref_mbx(ID mbxid, T_RMBX *pk_rmbx)
{
	MBXCB	*mbxcb;
	TCB	*tcb;
	ER	ercd;
    
	LOG_REF_MBX_ENTER(mbxid);
	CHECK_TSKCTX_UNL();

	CHECK_MBXID(mbxid);
	mbxcb = get_mbxcb(mbxid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mbxcb);

	if (!queue_empty(&(mbxcb->wait_queue))) {
		tcb = (TCB *)(mbxcb->wait_queue.next);
		pk_rmbx->wtskid = TSKID(tcb);
	} else {
		pk_rmbx->wtskid = TSK_NONE;
	}
	pk_rmbx->pk_msg = mbxcb->head;
	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_REF_MBX_LEAVE(ercd);
	return(ercd);
}

#endif /* __ref_mbx */

