/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2000-2003 by Masaki Muranaka
 *  Copyright (C) 2003 by Monami-software, JAPAN 
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: mempvar.c,v 1.29 2003/11/13 03:20:35 monaka Exp $
 */

/*
 *	Ĺס뵡ǽ
 */

#include "jsp_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "kmem.h"
#include "bufmgr.h"
#include "mempvar.h"

/*
 *  ĹסIDκ͡kernel_cfg.c
 */
extern const ID	tmax_mplid;

/*
 *  Ĺס֥åΥꥢkernel_cfg.c
 */
extern MPLINIB	mplinib_table[];

/*
 *  Ĺס֥åϢۥڥοkernel_cfg.c
 */
extern const UINT	tnum_mplinia;

/*
 *  Ĺס֥åϢۥڥΥꥢkernel_cfg.c
 */
extern const MPLINIA	mplinia_table[];

/*
 *  ĹסͽIDΥꥢkernel_cfg.c
 */
extern const ID		mplrid_table[];

/*
 *  ĹסͽIDο (kernel_cfg.c)
 */
extern const UINT	tnum_mplrid;

/*
 *  Ĺס֥åΥꥢkernel_cfg.c
 */
extern MPLCB	mplcb_table[];

/*
 *  Ĺסο
 */
#define TNUM_MPL	((UINT)(tmax_mplid - TMIN_MPLID + 1))

/*
 *  ĹסIDĹס֥åФ
 *  Υޥ
 */
#define INDEX_MPL(mplid)	((mplid) - TMIN_MPLID)
#define get_mplcb(mplid)	(&(mplcb_table[INDEX_MPL(mplid)]))

/*
 *  IDưѥե꡼ꥹ
 */
extern QUEUE mpl_freelist;

/*
 *  ĹסԤ֥å
 */
typedef struct variable_memorypool_waiting_information {
  WINFO winfo;		/* ɸԤ֥å */
  WOBJCB *wobjcb;	/* Ԥ֥ȤΥȥ֥å */
  UINT blksz;
  VP blk;		/* ֥å */
} WINFO_MPL;

/* 
 *  Ĺס뵡ǽν
 */
#ifdef __mplini

QUEUE mpl_freelist;

void
mempvar_initialize()
{
	UINT	i;
	MPLCB	*mplcb;
	MPLINIB *mplinib;
	const MPLINIA *mplinia;
	const ID	*mplrid;

	/*
	 * ͥ뵯ưξ֤˴ؤ餺ʤФʤΤ
	 * ޤ롣
	 */
	for (mplcb = mplcb_table, i = 0; i < TNUM_MPL; mplcb++, i++) {
		queue_initialize(&(mplcb->wait_queue));
	}
	queue_initialize(&mpl_freelist);

	/*
	 * mplinia ˤäƼΤޤ
	 */
	for (mplinia = mplinia_table, i = 0; i < tnum_mplinia; mplinia++, i++) {
		mplinib = &mplinib_table[mplinia->mplid - TMIN_MPLID];
		*mplinib = mplinia->mplinib;
		mplcb = &mplcb_table[mplinia->mplid - TMIN_MPLID];
		mplcb->mplinib = mplinib;
		mplcb->exist = KOBJ_EXIST;
		mplcb->reserved = TRUE;

		/*
		 *  ɸcfgȤäȤmplNULLˤʤǽ롣<BTS:21>
		 *  Τ褦cfgǤϸڹܤ롣ɸcfgǤϤΥɤ
		 *  뤳ȤϤʤ
		 */
		if (mplinib->mpl == NULL) {
			BOOL stat;
			bufmgr_allocate(&stat, mplinib->mplsz, &(mplinib->mpl));
			assert(stat);
		}

		kmem_setup(mplinib->mpl, mplinib->mplsz, &mplcb->free_list);
	}

	/*
	 *  ͽID
	 */
	for (mplrid = mplrid_table, i = 0; i < tnum_mplrid; mplrid++, i++) {
		mplcb_table[*mplrid - TMIN_MPLID].reserved = TRUE;
	}

	/*
	 * mplinia ˤäƼʤΤ
	 */
	for (mplcb = mplcb_table, i = 0; i < TNUM_MPL; mplcb++, i++) {
		if (mplcb->mplinib == NULL) {
			mplcb->exist = KOBJ_NOEXS;
			mplcb->mplinib = &mplinib_table[i];

			if (!CHECK_OBJECT_RESERVED(mplcb)) {
				queue_insert_prev(&mpl_freelist, (QUEUE*)mplcb);
			}
		}
	}
}

#endif /* __mplini */

/*
 *  Ԥ
 */
#ifdef __mplcbini
ER
mplcb_initialize(MPLCB *mplcb, T_CMPL *pk_cmpl)
{
	VP	mpl;
	MPLINIB	*mplinib;

	mpl = pk_cmpl->mpl;

	/* mpl == NULL λХåեޥ͡㤫롣 */
	if (mpl == NULL) {
		BOOL stat;
		bufmgr_allocate(&stat, pk_cmpl->mplsz, &mpl);
		if (!stat) {
			return E_NOMEM;
		}
	}

	queue_initialize((QUEUE*)mplcb);
	mplinib = mplcb->mplinib;
	mplinib->mplatr = pk_cmpl->mplatr;
	mplinib->mpl = mpl;
	mplinib->mplsz = pk_cmpl->mplsz;
	kmem_setup(mpl, mplinib->mplsz, &(mplcb->free_list));

	return E_OK;
}

#endif

/*
 *  Ĺס
 */
#ifdef __cre_mpl

SYSCALL ER
cre_mpl(ID mplid, const T_CMPL *pk_cmpl)
{
	MPLCB	*mplcb;
	MPLINIB *mplinib;
	ER	ercd;
    
	LOG_CRE_MPL_ENTER(mplid);
	CHECK_TSKCTX_UNL();

	CHECK_MPLID(mplid);
	mplcb = get_mplcb(mplid);
	CHECK_OBJECT_CREATABLE(mplcb);
	UPDATE_OBJECT_FREELIST(mplcb);

	ercd = mplcb_initialize(mplcb, pk_cmpl);

	/*
	 *  ǽ¾Υӥ뤫Ѳǽˤʤ롣
	 */
	mplcb->exist = KOBJ_EXIST;

    exit:
	LOG_CRE_MPL_LEAVE(ercd);
	return(ercd);
}

#endif

/*
 *  Ĺס(IDֹ漫ưդ
 */
#ifdef __acre_mpl

SYSCALL ER_ID
acre_mpl(const T_CMPL *pk_cmpl)
{
	MPLCB	*mplcb;
	MPLINIB *mplinib;
	ER_ID	ercd;
    
	LOG_ACRE_MPL_ENTER();
	CHECK_TSKCTX_UNL();

	t_lock_cpu();
	mplcb = (MPLCB *)t_get_free_id((QUEUE *)&mpl_freelist);
	if (mplcb == NULL) {
		ercd = E_NOID;
		t_unlock_cpu();
		goto exit;
	}
	mplcb->exist = KOBJ_INIT;
	t_unlock_cpu();

	ercd = mplcb_initialize(mplcb, pk_cmpl);
	if (ercd != E_OK) {
		t_lock_cpu();
		queue_insert_prev(&mpl_freelist, (QUEUE *)mplcb);
		t_unlock_cpu();
		goto exit;
	}

	ercd = MPLID(mplcb);

	/*
	 *  ǽ¾Υӥ뤫Ѳǽˤʤ롣
	 */
	mplcb->exist = KOBJ_EXIST;

    exit:
	LOG_ACRE_MPL_LEAVE(ercd);
	return(ercd);
}

#endif

/*
 *  Ĺסκ
 */
#ifdef __del_mpl
SYSCALL ER
del_mpl(ID mplid)
{
	MPLCB	*mplcb;
	TCB	*tcb;
	ER	ercd;
	BOOL	stat;

	LOG_DEL_MPL_ENTER(mplid);
	CHECK_TSKCTX_UNL();

	CHECK_MPLID(mplid);
	mplcb = get_mplcb(mplid);

	CHECK_OBJECT_DELETABLE(mplcb);

	/* ԤθդȼԤԤ*/
	while (queue_empty(&(mplcb->wait_queue)) == FALSE) {
		TCB *tcb;
		tcb = (TCB *)queue_delete_next(&(mplcb->wait_queue));
		t_lock_cpu();
		if (wait_deleted(tcb)) {
			dispatch();
		}
		t_unlock_cpu();
	}
	  
	if (!CHECK_OBJECT_RESERVED(mplcb)) {
	  /*
	   * ͽIDǤʤХե꡼ꥹȤ롣
	   */
		t_lock_cpu();
		queue_insert_prev(&mpl_freelist, (QUEUE *)mplcb);
		t_unlock_cpu();
	}

	/* סΰ롣*/
	stat = bufmgr_release(mplcb->free_list);
	if (stat) {
		ercd = E_OK;
	} else {
		ercd = E_SYS;
	}


	/* acre_/cre_ǤΥǽ */
	mplcb->exist = KOBJ_NOEXS;

    exit:
	LOG_DEL_MPL_LEAVE(ercd);
	return(ercd);
}

#endif /* __del_mpl */

/*
 *  Ĺ֥åγ
 */
#ifdef __get_mpl

SYSCALL ER
get_mpl(ID mplid, UINT blksz, VP *p_blk)
{
  MPLCB	*mplcb;
  WINFO_MPL winfo;
  ER	ercd;

  LOG_GET_MPL_ENTER(mplid, blksz, p_blk);
  CHECK_DISPATCH();

  CHECK_MPLID(mplid);
  mplcb = get_mplcb(mplid);

  t_lock_cpu();
  T_CHECK_OBJECT_EXIST(mplcb);

  if (kmem_allocate(mplcb->free_list, blksz, p_blk))
    {
      ercd = E_OK;
    }
  else
    {
      wobj_make_wait((WOBJCB *) mplcb, (WINFO_WOBJ *) &winfo);
      dispatch();
      *p_blk = winfo.blk;
      ercd = winfo.winfo.wercd;
    }

  t_unlock_cpu();

 exit:
  LOG_GET_MPL_LEAVE(ercd, p_blk);
  return(ercd);
}

#endif /* __get_mpl */

/*
 *  Ĺ֥åγʥݡ󥰡
 */
#ifdef __pget_mpl

SYSCALL ER
pget_mpl(ID mplid, UINT blksz, VP *p_blk)
{
  MPLCB	*mplcb;
  ER	ercd;

  LOG_PGET_MPL_ENTER(mplid, blksz, p_blk);
  CHECK_TSKCTX_UNL();

  CHECK_MPLID(mplid);
  mplcb = get_mplcb(mplid);

  t_lock_cpu();
  T_CHECK_OBJECT_EXIST(mplcb);

  if (kmem_allocate(mplcb->free_list, blksz, p_blk))
    {
      ercd = E_OK;
    }
  else {
    ercd = E_TMOUT;
  }

  t_unlock_cpu();

 exit:
  LOG_PGET_MPL_LEAVE(ercd, p_blk);
  return(ercd);
}

#endif /* __pget_mpl */

/*
 *  Ĺ֥åγʥॢȤ
 */
#ifdef __tget_mpl

SYSCALL ER
tget_mpl(ID mplid, UINT blksz, VP *p_blk, TMO tmout)
{
  MPLCB	*mplcb;
  WINFO_MPL winfo;
  TMEVTB	tmevtb;
  ER	ercd;

  LOG_TGET_MPL_ENTER(mplid, blksz, p_blk, tmout);
  CHECK_DISPATCH();
  CHECK_TMOUT(tmout);

  CHECK_MPLID(mplid);
  mplcb = get_mplcb(mplid);

  t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mplcb);

  if (kmem_allocate(mplcb->free_list, blksz, p_blk))
    {
      ercd = E_OK;
    }
  else if (tmout == TMO_POL)
    {
      ercd = E_TMOUT;
    }
  else
    {
      wobj_make_wait_tmout((WOBJCB *) mplcb, (WINFO_WOBJ *) &winfo,
			   &tmevtb, tmout);
      dispatch();
      *p_blk = winfo.blk;
      ercd = winfo.winfo.wercd;
    }

  t_unlock_cpu();

 exit:
  LOG_TGET_MPL_LEAVE(ercd, p_blk);
  return(ercd);
}

#endif /* __tget_mpl */

/*
 *  Ĺ֥åֵ
 */
#ifdef __rel_mpl

SYSCALL ER
rel_mpl(ID mplid, VP blk)
{
	MPLCB	*mplcb;
	TCB	*tcb;
	ER	ercd = E_OK;
	BOOL	stat;
	
	LOG_REL_MPL_ENTER(mplid, blk);
	CHECK_TSKCTX_UNL();

	CHECK_MPLID(mplid);
	mplcb = get_mplcb(mplid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mplcb);

	stat = kmem_release(mplcb->free_list, blk);
	if (stat == FALSE) {
		ercd = E_PAR;
	}
	else if (queue_empty(&(mplcb->wait_queue)) == FALSE)  {
		VP new_blk;
		UINT blksz;

		/* Ԥκǽˤ륿׵ᤷƤ
		 * ĹΥ롣
		 */
		tcb = (TCB *)(mplcb->wait_queue.next);
		blksz = ((WINFO_MPL *)(tcb->winfo))->blksz;

		if (kmem_allocate(mplcb->free_list, blksz, &new_blk) == TRUE) {
			/* Ǥ顢Ԥdispatch */
			queue_delete_next(&(mplcb->wait_queue));
			((WINFO_MPL *)(tcb->winfo))->blk = new_blk;
			if (wait_complete(tcb)) {
				dispatch();
			}
		}

		/* åƤ륿ɤʤȤ⡢
		 * θƽФˤϴطʤE_OKǤ롣
		 */
		ercd = E_OK;
	}

	t_unlock_cpu();
 exit:
	LOG_REL_MPL_LEAVE(ercd);
	return(ercd);
}

#endif /* __tget_mpl */

/*
 * Ĺסξּ
 */
#ifdef __ref_mpl

SYSCALL ER
ref_mpl(ID mplid, T_RMPL *pk_rmpl)
{
	MPLCB	*mplcb;
	ER	ercd;
	BOOL	stat;

	LOG_REF_MPL_ENTER(mplid);
	CHECK_TSKCTX_UNL();

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mplcb);

	CHECK_MPLID(mplid);
	mplcb = get_mplcb(mplid);

	if (!(queue_empty(&(mplcb->wait_queue)))) {
		TCB	*tcb;
		tcb = (TCB *)queue_peek_next(&(mplcb->wait_queue));
		pk_rmpl->wtskid = TSKID(tcb);
	}
	else {
		pk_rmpl->wtskid = TSK_NONE;
	}

	stat = kmem_status(mplcb->free_list, pk_rmpl->fmplsz, pk_rmpl->fblksz);
	if (stat == FALSE) {
		/* free_list Ƥ */
		ercd = E_SYS;
	} else {
		ercd = E_OK;
	}

	t_unlock_cpu();

    exit:
	LOG_REF_MPL_LEAVE(ercd);
	return(ercd);
}

#endif

#if 0
SYSCALL ER
iget_mpl(ID mplid, UINT blksz, VP *p_blk)
{
  MPLCB	*mplcb;
  ER	ercd;

  i_lock_cpu();

  CHECK_MPLID(mplid);
  mplcb = get_mplcb(mplid);

  if (kmem_allocate(&(mplcb->free_list), blksz, p_blk))
    {
      ercd = E_OK;
    }
  else {
    ercd = E_TMOUT;
  }

  i_unlock_cpu();

  return ercd;
}


SYSCALL ER
irel_mpl(ID mplid, VP blk)
{
  MPLCB	*mplcb;
  ER	ercd = E_OK;
    
  i_lock_cpu();

  CHECK_MPLID(mplid);
  mplcb = get_mplcb(mplid);

  if (mplcb->mplinib->mpl > blk ||
      blk >= mplcb->mplinib->mpl + mplcb->mplinib->mplsz ||
      mempvar_free(blk) == FALSE)
    {
      ercd = E_PAR;
    }

  i_unlock_cpu();

  return ercd;
}
#endif
