/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: messagebuffer.c,v 1.27 2003/11/19 04:14:24 monaka Exp $
 */

/*
 *	åХåեǽ
 */

#include "jsp_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "messagebuffer.h"
#include "bufmgr.h"

/*
 *  åХåեIDκ͡kernel_cfg.c
 */
extern const ID	tmax_mbfid;

/*
 *  åХåե֥åΥꥢkernel_cfg.c
 */
extern MBFINIB	mbfinib_table[];

/*
 *  åХåե֥åϢۥڥοkernel_cfg.c
 */
extern const UINT	tnum_mbfinia;

/*
 *  åХåե֥åϢۥڥΥꥢkernel_cfg.c
 */
extern const MBFINIA	mbfinia_table[];

/*
 *  åХåեͽIDΥꥢkernel_cfg.c
 */
extern const ID		mbfrid_table[];

/*
 *  åХåեͽIDο (kernel_cfg.c)
 */
extern const UINT	tnum_mbfrid;

/*
 *  åХåե֥åΥꥢkernel_cfg.c
 */
extern MBFCB	mbfcb_table[];
/*
 *  åХåեο
 */
#define TNUM_MBF	((UINT)(tmax_mbfid - TMIN_MBFID + 1))

/*
 *  åξ
 */
#define MBF_MAXMSZ_MAX		((UINT)65536)

/*
 *  åХåեIDåХåե֥åФΥޥ
 */
#define INDEX_MBF(mbfid)	((UINT)((mbfid) - TMIN_MBFID))
#define get_mbfcb(mbfid)	(&(mbfcb_table[INDEX_MBF(mbfid)]))

/*
 *  IDưѥե꡼ꥹ
 */
extern QUEUE mbf_freelist;

/*
 *  åХåեԤ֥å
 *
 *  åХåեؤԤȥåХåեμԤǡƱԤ
 *  ֥åȤ
 */
typedef struct dataqueue_waiting_information {
	WINFO	winfo;		/* ɸԤ֥å */
	WOBJCB	*wobjcb;	/* Ԥ֥Ȥδ֥å */
	VP	msg;		/* å  */
	UINT	msgsz;		/* åΥ */
} WINFO_MBF;

/*
 *
 */
#ifdef __mbfrwait

BOOL
send_mbf_rwait(ID mbfid, VP msg, UINT msgsz)
{
	TCB		*tcb;
	MBFCB		*mbfcb;
	WINFO_MBF	*winfo_mbf;

	mbfcb = get_mbfcb(mbfid);
	if (queue_empty(&(mbfcb->rwait_queue))) {
		return FALSE;
	}

	tcb = (TCB *) queue_delete_next(&(mbfcb->rwait_queue));
	winfo_mbf = (WINFO_MBF *)(tcb->winfo);
	memcpy(winfo_mbf->msg, msg, msgsz);
	winfo_mbf->msgsz = msgsz;
	if (wait_complete(tcb)) {
		dispatch();
	}

	return TRUE;
}

#endif /* __mbfrwait */

/*
 *
 */
#ifdef __mbfrbuf

BOOL
read_mbf_buffer(ID mbfid, VP msg, UINT *msgsz)
{
	MBFCB *mbfcb;
	UB *m;
	UB *buf;
	UINT mbfsz;
	UINT head;
	UINT tail;
	UINT i;
	UINT size;

	mbfcb = get_mbfcb(mbfid);
	m = (UB*)msg;
	buf = mbfcb->mbfinib->mbf;
	mbfsz = mbfcb->mbfinib->mbfsz;
	head = mbfcb->head;
	tail = mbfcb->tail;

	if (head == tail) {
		return FALSE;
	}

	size = (buf[tail++ % mbfsz] << 8);
	size |= buf[tail++ % mbfsz];
	tail %= mbfsz;
	for(i = 0; i < size; i++, tail = (tail + 1) % mbfsz) {
		m[i] = buf[tail];
	}
	mbfcb->tail = tail;
	*msgsz = size;

	return TRUE;
}
#endif /* __mbfrbuf */

/*
 *
 */
#ifdef __mbfwbuf

BOOL
write_mbf_buffer(ID mbfid, VP msg, UINT msgsz)
{
	MBFCB *mbfcb;
	UB *m;
	UB *buf;
	UINT mbfsz;
	UINT head;
	UINT tail;
	UINT i;
	UINT size;
	UINT limit;

	mbfcb = get_mbfcb(mbfid);
	m = (UB*)msg;
	buf = mbfcb->mbfinib->mbf;
	mbfsz = mbfcb->mbfinib->mbfsz;
	head = mbfcb->head;
	tail = mbfcb->tail;

	if (tail <= head) {
		limit = mbfsz + tail;
	} else {
		limit = tail;
	}

	if (head + 2 + msgsz > limit) {
		return FALSE;
	}

	buf[head++ % mbfsz] = (msgsz >> 8) & 0xff;
	buf[head++ % mbfsz] = msgsz & 0xff;
	head %= mbfsz;

	for(i = 0; i < msgsz; i++, head = (head + 1) % mbfsz) {
		buf[head] = m[i];
	}
	mbfcb->head = head;

	return TRUE;
}
#endif /* __mbfrbuf */

/* 
 *  åХåեǽν
 */
#ifdef __mbfini

QUEUE mbf_freelist;

void
messagebuffer_initialize()
{
	UINT	i;
	UINT	j;
	MBFCB	*mbfcb;
	MBFINIB *mbfinib;
	const MBFINIA *mbfinia;
	const ID	*mbfrid;

	/*
	 * ͥ뵯ưξ֤˴ؤ餺ʤФʤΤ
	 * ޤ롣
	 */
	for (mbfcb = mbfcb_table, i = 0; i < TNUM_MBF; mbfcb++, i++) {
		queue_initialize(&(mbfcb->wait_queue));
		queue_initialize(&(mbfcb->rwait_queue));
	}
	queue_initialize(&mbf_freelist);

	/*
	 * mbfinia ˤäƼΤޤ
	 */
	for (mbfinia = mbfinia_table, i = 0; i < tnum_mbfinia; mbfinia++, i++) {
		UINT idx = INDEX_MBF(mbfinia->mbfid);
		mbfinib = &mbfinib_table[idx];
		*mbfinib = mbfinia->mbfinib;
		mbfcb = &mbfcb_table[idx];
		mbfcb->mbfinib = mbfinib;
		mbfcb->exist = KOBJ_EXIST;
		mbfcb->reserved = TRUE;
		mbfcb->head = 0;
		mbfcb->tail = 0;

		/*
		 *  ɸcfgȤäȤmbfNULLˤʤǽ롣<BTS:21>
		 *  Τ褦cfgǤϸڹܤ롣ɸcfgǤϤΥɤ
		 *  뤳ȤϤʤ
		 */
		if (mbfinib->mbf == NULL) {
			BOOL stat;
			bufmgr_allocate(&stat, mbfinib->mbfsz, &(mbfinib->mbf));
			assert(stat);
		}
	}

	/*
	 *  ͽID
	 */
	for (mbfrid = mbfrid_table, i = 0; i < tnum_mbfrid; mbfrid++, i++) {
		mbfcb_table[INDEX_MBF(*mbfrid)].reserved = TRUE;
	}

	/*
	 * mbfinia ˤäƼʤΤ
	 */
	for (mbfcb = mbfcb_table, i = 0; i < TNUM_MBF; mbfcb++, i++) {
		if (mbfcb->mbfinib == NULL) {
			mbfcb->exist = KOBJ_NOEXS;
			mbfcb->mbfinib = &mbfinib_table[i];

			if (!CHECK_OBJECT_RESERVED(mbfcb)) {
				queue_insert_prev(&mbf_freelist, (QUEUE*)mbfcb);
			}
		}
	}
}

#endif /* __mbfini */

/*
 *  åХåե
 */
#ifdef __cre_mbf

SYSCALL ER
cre_mbf(ID mbfid, const T_CMBF * pk_cmbf)
{
	MBFCB	*mbfcb;
	MBFINIB *mbfinib;
	ER	ercd;
	VP	mbf;
	LOG_CRE_MBF_ENTER(mbfid);
	CHECK_TSKCTX_UNL();

	CHECK_MBFID(mbfid);
	CHECK_PAR(pk_cmbf->maxmsz < MBF_MAXMSZ_MAX);

	mbfcb = get_mbfcb(mbfid);
	CHECK_OBJECT_CREATABLE(mbfcb);
	UPDATE_OBJECT_FREELIST(mbfcb);

	mbf = pk_cmbf->mbf;
	if (mbf == NULL) {
		BOOL stat;
		t_lock_cpu();
		bufmgr_allocate(&stat, pk_cmbf->mbfsz, &mbf);
		t_unlock_cpu();
		if (!stat) {
			ercd = E_NOMEM;
			goto exit;
		}
	}
	
	/*
	 * Ԥ
	 * wait_queue ϡ messagebuffer_initialize()ǽ뤷
	 * del_mbfλˤݽ롣äơǤϽɬפʤ
	 */
	queue_initialize((QUEUE *)mbfcb);
	mbfinib = mbfcb->mbfinib;
	mbfinib->mbfatr = pk_cmbf->mbfatr;
	mbfinib->maxmsz = pk_cmbf->maxmsz;
	mbfinib->mbfsz  = pk_cmbf->mbfsz;
	mbfinib->mbf = pk_cmbf->mbf;
	mbfcb->head = 0;
	mbfcb->tail = 0;

	ercd = E_OK;

	/*
	 *  ǽ¾Υӥ뤫Ѳǽˤʤ롣
	 */
	mbfcb->exist = KOBJ_EXIST;

    exit:
	LOG_CRE_MBF_LEAVE(ercd);
	return(ercd);
}

#endif /* __cre_mbf */

/*
 *  åХåե(IDֹ漫ưդ)
 */
#ifdef __acre_mbf

SYSCALL ER_ID
acre_mbf(const T_CMBF *pk_cmbf)
{
	VP	mbf;
	MBFCB	*mbfcb;
	MBFINIB *mbfinib;
	ER_ID	ercd;
    
	LOG_ACRE_MBF_ENTER();

	CHECK_PAR(pk_cmbf->maxmsz < MBF_MAXMSZ_MAX);

	t_lock_cpu();

	mbfcb = (MBFCB *)t_get_free_id((QUEUE *)&mbf_freelist);
	if (mbfcb == NULL) {
		ercd = E_NOID;
		t_unlock_cpu();
		goto exit;
	}

	mbf = pk_cmbf->mbf;
	if (mbf == NULL) {
		BOOL stat;
		bufmgr_allocate(&stat, pk_cmbf->mbfsz, &mbf);
		if (!stat) {
			if (mbfcb) {
				queue_insert_prev(&mbf_freelist, (QUEUE *)mbfcb);		
			}
			t_unlock_cpu();
			ercd = E_NOMEM;
			goto exit;
		}
	}
	
	t_unlock_cpu();
	
	ercd = MBFID(mbfcb);
	mbfcb = get_mbfcb(ercd);

	mbfcb->exist = KOBJ_INIT;
	t_unlock_cpu();

	/*
	 * Ԥ
	 * swait_queue ϡ messagebuffer_initialize()ǽ뤷
	 * del_mbfλˤݽ롣äơǤϽɬפʤ
	 */
	queue_initialize((QUEUE *)mbfcb);
	mbfinib = mbfcb->mbfinib;
	mbfinib->mbfatr = pk_cmbf->mbfatr;
	mbfinib->maxmsz = pk_cmbf->maxmsz;
	mbfinib->mbfsz  = pk_cmbf->mbfsz;
	mbfinib->mbf = mbf;
	mbfcb->head = 0;
	mbfcb->tail = 0;

	/*
	 *  ǽ¾Υӥ뤫Ѳǽˤʤ롣
	 */
	mbfcb->exist = KOBJ_EXIST;

    exit:
	LOG_ACRE_MBF_LEAVE(ercd);
	return(ercd);
}

#endif /* __acre_mbf */

/*
 *  åХåեκ
 */
#ifdef __del_mbf
SYSCALL ER
del_mbf(ID mbfid)
{
	UINT	i;
	MBFCB	*mbfcb;
	TCB	*tcb;
	ER	ercd;
   	BOOL	stat;
 
	LOG_DEL_MBF_ENTER(mbfid);
	CHECK_TSKCTX_UNL();

	CHECK_MBFID(mbfid);
	mbfcb = get_mbfcb(mbfid);

	CHECK_OBJECT_DELETABLE(mbfcb);

	/* ԤθդȼԤԤ*/
	while (queue_empty(&(mbfcb->wait_queue)) == FALSE) {
		TCB *tcb;
		tcb = (TCB *)queue_delete_next(&(mbfcb->wait_queue));
		t_lock_cpu();
		if (wait_deleted(tcb)) {
			dispatch();
		}
		t_unlock_cpu();
	}

	/* ԤθդȼԤԤ*/
	while (queue_empty(&(mbfcb->rwait_queue)) == FALSE) {
		TCB *tcb;
		tcb = (TCB *)queue_delete_next(&(mbfcb->rwait_queue));
		t_lock_cpu();
		if (wait_deleted(tcb)) {
			dispatch();
		}
		t_unlock_cpu();
	}

	if (!CHECK_OBJECT_RESERVED(mbfcb)) {
	  /*
	   * ͽIDǤʤХե꡼ꥹȤ롣
	   */
		t_lock_cpu();
		queue_insert_prev(&mbf_freelist, (QUEUE *)mbfcb);
		t_unlock_cpu();
	}

	/*
	 *  åХåեΰ򥫡ͥǳݤˤϡ
	 *  ΰֵѤ롣
	 */
	stat = bufmgr_release(mbfcb->mbfinib->mbf);

	/* acre_/cre_ǤΥǽ */
	mbfcb->exist = KOBJ_NOEXS;

	ercd = E_OK;

    exit:
	LOG_DEL_MBF_LEAVE(ercd);
	return(ercd);
}

#endif /* __del_mbf */

/*
 *  åХåեؤ
 */
#ifdef __snd_mbf
SYSCALL ER
snd_mbf(ID mbfid, VP msg, UINT msgsz)
{
	MBFCB	*mbfcb;
	WINFO_MBF winfo;
	TCB *tcb;
	QUEUE	*queue;
	ER	ercd;
	BOOL	stat;

	LOG_SND_MBF_ENTER(mbfid);
	CHECK_DISPATCH();

	CHECK_MBFID(mbfid);
	mbfcb = get_mbfcb(mbfid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mbfcb);

	/*
	 * Ԥäʤ顢¨¤˥꥿
	 * ԡsend_mbf_rwait⤹Ǥ˽äƤ롣
	 */
	stat = send_mbf_rwait(mbfid, msg, msgsz);
	if (stat) {
		ercd = E_OK;
		goto escape;
	}

	/*
	 *  ʬͥ٤⤤ԤäƤ顢
	 *  ʬԤء
	 */
	queue = NULL;
	while((queue = queue_enumerate(&(mbfcb->wait_queue), queue)) != NULL) {
		tcb = (TCB *)queue;
		if (tcb->priority < runtsk->priority) {
			/* make waiting */
			WINFO_MBF winfo;
			winfo.msg = msg;
			winfo.msgsz = msgsz;
			wobj_make_wait((WOBJCB *) mbfcb, (WINFO_WOBJ *) &winfo);
			dispatch();
			ercd = winfo.winfo.wercd;
			goto escape;
		}
	}

	/*
	 *  åХåեؤνߤߤ롣åХåե˽񤱤ʤ硢
	 * Ԥء
	 */
	stat = write_mbf_buffer(mbfid, msg, msgsz);
	if (stat) {
		ercd = E_OK;
	} else {
		/* make waiting */
		WINFO_MBF winfo;
		winfo.msg = msg;
		winfo.msgsz = msgsz;
		wobj_make_wait((WOBJCB *) mbfcb, (WINFO_WOBJ *) &winfo);
		dispatch();
		ercd = winfo.winfo.wercd;
	}

    escape:
	t_unlock_cpu();

    exit:
	LOG_SND_MBF_LEAVE(ercd);
	return(ercd);
}

#endif /* __snd_mbf */

/*
 *  åХåեؤʥݡ󥰡
 */
#ifdef __psnd_mbf
SYSCALL ER
psnd_mbf(ID mbfid, VP msg, UINT msgsz)
{
	MBFCB	*mbfcb;
	WINFO_MBF winfo;
	TCB *tcb;
	QUEUE *queue;
	ER	ercd;
	BOOL	stat;

	LOG_SND_MBF_ENTER(mbfid);
	CHECK_TSKCTX_UNL();

	CHECK_MBFID(mbfid);
	mbfcb = get_mbfcb(mbfid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mbfcb);

	/*
	 * Ԥäʤ顢¨¤˥꥿
	 * ԡsend_mbf_rwait⤹Ǥ˽äƤ롣
	 */
	stat = send_mbf_rwait(mbfid, msg, msgsz);
	if (stat) {
		ercd = E_OK;
		goto escape;
	}

	/*
	 *  ʬͥ٤⤤ԤäƤ顢
	 *  ॢȥ顼롣
	 */
	queue = NULL;
	while((queue = queue_enumerate(&(mbfcb->wait_queue), queue)) != NULL) {
		tcb = (TCB *)queue;
		if (tcb->priority < runtsk->priority) {
			ercd = E_TMOUT;
			goto escape;
		}
	}

	/*
	 *  åХåեؤνߤߤ롣åХåե˽񤱤ʤ硢
	 *  ॢȥ顼롣
	 */
	stat = write_mbf_buffer(mbfid, msg, msgsz);
	if (stat) {
		ercd = E_OK;
	} else {
		ercd = E_TMOUT;
	}

    escape:
	t_unlock_cpu();

    exit:
	LOG_SND_MBF_LEAVE(ercd);
	return(ercd);
}

#endif /* __psnd_mbf */

/*
 *  åХåեؤʥॢȤ
 */
#ifdef __tsnd_mbf
SYSCALL ER
tsnd_mbf(ID mbfid, VP msg, UINT msgsz, TMO tmout)
{
	MBFCB	*mbfcb;
	WINFO_MBF winfo;
	TMEVTB	tmevtb;
	TCB *tcb;
	QUEUE *queue;
	ER	ercd;
	BOOL	stat;

	LOG_SND_MBF_ENTER(mbfid);
	CHECK_DISPATCH();
	CHECK_TMOUT(tmout);

	CHECK_MBFID(mbfid);
	mbfcb = get_mbfcb(mbfid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mbfcb);

	/*
	 * Ԥäʤ顢¨¤˥꥿
	 * ԡsend_mbf_rwait⤹Ǥ˽äƤ롣
	 */
	stat = send_mbf_rwait(mbfid, msg, msgsz);
	if (stat) {
		ercd = E_OK;
		goto escape;
	}

	/*
	 *  ʬͥ٤⤤ԤäƤ顢
	 *  ʬԤء
	 */
	queue = NULL;
	while((queue = queue_enumerate(&(mbfcb->wait_queue), queue)) != NULL) {
		tcb = (TCB *)queue;
		if (tcb->priority < runtsk->priority) {
			/* make waiting */
			WINFO_MBF winfo;
			winfo.msg = msg;
			winfo.msgsz = msgsz;
			wobj_make_wait((WOBJCB *) mbfcb, (WINFO_WOBJ *) &winfo);
			dispatch();
			ercd = winfo.winfo.wercd;
			goto escape;
		}
	}

	/*
	 *  åХåեؤνߤߤ롣åХåե˽񤱤ʤ硢
	 * Ԥء
	 */
	stat = write_mbf_buffer(mbfid, msg, msgsz);
	if (stat) {
		ercd = E_OK;
	} else {
		/* make waiting */
		WINFO_MBF winfo;
		winfo.msg = msg;
		winfo.msgsz = msgsz;
		wobj_make_wait((WOBJCB *) mbfcb, (WINFO_WOBJ *) &winfo);
		dispatch();
		ercd = winfo.winfo.wercd;
	}

    escape:
	t_unlock_cpu();

    exit:
	LOG_SND_MBF_LEAVE(ercd);
	return(ercd);
}

#endif /* __tsnd_mbf */

/*
 *  åХåեμ
 */
#ifdef __rcv_mbf
SYSCALL ER_UINT
rcv_mbf(ID mbfid, VP msg)
{
	MBFCB	*mbfcb;
	TCB	*tcb;
	WINFO_MBF winfo;
	ER_UINT	ercd;
	UINT	msgsz;
	BOOL	stat;
	volatile int a;

	LOG_RCV_MBF_ENTER(mbfid);
	CHECK_DISPATCH();

	CHECK_MBFID(mbfid);
	mbfcb = get_mbfcb(mbfid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mbfcb);

	/*
	 * åХåե˥ǡäʤ顢¨¤˥꥿
	 * ԡread_mbf_buffer⤹Ǥ˽äƤ롣
	 * ǡʤСԤ򸡺
	 * Ԥʤ顢Ԥء
	 * Ԥʤ顢ԡԤ
	 */
	stat = read_mbf_buffer(mbfid, msg, &msgsz);
	if (stat) {
		ercd = msgsz;
	} else {
		if (queue_empty(&(mbfcb->wait_queue))) {
			/*
			 *  make waiting.
			 */
			WINFO_MBF winfo;
			winfo.msg = msg;
			winfo.msgsz = msgsz;
			runtsk->tstat = (TS_WAITING | TS_WAIT_WOBJ);
			make_wait(&(winfo.winfo));
			queue_insert_prev(&(mbfcb->rwait_queue),
						  &(runtsk->task_queue));
			winfo.wobjcb = (WOBJCB *)mbfcb;
			LOG_TSKSTAT(runtsk);
			dispatch();
			ercd = winfo.winfo.wercd;
			if (ercd == E_OK) {
				ercd = winfo.msgsz;
			}
		} else {
			WINFO_MBF *winfo;
			tcb = (TCB *) queue_delete_next(&(mbfcb->wait_queue));
			winfo = (WINFO_MBF *)(tcb->winfo);
			memcpy(msg, winfo->msg, winfo->msgsz);
			if (wait_complete(tcb)) {
				dispatch();
			}
			ercd = winfo->msgsz;
		}
	}

	/* 
	 * ޤǤνԤʤС
	 * åХåեؤν񤭹ߤĩˤäƥåХåե
	 * ;͵ǤƤ뤫⤷ʤΤǡԤ
	 *  Ԥ󤬶ˤʤ뤫åХåեդˤʤޤ
	 * ³
	 */
	if (ercd >= 0) {
		while (!queue_empty(&(mbfcb->wait_queue))) {
			BOOL stat;
			WINFO_MBF *winfo;

			tcb = (TCB *)(mbfcb->wait_queue.next);
			winfo = (WINFO_MBF *)(tcb->winfo);
			stat = write_mbf_buffer(mbfid, winfo->msg, winfo->msgsz);
			if (stat) {
				queue_delete_next(&(mbfcb->wait_queue));
				if (wait_complete(tcb)) {
					dispatch();
				}
			} else {
				break;
			}
		}
	}

    escape:
	t_unlock_cpu();

    exit:
	LOG_RCV_MBF_LEAVE(ercd);
	return(ercd);
}

#endif /* __rcv_mbf */

/*
 *  åХåեμʥݡ󥰡
 */
#ifdef __prcv_mbf
SYSCALL ER_UINT
prcv_mbf(ID mbfid, VP msg)
{
	MBFCB	*mbfcb;
	TCB	*tcb;
	ER	ercd;
	UINT	msgsz;
	BOOL	stat;

	LOG_RCV_MBF_ENTER(mbfid);
	CHECK_DISPATCH();

	CHECK_MBFID(mbfid);
	mbfcb = get_mbfcb(mbfid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mbfcb);

	/*
	 * åХåե˥ǡäʤ顢¨¤˥꥿
	 * ԡread_mbf_buffer⤹Ǥ˽äƤ롣
	 * ǡʤСॢȥ顼
	 */
	stat = read_mbf_buffer(mbfid, msg, msgsz);
	if (!stat) {
		ercd = E_TMOUT;
		goto escape;
	}

	/* 
	 * ޤǤνԤʤС
	 * åХåեؤν񤭹ߤĩˤäƥåХåե
	 * ;͵ǤƤ뤫⤷ʤΤǡԤ
	 *  Ԥ󤬶ˤʤ뤫åХåեդˤʤޤ
	 * ³
	 */
	if (ercd >= E_OK) {
		while (!queue_empty(&(mbfcb->wait_queue))) {
			BOOL stat;
			WINFO_MBF *winfo;

			tcb = (TCB *)(mbfcb->wait_queue.next);
			winfo = (WINFO_MBF *)(tcb->winfo);
			stat = write_mbf_buffer(mbfid, winfo->msg, winfo->msgsz);
			if (stat) {
				queue_delete_next(&(mbfcb->wait_queue));
				if (wait_complete(tcb)) {
					dispatch();
				}
			} else {
				break;
			}
		}
	}

    escape:
	t_unlock_cpu();

    exit:
	LOG_RCV_MBF_LEAVE(ercd);
	return(ercd);
}

#endif /* __prcv_mbf */

/*
 *  åХåեμʥॢȤ
 */
#ifdef __trcv_mbf
SYSCALL ER_UINT
trcv_mbf(ID mbfid, VP msg, TMO tmout)
{
	MBFCB	*mbfcb;
	TCB	*tcb;
	TMEVTB	tmevtb;
	WINFO_MBF winfo;
	ER_UINT	ercd;
	UINT	msgsz;
	BOOL	stat;

	LOG_RCV_MBF_ENTER(mbfid);
	CHECK_DISPATCH();
	CHECK_TMOUT(tmout);

	CHECK_MBFID(mbfid);
	mbfcb = get_mbfcb(mbfid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mbfcb);

	/*
	 * åХåե˥ǡäʤ顢¨¤˥꥿
	 * ԡread_mbf_buffer⤹Ǥ˽äƤ롣
	 * ǡʤСԤ򸡺
	 * Ԥʤ顢Ԥء
	 * Ԥʤ顢ԡԤ
	 */
	stat = read_mbf_buffer(mbfid, msg, msgsz);
	if (stat) {
		ercd = msgsz;
	} else {
		if (queue_empty(&(mbfcb->wait_queue))) {
			WINFO_MBF winfo;
			winfo.msg = msg;
			winfo.msgsz = msgsz;
			runtsk->tstat = (TS_WAITING | TS_WAIT_WOBJ);
			make_wait_tmout(&(winfo.winfo), &tmevtb, tmout);
			queue_insert_prev(&(mbfcb->rwait_queue),
						  &(runtsk->task_queue));
			winfo.wobjcb = (WOBJCB *)mbfcb;
			LOG_TSKSTAT(runtsk);
			dispatch();
			ercd = winfo.winfo.wercd;
			if (ercd == E_OK) {
				ercd = winfo.msgsz;
			}
		} else {
			WINFO_MBF *winfo;
			tcb = (TCB *) queue_delete_next(&(mbfcb->wait_queue));
			winfo = (WINFO_MBF *)(tcb->winfo);
			memcpy(msg, winfo->msg, winfo->msgsz);
			if (wait_complete(tcb)) {
				dispatch();
			}
			ercd = winfo->msgsz;
		}
	}

	/* 
	 * ޤǤνԤʤС
	 * åХåեؤν񤭹ߤĩˤäƥåХåե
	 * ;͵ǤƤ뤫⤷ʤΤǡԤ
	 *  Ԥ󤬶ˤʤ뤫åХåեդˤʤޤ
	 * ³
	 */
	if (ercd > E_OK) {
		while (!queue_empty(&(mbfcb->wait_queue))) {
			BOOL stat;
			WINFO_MBF *winfo;

			tcb = (TCB *)(mbfcb->wait_queue.next);
			winfo = (WINFO_MBF *)(tcb->winfo);
			stat = write_mbf_buffer(mbfid, winfo->msg, winfo->msgsz);
			if (stat) {
				queue_delete_next(&(mbfcb->wait_queue));
				if (wait_complete(tcb)) {
					dispatch();
				}
			} else {
				break;
			}
		}
	}

    escape:
	t_unlock_cpu();

    exit:
	LOG_RCV_MBF_LEAVE(ercd);
	return(ercd);
}

#endif /* __trcv_mbf */

/*
 *  åХåեξֻ
 */
#ifdef __ref_mbf
SYSCALL ER
ref_mbf(ID mbfid, T_RMBF *pk_rmbf)
{
	TCB *tcb;
	MBFCB	*mbfcb;
	ER	ercd;
	UINT	head;
	UINT	tail;
	UB	*mbf;
	UINT	mbfsz;
	UINT	i;

	LOG_REF_MBF_ENTER(mbfid);
	CHECK_TSKCTX_UNL();

	CHECK_MBFID(mbfid);
	mbfcb = get_mbfcb(mbfid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mbfcb);

	if (!queue_empty(&(mbfcb->wait_queue))) {
		tcb = (TCB *)queue_peek_next(&(mbfcb->wait_queue));
		pk_rmbf->stskid = TSKID(tcb);
	} else {
		pk_rmbf->stskid = TSK_NONE;
	}
	if (!queue_empty(&(mbfcb->rwait_queue))) {
		tcb = (TCB *)queue_peek_next(&(mbfcb->rwait_queue));
		pk_rmbf->rtskid = TSKID(tcb);
	} else {
		pk_rmbf->rtskid = TSK_NONE;
	}

	mbf = mbfcb->mbfinib->mbf;
	mbfsz = mbfcb->mbfinib->mbfsz;
	head = mbfcb->head;
	tail = mbfcb->tail;

	pk_rmbf->smsgcnt = 0;
	for (i = tail; i != head; pk_rmbf->smsgcnt++) {
		UINT size;
		size = mbf[i] << 8;
		size |= mbf[i + 1];
		i = (i + size) % mbfsz;
	}

	pk_rmbf->fmbfsz = ((head < tail) ? (mbfsz + head) : head) - tail;
	if (pk_rmbf->fmbfsz < 2) {
		pk_rmbf->fmbfsz = 0;
	} else {
		pk_rmbf->fmbfsz -= 2;
	}

	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_REF_MBF_LEAVE(ercd);
	return(ercd);
}

#endif /* __ref_mbf */


