/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: messagebuffer.h,v 1.14 2003/11/11 13:53:58 monaka Exp $
 */

/*
 *	åХåեǽ
 */

#ifndef _MESSAGEBUFFER_H_
#define _MESSAGEBUFFER_H_

#include "queue.h"
#include "kmem.h"

/*
 *  åХåե֥å
 */
typedef struct messagebuffer_initialization_block {
	ATR mbfatr;
	UINT maxmsz;
	UINT mbfsz;
	VP mbf;
} MBFINIB;

/*
 *  åХåե֥åϢۥڥ
 */
typedef struct messagebuffer_initialization_block_apair {
	ID	mbfid;
	MBFINIB	mbfinib;
} MBFINIA;

#define MBF_SWAIT_QUEUE_NUM	(TMAX_TPRI - TMIN_TPRI + 1)

/*
 *  åХåե֥å
 */
typedef struct messagebuffer_control_block {
	QUEUE	wait_queue;				/* Ԥ塼 */
	QUEUE	rwait_queue;				/* Ԥ塼 */
	MBFINIB	*mbfinib;
	UINT	head;
	UINT	tail;
	unsigned int	exist:2;				/* ȤƤȤKOBJ_EXIST */
	unsigned int	reserved:1;
} MBFCB;

/*
 *  åХåեǽν
 */
extern void	messagebuffer_initialize(void);

extern BOOL send_mbf_rwait(ID mbfid, VP msg, UINT msgsz);
extern BOOL recv_mbuffer_swait(ID mbfid, VP msg, UINT *msgsz);

#define MBFID(mbfcb)	((ID)((mbfcb) - mbfcb_table) + TMIN_MBFID)

#endif /* _MESSAGEBUFFER_H_ */
