/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2000 by Muranaka Masaki
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: multiqueue.h,v 1.3 2003/11/10 07:51:21 monaka Exp $
 */

/*
 *	塼饤֥
 *
 *  Υ塼饤֥Ǥϡ塼إåޤ󥰹¤Υ֥
 *  󥯥塼򰷤Ūˤϡ塼إåμȥϥ塼
 *  ƬΥȥꡤȥϥ塼ΥȥȤ롥ޤ
 *  塼ƬΥȥȥȡ塼Υȥμ
 *  ȥϡ塼إåȤ롥Υ塼ϡȥꡤȥ
 *  ⼫ʬȤؤ塼إåǤ魯
 */

#ifndef	_MULTIQUEUE_H_
#define	_MULTIQUEUE_H_

#include "queue.h"


/*
 * TODO:comment
 */
typedef struct {
	ATR	multiobjatr;	/* TODO: comment */
} MULTIOBJINIB;

/*
 * TODO:comment
 */
typedef struct {
	QUEUE			wait_queue;
	const MULTIOBJINIB	*multiobjinib;
	QUEUE			multi_queue[1];
} MULTIOBJCB;

/*
 *  塼ν
 *
 *  wobjcb ˤϥ塼إåꤹ롥
 */
Inline void
multiqueue_initialize(MULTIOBJCB *wobjcb, UINT pos)
{
	QUEUE *queue;

	queue = &(wobjcb->multi_queue[pos]);
	queue->prev = queue->next = (QUEUE *)wobjcb;
}

/*
 *  塼ȥؤ
 *
 *  wobjcb  entry 롥multiqueue ˥塼إåꤷ
 *  ˤϡ塼 entry 뤳Ȥˤʤ롥
 */
Inline void
multiqueue_insert_prev(MULTIOBJCB *head, MULTIOBJCB *entry, UINT pos)
{
	QUEUE *head_queue;
	QUEUE *entry_queue;
	head_queue = &(head->multi_queue[pos]);
	entry_queue = &(entry->multi_queue[pos]);

	entry_queue->prev = head_queue->prev;
	entry_queue->next = (QUEUE *)head;
	(&((MULTIOBJCB *)(head_queue->prev))->multi_queue[pos])->next = (QUEUE *)entry;
	head_queue->prev = (QUEUE *)entry;
}

/*
 *  ȥκ
 *
 *  entry 򥭥塼롥
 */
Inline void
multiqueue_delete(MULTIOBJCB *entry, UINT pos)
{
	QUEUE *entry_queue;
	entry_queue = &(entry->multi_queue[pos]);
	((MULTIOBJCB *)(entry_queue->prev))->multi_queue[pos].next = entry_queue->next;
	((MULTIOBJCB *)(entry_queue->next))->multi_queue[pos].prev = entry_queue->prev;
}

/*
 *  塼
 *
 *  top򥭥塼Ȥ륨ȥƬ󤹤롣
 *  ǽθƽФǤϡentryNULLϤͤtopμΥȥ(ĤޤƬ)Ǥ롣
 *  ʹߤȥentryϤͤentryμΥȥȤʤ롣
 *  entryμΥȥ꤬topäȤNULLͤȤơ塼νü򤢤魯
 *  topNULLåentryڤϹԤäƤʤƽФ¦ǤǹԤȡ
 *  ޤޤǤʤåɥդˤϤʤꤨʤ롼¾
 *  ƽФ¦ǤǹԤȡ
 */
Inline MULTIOBJCB *
multiqueue_enumerate(MULTIOBJCB *top, MULTIOBJCB *entry, UINT pos)
{
	QUEUE	*result;

	if (entry == NULL) {
		result = top->multi_queue[pos].next;
	} else {
		result = entry->multi_queue[pos].next;
	}
	if (result == (QUEUE *)top) {
		return NULL;
	}
	return (MULTIOBJCB *)result;
}

/*
 *  塼μȥμФ
 *
 *  multiqueue μȥ򥭥塼ȥ֤multiqueue
 *  ˥塼إåꤷˤϡ塼ƬΥȥФ
 *  Ȥˤʤ롥multiqueue ˶Υ塼ꤷƸƤӽФƤϤʤʤ
 */
Inline MULTIOBJCB *
multiqueue_delete_next(MULTIOBJCB *objcb, UINT pos)
{
	MULTIOBJCB	*entry;
	MULTIOBJCB	*cb;

	assert(objcb->multi_queue[pos].next != (QUEUE *)objcb);
	entry = (MULTIOBJCB *)(objcb->multi_queue[pos].next);
	objcb->multi_queue[pos].next = entry->multi_queue[pos].next;
	cb = (MULTIOBJCB *)((MULTIOBJCB *)entry)->multi_queue[pos].next;
	cb->multi_queue[pos].prev = (QUEUE *)objcb;

	return (MULTIOBJCB *)entry;
}

/*
 *  塼ɤΥå
 *
 *  multiqueue ˤϥ塼إåꤹ롥
 */
Inline BOOL
multiqueue_empty(MULTIOBJCB *objcb, UINT pos)
{
	if (objcb->multi_queue[pos].next == (QUEUE *)objcb) {
		assert(objcb->multi_queue[pos].prev == (QUEUE *)objcb);
		return(TRUE);
	}
	return(FALSE);
}

#endif /* _MULTIQUEUE_H_ */
