/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  Copyright (C) 2002 by Masao Higuchi
 *
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: mutex.c,v 1.20 2003/11/11 05:29:02 monaka Exp $
 */

/*
 *	ߥ塼ƥåǽ
 *	(̩ͥ浬§)
 *
 *  The original code was written by Masao Higuchi.
 *  Extended for uITRON4.0 fullset was written by Masaki Muranaka.
 */

#include "jsp_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "mutex.h"
#include "multiqueue.h"

/*
 *  ߥ塼ƥåIDκ͡kernel_cfg.c
 */
extern const ID	tmax_mtxid;

/*
 *  ߥ塼ƥå֥åΥꥢkernel_cfg.c
 */
extern MTXINIB	mtxinib_table[];

/*
 *  ߥ塼ƥå֥åϢۥڥοkernel_cfg.c
 */
extern const UINT	tnum_mtxinia;

/*
 *  ߥ塼ƥå֥åϢۥڥΥꥢkernel_cfg.c
 */
extern const MTXINIA	mtxinia_table[];

/*
 *  ߥ塼ƥåͽIDΥꥢkernel_cfg.c
 */
extern const ID		mtxrid_table[];

/*
 *  ߥ塼ƥåͽIDο (kernel_cfg.c)
 */
extern const UINT	tnum_mtxrid;

/*
 *  ߥ塼ƥå֥åΥꥢkernel_cfg.c
 */
extern MTXCB	mtxcb_table[];

/*
 *  ߥ塼ƥåο
 */
#define TNUM_MTX	((UINT)(tmax_mtxid - TMIN_MTXID + 1))

/*
 *  ߥ塼ƥåIDߥ塼ƥå֥åФΥޥ
 */
#define INDEX_MTX(mtxid)	((UINT)((mtxid) - TMIN_MTXID))
#define get_mtxcb(mtxid)	(&(mtxcb_table[INDEX_MTX(mtxid)]))

/*
 *  IDưѥե꡼ꥹ
 */
extern QUEUE mtx_freelist;

/* 
 *  ߥ塼ƥåǽν
 */
#ifdef __mtxini

QUEUE mtx_freelist;

void
mutex_initialize()
{
	UINT	i;
	MTXCB	*mtxcb;
	MTXINIB *mtxinib;
	const MTXINIA *mtxinia;
	const ID	*mtxrid;

	/*
	 * ͥ뵯ưξ֤˴ؤ餺ʤФʤΤ
	 * ޤ롣
	 */
	for (mtxcb = mtxcb_table, i = 0; i < TNUM_MTX; mtxcb++, i++) {
		queue_initialize(&(mtxcb->wait_queue));
		queue_initialize(&(mtxcb->mtxlist));
	}
	queue_initialize(&mtx_freelist);

	/*
	 * mtxinia ˤäƼΤޤ
	 */
	for (mtxinia = mtxinia_table, i = 0; i < tnum_mtxinia; mtxinia++, i++) {
		mtxinib = &mtxinib_table[mtxinia->mtxid - TMIN_MTXID];
		*mtxinib = mtxinia->mtxinib;
		mtxcb = &mtxcb_table[mtxinia->mtxid - TMIN_MTXID];
		mtxcb->mtxinib = mtxinib;
		mtxcb->mtxtsk = NULL;
		mtxcb->exist = KOBJ_EXIST;
		mtxcb->reserved = TRUE;
	}

	/*
	 *  ͽID
	 */
	for (mtxrid = mtxrid_table, i = 0; i < tnum_mtxrid; mtxrid++, i++) {
		mtxcb[*mtxrid - TMIN_MTXID].reserved = TRUE;
	}

	/*
	 * mtxinia ˤäƼʤΤ
	 */
	for (mtxcb = mtxcb_table, i = 0; i < TNUM_MTX; mtxcb++, i++) {
		if (mtxcb->mtxinib == NULL) {
			mtxcb->exist = KOBJ_NOEXS;
			mtxcb->mtxinib = &mtxinib_table[i];

			if (!CHECK_OBJECT_RESERVED(mtxcb)) {
				queue_insert_prev(&mtx_freelist, (QUEUE*)mtxcb);
			}
		}
	}
}

#endif /* __mtxini */

/*
 *  ߥ塼ƥå
 */
#ifdef __cre_mtx

SYSCALL ER
cre_mtx(ID mtxid, const T_CMTX * pk_cmtx)
{
	MTXCB	*mtxcb;
	MTXINIB *mtxinib;
	ER	ercd;
    
	LOG_CRE_MTX_ENTER(mtxid);
	CHECK_TSKCTX_UNL();

	CHECK_MTXID(mtxid);
	mtxcb = get_mtxcb(mtxid);
	CHECK_OBJECT_CREATABLE(mtxcb);
	UPDATE_OBJECT_FREELIST(mtxcb);

	/*
	 * Ԥ
	 */
	queue_initialize(&mtxcb->wait_queue);
	queue_initialize(&mtxcb->mtxlist);
	mtxcb->mtxtsk = NULL;

	mtxinib = mtxcb->mtxinib;
	mtxinib->mtxatr = pk_cmtx->mtxatr;
	mtxinib->ceilpri = pk_cmtx->ceilpri;

	/*
	 *  ǽ¾Υӥ뤫Ѳǽˤʤ롣
	 */
	mtxcb->exist = KOBJ_EXIST;

	ercd = E_OK;

    exit:
	LOG_CRE_MTX_LEAVE(ercd);
	return(ercd);
}

#endif /* __cre_mtx */

/*
 *  ߥ塼ƥå(IDֹ漫ưդ)
 */
#ifdef __acre_mtx

SYSCALL ER_ID
acre_mtx(const T_CMTX *pk_cmtx)
{
	MTXCB	*mtxcb;
	MTXINIB *mtxinib;
	ER_ID	ercd;
    
	LOG_ACRE_MTX_ENTER();

	t_lock_cpu();
	mtxcb = (MTXCB *)t_get_free_id((QUEUE *)&mtx_freelist);
	if (mtxcb == NULL) {
		ercd = E_NOID;
		t_unlock_cpu();
		goto exit;
	}
	mtxcb->exist = KOBJ_INIT;
	t_unlock_cpu();

	/*
	 * Ԥ
	 */
	queue_initialize(&mtxcb->wait_queue);
	queue_initialize(&mtxcb->mtxlist);
	mtxcb->mtxtsk = NULL;

	mtxinib = mtxcb->mtxinib;
	mtxinib->mtxatr = pk_cmtx->mtxatr;
	mtxinib->ceilpri = pk_cmtx->ceilpri;

	ercd = MTXID(mtxcb);

	/*
	 *  ǽ¾Υӥ뤫Ѳǽˤʤ롣
	 */
	mtxcb->exist = KOBJ_EXIST;

    exit:
	LOG_ACRE_MTX_LEAVE(ercd);
	return(ercd);
}

#endif /* __acre_mtx */

/*
 *  ߥ塼ƥåκ
 */
#ifdef __del_mtx
SYSCALL ER
del_mtx(ID mtxid)
{
	MTXCB	*mtxcb;
	TCB	*tcb;
	ER	ercd;
    
	LOG_DEL_MTX_ENTER(mtxid);
	CHECK_TSKCTX_UNL();

	CHECK_MTXID(mtxid);
	mtxcb = get_mtxcb(mtxid);

	CHECK_OBJECT_DELETABLE(mtxcb);

	if (mtxcb->mtxtsk != NULL) {
		/* TODO: ȼνɬסܺ٤ϻͽ񻲾ȡ */
	}

	/* ԤθդȼԤԤ*/
	while (queue_empty(&(mtxcb->wait_queue)) == FALSE) {
		TCB *tcb;
		tcb = (TCB *)queue_delete_next(&(mtxcb->wait_queue));
		t_lock_cpu();
		if (wait_deleted(tcb)) {
			dispatch();
		}
		t_unlock_cpu();
	}

	if (!CHECK_OBJECT_RESERVED(mtxcb)) {
	  /*
	   * ͽIDǤʤХե꡼ꥹȤ롣
	   */
		t_lock_cpu();
		queue_insert_prev(&mtx_freelist, (QUEUE *)mtxcb);
		t_unlock_cpu();
	}

	/* acre_/cre_ǤΥǽ */
	mtxcb->exist = KOBJ_NOEXS;

	ercd = E_OK;

    exit:
	LOG_DEL_MTX_LEAVE(ercd);
	return(ercd);
}

#endif /* __del_mtx */

/*
 *  ߥ塼ƥåΥå
 */
#ifdef __loc_mtx
SYSCALL ER
loc_mtx(ID mtxid)
{
	MTXCB	*mtxcb;
	WINFO_WOBJ winfo;
	ER	ercd;
    
	LOG_LOC_MTX_ENTER(mtxid);
	CHECK_DISPATCH();

	CHECK_MTXID(mtxid);
	mtxcb = get_mtxcb(mtxid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mtxcb);

	if (runtsk == mtxcb->mtxtsk){
		/*
		 *  ¿ťå
		 */
		ercd = E_ILUSE;
		goto error;
	}

	if ( ( mtxcb->mtxinib->mtxatr == TA_CEILING ) 
	     && (runtsk->tinib->base_priority < INT_PRIORITY(mtxcb->mtxinib->ceilpri)) ) {
		/*
		 *  ͥ٤ͥ٤ΥϥåǤʤ
		 */
		ercd = E_ILUSE;
		goto error;
	}

	if (mtxcb->mtxtsk == NULL){
		/*
		 *  ƤƳǤ
		 */
		mtxcb->mtxtsk = runtsk;
		multiqueue_insert_prev((MULTIOBJCB *)runtsk, (MULTIOBJCB *)mtxcb, 0);
		if ((mtxcb->mtxinib->mtxatr == TA_CEILING) &&
		    (INT_PRIORITY(mtxcb->mtxinib->ceilpri) < runtsk->priority)) {
			/*
			 *  TA_CEILINGǤͥ٤ͥپ¤ޤǾ夲
			 */
			change_priority(runtsk, INT_PRIORITY(mtxcb->mtxinib->ceilpri));
		}
		ercd = E_OK;
	} else {
		/*
		 *  Ԥľ
		 */
		UINT pri;
		pri = runtsk->priority;
		if (mtxcb->mtxinib->mtxatr == TA_INHERIT) {
			if (mtxcb->mtxtsk->priority > pri) { 
				/*
				 *  ͥٵž顢åƤ륿
				 *  Ԥ֤륿ͥٷѾ
				 */
				set_current_priority(mtxcb->mtxtsk, pri);
			}
			wobj_make_wait_mutexi((WOBJCB *) mtxcb, &winfo);
		} else {
			wobj_make_wait((WOBJCB *) mtxcb, &winfo);
		}
		/*
		 *  ԤäΤǡ
		 *  ɬǥѥåɬ
		 */
		dispatch();
		ercd = winfo.winfo.wercd;
	}

    error:
	t_unlock_cpu();

    exit:
	LOG_LOC_MTX_LEAVE(ercd);
	return(ercd);
}

#endif /* __loc_mtx */

/*
 *  ߥ塼ƥåΥåʥݡ󥰡
 */
#ifdef __ploc_mtx
SYSCALL ER
ploc_mtx(ID mtxid)
{
	MTXCB	*mtxcb;
	WINFO_WOBJ winfo;
	ER	ercd;
    
	LOG_LOC_MTX_ENTER(mtxid);
	CHECK_TSKCTX_UNL();

	CHECK_MTXID(mtxid);
	mtxcb = get_mtxcb(mtxid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mtxcb);

	if (runtsk == mtxcb->mtxtsk){
		/*
		 *  ¿ťå
		 */
		ercd = E_ILUSE;
		goto error;
	}

	if ( ( mtxcb->mtxinib->mtxatr == TA_CEILING ) 
	     && (runtsk->tinib->base_priority < INT_PRIORITY(mtxcb->mtxinib->ceilpri)) ) {
		/*
		 *  ͥ٤ͥ٤ΥϥåǤʤ
		 */
		ercd = E_ILUSE;
		goto error;
	}

	if (mtxcb->mtxtsk == NULL){
		/*
		 *  ƤƳǤ
		 */
		mtxcb->mtxtsk = runtsk;
		multiqueue_insert_prev((MULTIOBJCB *)runtsk, (MULTIOBJCB *)mtxcb, 0);
		if ((mtxcb->mtxinib->mtxatr == TA_CEILING) &&
		    (INT_PRIORITY(mtxcb->mtxinib->ceilpri) < runtsk->priority)) {
			/*
			 *  TA_CEILINGǤͥ٤ͥپ¤ޤǾ夲
			 */
			change_priority(runtsk, INT_PRIORITY(mtxcb->mtxinib->ceilpri));
		}
		ercd = E_OK;
	} else {
		/*
		 *  Ԥľ
		 */
		ercd = E_NOSPT;
	}

    error:
	t_unlock_cpu();

    exit:
	LOG_LOC_MTX_LEAVE(ercd);
	return(ercd);
}

#endif /* __ploc_mtx */

/*
 *  ߥ塼ƥåΥåʥॢȤ
 */
#ifdef __tloc_mtx
SYSCALL ER
tloc_mtx(ID mtxid, TMO tmout)
{
	MTXCB	*mtxcb;
	WINFO_WOBJ winfo;
	TMEVTB tmevtb;
	ER	ercd;

	CHECK_MTXID(mtxid);
	mtxcb = get_mtxcb(mtxid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mtxcb);

	if (runtsk == mtxcb->mtxtsk){
		/*
		 *  ¿ťå
		 */
		ercd = E_ILUSE;
		goto error;
	}

	if ( ( mtxcb->mtxinib->mtxatr == TA_CEILING ) 
	     && (runtsk->tinib->base_priority < INT_PRIORITY(mtxcb->mtxinib->ceilpri)) ) {
		/*
		 *  ͥ٤ͥ٤ΥϥåǤʤ
		 */
		ercd = E_ILUSE;
		goto error;
	}

	if (mtxcb->mtxtsk == NULL){
		/*
		 *  ƤƳǤ
		 */
		mtxcb->mtxtsk = runtsk;
		multiqueue_insert_prev((MULTIOBJCB *)runtsk, (MULTIOBJCB *)mtxcb, 0);
		if ((mtxcb->mtxinib->mtxatr == TA_CEILING) &&
		    (INT_PRIORITY(mtxcb->mtxinib->ceilpri) < runtsk->priority)) {
			/*
			 *  TA_CEILINGǤͥ٤ͥپ¤ޤǾ夲
			 */
			change_priority(runtsk, INT_PRIORITY(mtxcb->mtxinib->ceilpri));
		}
		ercd = E_OK;
	} else {
		/*
		 *  Ԥľ
		 */
		UINT pri;
		pri = runtsk->priority;
		if (mtxcb->mtxinib->mtxatr == TA_INHERIT) {
			if (mtxcb->mtxtsk->priority > pri) { 
				/*
				 *  ͥٵž顢åƤ륿
				 *  Ԥ֤륿ͥٷѾ
				 */
				set_current_priority(mtxcb->mtxtsk, pri);
			}
			wobj_make_wait_mutexi_tmout((WOBJCB *) mtxcb, &winfo, tmout);
		} else {
			wobj_make_wait_tmout((WOBJCB *) mtxcb, &winfo, &tmevtb, tmout);
		}
		/*
		 *  ԤäΤǡ
		 *  ɬǥѥåɬ
		 */
		dispatch();
		ercd = winfo.winfo.wercd;
	}

    error:
	t_unlock_cpu();

    exit:
	LOG_LOC_MTX_LEAVE(ercd);
	return(ercd);
}

#endif /* __tloc_mtx */

/*
 *  ߥ塼ƥåΥå
 */
#ifdef __unl_mtx
SYSCALL ER
unl_mtx(ID mtxid)
{
	MTXCB	*mtxcb;
	TCB	*tcb;
	ER	ercd;
    
	UINT	pri;
	BOOL	dispflg = FALSE;

	LOG_UNL_MTX_ENTER(mtxid);
	CHECK_DISPATCH();

	CHECK_MTXID(mtxid);
	mtxcb = get_mtxcb(mtxid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mtxcb);

	if (mtxcb->mtxtsk != runtsk){
		ercd = E_ILUSE;
		goto error;
	}

	multiqueue_delete((MULTIOBJCB *)mtxcb, 0);/*ߥ塼ƥååꥹȤ*/

	if (mtxcb->mtxinib->mtxatr == TA_INHERIT)  {
		/*ͥ٤ѹ(̩ͥ浬§˽)*/
		if (multiqueue_empty((MULTIOBJCB *)runtsk, 0)) {
			/*
			 *  åƤߥ塼ƥå
			 *  ̵ʤäȤˤϥ١ͥ٤᤹
			 */
			dispflg = set_current_priority(runtsk,runtsk->tinib->base_priority);
		}else if (!queue_empty(&(mtxcb->wait_queue))) {
			if (runtsk->priority == ((TCB *)(mtxcb->wait_queue.next))->priority ) {
				/*
				 *  ͥ٤ƬԤθͥ٤
				 * פƤȤϥѹ
				 */
				pri = search_mtx_priority(runtsk);
				if (pri != runtsk->priority){
					dispflg |= set_current_priority(runtsk, pri);
				}
			}
		}
	} else if ( mtxcb->mtxinib->mtxatr == TA_CEILING) {
		/*ͥ٤ѹ(̩ͥ浬§˽)*/
		if (multiqueue_empty((MULTIOBJCB *)runtsk, 0)) {
			/*
			 *  åƤߥ塼ƥå
			 *  ̵ʤäȤˤϥ١ͥ٤᤹
			 */
			dispflg = set_current_priority(runtsk, runtsk->tinib->base_priority);
		} else if (runtsk->priority != runtsk->tinib->base_priority &&
			   runtsk->priority == INT_PRIORITY(mtxcb->mtxinib->ceilpri)) {
			/*
			 *  ͥ٤ͥ٤Ȱפ
			 *  Ȥϥѹ
			 */
			pri = search_mtx_priority(runtsk);
			if (pri != runtsk->priority) {
				dispflg |= set_current_priority(runtsk, pri);
			}
		}
	}

	if (!queue_empty(&(mtxcb->wait_queue))) {
		tcb = (TCB *) queue_delete_next(&(mtxcb->wait_queue));
		dispflg |= wait_complete(tcb);
		mtxcb->mtxtsk = tcb;
		multiqueue_insert_prev((MULTIOBJCB *)tcb, (MULTIOBJCB *)mtxcb, 0);
		/*TA_CEILINGǤͥ٤ͥپ¤ޤǾ夲*/
		if (mtxcb->mtxinib->mtxatr == TA_CEILING
		    && (INT_PRIORITY(mtxcb->mtxinib->ceilpri) < tcb->priority) ){
			dispflg |= change_priority(tcb, INT_PRIORITY(mtxcb->mtxinib->ceilpri));
		}
	} else {
		mtxcb->mtxtsk = NULL;
	}

	if (dispflg) {
		dispatch();
	}
	ercd = E_OK;

    error:
	t_unlock_cpu();

    exit:
	LOG_UNL_MTX_LEAVE(ercd);
	return(ercd);
}

#endif /* __unl_mtx */

/*
 *  ߥ塼ƥåξֻ
 */
#ifdef __ref_mtx
SYSCALL ER
ref_mtx(ID mtxid, T_RMTX *pk_rmtx)
{
	MTXCB	*mtxcb;
	TCB	*tcb;
	ER	ercd;
    
	LOG_REF_MTX_ENTER(mtxid);
	CHECK_TSKCTX_UNL();

	CHECK_MTXID(mtxid);
	mtxcb = get_mtxcb(mtxid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(mtxcb);

	/* TODO: pk_rsem->htskid */

	if (!queue_empty(&(mtxcb->wait_queue))) {
		tcb = (TCB *)queue_peek_next(&(mtxcb->wait_queue));
		pk_rmtx->wtskid = TSKID(tcb);
	} else {
		pk_rmtx->wtskid = TSK_NONE;
	}

	ercd = E_OK;
   
	t_unlock_cpu();

    exit:
	LOG_REF_MTX_LEAVE(ercd);
	return(ercd);
}

#endif /* __ref_mtx */


/*
 *  åߥ塼ƥåκǹͥ٤Υ
 *  - TA_INHERITΥߥ塼ƥåԤθͥ
 *  - TA_CEILINGΥߥ塼ƥåͥپ
 *  - ١ͥ
 *  Τǹͥ٤ͤ򸡺
 */
#ifdef __schmtxpri

UINT 
search_mtx_priority(TCB *tcb)
{
	UINT pri;
	MULTIOBJCB *cb;

	/*
	 *  ١ͥ٤ͤȤƸ
	 */
	pri = tcb->tinib->base_priority;

	cb = NULL;
	while ((cb = multiqueue_enumerate((MULTIOBJCB *)tcb, cb, 0)) != NULL) {
		MTXCB *mtxcb;
		mtxcb = (MTXCB *)cb;
		if (mtxcb->mtxinib->mtxatr == TA_INHERIT) {
			TCB *tcb;
			/*
			 *  ǹͥ٤Ԥθͥ٤
			 */
			if (!queue_empty(&(mtxcb->wait_queue))) {
				TCB *tcb;
				tcb = (TCB *)(mtxcb->wait_queue.next);
				if(tcb->priority < pri){
					pri = tcb->priority;
				}
			}
		} if (mtxcb->mtxinib->mtxatr == TA_CEILING) {
			/*
			 *  ͥپ¤
			 */
			if (INT_PRIORITY(mtxcb->mtxinib->ceilpri) < pri){
				pri = INT_PRIORITY(mtxcb->mtxinib->ceilpri);
			}
		}
	}
	return pri;
}

#endif /* __schmtxpri */


/*
 *  åƤTA_CEILINGߥ塼ƥåξͥ٤Τ
 *  ͤθ
 */
#ifdef __schmaxceilpri

UINT
search_max_ceilpri(TCB *tcb)
{
	UINT pri = 0;/*ߡι⤤*/
	MULTIOBJCB *cb;

	cb = NULL;
	while ((cb = multiqueue_enumerate((MULTIOBJCB *)tcb, cb, 0)) != NULL) {
		MTXCB *mtxcb;
		mtxcb = (MTXCB *)cb;

		if(mtxcb->mtxinib->mtxatr == TA_CEILING) {
			/*
			 *  TA_CEILINGʤͥپ¤
			 */
			if (INT_PRIORITY(mtxcb->mtxinib->ceilpri) > pri) {
				pri = INT_PRIORITY(mtxcb->mtxinib->ceilpri);
			}
		}
	}

	return pri;
}

#endif /* __schmaxceilpri */
