/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  Copyright (C) 2002 by Masao Higuchi
 *
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: mutex.h,v 1.12 2003/11/11 13:53:58 monaka Exp $
 */

/*
 *	ߥ塼ƥåǽ
 *
 *  The original code was written by Masao Higuchi.
 *  Extended for uITRON4.0 fullset was written by Masaki Muranaka.
 */

#ifndef _MUTEX_H_
#define _MUTEX_H_

#include "queue.h"

/*
 *  ߥ塼ƥå֥å
 */
typedef struct mutex_initialization_block {
	ATR	mtxatr;		/* ߥ塼ƥå° */
	PRI	ceilpri;	/*ͥپ*/
} MTXINIB;

/*
 *  ߥ塼ƥå֥åϢۥڥ
 */
typedef struct mutex_initialization_block_apair {
	ID	mtxid;
	MTXINIB	mtxinib;
} MTXINIA;

/*
 *  ߥ塼ƥå֥å
 */
typedef struct mutex_control_block {
	QUEUE	wait_queue;	/* ߥ塼ƥåԤ塼 */
	MTXINIB	*mtxinib;	/* ߥ塼ƥå֥å */
	QUEUE	mtxlist;	/* ƱˤƤߥ塼ƥåΥꥹ */

	TCB	*mtxtsk;	/* Υߥ塼ƥååƤ륿ؤΥݥ
				 *  åƤʤ == NULL
				 */
	unsigned int	exist:2;	/* ȤƤȤKOBJ_EXIST */
	unsigned int	reserved:1;
} MTXCB;

/*
 *  ߥ塼ƥåꥹȤ
 *  δ֥åƬɥ쥹
 *  뤿Υޥ
 */
#define HEADMTX(ptr) ( ((int)ptr) - (offsetof(MTXCB, mtxlist)) )

/*
 *  ߥ塼ƥåǽν
 */
extern void	mutex_initialize(void);

/*
 *  ߥ塼ƥåϢؿ
 */
extern UINT search_max_ceilpri(TCB *);
extern UINT search_mtx_priority(TCB *);

#define MTXID(mtxcb)	((ID)(mtxcb - mtxcb_table) + TMIN_MTXID)

#endif /* _MUTEX_H_ */
