/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2000-2003 by Masaki Muranaka
 *  Copyright (C) 2003 by Monami-software, JAPAN 
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: rendezvous.c,v 1.20 2003/11/10 16:05:39 monaka Exp $
 */

/*
 *	ǥֵǽ
 */

#include "jsp_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "rendezvous.h"

/*
 *  ǥ֥ݡIDκ͡kernel_cfg.c
 */
extern const ID	tmax_porid;

/*
 *  ǥ֥ݡȽ֥åΥꥢkernel_cfg.c
 */
extern PORINIB	porinib_table[];

/*
 *  ǥ֥ݡȽ֥åϢۥڥοkernel_cfg.c
 */
extern const UINT	tnum_porinia;

/*
 *  ǥ֥ݡȽ֥åϢۥڥΥꥢkernel_cfg.c
 */
extern const PORINIA	porinia_table[];

/*
 *  ǥ֥ݡͽIDΥꥢkernel_cfg.c
 */
extern const ID		porrid_table[];

/*
 *  ǥ֥ݡͽIDο (kernel_cfg.c)
 */
extern const UINT	tnum_porrid;

/*
 *  ǥ֥ݡȴ֥åΥꥢkernel_cfg.c
 */
extern PORCB	porcb_table[];

/*
 *  IDưѥե꡼ꥹ
 */
extern QUEUE sem_freelist;

/*
 *  ǥ֥ݡIDǥ֥ݡȴ֥åФΥޥ
 */
#define INDEX_POR(porid)	((UINT)((porid) - TMIN_PORID))
#define get_porcb(porid)	(&(porcb_table[INDEX_POR(porid)]))

/*
 *  ǥ֥ݡȤο
 */
#define TNUM_POR	((UINT)(tmax_porid - TMIN_PORID + 1))

#define CHECK_RDVPTN(x) { if ((x) == 0) { return E_PAR; } }

#define TNUM_RDVNO_HASH (10)

extern RDVCB rdvcb_table[TNUM_RDVNO_HASH];

extern UINT rdvidx;

/*
 *  ǥԤ֥å
 */
typedef struct rdvport_waiting_information {
	WINFO	winfo;		/* ɸԤ֥å */
	WOBJCB *wobjcb;	/* Ԥ֥ȤΥȥ֥å */
	RDVPTN ptn;		/* ƽ/դΥѥ */
	RDVNO rdvno;
	VP *msg;
	UINT msgsz;
	UINT maxrmsz;
	TCB *caller_tcb;
} WINFO_POR;

extern QUEUE por_freelist;

/* 
 *  ǥ֥ݡȵǽν
 */
#ifdef __inipor

UINT rdvidx = 0;
RDVCB rdvcb_table[TNUM_RDVNO_HASH];
QUEUE por_freelist;

void
rendezvous_initialize()
{
	UINT	i;
	PORCB	*porcb;
	PORINIB *porinib;
	const PORINIA	*porinia;
	const ID	*porrid;

	/*
	 * ͥ뵯ưξ֤˴ؤ餺ʤФʤΤ
	 * ޤ롣
	 */
	for (porcb = porcb_table, i = 0; i < tmax_porid; porcb++, i++) {
		queue_initialize(&(porcb->wait_queue));
	}
	queue_initialize(&por_freelist);

	/*
	 *  porinia ˤäƼΤޤ
	 */
	for (porinia = porinia_table, i = 0; i < tnum_porinia; porinia++, i++) {
		UINT idx = INDEX_POR(porinia->porid);
		queue_initialize(&(porcb_table[idx].wait_queue));
		queue_initialize(&(porcb_table[idx].await_queue));
		porinib = &porinib[idx];
		*porinib = porinia->porinib;
		porcb = &porcb_table[idx];
		porcb->porinib = porinib;
		porcb->exist = KOBJ_EXIST;
		porcb->reserved = TRUE;
	}

	/*
	 *  ͽID
	 */
	for (porrid = porrid_table, i = 0; i < tnum_porrid; porrid++, i++) {
		porcb[INDEX_POR(*porrid)].reserved = TRUE;
	}

	/*
	 *  porinia ˤäƼʤΤ
	 */
	for (porcb = porcb_table, i = 0; i < TNUM_POR; porcb++, i++) {
		if (porcb->porinib == NULL) {
			porcb->exist = KOBJ_NOEXS;
			porcb->porinib = &porinib_table[i];

			if (!CHECK_OBJECT_RESERVED(porcb)) {
				queue_insert_prev(&por_freelist, (QUEUE*)porcb);
			}
		}
	}

	for(i = 0; i < TNUM_RDVNO_HASH; i++) {
		queue_initialize(&(rdvcb_table[i].wait_queue));
	}
}

#endif /* __inipor */

/*
 *  ǥ֥ݡȤ
 */
#ifdef __cre_por

SYSCALL ER
cre_por(ID porid, const T_CPOR * pk_cpor)
{
	PORCB	*porcb;
	PORINIB *porinib;
	ER	ercd;
    
	LOG_CRE_POR_ENTER(porid);
	CHECK_TSKCTX_UNL();

	t_lock_cpu();

	CHECK_PORID(porid);
	porcb = get_porcb(porid);
	CHECK_OBJECT_CREATABLE(porcb);
	UPDATE_OBJECT_FREELIST(porcb);

	/*
	 * Ԥ
	 */
	queue_initialize(&(porcb->wait_queue));
	queue_initialize(&(porcb->await_queue));
	porinib = porcb->porinib;
	porinib->poratr = pk_cpor->poratr;
	porinib->maxcmsz = pk_cpor->maxcmsz;
	porinib->maxrmsz = pk_cpor->maxrmsz;

	/*
	 *  ǽ¾Υӥ뤫Ѳǽˤʤ롣
	 */
	porcb->exist = KOBJ_EXIST;

	ercd = E_OK;

    exit:
	LOG_CRE_POR_LEAVE(ercd);
	return(ercd);
}

#endif /* __cre_por */

/*
 *  ǥ֥ݡȤ(IDֹ漫ưդ)
 */
#ifdef __acre_por

SYSCALL ER_ID
acre_por(const T_CPOR *pk_cpor)
{
	PORCB	*porcb;
	PORINIB *porinib;
	ER_ID	ercd;
    
	LOG_ACRE_POR_ENTER();
	CHECK_TSKCTX_UNL();

	t_lock_cpu();
	porcb = (PORCB *)t_get_free_id((QUEUE *)&por_freelist);
	if (porcb == NULL) {
		ercd = E_NOID;
		t_unlock_cpu();
		goto exit;
	}
	porcb->exist = KOBJ_INIT;
	t_unlock_cpu();

	/*
	 *  Ԥ
	 */
	queue_initialize(&(porcb->wait_queue));
	queue_initialize(&(porcb->await_queue));
	porinib = porcb->porinib;
	porinib->poratr = pk_cpor->poratr;
	porinib->maxcmsz = pk_cpor->maxcmsz;
	porinib->maxrmsz = pk_cpor->maxrmsz;

	ercd = PORID(porcb);

	/*
	 *  ǽ¾Υӥ뤫Ѳǽˤʤ롣
	 */
	porcb->exist = KOBJ_EXIST;

    exit:
	LOG_ACRE_POR_LEAVE(ercd);
	return(ercd);
}

#endif /* __acre_por */


/*
 *  ǥ֥ݡȤκ
 */
#ifdef __del_por
SYSCALL ER
del_por(ID porid)
{
	PORCB	*porcb;
	TCB	*tcb;
	ER	ercd;
    
	LOG_DEL_POR_ENTER(porid);
	CHECK_TSKCTX_UNL();

	CHECK_PORID(porid);
	porcb = get_porcb(porid);

	CHECK_OBJECT_DELETABLE(porcb);

	/*
	 *  ԤθդȼԤԤ
	 */
	while (queue_empty(&(porcb->wait_queue)) == FALSE) {
		TCB *tcb;
		tcb = (TCB *)queue_delete_next(&(porcb->wait_queue));
		t_lock_cpu();
		if (wait_deleted(tcb)) {
			dispatch();
		}
		t_unlock_cpu();
	}

	/*
	 *  ԤθդȼԤԤ
	 */
	while (queue_empty(&(porcb->await_queue)) == FALSE) {
		TCB *tcb;
		tcb = (TCB *)queue_delete_next(&(porcb->await_queue));
		t_lock_cpu();
		if (wait_deleted(tcb)) {
			dispatch();
		}
		t_unlock_cpu();
	}

	if (!CHECK_OBJECT_RESERVED(porcb)) {
		/*
		 *  ͽIDǤʤХե꡼ꥹȤ롣
		 */
		t_lock_cpu();
		queue_insert_prev(&por_freelist, (QUEUE *)porcb);
		t_unlock_cpu();
	}

	/*
	 *  acre_/cre_ǤΥǽ
	 */
	porcb->exist = KOBJ_EXIST;

	ercd = E_OK;

    exit:
	LOG_DEL_POR_LEAVE(ercd);
	return(ercd);
}

#endif /* __del_por */

/*
 *  ǥ֤θƽФ
 *
 *  poridǻꤵǥץݡȤФơ
 *  calptnǻꤵǥ־ˤꡢǥ֤ƤӽФ
 */
#ifdef __cal_por

SYSCALL ER_UINT
cal_por(ID porid, RDVPTN calptn, VP msg, UINT cmsgsz)
{
	PORCB	*porcb = NULL;
	ER	ercd;
	QUEUE	*queue = NULL;
	RDVNO	rdvno;

	CHECK_DISPATCH();
	CHECK_RDVPTN(calptn);

	CHECK_PORID(porid);
	porcb = get_porcb(porid);

	if (cmsgsz > porcb->porinib->maxcmsz) {
		/*
		 *  cmsgsz оݥǥ֥ݡȤθƽФå
		 *  祵礭ˤϡE_PARΥ顼֤
		 */
		ercd = E_PAR;
		goto exit;
	}

	rdvno = ((TSKID(runtsk) & 0xffff) << 16) | (++rdvidx & 0xffff);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(porcb);

	/*
	 *  ǥּԤӥåȥѥ󤬰פ
	 *  ǥּԤ롣
	 */
	while ((queue = queue_enumerate(&(porcb->await_queue), queue)) != NULL) {
		WINFO_POR *pk_winfo;
		TCB *tcb;
		tcb = (TCB *)queue;
		pk_winfo = (WINFO_POR *)(tcb->winfo);
		if ((pk_winfo->ptn & calptn)) {
			memcpy(pk_winfo->msg, msg, cmsgsz);
			pk_winfo->msgsz = cmsgsz;
			pk_winfo->rdvno = rdvno;
			queue_delete(queue);
			if (wait_complete(tcb)) {
				dispatch();
			}
			break;
		}
	}

	/*
	 *  ǥּԤƤ(¨νǥӥåȥѥ
	 *  פƤ)ǥֽλԤˤ롣
	 *  ǤʤСǥָƽФԤ֤ˤ롣
	 */
	if (queue != NULL) {
		WINFO_POR winfo;
		RDVCB *rdvcb;
		winfo.msg = msg;
		winfo.msgsz = cmsgsz;
		winfo.rdvno = rdvno;
		winfo.maxrmsz = porcb->porinib->maxrmsz;
		rdvcb = &rdvcb_table[winfo.rdvno % TNUM_RDVNO_HASH];
		wobj_make_wait((WOBJCB *)rdvcb, (WINFO_WOBJ *)&winfo);
		dispatch();
		if (winfo.winfo.wercd == E_OK) {
			ercd = winfo.msgsz;
		}
	} else {
		WINFO_POR winfo;
		winfo.ptn = calptn;
		winfo.msg = msg;
		winfo.msgsz = cmsgsz;
		winfo.rdvno = rdvno;
		winfo.caller_tcb = runtsk;
		winfo.maxrmsz = porcb->porinib->maxrmsz;
		wobj_make_wait((WOBJCB *) porcb, (WINFO_WOBJ *)&winfo);
		dispatch();
		if (winfo.winfo.wercd == E_OK) {
			ercd = winfo.msgsz;
		}
	}

	t_unlock_cpu();
    exit:
	return ercd;
}

#endif /* __cal_por */

/*
 *  ǥ֤θƽФ
 *
 * poridǻꤵǥץݡȤФơ
 * calptnǻꤵǥ־ˤꡢǥ֤ƤӽФ
 */
#ifdef __tcal_por

SYSCALL ER_UINT
tcal_por(ID porid, RDVPTN calptn, VP msg, UINT cmsgsz, TMO tmout)
{
	PORCB	*porcb = NULL;
	ER	ercd;
	QUEUE	*queue = NULL;
	RDVNO	rdvno;
	TMEVTB	tmevtb;

	CHECK_DISPATCH();
	CHECK_RDVPTN(calptn);
	CHECK_TMOUT(tmout);

	CHECK_PORID(porid);
	porcb = get_porcb(porid);

	if (cmsgsz > porcb->porinib->maxcmsz) {
		/*
		 *  cmsgsz оݥǥ֥ݡȤθƽФå
		 *  祵礭ˤϡE_PARΥ顼֤
		 */
		ercd = E_PAR;
		goto exit;
	}

	rdvno = ((TSKID(runtsk) & 0xffff) << 16) | (++rdvidx & 0xffff);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(porcb);

	/*
	 *  ǥּԤӥåȥѥ󤬰פ
	 *  ǥּԤ롣
	 */
	while ((queue = queue_enumerate(&(porcb->await_queue), queue)) != NULL) {
		WINFO_POR *pk_winfo;
		TCB *tcb;
		tcb = (TCB *)queue;
		pk_winfo = (WINFO_POR *)(tcb->winfo);
		if ((pk_winfo->ptn & calptn)) {
			memcpy(pk_winfo->msg, msg, cmsgsz);
			pk_winfo->msgsz = cmsgsz;
			pk_winfo->rdvno = rdvno;
			queue_delete(queue);
			if (wait_complete(tcb)) {
				dispatch();
			}
			break;
		}
	}

	/*
	 *  ǥּԤƤ(¨νǥӥåȥѥ
	 *  פƤ)ǥֽλԤˤ롣
	 *  ǤʤСǥָƽФԤ֤ˤ롣
	 */
	if (queue != NULL) {
		WINFO_POR winfo;
		RDVCB *rdvcb;
		winfo.msg = msg;
		winfo.msgsz = cmsgsz;
		winfo.rdvno = rdvno;
		winfo.maxrmsz = porcb->porinib->maxrmsz;
		rdvcb = &rdvcb_table[winfo.rdvno % TNUM_RDVNO_HASH];
		wobj_make_wait_tmout((WOBJCB *)rdvcb, (WINFO_WOBJ *)&winfo, &tmevtb, tmout);
		dispatch();
		if (winfo.winfo.wercd == E_OK) {
			ercd = winfo.msgsz;
		}
	} else {
		WINFO_POR winfo;
		winfo.ptn = calptn;
		winfo.msg = msg;
		winfo.msgsz = cmsgsz;
		winfo.rdvno = rdvno;
		winfo.maxrmsz = porcb->porinib->maxrmsz;
		winfo.caller_tcb = runtsk;
		wobj_make_wait_tmout((WOBJCB *) porcb, (WINFO_WOBJ *)&winfo, &tmevtb, tmout);
		dispatch();
		if (winfo.winfo.wercd == E_OK) {
			ercd = winfo.msgsz;
		}
	}

	t_unlock_cpu();
    exit:
	return ercd;
}

#endif /* __tcal_por */

/*
 *  ǥ֤μ
 *
 * porid ǻꤵǥ֥ݡȤФơ
 * acpptnǻꤵǥ־ˤꡢǥ֤դ롣
 */
#ifdef __acp_por

SYSCALL ER
acp_por(ID porid, RDVPTN acpptn, RDVNO *p_rdvno, VP msg)
{
	PORCB	*porcb = NULL;
	WINFO_POR winfo;
	ER_UINT	ercd = E_SYS;
	BOOL	stat;
	QUEUE	*queue = NULL;

	CHECK_DISPATCH();
	
	CHECK_PORID(porid);
	CHECK_RDVPTN(acpptn);
	porcb = get_porcb(porid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(porcb);

	/*
	 *  ƽФԤӥåȥѥ󤬰פʤС
	 *  ԤǥֽλԤ˰ܹԤ롣
	 */
	while ((queue = queue_enumerate(&(porcb->wait_queue), queue)) != NULL) {
		WINFO_POR *pk_winfo;
		TCB *tcb;

		tcb = (TCB *)queue;
		pk_winfo = (WINFO_POR *)(tcb->winfo);
		if ((pk_winfo->ptn & acpptn)) {
			memcpy(msg, pk_winfo->msg, pk_winfo->msgsz);
			ercd = pk_winfo->msgsz;
			*p_rdvno = pk_winfo->rdvno;

			queue_delete(queue);
			queue_insert_prev(&rdvcb_table[pk_winfo->rdvno % TNUM_RDVNO_HASH].wait_queue, queue);

			break;
		}
	}

	if (queue == NULL) {
		/*
		 *  ¦˰פƽФԤ¸ߤʤ
		 *  ǥּԤ֤ˤ롣
		 */
		winfo.ptn = acpptn;
		winfo.msg = msg;
		winfo.msgsz = porcb->porinib->maxcmsz;
		winfo.maxrmsz = porcb->porinib->maxrmsz;
		runtsk->tstat = (TS_WAITING | TS_WAIT_WOBJ);
		make_wait(&(winfo.winfo));
		queue_insert_prev(&(porcb->await_queue),
				  &(runtsk->task_queue));
		winfo.wobjcb = (WOBJCB *)porcb;
		LOG_TSKSTAT(runtsk);
		dispatch();
		ercd = winfo.winfo.wercd;
		if (MERCD(ercd) == E_OK)
		{
			ercd = winfo.msgsz;
			*p_rdvno = winfo.rdvno;
		}
	}

	t_unlock_cpu();
    exit:
	return ercd;
}

#endif /* __acp_por */

/*
 *  ǥ֤μ (ݡ)
 *
 * porid ǻꤵǥ֥ݡȤФơ
 * acpptnǻꤵǥ־ˤꡢǥ֤դ롣
 */
#ifdef __pacp_por

ER_UINT
pacp_por(ID porid, RDVPTN acpptn, RDVNO *p_rdvno, VP msg)
{
	PORCB	*porcb = NULL;
	WINFO_POR winfo;
	ER_UINT	ercd = E_SYS;
	BOOL	stat;
	QUEUE	*queue = NULL;

	CHECK_TSKCTX_UNL();
	
	CHECK_PORID(porid);
	CHECK_RDVPTN(acpptn);
	porcb = get_porcb(porid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(porcb);

	/*
	 *  ƽФԤӥåȥѥ󤬰פʤС
	 *  ԤǥֽλԤ˰ܹԤ롣
	 */
	while ((queue = queue_enumerate(&(porcb->wait_queue), queue)) != NULL) {
		WINFO_POR *pk_winfo;
		TCB *tcb;

		tcb = (TCB *)queue;
		pk_winfo = (WINFO_POR *)(tcb->winfo);
		if ((pk_winfo->ptn & acpptn)) {
			memcpy(msg, pk_winfo->msg, pk_winfo->msgsz);
			ercd = pk_winfo->msgsz;
			*p_rdvno = pk_winfo->rdvno;

			queue_delete(queue);
			queue_insert_prev(&rdvcb_table[pk_winfo->rdvno % TNUM_RDVNO_HASH].wait_queue, queue);

			break;
		}
	}

	/*
	 * ¦˰פƽФԤ¸ߤʤ
	 * ॢȥ顼ˤ롣
	 */
	if (queue == NULL) {
		ercd = E_TMOUT;
	}

	t_unlock_cpu();
    exit:
	return ercd;
}

#endif /* __pacp_por */

/*
 *  ǥ֤μ (ॢ)
 *
 * porid ǻꤵǥ֥ݡȤФơ
 * acpptnǻꤵǥ־ˤꡢǥ֤դ롣
 */
#ifdef __tacp_por

ER_UINT
tacp_por(ID porid, RDVPTN acpptn, RDVNO *p_rdvno, VP msg, TMO tmout)
{
	PORCB	*porcb = NULL;
	WINFO_POR winfo;
	ER_UINT	ercd = E_SYS;
	BOOL	stat;
	QUEUE	*queue = NULL;

	CHECK_DISPATCH();
	CHECK_TMOUT(tmout);
	
	CHECK_PORID(porid);
	CHECK_RDVPTN(acpptn);
	porcb = get_porcb(porid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(porcb);

	/*
	 *  ƽФԤӥåȥѥ󤬰פʤС
	 *  ԤǥֽλԤ˰ܹԤ롣
	 */
	while ((queue = queue_enumerate(&(porcb->wait_queue), queue)) != NULL) {
		WINFO_POR *pk_winfo;
		TCB *tcb;

		tcb = (TCB *)queue;
		pk_winfo = (WINFO_POR *)(tcb->winfo);
		if ((pk_winfo->ptn & acpptn)) {
			memcpy(msg, pk_winfo->msg, pk_winfo->msgsz);
			ercd = pk_winfo->msgsz;
			*p_rdvno = pk_winfo->rdvno;

			queue_delete(queue);
			queue_insert_prev(&rdvcb_table[pk_winfo->rdvno % TNUM_RDVNO_HASH].wait_queue, queue);

			break;
		}
	}

	if (queue == NULL) {
		TMEVTB tmevtb;
		/*
		 * ¦˰פƽФԤ¸ߤʤ
		 * ǥּԤ֤ˤ롣
		 */
		winfo.ptn = acpptn;
		winfo.msg = msg;
		winfo.msgsz = porcb->porinib->maxcmsz;
		runtsk->tstat = (TS_WAITING | TS_WAIT_WOBJ);
		make_wait_tmout(&(winfo.winfo), &tmevtb, tmout);
		queue_insert_prev(&(porcb->await_queue),
				  &(runtsk->task_queue));
		winfo.wobjcb = (WOBJCB *)porcb;
		LOG_TSKSTAT(runtsk);
		dispatch();
		ercd = winfo.winfo.wercd;
		if (MERCD(ercd) == E_OK)
		{
			ercd = winfo.msgsz;
			*p_rdvno = winfo.rdvno;
		}
	}

	t_unlock_cpu();
    exit:
	return ercd;
}

#endif /* __tacp_por */

/*
 *  ǥ֤νλ
 */
#ifdef __rpl_rdv

SYSCALL ER
rpl_rdv(RDVNO rdvno, VP msg, UINT rmsgsz)
{
	ER	ercd = E_SYS;
	INT	i;
	QUEUE	*queue = NULL;
	RDVCB	*rdvcb;
	TCB	*tcb;
	WINFO_POR *pk_winfo;

	UH	idx;
	UH	tskid;

	CHECK_TSKCTX_UNL();

	rdvcb = &rdvcb_table[rdvno % TNUM_RDVNO_HASH];

	t_lock_cpu();

	/*
	 *  ǥֽλԤǥֹ椬פʤС
	 *  Ԥ롣
	 */
	while ((queue = queue_enumerate(&(rdvcb->wait_queue), queue)) != NULL) {
		tcb = (TCB *)queue;
		pk_winfo = (WINFO_POR *)(tcb->winfo);
		
		if (pk_winfo->rdvno == rdvno) {
			if (pk_winfo->maxrmsz < rmsgsz) {
				ercd = E_PAR;
				goto error;
			}
			memcpy(pk_winfo->msg, msg, rmsgsz);
			pk_winfo->msgsz = rmsgsz;
			queue_delete(queue);
			if (wait_complete(tcb)) {
				dispatch();
			}
			break;
		}
	}

	if (queue == NULL && ercd == E_SYS) {
			ercd = E_OBJ;
	} else {
		ercd = E_OK;
	}

    error:
	t_unlock_cpu();
    exit:
	return ercd;
}
#endif /* __rpl_rdv */

/*
 *  ǥ֤β
 */
#ifdef __fwd_por

SYSCALL ER
fwd_por(ID porid, RDVPTN calptn, RDVNO rdvno, VP msg, UINT cmsgsz)
{
	INT idx;
	PORCB *porcb;
	RDVCB *rdvcb;
	QUEUE *queue = NULL;
	QUEUE *await_queue = NULL;
	TCB	*tcb;
	WINFO_POR	*pk_winfo;
	WINFO_POR	*tcb_winfo;

	ER	ercd = E_SYS;

	CHECK_DISPATCH();

	CHECK_PORID(porid);
	CHECK_RDVPTN(calptn);
	porcb = get_porcb(porid);

	if (cmsgsz > porcb->porinib->maxcmsz) {
		/*
		 *  cmsgsz оݥǥ֥ݡȤθƽФå
		 *  祵礭ˤϡE_PARΥ顼֤
		 */
		ercd = E_PAR;
		goto exit;
	}

	rdvcb = &rdvcb_table[rdvno % TNUM_RDVNO_HASH];

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(porcb);

	/*
	 *  ǥֽλԤΥ롣
	 */
	while ((queue = queue_enumerate(&(rdvcb->wait_queue), queue)) != NULL) {
		tcb = (TCB *)queue;
		pk_winfo = (WINFO_POR *)(tcb->winfo);
		
		if (rdvno == pk_winfo->rdvno) {
			QUEUE	*await_queue = NULL;

			/*
			 *  ǥ֤Ωǥ֥ݡȤå
			 *  cmsgsz礭СE_PAR顼֤
			 */
			if (pk_winfo->maxrmsz < cmsgsz) {
				ercd = E_PAR;
				break;
			}
			queue_delete(queue);

			/*
			 *  ǥּԤΥӥåȥѥ
			 *  郎礨СΥԤ롣
			 */
			while ((await_queue = queue_enumerate(&(porcb->await_queue), await_queue)) != NULL) {
				TCB *await_tcb;
				await_tcb = (TCB *)await_queue;
				pk_winfo = (WINFO_POR *)(await_tcb->winfo);
				if ((pk_winfo->ptn & calptn)) {
					memcpy(pk_winfo->msg, msg, cmsgsz);
					pk_winfo->msgsz = cmsgsz;
					pk_winfo->rdvno = rdvno;
					queue_delete(await_queue);
					if (wait_complete(await_tcb)) {
						dispatch();
					}

					queue_insert_prev(&rdvcb_table[rdvno % TNUM_RDVNO_HASH].wait_queue, queue);

					break;
				}
			}

			/*
			 *  ǥּԤ˳ӥåȥѥ󤬤ʤС
			 *  poridݡȤФƥǥָƽФԤξ֤ˤ롣
			 */
			if (await_queue == NULL) {
				memcpy(pk_winfo->msg, msg, cmsgsz);
				pk_winfo->msgsz = cmsgsz;
				wobj_move_wait(porcb, pk_winfo, tcb);
			}

			ercd = E_OK;
			break;
		}
	}

	/*
	 *  ǥֹ椬ʤΤǡE_OBJ֤
	 */
	if (queue == NULL) {
		ercd = E_OBJ;
	}

	t_unlock_cpu();
    exit:
	return ercd;
}

#endif /* __fwd_por */

/*
 *  ǥ֥ݡȤξֻ
 */
#ifdef __ref_por

SYSCALL ER
ref_por(ID porid, T_RPOR *pk_rpor)
{
	ER ercd;
	TCB *tcb;
	PORCB *porcb;

	LOG_REF_POR_ENTER(porid);
	CHECK_TSKCTX_UNL();

	CHECK_PORID(porid);
	porcb = get_porcb(porid); 

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(porcb);

	if (!queue_empty(&(porcb->wait_queue))) {
		tcb = (TCB *)queue_peek_next(&(porcb->wait_queue));
		pk_rpor->ctskid = TSKID(tcb);
	} else {
		pk_rpor->ctskid = TSK_NONE;
	}

	porcb = get_porcb(porid);
	if (!queue_empty(&(porcb->wait_queue))) {
		tcb = (TCB *)queue_peek_next(&(porcb->wait_queue));
		pk_rpor->atskid = TSKID(tcb);
	} else {
		pk_rpor->atskid = TSK_NONE;
	}

	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_REF_POR_LEAVE(ercd);

	return(ercd);
}

#endif

/*
 *  ǥ֤ξֻ
 */
#ifdef __ref_rdv

SYSCALL ER
ref_rdv(RDVNO rdvno, T_RRDV *pk_rrdv)
{
	ER ercd;
	RDVCB *rdvcb;

	LOG_REF_RDV_ENTER(rdvno);

	rdvcb = &rdvcb_table[rdvno % TNUM_RDVNO_HASH];

	t_lock_cpu();

	/*
	 *  ǥֹ椬̵Ƥ⡢E_OBJˤϤʤ餺TSK_NONEˤʤ롣
	 */
	if (rdvcb->rdvno == rdvno &&
	    !queue_empty(&(rdvcb->wait_queue))) {
			TCB *tcb;
			tcb = (TCB *)queue_peek_next(&(rdvcb->wait_queue));
			pk_rrdv->wtskid = TSKID(tcb);
	} else {
		pk_rrdv->wtskid = TSK_NONE;
	}

	ercd = E_OK;

	t_unlock_cpu();

     exit:
	LOG_REF_RDV_LEAVE(ercd);

	return(ercd);
}

#endif
