/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: semaphore.c,v 1.19 2003/11/10 12:33:11 monaka Exp $
 */

/*
 *	ޥեǽ
 */

#include "jsp_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "semaphore.h"

/*
 *  ޥեIDκ͡kernel_cfg.c
 */
extern const ID	tmax_semid;

/*
 *  ޥե֥åΥꥢkernel_cfg.c
 */
extern SEMINIB	seminib_table[];

/*
 *  ޥե֥åϢۥڥοkernel_cfg.c
 */
extern const UINT	tnum_seminia;

/*
 *  ޥե֥åϢۥڥΥꥢkernel_cfg.c
 */
extern const SEMINIA	seminia_table[];

/*
 *  ޥեͽIDΥꥢkernel_cfg.c
 */
extern const ID		semrid_table[];

/*
 *  ޥեͽIDο (kernel_cfg.c)
 */
extern const UINT	tnum_semrid;

/*
 *  ޥե֥åΥꥢkernel_cfg.c
 */
extern SEMCB	semcb_table[];

/*
 *  ޥեο
 */
#define TNUM_SEM	((UINT)(tmax_semid - TMIN_SEMID + 1))

/*
 *  ޥեID饻ޥե֥åФΥޥ
 */
#define INDEX_SEM(semid)	((UINT)((semid) - TMIN_SEMID))
#define get_semcb(semid)	(&(semcb_table[INDEX_SEM(semid)]))

/*
 *  IDưѥե꡼ꥹ
 */
extern QUEUE sem_freelist;

/* 
 *  ޥեǽν
 */
#ifdef __semini

/*
 *  IDưѥե꡼ꥹ
 */
QUEUE sem_freelist;

void
semaphore_initialize()
{
	UINT	i;
	SEMCB	*semcb;
	SEMINIB *seminib;
	const SEMINIA	*seminia;
	const ID	*semrid;

	/*
	 * ͥ뵯ưξ֤˴ؤ餺ʤФʤΤ
	 * ޤ롣
	 */
	for (semcb = semcb_table, i = 0; i < TNUM_SEM; semcb++, i++) {
		queue_initialize(&(semcb->wait_queue));
	}
	queue_initialize(&sem_freelist);

	/*
	 * seminia ˤäƼΤޤ
	 */
	for (seminia = seminia_table, i = 0; i < tnum_seminia; seminia++, i++) {
		seminib = &seminib_table[seminia->semid - TMIN_SEMID];
		*seminib = seminia->seminib;
		semcb = &semcb_table[seminia->semid - TMIN_SEMID];
		semcb->seminib = seminib;
		semcb->exist = KOBJ_EXIST;
		semcb->reserved = TRUE;

		semcb->semcnt = seminib->isemcnt;
	}

	/*
	 *  ͽID
	 */
	for (semrid = semrid_table, i = 0; i < tnum_semrid; semrid++, i++) {
		semcb_table[*semrid - TMIN_SEMID].reserved = TRUE;
	}

	/*
	 * seminia ˤäƼʤΤ
	 */
	for (semcb = semcb_table, i = 0; i < TNUM_SEM; semcb++, i++) {
		if (semcb->seminib == NULL) {
			semcb->exist = KOBJ_NOEXS;
			semcb->seminib = &seminib_table[i];

			if (!CHECK_OBJECT_RESERVED(semcb)) {
				queue_insert_prev(&sem_freelist, (QUEUE*)semcb);
			}
		}
	}
}

#endif /* __semini */

/*
 *  ޥեν
 */
#ifdef __semcbini

ER init_semcb(SEMCB *semcb, T_CSEM *pk_csem)
{
	SEMINIB *seminib;

	/*
	 * Ԥ
	 */
	queue_initialize(&(semcb->wait_queue));
	seminib = semcb->seminib;
	seminib->sematr = pk_csem->sematr;
	semcb->semcnt = seminib->isemcnt = pk_csem->isemcnt;
	seminib->maxsem = pk_csem->maxsem;


	/*
	 *  ǽ¾Υӥ뤫Ѳǽˤʤ롣
	 */
	semcb->exist = KOBJ_EXIST;

	return E_OK;
}

#endif /* __semcbini */

/*
 *  ޥե
 */
#ifdef __cre_sem

SYSCALL ER
cre_sem(ID semid, const T_CSEM * pk_csem)
{
	SEMCB	*semcb;
	SEMINIB *seminib;
	TCB	*tcb;
	ER	ercd;
    
	LOG_CRE_SEM_ENTER(semid);
	CHECK_TSKCTX_UNL();

	CHECK_SEMID(semid);
	semcb = get_semcb(semid);
	CHECK_OBJECT_CREATABLE(semcb);
	UPDATE_OBJECT_FREELIST(semcb);

	ercd = init_semcb(semcb, pk_csem);

    exit:
	LOG_CRE_SEM_LEAVE(ercd);
	return(ercd);
}

#endif /* __cre_sem */

/*
 *  ޥե(IDֹ漫ưդ)
 */
#ifdef __acre_sem

SYSCALL ER_ID
acre_sem(const T_CSEM *pk_csem)
{
	SEMCB	*semcb;
	ER_ID	ercd;
    
	LOG_ACRE_SEM_ENTER();

	t_lock_cpu();
	semcb = (SEMCB *)t_get_free_id((QUEUE *)&sem_freelist);
	if (semcb == NULL) {
		ercd = E_NOID;
		t_unlock_cpu();
		goto exit;
	}
	semcb->exist = KOBJ_EXIST;
	t_unlock_cpu();

	ercd = init_semcb(semcb, pk_csem);

	if (ercd == E_OK) {
		ercd = SEMID(semcb);
	}

    exit:
	LOG_ACRE_SEM_LEAVE(ercd);
	return(ercd);
}

#endif /* __acre_sem */

/*
 *  ޥեκ
 */
#ifdef __del_sem
SYSCALL ER
del_sem(ID semid)
{
	SEMCB	*semcb;
	TCB	*tcb;
	ER	ercd;
    
	LOG_DEL_SEM_ENTER(semid);
	CHECK_TSKCTX_UNL();

	CHECK_SEMID(semid);
	semcb = get_semcb(semid);

	CHECK_OBJECT_DELETABLE(semcb);

	/* ԤθդȼԤԤ*/
	while (queue_empty(&(semcb->wait_queue)) == FALSE) {
		TCB *tcb;
		tcb = (TCB *)queue_delete_next(&(semcb->wait_queue));
		t_lock_cpu();
		if (wait_deleted(tcb)) {
			dispatch();
		}
		t_unlock_cpu();	
	}

	if (!CHECK_OBJECT_RESERVED(semcb)) {
	  /*
	   * ͽIDǤʤХե꡼ꥹȤ롣
	   */
		t_lock_cpu();
		queue_insert_prev(&sem_freelist, (QUEUE *)semcb);
		t_unlock_cpu();
	}

	/* acre_/cre_ǤΥǽ */
	semcb->exist = KOBJ_NOEXS;

	ercd = E_OK;

    exit:
	LOG_DEL_SEM_LEAVE(ercd);
	return(ercd);
}

#endif /* __del_sem */

/*
 *  ޥե񸻤ֵ
 */
#ifdef __sig_sem

SYSCALL ER
sig_sem(ID semid)
{
	SEMCB	*semcb;
	TCB	*tcb;
	ER	ercd;
    
	LOG_SIG_SEM_ENTER(semid);

	CHECK_TSKCTX_UNL();

	CHECK_SEMID(semid);
	semcb = get_semcb(semid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(semcb);

	if (!(queue_empty(&(semcb->wait_queue)))) {
		tcb = (TCB *) queue_delete_next(&(semcb->wait_queue));
		if (wait_complete(tcb)) {
			dispatch();
		}
		ercd = E_OK;
	}
	else if (semcb->semcnt < semcb->seminib->maxsem) {
		semcb->semcnt += 1;
		ercd = E_OK;
	}
	else {
		ercd = E_QOVR;
	}

	t_unlock_cpu();

    exit:
	LOG_SIG_SEM_LEAVE(ercd);
	return(ercd);
}

#endif /* __sig_sem */

/*
 *  ޥե񸻤ֵѡ󥿥ƥѡ
 */
#ifdef __isig_sem

SYSCALL ER
isig_sem(ID semid)
{
	SEMCB	*semcb;
	TCB	*tcb;
	ER	ercd;
    
	LOG_ISIG_SEM_ENTER(semid);
	CHECK_INTCTX_UNL();

	CHECK_SEMID(semid);
	semcb = get_semcb(semid);

	i_lock_cpu();
	I_CHECK_OBJECT_EXIST(semcb);

	if (!queue_empty(&(semcb->wait_queue))) {
		tcb = (TCB *) queue_delete_next(&(semcb->wait_queue));
		if (wait_complete(tcb)) {
			reqflg = TRUE;
		}
		ercd = E_OK;
	}
	else if (semcb->semcnt < semcb->seminib->maxsem) {
		semcb->semcnt += 1;
		ercd = E_OK;
	}
	else {
		ercd = E_QOVR;
	}

	i_unlock_cpu();

    exit:
	LOG_ISIG_SEM_LEAVE(ercd);
	return(ercd);
}

#endif /* __isig_sem */

/*
 *  ޥե񸻤γ
 */
#ifdef __wai_sem

SYSCALL ER
wai_sem(ID semid)
{
	SEMCB	*semcb;
	WINFO_WOBJ winfo;
	ER	ercd;

	LOG_WAI_SEM_ENTER(semid);
	CHECK_DISPATCH();

	CHECK_SEMID(semid);
	semcb = get_semcb(semid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(semcb);

	if (semcb->semcnt >= 1) {
		semcb->semcnt -= 1;
		ercd = E_OK;
	}
	else {
		wobj_make_wait((WOBJCB *) semcb, &winfo);
		dispatch();
		ercd = winfo.winfo.wercd;
	}

	t_unlock_cpu();

    exit:
	LOG_WAI_SEM_LEAVE(ercd);
	return(ercd);
}

#endif /* __wai_sem */

/*
 *  ޥե񸻤γʥݡ󥰡
 */
#ifdef __pol_sem

SYSCALL ER
pol_sem(ID semid)
{
	SEMCB	*semcb;
	ER	ercd;

	LOG_POL_SEM_ENTER(semid);
	CHECK_TSKCTX_UNL();

	CHECK_SEMID(semid);
	semcb = get_semcb(semid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(semcb);

	if (semcb->semcnt >= 1) {
		semcb->semcnt -= 1;
		ercd = E_OK;
	}
	else {
		ercd = E_TMOUT;
	}

	t_unlock_cpu();

    exit:
	LOG_POL_SEM_LEAVE(ercd);
	return(ercd);
}

#endif /* __pol_sem */

/*
 *  ޥե񸻤γʥॢȤ
 */
#ifdef __twai_sem

SYSCALL ER
twai_sem(ID semid, TMO tmout)
{
	SEMCB	*semcb;
	WINFO_WOBJ winfo;
	TMEVTB	tmevtb;
	ER	ercd;

	LOG_TWAI_SEM_ENTER(semid, tmout);
	CHECK_DISPATCH();
	CHECK_TMOUT(tmout);

	CHECK_SEMID(semid);
	semcb = get_semcb(semid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(semcb);

	if (semcb->semcnt >= 1) {
		semcb->semcnt -= 1;
		ercd = E_OK;
	}
	else if (tmout == TMO_POL) {
		ercd = E_TMOUT;
	}
	else {
		wobj_make_wait_tmout((WOBJCB *) semcb, &winfo, &tmevtb, tmout);
		dispatch();
		ercd = winfo.winfo.wercd;
	}

	t_unlock_cpu();

    exit:
	LOG_TWAI_SEM_LEAVE(ercd);
	return(ercd);
}

#endif /* __twai_sem */

/*
 *  ޥեξֻ
 */
#ifdef __ref_sem
SYSCALL ER
ref_sem(ID semid, T_RSEM *pk_rsem)
{
	SEMCB	*semcb;
	TCB	*tcb;
	ER	ercd;
    
	LOG_REF_SEM_ENTER(semid);
	CHECK_TSKCTX_UNL();

	CHECK_SEMID(semid);
	semcb = get_semcb(semid);

	t_lock_cpu();
	T_CHECK_OBJECT_EXIST(semcb);

	if (!queue_empty(&(semcb->wait_queue))) {
		TCB *tcb;
		tcb = (TCB *)queue_peek_next(&(semcb->wait_queue));
		pk_rsem->wtskid = TSKID(tcb);
	} else {
		pk_rsem->wtskid = TSK_NONE;
	}
	pk_rsem->semcnt = semcb->semcnt;
	ercd = E_OK;
   
	t_unlock_cpu();

    exit:
	LOG_REF_SEM_LEAVE(ercd);
	return(ercd);
}

#endif /* __ref_sem */

