/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: servicecall.c,v 1.11 2003/11/11 08:20:41 monaka Exp $
 */

/*
 *	ĥӥǽ
 */

#include "jsp_kernel.h"
#include "servicecall.h"
#include "bufmgr.h"

/*
 *  ĥӥοkernel_cfg.c
 */
extern const UINT	tnum_svcno;

/*
 *  ĥӥΥꥢkernel_cfg.c
 */
extern SVCCB	svccb_table[];

/*
 *  ĥӥ֥åΥꥢkernel_cfg.c
 */
extern SVCINIB	svcinib_table[];

#define SVCINIB_HASH_SIZE	(8)
extern QUEUE	svcinib_hash_table[];

extern const UINT _kernel_tnum_svcno;

/* 
 *  ĥӥǽν
 */
#ifdef __svcini

QUEUE	svcinib_hash_table[SVCINIB_HASH_SIZE];

void
exservicecall_initialize()
{
	UINT		i;
	SVCCB		*svccb;
	SVCINIB		*svcinib;

	for (i = 0; i < SVCINIB_HASH_SIZE; i++) {
		queue_initialize(&svcinib_hash_table[i]);
	}

	for (svccb = svccb_table, svcinib = svcinib_table, i = 0; i < _kernel_tnum_svcno; svccb++, svcinib++, i++) {
		UINT hash;
		hash = (UINT)svcinib->fncd % SVCINIB_HASH_SIZE;
		svccb->svcinib = svcinib;
		queue_insert_prev(&svcinib_hash_table[hash], &(svccb->queue));
	}
}

#endif /* __svcini */

/*
 *  ĥӥ
 */
#ifdef __def_svc

SYSCALL
ER def_svc(FN fncd, const T_DSVC *pk_dsvc)
{
	SIZE bufsz;
	SVCCB *svccb;
	UINT hash;
	QUEUE *queue = NULL;
	BOOL stat;

	if (fncd <= 0) {
		return E_RSFN;
	}
	if ((pk_dsvc->svcatr & ~(TA_HLNG | TA_ASM))) {
		return E_RSATR;
	}

	hash = (UINT)fncd % SVCINIB_HASH_SIZE;

	while ((queue = queue_enumerate(&svcinib_hash_table[hash], queue)) != NULL) {
		SVCINIB *svcinib;
		svcinib = ((SVCCB *)queue)->svcinib;
		if (svcinib->fncd == fncd) {
			queue_delete(queue);
			/*
			 *  svcrtn == NULL Ͽβ̣롣
			 */
			if (pk_dsvc->svcrtn == NULL) {
				return E_OK;
			}
			break;
		}
	}

	bufsz = sizeof(SVCCB) + sizeof(SVCINIB);
	t_lock_cpu();
	bufmgr_allocate(&stat, bufsz, (VP *)&svccb);
	t_unlock_cpu();
	if (!stat) {
		return E_NOMEM;
	}

	svccb->svcinib = (SVCINIB *)(svccb + 1);
	
	svccb->svcinib->fncd = fncd;
	svccb->svcinib->svcatr = pk_dsvc->svcatr;
	svccb->svcinib->svcrtn = pk_dsvc->svcrtn;
	queue_insert_prev(&svcinib_hash_table[hash], &(svccb->queue));

	return E_OK;
}

#endif /* __def_svc */

/*
 *  ĥӥθƽФ
 */
#ifdef __cal_svc
#include "fncd.h"
#include <stdarg.h>

SYSCALL
ER cal_svc(FN fncd, VP_INT arg1, VP_INT arg2, VP_INT arg3, VP_INT arg4, VP_INT arg5)
{
	ER_UINT ercd;
	QUEUE	*queue = NULL;

	UINT hash;

	if (fncd <= 0) {
		return E_RSFN;
	}

	hash = (UINT)fncd % SVCINIB_HASH_SIZE;

	while ((queue = queue_enumerate(&svcinib_hash_table[hash], queue)) != NULL) {
		SVCINIB *svcinib;
		svcinib = ((SVCCB *)queue)->svcinib;
		if (svcinib->fncd == fncd) {
			ER_UINT (*svcrtn)(VP_INT arg1, VP_INT arg2, VP_INT arg3, VP_INT arg4, VP_INT arg5) = svcinib->svcrtn;
			ercd = svcrtn(arg1, arg2, arg3, arg4, arg5);
			return ercd;
		}
	}

	return E_RSFN;
}

#endif /* __cal_svc */

