/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: task.c,v 1.13 2003/11/20 18:00:32 monaka Exp $
 */

/*
 *	⥸塼
 */

#include "jsp_kernel.h"
#include "task.h"
#include "cpu_context.h"

#define CHECK_TASK_RESERVED(exp) ((exp)->reserved)

#ifdef __tskini

/*
 *  ¹Ծ֤Υ
 */
TCB	*runtsk;

/*
 *  ǹ̤ͥΥ
 */
TCB	*schedtsk;

/*
 *  ǥѥå㳰롼ư׵ե饰
 */
BOOL	reqflg;

/*
 *  ǥѥåľ
 */
BOOL	enadsp;

/*
 *  ǥ塼
 */
QUEUE	ready_queue[TNUM_TPRI];

/*
 *  ǥ塼ΤΥӥåȥޥå
 *
 *  ӥåȥޥåפ UINT Ƥ뤬ӥåȥޥåץؿͥ
 *  ٤16ʳʲǤ뤳ȤꤷƤ롥
 */
UINT	ready_primap;

/*
 *  IDưѥե꡼ꥹ
 */
QUEUE tsk_freelist;

#include "bufmgr.h"
#include "multiqueue.h"

/*
 *  ⥸塼ν
 */
void
task_initialize()
{
	UINT	i, j;
	TCB	*tcb;
	TINIB	*tinib;
	const TINIA	*tinia;
	const ID	*trid;

	runtsk = schedtsk = NULL;
	reqflg = FALSE;
	enadsp = TRUE;

	/*
	 *  ͥ뵯ưξ֤˴ؤ餺ʤФʤΤ
	 *  ޤ롣
	 */
	for (tcb = tcb_table, i = 0; i < TNUM_TSK; tcb++, i++) {
		queue_initialize(&(tcb->task_queue));
		multiqueue_initialize((MULTIOBJCB *)tcb, 0);
		tcb->tinib = NULL;
	}
	queue_initialize(&tsk_freelist);

	for (i = 0; i < TNUM_TPRI; i++) {
		queue_initialize(&(ready_queue[i]));
	}
	ready_primap = 0;

	/*
	 *  tinia ˤäƼΤޤ
	 */
	for (tinia = tinia_table, i = 0; i < tnum_tinia; tinia++, i++) {
		tinib = &tinib_table[INDEX_TSK(tinia->tskid)];
		*tinib = tinia->tinib;
		tcb = &tcb_table[INDEX_TSK(tinia->tskid)];
		tcb->tinib = tinib;
		tcb->exist = KOBJ_EXIST;
		tcb->reserved = TRUE;

		/*
		 *  ɸcfgȤäȤstkNULLˤʤǽ롣<BTS:21>
		 *  Τ褦cfgǤϸڹܤ롣ɸcfgǤϤΥɤ
		 *  뤳ȤϤʤ
		 */
		if (tinib->stk == NULL) {
			BOOL stat;
			bufmgr_allocate(&stat, tinib->stksz, &(tinib->stk));
			assert(stat);
		}
	}

	for (tinia = tinia_table, i = 0; i < tnum_tinia; tinia++, i++) {
		j = INDEX_TSK(torder_table[i]);
		tcb = &(tcb_table[j]);
		tcb->tinib = &(tinib_table[j]);
		tcb->actcnt = FALSE;
		make_dormant(tcb);
		if ((tcb->tinib->tskatr & TA_ACT) != 0) {
			make_active(tcb);
		}
	}

	/*
	 *  ͽID
	 */
	for (trid = trid_table, i = 0; i < tnum_trid; trid++, i++) {
	  tcb[INDEX_TSK(*trid)].reserved = TRUE;
	}

	/*
	 * tinia ˤäƼʤΤ
	 */
	for (tcb = tcb_table, i = 0; i < TNUM_TSK; tcb++, i++) {
		tcb->tskid = i + TMIN_TSKID;
		if (tcb->tinib == NULL) {
			tcb->exist = KOBJ_NOEXS;
			tcb->tinib = &tinib_table[i];

			if (!CHECK_TASK_RESERVED(tcb)) {
				queue_insert_prev(&tsk_freelist, (QUEUE*)tcb);
			}
		}
	}
}

#endif /* __tskini */

/*
 *  ӥåȥޥåץؿ
 *
 *  bitmap  1 ΥӥåȤ⡤ǤⲼ̡ʱˤΤΤ򥵡Υ
 *  åֹ֤ӥåֹϡǲ̥ӥåȤ 0 Ȥ롥bitmap  0
 *  ꤷƤϤʤʤδؿǤϡͥ٤16ʳʲǤ뤳Ȥ
 *  ꤷbitmapβ 16ӥåȤΤߤ򥵡롥
 *  ӥåȥ̿CPUǤϡӥåȥ̿Ȥ褦˽ľ
 *  ΨɤΤ褦ʾˤϡcpu_insn.h ǥӥå
 *  ̿Ȥä bitmap_search CPU_BITMAP_SEARCH 
 *  Ф褤ޤӥåȥ̿Υդʤɤ
 *  ͳͥ٤ȥӥåȤȤбѹˤϡPRIMAP_BIT ޥ
 *  Ф褤
 *  ޤɸ饤֥ ffs ʤ顤Τ褦ɸ饤
 *  ֥ȤäΨɤǽ⤢롥
 *	#define	bitmap_search(bitmap) (ffs(bitmap) - 1)
 */
#ifndef PRIMAP_BIT
#define	PRIMAP_BIT(pri)		(1 << (pri))
#endif /* PRIMAP_BIT */

#ifndef CPU_BITMAP_SEARCH

Inline UINT
bitmap_search(UINT bitmap)
{
	static const VB search_table[] = { 0, 1, 0, 2, 0, 1, 0,
					3, 0, 1, 0, 2, 0, 1, 0 };
	INT	n = 0;

	assert((bitmap & 0xffff) != 0);
	if ((bitmap & 0x00ff) == 0) {
		bitmap >>= 8;
		n += 8;
	}
	if ((bitmap & 0x0f) == 0) {
		bitmap >>= 4;
		n += 4;
	}
	return(n + search_table[(bitmap & 0x0f) - 1]);
}

#endif /* CPU_BITMAP_SEARCH */

/*
 *  ǹ̥ͥΥ
 */
#ifdef __tsksched

TCB *
search_schedtsk()
{
	UINT	schedpri;

	schedpri = bitmap_search(ready_primap);
	return((TCB *)(ready_queue[schedpri].next));
}

#endif /* __tsksched */

/*
 *  ¹ԤǤ֤ؤΰܹ
 *
 *  ǹ̤ͥΥ򹹿Τϡ¹ԤǤ륿ʤä
 *  ȡtcb ͥ٤ǹ̤ͥΥͥ٤⤤Ǥ롥
 */
#ifdef __tskrun

BOOL
make_runnable(TCB *tcb)
{
	UINT	pri = tcb->priority;

	tcb->tstat = TS_RUNNABLE;
	LOG_TSKSTAT(tcb);
	queue_insert_prev(&(ready_queue[pri]), &(tcb->task_queue));
	ready_primap |= PRIMAP_BIT(pri);

	if (schedtsk == (TCB *) NULL || pri < schedtsk->priority) {
		schedtsk = tcb;
		return(enadsp);
	}
	return(FALSE);
}

#endif /* __tskrun */

/*
 *  ¹ԤǤ֤¾ξ֤ؤΰܹ
 *
 *  ǹ̤ͥΥ򹹿Τϡtcb ǹ̤ͥΥǤ
 *  Ǥ롥tcb Ʊͥ٤Υ¾ˤϡtcb μ
 *  ǹ̤ͥˤʤ롥Ǥʤϡǥ塼򥵡
 *  ɬפ롥
 */
#ifdef __tsknrun

BOOL
make_non_runnable(TCB *tcb)
{
	UINT	pri = tcb->priority;
	QUEUE	*queue = &(ready_queue[pri]);

	queue_delete(&(tcb->task_queue));
	if (queue_empty(queue)) {
		ready_primap &= ~PRIMAP_BIT(pri);
		if (schedtsk == tcb) {
			schedtsk = (ready_primap == 0) ? (TCB * ) NULL
						: search_schedtsk();
			return(enadsp);
		}
	}
	else {
		if (schedtsk == tcb) {
			schedtsk = (TCB *)(queue->next);
			return(enadsp);
		}
	}
	return(FALSE);
}

#endif /* __tsknrun */

/*
 *  ٻ߾֤ؤΰܹ
 */
#ifdef __tskdmt

void
make_dormant(TCB *tcb)
{
	tcb->priority = tcb->tinib->base_priority;
	tcb->tstat = TS_DORMANT;
	tcb->wupcnt = FALSE;
	tcb->enatex = FALSE;
	tcb->texptn = 0;
	create_context(tcb);
	LOG_TSKSTAT(tcb);
}

#endif /* __tskdmt */

/*
 *  ٻ߾֤¹ԤǤ֤ؤΰܹ
 */
#ifdef __tskact

BOOL
make_active(TCB *tcb)
{
	activate_context(tcb);
	return(make_runnable(tcb));
}

#endif /* __tskact */

/*
 *  ¹Ծ֤Υνλ
 */
#ifdef __tskext

#include "mutex.h"
#include "multiqueue.h"

void
exit_task()
{
	TCB	*tcb;
	MTXCB *mtxcb;

	/*
	 *  åƤߥ塼ƥåƲ
	 */
	while (!multiqueue_empty((MULTIOBJCB *)runtsk, 0)) {
		mtxcb = (MTXCB *)multiqueue_delete_next((MULTIOBJCB *)runtsk, 0);
		mtxcb->mtxtsk = NULL;
		if (!(queue_empty(&(mtxcb->wait_queue)))) {
			tcb = (TCB *)queue_delete_next(&(mtxcb->wait_queue));
			mtxcb->mtxtsk = tcb;
			multiqueue_insert_prev((MULTIOBJCB *)tcb, (MULTIOBJCB *)mtxcb, 0);
			wait_complete(tcb);
		}
	}	

	make_non_runnable(runtsk);
	make_dormant(runtsk);
	if (runtsk->actcnt) {
		runtsk->actcnt = FALSE;
		make_active(runtsk);
	}
	exit_and_dispatch();
}

#endif /* __tskext */

/*
 *  ǥ塼Υͥ٤ѹ
 *
 *  ǹ̤ͥΥ򹹿Τϡ(1) tcb ǹ̤ͥΥ
 *  Ǥäơͥ٤򲼤硤(2) tcb ǹ̤ͥΥ
 *  Ϥʤѹͥ٤ǹ̤ͥΥͥ٤⤤
 *  Ǥ롥(1) ξˤϡǥ塼򥵡ɬפ롥
 */
#ifdef __tskpri

BOOL
change_priority(TCB *tcb, UINT newpri)
{
	UINT	oldpri = tcb->priority;

	tcb->priority = newpri;
	queue_delete(&(tcb->task_queue));
	if (queue_empty(&(ready_queue[oldpri]))) {
		ready_primap &= ~PRIMAP_BIT(oldpri);
	}
	queue_insert_prev(&(ready_queue[newpri]), &(tcb->task_queue));
	ready_primap |= PRIMAP_BIT(newpri);

	if (schedtsk == tcb) {
		if (newpri >= oldpri) {
			schedtsk = search_schedtsk();
			return(schedtsk != tcb && enadsp);
		}
	}
	else {
		if (newpri < schedtsk->priority) {
			schedtsk = tcb;
			return(enadsp);
		}
	}
	return(FALSE);
}

#endif /* __tskpri */

/*
 *  ǥ塼βž
 *
 *  ǹ̤ͥΥ򹹿Τϡǹ̤ͥΥ
 *  塼˰ưǤ롥
 */
#ifdef __tskrot

BOOL
rotate_ready_queue(UINT pri)
{
	QUEUE	*queue = &(ready_queue[pri]);
	QUEUE	*entry;

	if (!(queue_empty(queue)) && queue->next->next != queue) {
		entry = queue_delete_next(queue);
		queue_insert_prev(queue, entry);
		if (schedtsk == (TCB *) entry) {
			schedtsk = (TCB *)(queue->next);
			return(enadsp);
		}
	}
	return(FALSE);
}

#endif /* __tskrot */

/*
 *  ޤ㳰롼η
 */
typedef void	(*TEXRTN)(TEXPTN texptn, VP_INT exinf);

/*
 *  㳰롼θƽФ
 */
#ifdef __tsktex

void
call_texrtn()
{
	TEXPTN	texptn;

	do {
		texptn = runtsk->texptn;
		runtsk->enatex = FALSE;
		runtsk->texptn = 0;
		t_unlock_cpu();
		LOG_TEX_ENTER(texptn);
		((TEXRTN)(*runtsk->tinib->texrtn))(texptn,
						runtsk->tinib->exinf);
		LOG_TEX_LEAVE(texptn);
		if (!t_sense_lock()) {
			t_lock_cpu();
		}
	} while (runtsk->texptn != 0);
	runtsk->enatex = TRUE;
}

/*
 *  㳰롼εư
 */
#ifndef OMIT_CALLTEX

void
calltex()
{
	if (runtsk->enatex && runtsk->texptn != 0) {
		call_texrtn();
	}
}

#endif /* OMIT_CALLTEX */
#endif /* __tsktex */

/*
 *	ͥ٤(ŪͥٷѾޤ)
 */
#ifdef __setcurpri

#include "wait.h"
#include "mutex.h"

BOOL
set_current_priority(TCB *tcb, UINT newpri)
{
	UINT oldpri;

	while (TRUE) {
		oldpri = tcb->priority;
		if (newpri == oldpri) {
			return FALSE;
		}
		if ( TSTAT_RUNNABLE(tcb->tstat) ) {
			return change_priority(tcb, newpri);
		} else if ( (tcb->tstat & TS_WAIT_WOBJCB) != 0 ) {
			tcb->priority = newpri;
			wobj_change_priority ( ((WINFO_WOBJ *)(tcb->winfo))->wobjcb, tcb);
			if (!(tcb->tstat & TS_WAIT_MTX_I))  {
				return FALSE;
			}
			tcb =( (MTXCB *)( ((WINFO_WOBJ *)(tcb->winfo))->wobjcb) )->mtxtsk;
			if( oldpri < newpri) {
				newpri = search_mtx_priority(tcb);
			}
		} else {
			tcb->priority = newpri;
			return FALSE;
		}
	}
}

#endif /* __setcurpri */
