/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: task_manage.c,v 1.26 2003/11/20 18:03:02 monaka Exp $
 */

/*
 *	ǽ
 */

#include "jsp_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "bufmgr.h"

/*
 *  IDưѥե꡼ꥹ
 */
extern QUEUE tsk_freelist;


/*
 *  
 */
#ifdef __cre_tsk

SYSCALL ER
cre_tsk(ID tskid, const T_CTSK *pk_ctsk)
{
	TCB	*tcb;
	TINIB *tinib;
	ER	ercd;
	VP	stk = NULL;

	LOG_CRE_TSK_ENTER(tskid);
	CHECK_TSKCTX_UNL();

	stk = pk_ctsk->stk;
	if (stk == NULL) {
		BOOL stat;
		bufmgr_allocate(&stat, pk_ctsk->stksz, &stk);
		if (!stat) {
			ercd = E_NOMEM;
			goto exit;
		}
	}
	
	CHECK_TSKID(tskid);
	tcb = get_tcb(tskid);
	CHECK_TASK_CREATABLE(tcb);
	UPDATE_TASK_FREELIST(tcb);
	
	/*
	 * Ԥ
	 * tcbtinibνɬס
	 */
	tinib = tcb->tinib;
	tinib->tskatr = pk_ctsk->tskatr;
	tinib->exinf = pk_ctsk->exinf;
	tinib->task = pk_ctsk->task;
	tinib->stksz = pk_ctsk->stksz;
	tinib->stk = stk;

	tcb->actcnt = FALSE;

	/*
	 *  ⤷ make_dormant()
	 *  t_lock_cpu()Τ
	 *  Ĺ⤷ʤɡǰΤᡣ
	 */
	t_lock_cpu();
	make_dormant(tcb);
	if ((tcb->tinib->tskatr & TA_ACT) != 0) {
		/*
		 *  make_activequeueؤΥ
		 *  뤿ᡢCPUåɬܡ
		 */
		make_active(tcb);
	}
	t_unlock_cpu();

	/*
	 *  ǽ¾Υӥ뤫Ѳǽˤʤ롣
	 */
	tcb->exist = KOBJ_EXIST;

	ercd = E_OK;

    exit:
	LOG_CRE_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* __cre_tsk */

/*
 *   (IDֹ漫ưդ)
 */
#ifdef __acre_tsk

SYSCALL ER_ID
acre_tsk(const T_CTSK *pk_ctsk)
{
	TCB	*tcb;
	TINIB	*tinib;
	ER_ID	ercd;
	VP stk;

	LOG_ACRE_TSK_ENTER();
	CHECK_TSKCTX_UNL();

	if (pk_ctsk->stk == NULL) {
		BOOL stat;
		bufmgr_allocate(&stat, pk_ctsk->stksz, &stk);
		if (stat == FALSE) {
			ercd = E_NOMEM;
			goto exit;
		}
	} else {
		stk = pk_ctsk->stk;
	}
	
	t_lock_cpu();
	tcb = (TCB *)t_get_free_id((QUEUE *)&tsk_freelist);
	if (tcb == NULL) {
		ercd = E_NOID;
		t_unlock_cpu();
		goto exit;
	}
	tcb->exist = KOBJ_INIT;
	t_unlock_cpu();

	/*
	 * Ԥ
	 * tcbtinibνɬס
	 */
	tinib = tcb->tinib;
	tinib->tskatr = pk_ctsk->tskatr;
	tinib->exinf = pk_ctsk->exinf;
	tinib->task = pk_ctsk->task;
	tinib->stk = stk;
	tinib->stksz = pk_ctsk->stksz;

	tcb->actcnt = FALSE;

	/*
	 * ⤷ t_lock_cpu()θƽФ
	 * Ĺ⤷ʤɡǰΤᡣ
	 */
	t_lock_cpu();
	make_dormant(tcb);
	if ((tcb->tinib->tskatr & TA_ACT) != 0) {
		make_active(tcb);
	}
	t_unlock_cpu();

	ercd = TSKID(tcb);

	/*
	 *  ǽ¾Υӥ뤫Ѳǽˤʤ롣
	 */
	tcb->exist = KOBJ_EXIST;

    exit:
	if (ercd < E_OK) {
		BOOL stat;
		stat = bufmgr_release(stk);
		if (stat == FALSE) {
			ercd = E_SYS;
		}
	}
	LOG_ACRE_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* __acre_tsk */

/*
 *  κ
 */
#ifdef __del_tsk

SYSCALL ER
del_tsk(ID tskid)
{
	TCB	*tcb;
	ER	ercd;
	BOOL	stat;
    
	LOG_DEL_TSK_ENTER(tskid);
	CHECK_TSKCTX_UNL();

	/*
	 * Ǥϡλ
	 * ٻ߾֤ǤϤʤ
	 * E_OBJ顼֤
	 */
	CHECK_TSKID_SELF(tskid);
	tcb = get_tcb_self(tskid);

	t_lock_cpu();
	if (tcb->exist != KOBJ_EXIST || !TSTAT_DORMANT(tcb->tstat)) {
		ercd = E_OBJ;
		t_unlock_cpu();
		goto exit;
	}
	tcb->exist = KOBJ_INIT;
	t_unlock_cpu();

	/*
	 *  åΰ롣
	 */
	stat = bufmgr_release(tcb->tinib->stk);
	if (stat) {
		ercd = E_OK;
	} else {
		ercd = E_SYS;
	}

	/*
	 * ̤Ͽ֤ء
	 */
	if (!CHECK_TASK_RESERVED(tcb)) {
	  /*
	   * ͽIDǤʤХե꡼ꥹȤ롣
	   */
		t_lock_cpu();
		queue_insert_prev(&tsk_freelist, (QUEUE *)tcb);
		t_unlock_cpu();
	}

	/* acre_/cre_ǤΥǽ */
	tcb->exist = KOBJ_NOEXS;

    exit:
	LOG_DEL_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* __del_tsk */

/*
 *  εư
 */
#ifdef __act_tsk

SYSCALL ER
act_tsk(ID tskid)
{
	TCB	*tcb;
	ER	ercd;

	LOG_ACT_TSK_ENTER(tskid);
	CHECK_TSKCTX_UNL();

	CHECK_TSKID_SELF(tskid);
	tcb = get_tcb_self(tskid);

	t_lock_cpu();
	T_CHECK_TASK_EXIST(tcb);

	if (TSTAT_DORMANT(tcb->tstat)) {
		if (make_active(tcb)) {
			dispatch();
		}
		ercd = E_OK;
	}
	else if (!(tcb->actcnt)) {
		tcb->actcnt = TRUE;
		ercd = E_OK;
	}
	else {
		ercd = E_QOVR;
	}

	t_unlock_cpu();

    exit:
	LOG_ACT_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* __act_tsk */

/*
 *  εư󥿥ƥѡ
 */
#ifdef __iact_tsk

SYSCALL ER
iact_tsk(ID tskid)
{
	TCB	*tcb;
	ER	ercd;

	LOG_IACT_TSK_ENTER(tskid);
	CHECK_INTCTX_UNL();

	CHECK_TSKID(tskid);
	tcb = get_tcb(tskid);

	i_lock_cpu();
	I_CHECK_TASK_EXIST(tcb);

	if (TSTAT_DORMANT(tcb->tstat)) {
		if (make_active(tcb)) {
			reqflg = TRUE;
		}
		ercd = E_OK;
	}
	else if (!(tcb->actcnt)) {
		tcb->actcnt = TRUE;
		ercd = E_OK;
	}
	else {
		ercd = E_QOVR;
	}

	i_unlock_cpu();

    exit:
	LOG_IACT_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* __iact_tsk */

/*
 *  ư׵Υ󥻥
 */
#ifdef __can_act

SYSCALL ER_UINT
can_act(ID tskid)
{
	TCB	*tcb;
	ER_UINT	ercd;

	LOG_CAN_ACT_ENTER(tskid);
	CHECK_TSKCTX_UNL();

	CHECK_TSKID_SELF(tskid);
	tcb = get_tcb_self(tskid);

	t_lock_cpu();
	T_CHECK_TASK_EXIST(tcb);

	ercd = tcb->actcnt ? 1 : 0;
	tcb->actcnt = FALSE;

	t_unlock_cpu();

    exit:
	LOG_CAN_ACT_LEAVE(ercd);
	return(ercd);
}

#endif /* __can_act */

/*
 *  εưʵưɻ
 */
#ifdef __sta_tsk

#include "cpu_context.h"

SYSCALL ER
sta_tsk(ID tskid, VP_INT stacd)
{
	ER	ercd;
	TCB	*tcb;
	LOG_STA_TSK_ENTER(tskid);
	CHECK_TSKCTX_UNL();

	/*
	 *  ǤTSK_SELF
	 *  θDORMANT֥å
	 *  E_OBJȤʤ롣
	 */
	CHECK_TSKID_SELF(tskid);
	tcb = get_tcb_self(tskid);

	t_lock_cpu();
	T_CHECK_TASK_EXIST(tcb);

	if (TSTAT_DORMANT(tcb->tstat)) {
		activate_context_with_stacd(tcb, stacd);
		if (make_active(tcb)) {
			reqflg = TRUE;
		}
		ercd = E_OK;
	} else {
		ercd = E_OBJ;
	}

	t_unlock_cpu();
    exit:
	LOG_STA_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* __sta_tsk */

/*
 *  νλ롼
 *  ext_tskexd_tskǶͭ롣
 */
#ifdef __prepexttsk
void
prepate_exit_task(void)
{
#ifdef ACTIVATED_STACK_SIZE
	/*
	 *  create_context  activate_context ǡΥå
	 *  ˲ʤ褦ˡå˥ߡΰݤ롥
	 */
	(void) alloca(ACTIVATED_STACK_SIZE);
#endif /* ACTIVATED_STACK_SIZE */

	if (sense_context()) {
		/*
		 *  󥿥ƥȤ ext_tsk/exd_task 
		 *  ƤФ줿硤
		 *  ƥ˥顼ϿΤޤ޼¹Ԥ³롥
		 *  η̡Ū˥ƥȤڤ괹ơ
		 *  ¹Ծ֤Υλ뤳Ȥˤʤ롥ͥ
		 *  Τޤ޼¹Ԥ³뤬åȤˤäƤϡ
		 *  ƥѤΥå˥ߤĤäꡤ
		 *  ߥϥɥΥͥȿδ̷⤬ꤹ
		 *  礬롥
		 */
		syslog_0(LOG_ALERT,
			"ext_tsk is called from non-task contexts.");
	}
	if (sense_lock()) {
		/*
		 *  CPUå֤ ext_tsk ƤФ줿ϡCPUå
		 *  Ƥ饿λ롥ϡӥ
		 *  ǤCPUåάФ褤
		 */
		syslog_0(LOG_WARNING,
			"ext_tsk is called from CPU locked state.");
	}
	else {
		if (sense_context()) {
			i_lock_cpu();
		}
		else  {
			t_lock_cpu();
		}
	}
	if (!(enadsp)) {
		/*
		 *  ǥѥåػ߾֤ ext_tsk ƤФ줿ϡ
		 *  ǥѥåľ֤ˤƤ饿λ롥
		 */
		syslog_0(LOG_WARNING,
			"ext_tsk is called from dispatch disabled state.");
		enadsp = TRUE;
	}
}
#endif /* __prepexttsk */

/*
 *  νλ
 */
#ifdef __ext_tsk

SYSCALL void
ext_tsk(void)
{
	LOG_EXT_TSK_ENTER();

	prepate_exit_task();
	exit_task();
}

#endif /* __ext_tsk */

/*
 *  νλȺ
 */
#ifdef __exd_tsk

SYSCALL void
exd_tsk(void)
{
	LOG_EXD_TSK_ENTER();
	prepate_exit_task();

	/*
	 * ̤Ͽ֤ء
	 */
	runtsk->exist = KOBJ_NOEXS;
	if (!CHECK_TASK_RESERVED(runtsk)) {
	  /*
	   * ͽIDǤʤХե꡼ꥹȤ롣
	   */
	  queue_insert_prev(&tsk_freelist, (QUEUE *)runtsk);
	}

	exit_task();
}

#endif /* __exd_tsk */

/*
 *  ζλ
 */
#ifdef __ter_tsk

SYSCALL ER
ter_tsk(ID tskid)
{
	TCB	*tcb;
	UINT	tstat;
	ER	ercd;

	LOG_TER_TSK_ENTER(tskid);
	CHECK_TSKCTX_UNL();

	CHECK_TSKID(tskid);
	tcb = get_tcb(tskid);
	CHECK_NONSELF(tcb);

	t_lock_cpu();
	T_CHECK_TASK_EXIST(tcb);

	if (TSTAT_DORMANT(tstat = tcb->tstat)) {
		ercd = E_OBJ;
	}
	else {
		if (TSTAT_RUNNABLE(tstat)) {
			make_non_runnable(tcb);
		}
		else if (TSTAT_WAITING(tstat)) {
			wait_cancel(tcb);
		}
		make_dormant(tcb);
		if (tcb->actcnt) {
			tcb->actcnt = FALSE;
			if (make_active(tcb)) {
				dispatch();
			}
		}
		ercd = E_OK;
	}

	t_unlock_cpu();

    exit:
	LOG_TER_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* __ter_tsk */

/*
 *  ͥ٤ѹ
 */
#ifdef __chg_pri

SYSCALL ER
chg_pri(ID tskid, PRI tskpri)
{
	TCB	*tcb;
	UINT	newpri;
	UINT	tstat;
	ER	ercd;

	LOG_CHG_PRI_ENTER(tskid, tskpri);
	CHECK_TSKCTX_UNL();
	CHECK_TPRI_INI(tskpri);

	CHECK_TSKID_SELF(tskid);
	tcb = get_tcb_self(tskid);

	t_lock_cpu();
	T_CHECK_TASK_EXIST(tcb);

	newpri = (tskpri == TPRI_INI) ? tcb->tinib->base_priority
					: INT_PRIORITY(tskpri);

	if (TSTAT_DORMANT(tstat = tcb->tstat)) {
		ercd = E_OBJ;
	}
	else if (TSTAT_RUNNABLE(tstat)) {
		if (change_priority(tcb, newpri)) {
			dispatch();
		}
		ercd = E_OK;
	}
	else {
		tcb->priority = newpri;
		if ((tstat & TS_WAIT_WOBJCB) != 0) {
			wobj_change_priority(((WINFO_WOBJ *)(tcb->winfo))
							->wobjcb, tcb);
		}
		ercd = E_OK;
	}

	t_unlock_cpu();

    exit:
	LOG_CHG_PRI_LEAVE(ercd);
	return(ercd);
}

#endif /* __chg_pri */

/*
 *  ͥ٤λ
 */
#ifdef __get_pri

SYSCALL ER
get_pri(ID tskid, PRI *p_tskpri)
{
	TCB	*tcb;
	ER	ercd;

	LOG_GET_PRI_ENTER(tskid, p_tskpri);
	CHECK_TSKCTX_UNL();

	CHECK_TSKID_SELF(tskid);
	tcb = get_tcb_self(tskid);

	t_lock_cpu();
	T_CHECK_TASK_EXIST(tcb);

	if (TSTAT_DORMANT(tcb->tstat)) {
		ercd = E_OBJ;
	}
	else {
		*p_tskpri = EXT_TSKPRI(tcb->priority);
		ercd = E_OK;
	}

	t_unlock_cpu();

    exit:
	LOG_GET_PRI_LEAVE(ercd, *p_tskpri);
	return(ercd);
}

#endif /* __get_pri */

/*
 *  ξֻ
 */
#ifdef __ref_tsk

SYSCALL ER
ref_tsk(ID tskid, T_RTSK *pk_rtsk)
{
	TCB	*tcb;
	ER	ercd;
	UINT	tstat;

	LOG_REF_TSK_ENTER(tskid);

	CHECK_TSKID_SELF(tskid);
	tcb = get_tcb_self(tskid);

	t_lock_cpu();
	T_CHECK_TASK_EXIST(tcb);

	tstat = tcb->tstat;
	if (TSTAT_RUNNABLE(tstat)) {
		if (tcb == runtsk) {
			pk_rtsk->tskstat = TTS_RUN;
		} else pk_rtsk->tskstat = TTS_RDY;
	} else {
		pk_rtsk->tskstat = 0;
	}

	if (pk_rtsk->tskstat != 0) {
		if (TSTAT_WAITING(tstat)) {
			pk_rtsk->tskstat = TTS_WAI;
		} else if (TSTAT_SUSPENDED(tstat)) {
			pk_rtsk->tskstat = TTS_SUS;
		} else if (TSTAT_WAIT_SUSPENDED(tstat)) {
			pk_rtsk->tskstat = TTS_WAS;
		} else if (TSTAT_DORMANT(tstat)) {
			pk_rtsk->tskstat = TTS_DMT;
		}
	}

	/* TODO: ̤ */

	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_REF_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* __ref_tsk */

/*
 *  ξֻȡʴʰǡ
 */
#ifdef __ref_tst

SYSCALL ER
ref_tst(ID tskid, T_RTST *pk_rtst)
{
	TCB	*tcb;
	ER	ercd;
	UINT	tstat;

	LOG_REF_TST_ENTER(tskid);
	CHECK_TSKCTX_UNL();

	CHECK_TSKID_SELF(tskid);
	tcb = get_tcb_self(tskid);

	t_lock_cpu();
	T_CHECK_TASK_EXIST(tcb);

	tstat = tcb->tstat;
	if (TSTAT_RUNNABLE(tstat)) {
		if (tcb == runtsk) {
			pk_rtst->tskstat = TTS_RUN;
		} else pk_rtst->tskstat = TTS_RDY;
	} else {
		pk_rtst->tskstat = 0;
	}

	/* TODO: pk_rtst->tskwait = tcb-> */

	if (pk_rtst->tskstat != 0) {
		if (TSTAT_WAITING(tstat)) {
			pk_rtst->tskstat = TTS_WAI;
		} else if (TSTAT_SUSPENDED(tstat)) {
			pk_rtst->tskstat = TTS_SUS;
		} else if (TSTAT_WAIT_SUSPENDED(tstat)) {
			pk_rtst->tskstat = TTS_WAS;
		} else if (TSTAT_DORMANT(tstat)) {
			pk_rtst->tskstat = TTS_DMT;
		}
	}

	ercd = E_OK;

	t_unlock_cpu();

    exit:
	LOG_REF_TST_LEAVE(ercd);
	return(ercd);
}

#endif /* __ref_tsk */

