/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: task_overrun.c,v 1.12 2003/11/11 08:20:41 monaka Exp $
 */

/*
 *	Сϥɥ鵡ǽ
 */

#include "jsp_kernel.h"
#include "check.h"
#include "task.h"
#include "task_overrun.h"

/*
 *  СϥɥIDκ͡kernel_cfg.c
 */
extern const ID	tmax_ovrid;

/*
 *  Сϥɥ֥åΥꥢkernel_cfg.c
 */
extern const OVRINIB	ovrinib_table[];

/*
 *  Сϥɥ֥åΥꥢkernel_cfg.c
 */
extern OVRCB	ovrcb_table[];

/*
 *  ޤСϥɥη
 */
typedef void	(*OVRHDR)(ID tskid, VP_INT exinf);

/*
 *  Сϥɥ鵡ǽν
 */
#ifdef __ovrini

void
overrun_initialize()
{
	UINT	i;

	/* TODO: ̤*/
}

#endif /* __ovrini */

/*
 *  Хϥɥ
 */
#ifdef __def_ovr

SYSCALL ER
def_ovr(const T_DOVR * pk_dovr)
{
	TCB	*tcb;
	ER	ercd;
    
	LOG_DEF_OVR_ENTER();
	CHECK_TSKCTX_UNL();

	t_lock_cpu();
	ercd = E_NOSPT;

	t_unlock_cpu();

    exit:
	LOG_DEF_OVR_LEAVE(ercd);
	return(ercd);
}

#endif /* __def_ovr */

/*
 *  Хϥɥư
 */
#ifdef __sta_ovr

SYSCALL ER
sta_ovr(ID tskid, OVRTIM ovrtim)
{
	TCB	*tcb;
	ER	ercd;

	LOG_STA_OVR_ENTER(tskid);
	CHECK_TSKCTX_UNL();

	CHECK_TSKID_SELF(tskid);
	tcb = get_tcb_self(tskid);

	t_lock_cpu();
	T_CHECK_TASK_EXIST(tcb);

	tcb->staovr = TRUE;

	ercd = E_NOSPT;

	t_unlock_cpu();

    exit:
	LOG_STA_OVR_LEAVE(ercd);
	return(ercd);
}

#endif /* __sta_ovr */

/*
 *  Хϥɥư
 */
#ifdef __stp_ovr

SYSCALL ER
stp_ovr(ID tskid)
{
	TCB	*tcb;
	ER	ercd;

	LOG_STP_OVR_ENTER(tskid);
	CHECK_TSKCTX_UNL();

	CHECK_TSKID_SELF(tskid);
	tcb = get_tcb_self(tskid);

	t_lock_cpu();
	T_CHECK_TASK_EXIST(tcb);

	tcb->staovr = FALSE;

	ercd = E_NOSPT;

	t_unlock_cpu();

    exit:
	LOG_STP_OVR_LEAVE(ercd);
	return(ercd);
}

#endif /* __stp_ovr */

/*
 *  Хϥɥξֻ
 */
#ifdef __ref_ovr
SYSCALL ER
ref_ovr(ID tskid, T_ROVR *pk_rovr)
{
	TCB	*tcb;
	ER	ercd;
    
	LOG_REF_OVR_ENTER(tskid);
	CHECK_TSKCTX_UNL();

	CHECK_TSKID_SELF(tskid);
	tcb = get_tcb_self(tskid);

	t_lock_cpu();
	T_CHECK_TASK_EXIST(tcb);

	if (tcb->staovr) {
		pk_rovr->ovrstat = TOVR_STA;
	} else {
		pk_rovr->ovrstat = TOVR_STP;
	}

	/* TODO: pk_rovr->leftotm */

	ercd = E_NOSPT;

	t_unlock_cpu();

    exit:
	LOG_REF_OVR_LEAVE(ercd);
	return(ercd);
}

#endif /* __ref_ovr */

