/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 */

#include "tl16pir552.h"
#include <s_services.h>
#include "sys_defs.h"	/* TNUM_PORT */

/*
 *	PD72001 ʰSIOɥ饤
 */

/* TNUM_PORT:ݡȤ륷ꥢݡȿ (ǥե 2), sys_defs.h ˵ */

/*
 *  ꥢI/OݡȽ֥å
 */
typedef struct sio_port_initialization_block {
	VP	channel_addr;	/* ꥢݡȤγ */

	UB	lcr_def;	/* LCR b0-b6;
				(ӥåȿȥåץӥåȡѥƥ) */
	UB	scr_def;	/* SCR͡ʥץꥹ顨*/
	UB	boud_hi_def;	/* DLM͡ʥܡ졼Ⱦ̤͡ */
	UB	boud_lo_def;	/* DLL͡ʥܡ졼Ȳ̤͡ */
} SIOPINIB;

/*
 *  ꥢI/Oݡȴ֥å
 */
struct sio_port_control_block {
	const SIOPINIB	*siopinib;	/* ꥢI/OݡȽ֥å */
	VP_INT		exinf;		/* ĥ */
	BOOL		openflag;	/* ץѤߥե饰 */
	UB		ier;		/* IER */
	BOOL		getready;	/* ʸ */
	BOOL		putready;	/* ʸǤ */
};

/*
 *  ꥢI/OݡȽ֥å
 *
 *  ID = 1 ݡ1ID = 2 ݡ2бƤ롥
 */
const SIOPINIB siopinib_table[TNUM_PORT] = {
	{ (VP)  UART_CH01,
	  (UB)	WORD_LENGTH_8 | STOP_BITS_1 | PARITY_NON,
	  (UB)	PRE_DIVISOR,
	  (UB)	HI8(DIVISOR),
	  (UB)	LO8(DIVISOR) },
#if TNUM_PORT >= 2
	{ (VP)  UART_CH02,
	  (UB)	WORD_LENGTH_8 | STOP_BITS_1 | PARITY_NON,
	  (UB)	PRE_DIVISOR,
	  (UB)	HI8(DIVISOR),
	  (UB)	LO8(DIVISOR) },
#endif /* TNUM_PORT >= 2 */
};

/*
 *  ꥢI/Oݡȴ֥åΥꥢ
 */
SIOPCB	siopcb_table[TNUM_PORT];

/*
 *  ꥢI/OݡID֥åФΥޥ
 */
#define INDEX_SIOP(siopid)	((UINT)((siopid) - 1))
#define get_siopcb(siopid)	(&(siopcb_table[INDEX_SIOP(siopid)]))

/*
 *  ֤ɽФIIRɽФ
 */
static void
tl16pir552_get_stat(SIOPCB *siopcb)
{
	UB	iir;

	iir = tl16pir552_read_reg( siopcb->siopinib->channel_addr, IIR) & INT_MASK;

	switch( iir ) {
		case INT_TRANS_EMPTY :
			siopcb->putready = TRUE;
			break;
		case INT_RECEIVE_DATA :
		case INT_CHAR_TIME_OUT :
			siopcb->getready = TRUE;
			break;
		default :
			break;
	}


}

/*
 *  ʸǤ뤫
 */
Inline BOOL
tl16pir552_getready(SIOPCB *siopcb)
{
	return(siopcb->getready);
}

/*
 *  ʸǤ뤫
 */
Inline BOOL
tl16pir552_putready(SIOPCB *siopcb)
{
	return(siopcb->putready);
}

/*
 *  ʸμФ
 */
Inline char
tl16pir552_getchar(SIOPCB *siopcb)
{
	siopcb->getready = FALSE;
	return((char) tl16pir552_read_reg( siopcb->siopinib->channel_addr, RBR ));
}

/*
 *  ʸν
 */
Inline void
tl16pir552_putchar(SIOPCB *siopcb, char c)
{
	siopcb->putready = FALSE;
	tl16pir552_write_reg( siopcb->siopinib->channel_addr, THR, c );
}

/*
 *  SIOɥ饤Фν롼
 */
void
tl16pir552_initialize()
{
	SIOPCB	*siopcb;
	UINT	i;

	/*
	 *  륢I/Oݡȴ֥åν
	 */
	for (siopcb = siopcb_table, i = 0; i < TNUM_PORT; siopcb++, i++) {
		siopcb->siopinib = &(siopinib_table[i]);
		siopcb->openflag = FALSE;
	}
}

/*
 *  ץ󤷤ƤݡȤ뤫
 */
BOOL
tl16pir552_openflag(void)
{
#if TNUM_PORT < 2
	return(siopcb_table[0].openflag);
#else /* TNUM_PORT < 2 */
	return(siopcb_table[0].openflag || siopcb_table[1].openflag);
#endif /* TNUM_PORT < 2 */
}

/*
 *  ꥢI/OݡȤΥץ
 */
SIOPCB *
tl16pir552_opn_por(ID siopid, VP_INT exinf)
{
	SIOPCB		*siopcb;
	const SIOPINIB	*siopinib;
	VP	 scc_base_addr;

	siopcb = get_siopcb(siopid);
	siopinib = siopcb->siopinib;

	/* ꥢ륳ȥν */
	scc_base_addr = siopinib->channel_addr;

	tl16pir552_write_reg( scc_base_addr, IER,	DIS_INT );

	tl16pir552_write_reg( scc_base_addr, MCR,	ENABLE_EXT_INT );

	tl16pir552_write_reg( scc_base_addr, LCR,	siopinib->lcr_def | DIVISOR_LATCH_ACC );

	tl16pir552_write_reg( scc_base_addr, SCR,	siopinib->scr_def );

	tl16pir552_write_reg( scc_base_addr, DLL,	siopinib->boud_lo_def );
	tl16pir552_write_reg( scc_base_addr, DLM,	siopinib->boud_hi_def );

	tl16pir552_write_reg( scc_base_addr, LCR,	siopinib->lcr_def );

	tl16pir552_write_reg( scc_base_addr, FCR,	FIFO_ENABLE );
	tl16pir552_write_reg( scc_base_addr, FCR,	FIFO_ENABLE | RECEIVE_FIFO_RESET | TRANS_FIFO_RESET | RECEIVE_TRIG_1_BYTE);
	tl16pir552_write_reg( scc_base_addr, FCR,	FIFO_ENABLE | RECEIVE_TRIG_1_BYTE );

	tl16pir552_write_reg( scc_base_addr, MCR,	DTR | RTS | ENABLE_EXT_INT );

	tl16pir552_write_reg( scc_base_addr, IER,	RECEIVE_DATA_AVAILABLE);

	/* ߥ٥ꡢ׵᥯ꥢϡsio_opn_por(hw_serial.h)ǹԤ */

	siopcb->exinf = exinf;
	siopcb->getready = siopcb->putready = FALSE;
	siopcb->openflag = TRUE;

	return(siopcb);
}

/*
 *  ꥢI/OݡȤΥ
 */
void
tl16pir552_cls_por(SIOPCB *siopcb)
{
	tl16pir552_write_reg( siopcb->siopinib->channel_addr, IER, DIS_INT );

	siopcb->openflag = FALSE;
}

/*
 *  ꥢI/OݡȤؤʸ
 */
BOOL
tl16pir552_snd_chr(SIOPCB *siopcb, char c)
{
	if (tl16pir552_putready(siopcb)) {
		tl16pir552_putchar(siopcb, c);
		return(TRUE);
	}
	return(FALSE);
}

/*
 *  ꥢI/OݡȤʸ
 */
INT
tl16pir552_rcv_chr(SIOPCB *siopcb)
{
	if (tl16pir552_getready(siopcb)) {
		return((INT)(UB) tl16pir552_getchar(siopcb));
	}
	return(-1);
}

/*
 *  ꥢI/OݡȤΥХåε
 */
void
tl16pir552_ena_cbr(SIOPCB *siopcb, UINT cbrtn)
{
	UB	temp;
	UB	ier_bit = 0;

	switch (cbrtn) {
	case SIO_ERDY_SND:
		ier_bit = TRANS_REG_EMPTY;
		break;
	case SIO_ERDY_RCV:
		ier_bit = RECEIVE_DATA_AVAILABLE | RECEIVE_LINE_STATUS;
		break;
	}

	temp = tl16pir552_read_reg( siopcb->siopinib->channel_addr, IER );
	temp |= ier_bit;
	siopcb->ier = temp;
	tl16pir552_write_reg( siopcb->siopinib->channel_addr, IER, temp );
}

/*
 *  ꥢI/OݡȤΥХåζػ
 */
void
tl16pir552_dis_cbr(SIOPCB *siopcb, UINT cbrtn)
{
	UB	temp;
	UB	ier_bit = 0;

	switch (cbrtn) {
	case SIO_ERDY_SND:
		ier_bit = TRANS_REG_EMPTY;
		break;
	case SIO_ERDY_RCV:
		ier_bit = RECEIVE_DATA_AVAILABLE | RECEIVE_LINE_STATUS;
		break;
	}

	temp = tl16pir552_read_reg( siopcb->siopinib->channel_addr, IER );
	temp &= ~ier_bit;
	siopcb->ier = temp;
	tl16pir552_write_reg( siopcb->siopinib->channel_addr, IER, temp );
}

/*
 *  ꥢI/OݡȤФ߽
 */
static void
tl16pir552_isr_siop(SIOPCB *siopcb)
{
	tl16pir552_get_stat(siopcb);

	if ( tl16pir552_getready(siopcb) ) {
		/*
		 *  ΥХå롼ƤӽФ
		 */
		tl16pir552_ierdy_rcv(siopcb->exinf);
	} else if ( tl16pir552_putready(siopcb) ) {
		/*
		 *  ǽХå롼ƤӽФ
		 */
		tl16pir552_ierdy_snd(siopcb->exinf);
	}
}

/*
 *  SIOγߥӥ롼
 */
void
tl16pir552_uart0_isr()
{
	if (siopcb_table[0].openflag) {
		tl16pir552_isr_siop(&(siopcb_table[0]));
	}
}

#if TNUM_PORT >= 2
void
tl16pir552_uart1_isr()
{
	if (siopcb_table[1].openflag) {
		tl16pir552_isr_siop(&(siopcb_table[1]));
	}
}
#endif /* TNUM_SIOP >= 2 */
